#!/bin/bash

## bu jiaoyan  anzhuangmulu
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    initInputParam.sh
## Description: Get and validate the input parameter of installation
## Version:     FusionInsight Hadoop V100R002C02
## Created:     Wednesday, May 22, 2013
################################################################################
# ---------------------------------------------------------------------------- #
#                                                                      #
# ---------------------------------------------------------------------------- #
declare g_productHome=""                # ƷҪװĸĿ¼
declare g_omServerWorkspace=""          # om-serverҪװĹĿ¼
declare g_bigdataCommon=""              # commonĿ¼ /opt/huawei/Bigdata/common/runtime
declare g_bigdataCommonHome=""          # commonĿ¼ /opt/huawei/Bigdata/common/
declare g_productDataHome=""            # ƷݵĴŸĿ¼
declare g_logHome=""                    # Ʒ־Ŀ¼
declare g_haMode=""                     # haģʽ(single)˫(double)
declare g_server1Name=""                # 
declare g_server1IP1=""                 # ip1haip1
declare g_server1IP2=""                 # ip2haip2
declare g_server1IP3=""                 # ip3haip3
declare g_server1IP4=""                 # ip4haip4
declare g_server2Name=""                # Զ
declare g_server2IP1=""                 # Զip1haip1
declare g_server2IP2=""                 # Զip2haip2
declare g_server2IP3=""                 # Զip3haip3
declare g_server2IP4=""                 # Զip4haip4
declare g_wsFloatIP=""                  # ûwebҳϵͳĸip
declare g_wsFloatIPNetmask=""           # ûWebҳϵͳ
declare g_wsFloatIPInterface=""         # ûWebҳϵͳ
declare g_wsGateway=""                  # ûWebҳϵͳ
declare g_omFloatIP=""                  # Ըڵcontrollerĸip
declare g_omFloatIPNetmask=""           # Ըڵcontroller
declare g_omFloatIPInterface=""         # Ըڵcontrollerĵ
declare g_omGateway=""                  # Ըڵcontrollerĵ
declare g_ntpServerIP=""                # ntpʱ׼ip,ֶ֧ipÿipԶŷָ
declare g_log_archive_time=""           #
declare g_mediatorIP=""                 # ٲip,жϱǷڼȺ
declare g_logFile="${TEMP_LOG_PATH}/install.log" # ־ļ
declare g_clsNodeNum=""                 # װļȺģ
declare g_curPath=""                    # ǰűڵĿ¼
declare g_scriptName=""                 # ǰűĽű
declare g_operatorType="install"        # ǰ,ĬΪװ
declare -i retVal=0                     # ֵ
declare g_ssoip=""
declare g_ssoport=""
declare g_ommid=""                      # ommûid
declare g_ommdbaid=""                   # omm DBAûid
declare g_installFile=""                # װļ·
declare g_combination=""                # ǷԽʽȷѴڸIP
declare g_super_user="root"             # û
declare g_sudo_profile="/etc/profile.d/sudoProfile.sh" # sudoűõĻļ
declare omm_profile="/home/omm/.profile" # ļ
declare g_tls_protocol_min=""            #ʾǰϵͳldapserverֵ֧Ͱ汾TLSЭ
declare g_realmParseIp=""                # ip

# ---------------------------------------------------------------------------- #
#                                                                      #
# ---------------------------------------------------------------------------- #
################################################################################
# Function: get_cur_path
# Description: ȡűڵĿ¼ű
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - >/dev/null
}

################################################################################
# Function: print_usage
# Description: ʾװʽ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
print_usage()
{
    echo -e "Installation parameter:"
    echo -e "-m oms_ha_mode   : Mode can be double or single."
    echo -e "-h heartbeat_para: OMS HA local and peer heart-beat parameters seperated by ':'."
    echo -e "                   Heart-beat parameters include HA name and HA heart-beat IP addresses(max 4 IP addresses), separated by ','."
    echo -e "-o web_para      : Interface parameters for OMS WebUI, formatted as 'web_ip_interface,web_ip,web_ip_netmask'."
    echo -e "-i om_para       : Interface parameters for OMS Agent, formatted as 'om_ip_interface,om_ip,om_ip_netmask'."
    echo -e "-t ntp_server_ip : NTP server IP addresses. multi-IPs are separated by ','."
    echo -e "                   Notes: The first one is the preferred server."
    echo -e "-g om_mediator_ip   : Mediator IP address. The standby HA can turn to active only if mediator IP address is reachable, when heart-beat is lost."
    echo -e "-f config_file   : Installer read parameters from config_file."
    echo -e "                   Notes: The config_file must be absolute path."
    echo -e "-p product_home  : Home directory for installing the product software."
    echo -e "-d data_home     : Home directory for storing product data."
    echo -e "-U operator_type : Operator type: upgrade."
    echo -e "-c Combination mode : Ignore the interactive confirmation operation of duplicate floating IP addresses."
    echo -e "-I sso_ip        :Third-party single sign-on authentication server ip"
    echo -e "-P sso_port      :Third-party single sign-on authentication server port"
    echo -e "-T tls_protocol_min :Minimum tls version configed for ldap"
    echo -e "-n cluster_nodes_scale :Nodes scale of cluster"
    echo -e ""
    echo -e "Installation example:"
    echo -e "For example 1    : ./install.sh -m double -h server1_ip1,server1_ip2,server1_ip3,server1_ip4:server2_ip1,server2_ip2,server2_ip3,server2_ip4"
    echo -e "                   -o web_ip_interface,web_ip,web_ip_netmask -i om_ip_interface,om_ip,om_ip_netmask -t ntp_server_ip1,ntp_server_ip2 -g om_mediator_ip"
    echo -e "For example 2    : ./install.sh -f /opt/huawei/Bigdata/software/install.ini"
    echo -e "For example 3    : ./install.sh -f /opt/huawei/Bigdata/software/install.ini -p /opt/huawei/Bigdata -d /srv/Bigdata"
    echo -e "For example 4    : ./install.sh -m single"

    return 0
}

################################################################################
# Function:
# Description: ǷϷ
# Parameter:
#   input:
#   $1 --  ҪУ
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
number_match()
{
  if [ -z "$1" ]; then
    #Ĭ־ڣs
    g_log_archive_time="21600"
    return 0
  fi
  if [[ ! $1 =~ ^[0-9]+$ ]]; then
    return 1
  fi

  return 0
}
################################################################################
# Function: validate_ip
# Description: ipǷϷ
# Parameter:
#   input:
#   $1 -- ip ҪУip
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_ip()
{
    local tmpIP=$1

    if [ -z "${tmpIP}" ] ; then
        showLog_error "${LINENO}" "The input parameter is incorrect."
        return 1
    fi

    echo "${tmpIP}" | grep "^[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}$" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        return 1
    fi

    local -i temp=0
    for temp in $(echo ${tmpIP} | awk -F"." '{printf ("%s %s %s %s ", $1, $2, $3, $4);}'); do
        if [ ${temp} -gt 255 ] || [ ${temp} -lt 0 ] ; then
            return 1
        fi
    done

    return 0
}

################################################################################
# Function: validate_port
# Description: portǷϷ
# Parameter:
#   input:
#   $1 -- port ҪУport
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_port()
{
    local tmpPort=$1

    if [ -z "${tmpPort}" ] ; then
        showLog_error "${LINENO}" "The input parameter is incorrect."
        return 1
    fi

    echo "${tmpPort}" | grep "^[0-9]\{1,5\}$" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        return 1
    fi

    if [ ${tmpPort} -gt 65535 ] || [ ${tmpPort} -lt 0 ] ; then
        return 1
    fi

    return 0
}

################################################################################
# Function: validate_float_ip
# Description: 鸡ipĺϷ
# Parameter:
#   input:
#   $1 -- floatIPType ip(ws_float_ip or om_float_ip)
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_float_ip()
{
    local floatIPType=$1
    local tmpIP="${g_omFloatIP}"
    local input=""

    if [ "${floatIPType}" != "ws_float_ip" ] && [ "${floatIPType}" != "om_float_ip" ] ; then
        showLog_error "${LINENO}" "The input parameter($1) is incorrect in the validate_float_ip funciton."
        return 1
    fi

    if [ "${floatIPType}" = "ws_float_ip" ] ; then
        tmpIP="${g_wsFloatIP}"
    fi

    validate_ip ${tmpIP}
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "The ${floatIPType}(${tmpIP}) is incorrect."
        return 1
    fi

    # жϸipڱǷѾ
    if  [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            if [ -f /sbin/ifconfig ]; then
                IFCONFIG="/sbin/ifconfig"
            else
                IFCONFIG="/usr/bin/ifconfig"
            fi
            ${IFCONFIG} | grep -w -F ${tmpIP} >> "${g_logFile}" 2>&1
        else
            sudo ${INSTALL_SUDO_PATH} checkFloat_ip ${tmpIP}
        fi
        if [ $? -eq 0 ]; then
            showLog_error "${LINENO}" "The ${floatIPType}(${tmpIP}) already exists on local host."
            return 1
        fi

        ping -c 1 "${tmpIP}" >> "${g_logFile}" 2>&1
        # ȷpingͨĸipڵǰcontrollerʹãǣ˵
        if [ $? -eq 0 ]; then
            if [ -z ${g_combination} ]; then
                echo -n "The ${floatIPType}(${tmpIP}) already exists on the network. Is it used on the active OMS HA? (y/n):"
                read input

                if [ "${input}" != "y" ] && [ "${input}" != "Y" ] ; then
                    return 1
                fi
            else
                showLog_warn "${LINENO}" "The ${floatIPType}(${tmpIP}) already exists on local host."
            fi
        fi
    fi
    
    return 0
}

################################################################################
# Function: validate_netmask
# Description: ĺϷ
# Parameter:
#   input:
#   $1 -- netmaskType (om_float_ip_netmask or ws_float_ip_netmask)
#   output:
#   $1 --
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_netmask()
{
    local netmaskType=$1
    local netmask="${g_omFloatIPNetmask}"

    if [ "${netmaskType}" != "om_float_ip_netmask" ] && [ "${netmaskType}" != "ws_float_ip_netmask" ] ; then
        showLog_error "${LINENO}" "The input parameter(${netmaskType}) is incorrect in the validate_netmask funciton."
        return 1
    fi

    if [ "${netmaskType}" = "ws_float_ip_netmask" ] ; then
        netmask="${g_wsFloatIPNetmask}"
    fi

    echo "${netmask}" | grep "^[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}$" > /dev/null
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "The ${netmaskType}(${netmask}) is incorrect."
        return 1
    fi

    local -i temp=0
    local -i flag=0
    local -i error=0

    for temp in $(echo ${netmask} | awk -F"." '{printf ("%s %s %s %s ", $1, $2, $3, $4);}'); do
        case ${temp} in
            0)
                flag=${flag}+1
            ;;
            128)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            192)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            224)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            240)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            248)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            252)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            254)
                if [ "${flag}" -gt 0 ]; then
                    error=1
                    break;
                fi

                flag=${flag}+1
            ;;
            255)
            ;;
            *)
                error=1
                break;
            ;;
        esac
    done

    if [ "${error}" -ne 0 ]; then
        showLog_error "${LINENO}" "The ${netmaskType}(${netmask}) is incorrect."
        return 1
    fi

    return 0
}

################################################################################
# Function: validate_float_ip_interface
# Description: 鸡ipĺϷ
# Parameter:
#   input:
#   $1 -- interfaceType (om_float_ip_interface or ws_float_ip_interface)
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_float_ip_interface()
{
    local interfaceType=$1
    local interface="${g_omFloatIPInterface}"

    if [ "${interfaceType}" != "om_float_ip_interface" ] \
        && [ "${interfaceType}" != "ws_float_ip_interface" ]; then
        showLog_error "${LINENO}" "The ${interfaceType}(${interface}) is incorrect."
        return 1
    fi

    if [ "${interfaceType}" = "ws_float_ip_interface" ] ; then
        interface="${g_wsFloatIPInterface}"
    fi

    # ΪգǷ
    if [ -z "${interface}" ]; then
        showLog_error "${LINENO}" "The ${interfaceType} is empty."
        return 1
    fi
    # ȴڵ14Ƿ
    #interfaceLength=${#interface}
    #if [ "${interfaceLength}" -ge 14 ]; then
    #   showLog_error "${LINENO}" "The ${interface} length should be less than 15."
    #  return 1
    #fi
    tmpdev=${interface%%:*}


    if [ "${interfaceType}" = "om_float_ip_interface" ] ; then
        interface="${g_omFloatIPInterface}"
        tmpdevLength=${#tmpdev}
        omsTail="oms"
        if [ "${tmpdevLength}" -le 10 ];then
            omsTail="oms"
        elif [ "${tmpdevLength}" -eq 11 ];then
            omsTail="oms"
        elif [ "${tmpdevLength}" -eq 12 ];then
            omsTail="om"
        elif [ "${tmpdevLength}" -eq 13 ];then
            omsTail="o"
        elif [ "${tmpdevLength}" -ge 14 ];then
            showLog_error "${LINENO}" "The ${interfaceType} length should be less than 14."
            return 1
        fi
    om_float_ip_interface=${tmpdev}:${omsTail}
    fi

    if [ "${interfaceType}" = "ws_float_ip_interface" ] ; then
        interface="${g_wsFloatIPInterface}"
        tmpdevLength=${#tmpdev}

    #omswsipͬͲͬ,ֿ
        if [ "${g_wsFloatIP}" = "${g_omFloatIP}" ] ; then
            webTail="oms"
            if [ "${tmpdevLength}" -le 10 ];then
                webTail="oms"
            elif [ "${tmpdevLength}" -eq 11 ];then
                webTail="oms"
            elif [ "${tmpdevLength}" -eq 12 ];then
                webTail="om"
            elif [ "${tmpdevLength}" -eq 13 ];then
                webTail="o"
            elif [ "${tmpdevLength}" -ge 14 ];then
                showLog_error "${LINENO}" "The ${interfaceType} length should be less than 14."
                return 1
            fi
        else
            if [ "${tmpdevLength}" -le 10 ];then
                webTail="web"
            elif [ "${tmpdevLength}" -eq 11 ];then
                webTail="web"
            elif [ "${tmpdevLength}" -eq 12 ];then
                webTail="we"
            elif [ "${tmpdevLength}" -eq 13 ];then
                webTail="w"
            elif [ "${tmpdevLength}" -ge 14 ];then
                showLog_error "${LINENO}" "The ${interfaceType} length should be less than 14."
                return 1
            fi
        fi
    ws_float_ip_interface=${tmpdev}:${webTail}
    fi

    if [ -f /sbin/ifconfig ]; then
        IFCONFIG="/sbin/ifconfig"
    else
        IFCONFIG="/usr/bin/ifconfig"
    fi
    
    #wsipܰûþ̬ipϣûinetʾEuler 2.5˲У顣
    if [ "${interfaceType}" = "om_float_ip_interface" ];then
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            ${IFCONFIG} ${tmpdev} | grep "inet" >> "${g_logFile}" 2>&1
        else
           sudo ${INSTALL_SUDO_PATH} checkInterface_inet ${tmpdev}
        fi
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "${interfaceType}(${tmpdev}) is not exists."
            return 1
        fi
    fi
    
    # жϸǷѾռ
    if [ "${g_haMode}" = 'double' ] && [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            ${IFCONFIG} ${interface} | grep "inet addr" >> "${g_logFile}" 2>&1
        else
           sudo ${INSTALL_SUDO_PATH} checkInterface_inet_addr ${interface}
        fi
        if [ $? -eq 0 ]; then
            showLog_error "${LINENO}" "IP already exists on ${interfaceType}(${interface}). virtual interface is supported,such as ${interface}:0."
            return 1
        fi
    fi

    return 0
}

################################################################################
# Function: validate_GateWay
# Description: صĺϷ
# Parameter:
#   input:
#   $1 -- om_float_ip_gateWay or ws_float_ip_gateWay
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_GateWay()
{
    local gateWay=$1
    if [ -n "${gateWay}" ] ; then
        validate_ip "${gateWay}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The gateWay ip ${gateWay} is incorrect."
            return 1
        fi
    else
       log_warn "${LINENO}" "The gateWay is empty."
       return 0
    fi
    return 0
}

################################################################################
# Function: validate_clsNodeNum
# Description: У鼯ȺڵĿҪΪΪ
# Parameter:
#   input: clsNodeNum
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_clsNodeNum()
{
    if [ -z "$1" ]; then
        return 0
    fi
    
    if [[ ! $1 =~ ^[0-9]+$ ]]; then
        showLog_error "${LINENO}" "The cluster_nodes_scale param must be a integer."
        return 1
    fi
    
    return 0
}

################################################################################
# Function: validate_ha_mode
# Description: haģʽ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_ha_mode()
{
    if [ "${g_haMode}" != "single" ] && [ "${g_haMode}" != "double" ]; then
        showLog_error "${LINENO}" "The ha mode ${g_haMode} is incorrect. Only single or double mode is supported."
        return 1
    fi

    return 0
}

################################################################################
# Function: validate_ha_name
# Description: У鵥ha
# Parameter:
#   input:
#   $1 -- nameType ha (server1_name or server2_name)
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_ha_name()
{
    local -i retVal=0
    local nameType=$1
    local serverName="${g_server1Name}"

    if [ "${nameType}" != "server1_name" ] && [ "${nameType}" != "server2_name" ] ; then
        showLog_error "${LINENO}" "The server name type(${nameType}) is incorrect."
        return 1
    fi

    if [ "${nameType}" = "server2_name" ] ; then
        serverName="${g_server2Name}"
    fi

    # жserver name
    local -i nameLen=$(echo ${serverName} | wc -L)
    if [ ${nameLen} -eq 0 ] || [ ${nameLen} -gt 38 ] ; then
        showLog_error "${LINENO}" "The length of server2_name must be between 1 and 38."
        retVal=$(expr ${retVal} + 1)
    fi

    # ȷserver name-_0-9a-zA-Zַ
    isInvalid=$(echo ${serverName} | grep [^-_0-9a-zA-Z])
    if [ -n "${isInvalid}" ]; then
        showLog_error "${LINENO}" "The ${nameType} is incorrect. Only alphabet(a~z A~Z), digital(0~9),hyphen(-) and underscode(_) are supported in ${nameType}."
        retVal=$(expr ${retVal} + 1)
    fi

    return ${retVal}
}

################################################################################
# Function: validate_ha_names
# Description: Уha
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_ha_names()
{
    local -i retVal=0

    # Уg_server1NameЧ
    validate_ha_name server1_name
    retVal=$(expr ${retVal} + $?)

    # ˫ģʽУ鱸ha
    if [ "${g_haMode}" = 'double' ]; then
        # Уg_server2NameЧ
        validate_ha_name server2_name
        retVal=$(expr ${retVal} + $?)

        if [ "${g_server1Name}" = "${g_server2Name}" ]; then
            showLog_error "${LINENO}" "The ${g_server1Name} server1_name cannot be the same with the ${g_server2Name} server2_name."
            retVal=$(expr ${retVal} + 1)

        fi
    fi

    return ${retVal}
}

################################################################################
# Function: validate_interfate
# Description: УϢ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_interfate()
{
    local -i retVal=0

    if [ "${g_haMode}" = 'double' ] && [ "${g_omFloatIPInterface}" != "${g_wsFloatIPInterface}" ]; then
        if [ "${g_omFloatIPInterface:0:15}" = "${g_wsFloatIPInterface:0:15}" ] ; then
            showLog_error "${LINENO}" "The ws_float_ip_interface and the om_float_ip_interface's first fifteen characters can not be the same."
            retVal=$(expr ${retVal} + 1)
        fi
    fi
    
    return ${retVal}
}
################################################################################
# Function: is_ha_ip_matched
# Description: жhaipǷƥ䣺Ҫô߶ΪգҪô߶Ϊ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
is_ha_ip_matched()
{
    local -i retVal=0

    for ((i=1;i<=4;i++)); do
        eval server1IP='$'g_server1IP"${i}"
        eval server2IP='$'g_server2IP"${i}"

        # server1IPΪգserver2IPҲҪΪ
        if [ -z "${server1IP}" ]; then
            if [ -n "${server2IP}" ]; then
                showLog_error "${LINENO}" "The server1_ip${i} is empty, but the server2_ip${i} is not empty."
                retVal=$(expr ${retVal} + 1)
            fi

        # server1IPΪգserver2IPҲΪ
        else
            if [ -z "${server2IP}" ]; then
                showLog_error "${LINENO}" "The server1_ip${i} is not empty, but the server2_ip${i} is empty."
                retVal=$(expr ${retVal} + 1)
            fi
        fi
    done

    return ${retVal}
}

################################################################################
# Function: validate_ha_ips
# Description: haipĺϷ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_ha_ips()
{
    # ǵģʽip,ʲж
    if [ "${g_haMode}" = 'single' ] ; then
        return 0
    fi

    local -i retVal=0
    local -i i=1
    local -i j=1
    local tmpIP=""

    for ((i=1;i<=2;i++)); do
        for ((j=1;j<=4;j++)); do
            eval tmpIP='$'g_server"${i}"IP"${j}"

            # 4haipԣһipԲΪգĬֵѱ֤
            # ipΪգֱ
            if [ -z "${tmpIP}" ] ; then
                continue
            fi

            # жipǷϷ
            validate_ip ${tmpIP}
            if [ $? -ne 0 ]; then
                showLog_error "${LINENO}" "The server${i}_ip${j}(${tmpIP}) is incorrect."
                retVal=$(expr ${retVal} + 1)
            else
                # жϱipǷʵڣԶipڰװԶcontrollerʱж
                if [ ${i} -eq 1 ]; then
                    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
                        if [ -f /sbin/ifconfig ]; then
                            IFCONFIG="/sbin/ifconfig"
                        else
                            IFCONFIG="/usr/bin/ifconfig"
                        fi
                        ${IFCONFIG} | grep -w -F ${tmpIP} >> "${g_logFile}" 2>&1
                    else
                       sudo ${INSTALL_SUDO_PATH} checkFloat_ip ${tmpIP}
                    fi
                    if [ $? -ne 0 ]; then
                        showLog_error "${LINENO}" "The server${i}_ip${j}(${tmpIP}) ip does not exist. Please configure the ${tmpIP} ip first."
                        retVal=$(expr ${retVal} + 1)
                    fi
                fi
            fi

        done
    done

    # жhaipǷƥ䣺Ҫô߶ΪգҪô߶Ϊ
    is_ha_ip_matched
    retVal=$(expr ${retVal} + $?)

    return ${retVal}
}

################################################################################
# Function: validate_input
# Description: ĺϷ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
validate_input()
{
    log_info "${LINENO}" "Start to validate input parameters."
    if [ "${g_productHome}" = "${g_productDataHome}" ] ; then
        showLog_error "${LINENO}" "The product installation directory cannot be the same as the product data directory."
        return 1
    fi
    echo "${g_productDataHome}" | grep "${g_productHome}" > /dev/null 2>&1
    if [ $? -eq 0 ] ; then 
        echo "${g_productDataHome:${#g_productHome}}" | grep "/" > /dev/null 2>&1
        if [ $? -eq 0 ] ; then
            showLog_error "${LINENO}" "The product data directory cannot be the subdirectory of the product installation directory."
            return 1
        fi
    fi
    #INSTALL_USERдsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "INSTALL_USER=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "INSTALL_USER=root" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "INSTALL_USER=omm"
    fi
    #װĿ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_HOME=${g_productHome}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_HOME=${g_productHome}"
    fi
    
    local -i retVal=0
    
    #Common workspaceĿ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_COMMON=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_COMMON=${g_bigdataCommon}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_COMMON=${g_bigdataCommon}"
    fi
    local -i retVal=0
    
    #CommonĿ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_COMMON_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_COMMON_HOME=${g_bigdataCommonHome}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_COMMON_HOME=${g_bigdataCommonHome}"
    fi
    local -i retVal=0
    
    
    # ȷƷװĿ¼-_0-9a-zA-Zַ
    isInvalid=$(echo "${g_productHome}" | grep [^-_0-9a-zA-Z/])
    if [ -n "${isInvalid}" ]; then
        showLog_error "${LINENO}" "Incorrect path. The product installation path can contain only uppercase and lower case letters, digits,hyphen (-) and underscores (_)."
        return 1
    fi
    
    # жϲƷװĿ¼Ƿ񳬳128
    if [ ${#g_productHome} -gt 128 ] ; then
        showLog_error "${LINENO}" "The length of ${g_productHome} directory beyond the maximum limit 128 characters."
        return 1
    fi

    # жϲƷװĿ¼ļϵͳǷΪnfs
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        if [ "$(df -T ${g_productHome} | awk 'END {print $2}')" = "nfs" ] ; then
            showLog_error "${LINENO}" "The file system of ${g_productHome} directory can not be nfs."
            return 1
        fi
    else
        sudo ${INSTALL_SUDO_PATH} validate_file_system "${g_productHome}"
      if [ $? -ne 0 ] ; then
          showLog_error "${LINENO}" "The file system of ${g_productHome} directory can not be nfs."
          return 1
      fi
    fi
    
    # òƷװĿ¼Ȩ, ʱҪĿ¼Ȩ
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
    exec_cmd add_path_permission "${g_productHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
       sudo ${INSTALL_SUDO_PATH} add_install_dir_permission "${g_productHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    fi
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
    exec_cmd chmod 770 "${g_productHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
       sudo ${INSTALL_SUDO_PATH} software_install_chmod "${g_productHome}" "${g_logFile}" || return ${INS_MODIG_AUTHORITY_FAILURE}
       sudo ${INSTALL_SUDO_PATH} software_dir_chown "${g_productHome}" "${GLOBAL_INSTALL_USER}" "${g_logFile}" || return ${INS_MODIG_AUTHORITY_FAILURE}
        fi
    fi

    # ȷƷĿ¼-_0-9a-zA-Zַ
    isInvalid=$(echo "${g_productDataHome}" | grep [^-_0-9a-zA-Z/])
    if [ -n "${isInvalid}" ]; then
        showLog_error "${LINENO}" "Incorrect path. The product data path can contain only uppercase and lower case letters, digits,hyphen (-) and underscores (_)."
        return 1
    fi
    
    # жϲƷݴŸĿ¼Ƿ񳬳128
    if [ ${#g_productDataHome} -gt 128 ] ; then
        showLog_error "${LINENO}" "The length of ${g_productDataHome} directory beyond the maximum limit 128 characters."
        return 1
    fi
    
    #Ŀ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_DATA_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_DATA_HOME=${g_productDataHome}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_DATA_HOME=${g_productDataHome}"
    fi
    # жϲƷݴŸĿ¼Ƿ
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        if [ ! -d "${g_productDataHome}" ] ; then
            showLog_error "${LINENO}" "The ${g_productDataHome} directory does not exist."
            return 1
        fi
    else
        sudo ${INSTALL_SUDO_PATH} validate_dir_exist "${g_productDataHome}"
        if [ $? -ne 0 ] ; then
            showLog_error "${LINENO}" "The ${g_productDataHome} directory does not exist."
            return 1
        fi
    fi
    # жϲƷݴŸĿ¼ļϵͳǷΪnfs
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        if [ $(df -T $g_productDataHome | awk 'END {print $2}') = "nfs" ] ; then
            showLog_error "${LINENO}" "The file system of ${g_productDataHome} directory can not be nfs."
            return 1
        fi
    else
        sudo ${INSTALL_SUDO_PATH} validate_file_system "${g_productDataHome}"
        if [ $? -ne 0 ] ; then
          showLog_error "${LINENO}" "The file system of ${g_productDataHome} directory can not be nfs."
          return 1
        fi
    fi
    #ʱظĿ¼Ȩ
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
    # òƷĿ¼Ȩ
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        exec_cmd add_path_permission "${g_productDataHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
       sudo ${INSTALL_SUDO_PATH} add_data_dir_permission "${g_productDataHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    fi
    
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            exec_cmd chmod 770 "${g_productDataHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
        else
           sudo ${INSTALL_SUDO_PATH} software_data_chmod "${g_productDataHome}" "${g_logFile}" || return ${INS_MODIG_AUTHORITY_FAILURE}
           sudo ${INSTALL_SUDO_PATH} software_data_chown "${g_productDataHome}" "${GLOBAL_INSTALL_USER}" || return ${INS_MODIG_AUTHORITY_FAILURE}
        fi
    fi
    
    #־Ŀ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_LOG_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_LOG_HOME=${g_logHome}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_LOG_HOME=${g_logHome}"
    fi
    # жϲƷ־Ŀ¼Ƿ
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        if [ ! -d "${g_logHome}" ] ; then
            showLog_error "${LINENO}" "The ${g_logHome} directory does not exist."
            return 1
        fi
    else
        sudo ${INSTALL_SUDO_PATH} validate_dir_exist "${g_logHome}"
        if [ $? -ne 0 ] ; then
            showLog_error "${LINENO}" "The ${g_logHome} directory does not exist."
            return 1
        fi
    fi
    # haģʽĺϷԣ²У鶼ha modeУ飨ͬģʽ
    # У鷽ʽͬˣha mode У鲻ֱͨӷ
    validate_ha_mode
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi

    # haֵĺϷ
    validate_ha_names
    retVal=$(expr ${retVal} + $?)

    # haipĺϷ
    validate_ha_ips
    retVal=$(expr ${retVal} + $?)

    # ha˫ģʽweb serviceĸipĺϷ
    if [ "${g_haMode}" = 'double' ] ; then
        validate_float_ip ws_float_ip
        retVal=$(expr ${retVal} + $?)
    fi

    # web serviceipĺϷ
    validate_netmask ws_float_ip_netmask
    retVal=$(expr ${retVal} + $?)

    # web serviceipĺϷ
    validate_float_ip_interface ws_float_ip_interface
    retVal=$(expr ${retVal} + $?)

    # wsGateway ipǷϷ
    if [ "${g_haMode}" = 'double' ] ; then
        if [  -z ${g_wsGateway} ] ; then
            showLog_error "${LINENO}" "The webService GateWay ip is empty."
            return 1;
        fi
    fi

    validate_GateWay ${g_wsGateway}
    retVal=$(expr ${retVal} + $?)

    validate_clsNodeNum ${g_clsNodeNum}
    retVal=$(expr ${retVal} + $?)
    
    # ha˫ģʽagentcontrollerĸipĺϷ
    if [ "${g_haMode}" = 'double' ] ; then
        validate_float_ip om_float_ip
        retVal=$(expr ${retVal} + $?)
    fi
    # 鸡ipĺϷ
    validate_interfate
    retVal=$(expr ${retVal} + $?)
    
    # agentcontrollerĸipĺϷ
    validate_netmask om_float_ip_netmask
    retVal=$(expr ${retVal} + $?)

    # agentcontrolleripĺϷ
    validate_float_ip_interface om_float_ip_interface
    retVal=$(expr ${retVal} + $?)

    # omGateway ipǷϷ
    validate_GateWay ${g_omGateway}
    retVal=$(expr ${retVal} + $?)

    # 鲻ͬĸipǷͬ
    if [ "${g_omFloatIP}" != "${g_wsFloatIP}" ] \
        && [ "${g_omFloatIPInterface}" = "${g_wsFloatIPInterface}" ]; then
        showLog_error "${LINENO}" "Different floatips(om and webServices) cannot be configured on the same interface."
        retVal=$(expr ${retVal} + 1)
    fi

    # ntp server ipĺϷ(ntp ipֶ֧ip,ÿip֮Զŷָ)
    local -a ntpArray=( $(echo "${g_ntpServerIP}" | tr "," " ") )
    local ntp_server_num=${#ntpArray[@]}
    if [ "${ntp_server_num}" -ge 4 ]; then
        showLog_error "${LINENO}" "The ntp server number($(expr $ntp_server_num - 1)) is more than 2."
        retVal=$(expr ${retVal} + 1)
    fi

    local tmpIP=""
    for tmpIP in "${ntpArray[@]}" ; do
        # ipǷ񲻷ip
        validate_ip "${tmpIP}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The ntp ip ${tmpIP} is incorrect."
            retVal=$(expr ${retVal} + 1)
        fi

        # ȷntp ipܵڸip
        if [ "${tmpIP}" = "${g_omFloatIP}" ] \
            || [ "${tmpIP}" = "${g_wsFloatIP}" ] ; then
            showLog_error "${LINENO}" "The ntp ip ${tmpIP} can not be same with the float ip(${g_omFloatIP} or ${g_wsFloatIP})."
            retVal=$(expr ${retVal} + 1)
        fi
    done

    # mediator ipǷϷ
    if [ -n "${g_mediatorIP}" ] ; then
        validate_ip "${g_mediatorIP}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The mediator ip ${g_mediatorIP} is incorrect."
            retVal=$(expr ${retVal} + 1)
        fi
        ping -c 5 -w 10 "${g_mediatorIP}" >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ]; then
            log_warn "${LINENO}" "The mediator ip ${g_mediatorIP} is incorrect."
        fi
    else  
        g_mediatorIP=${g_wsGateway}
    fi
    
    if [ -n "${g_ssoip}" ]; then
        validate_ip "${g_ssoip}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The sso_ip ${g_ssoip} is incorrect."
            retVal=$(expr ${retVal} + 1)
        fi
    fi
    
    if [ -n "${g_ssoport}" ]; then
        validate_port "${g_ssoport}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The sso_port ${g_ssoport} is incorrect."
            retVal=$(expr ${retVal} + 1)
        fi
    fi

    #жg_realmParseIpǷϷ
    if [ -n "${g_realmParseIp}" ]; then
        validate_ip "${g_realmParseIp}"
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "The realmParseIp ${g_realmParseIp} is incorrect."
            retVal=$(expr ${retVal} + 1)
        fi
        ping -c 1 "${g_realmParseIp}" >> "${g_logFile}" 2>&1
        if [ $? -eq 0 ]; then
            log_warn "${LINENO}" "The realmParseIp ${g_realmParseIp} is reachable."
        fi
    fi

    #У־ռ
    number_match ${g_log_archive_time}
    retVal=$(expr ${retVal} + $?)

    return ${retVal}
}

################################################################################
# Function: is_controller_installed
# Description: жcontrollerǷѾװ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
is_controller_installed()
{
    if [ -f "${omm_profile}" ] ; then
        source ${omm_profile}
        # controllerжؽűʾcontrollerѾװʾûжؽűȥж
        local uninstallCmd="${CONTROLLER_HOME}/inst/uninstall.sh"
        if [ -f "${uninstallCmd}" ] ; then
            if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
                chmod +x "${uninstallCmd}"
            else
               sudo ${INSTALL_SUDO_PATH} uninstall_script_executive_chmod "${uninstallCmd}"
            fi
            showLog_error "${LINENO}" "The OMS has been installed on the host."
            showLog_error "${LINENO}" "To reinstall the OMS, uninstall the original OMS first."
            exit 1
        fi
    fi

    return ${INS_SUCCESS}
}

################################################################################
# Function: set_default_config
# Description: װĸУĳЩûãĬֵ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
set_default_config()
{
    log_info "${LINENO}" "Start to set default installation parameters."
    local -i MAX_NTP_NUM=4
    
    # ûдƷİװĿ¼Ĭֵ(/opt/huawei/Bigdata)Ŀ¼

    if [ -z "${g_productHome}" ] ; then
        g_productHome=${HADOOP_HOME}
        
        #INSTALL_USERдsudoűļ
        if [ $(id -u) -eq 0 ] ; then
            grep "INSTALL_USER=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
            if [ $? -ne 0 ] ; then
                echo "INSTALL_USER=root" >> ${g_sudo_profile}
            fi
        else
            sudo ${INSTALL_SUDO_PATH} write_sudo_profile "INSTALL_USER=omm"
        fi
        #װĿ¼дsudoűļ
        if [ $(id -u) -eq 0 ] ; then
            grep "BIGDATA_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
            if [ $? -ne 0 ] ; then
                echo "BIGDATA_HOME=${g_productHome}" >> ${g_sudo_profile}
            fi
        else
            sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_HOME=${g_productHome}"
        fi
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            exec_cmd mkdir -p "${g_productHome}"
        else
            sudo ${INSTALL_SUDO_PATH} software_install_mkdir "${g_productHome}" "${g_logFile}"
        fi
    fi
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the product installation home."
        return ${INS_MKDIR_FAILURE}
    fi

    g_omServerWorkspace="${g_productHome}/${OM_SERVER_HOME_NAME}"
    g_bigdataCommon="${g_productHome}/${COMMON_HOME_NAME}/${COMMON_WORKSPACE_NAME}"
    g_bigdataCommonHome="${g_productHome}/${COMMON_HOME_NAME}"
    
    # ûдƷݴŸĿ¼Ĭֵ(/srv/BigData)Ŀ¼
    if [ -z "${g_productDataHome}" ] ; then
        g_productDataHome=${HADOOP_DATA_HOME}
        
        #Ŀ¼дsudoűļ
        if [ $(id -u) -eq 0 ] ; then
            grep "BIGDATA_DATA_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
            if [ $? -ne 0 ] ; then
                echo "BIGDATA_DATA_HOME=${g_productDataHome}" >> ${g_sudo_profile}
            fi
        else
            sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_DATA_HOME=${g_productDataHome}"
        fi
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            exec_cmd mkdir -p "${g_productDataHome}"
        else
            sudo ${INSTALL_SUDO_PATH} software_data_mkdir "${g_productDataHome}" "${g_logFile}"
        fi
    fi
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the product data home."
        return ${INS_MKDIR_FAILURE}
    fi

    # ûдƷ־ŸĿ¼Ĭֵ(/var/log/Bigdata)ĬĿ¼
    g_logHome="${g_logHome:-${HADOOP_LOG_HOME}}"
    
    #־Ŀ¼дsudoűļ
    if [ $(id -u) -eq 0 ] ; then
        grep "BIGDATA_LOG_HOME=*" ${g_sudo_profile} >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
            echo "BIGDATA_LOG_HOME=${g_logHome}" >> ${g_sudo_profile}
        fi
    else
        sudo ${INSTALL_SUDO_PATH} write_sudo_profile "BIGDATA_LOG_HOME=${g_logHome}"
    fi
    if [ "$g_operatorType" != $UPGRADE_OPERATOR ]; then
        if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
            exec_cmd rm -rf "${g_logHome}"
        else
            sudo ${INSTALL_SUDO_PATH} software_log_rm "${g_logHome}" "${g_logFile}"
        fi
    fi
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        exec_cmd mkdir -p "${g_logHome}"
    else
       sudo ${INSTALL_SUDO_PATH} software_log_mkdir "${g_logHome}"
    fi
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the product log home."
        return ${INS_MKDIR_FAILURE}
    fi
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        exec_cmd add_path_permission "${g_logHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
        sudo ${INSTALL_SUDO_PATH} add_log_dir_permission "${g_logHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    fi
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        exec_cmd chmod 770 "${g_logHome}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
       sudo ${INSTALL_SUDO_PATH} software_log_chmod "${g_logHome}" "${g_logFile}" || return ${INS_MODIG_AUTHORITY_FAILURE}
    fi
    g_haMode=${g_haMode:-"double"}
    g_server1Name=${g_server1Name:-"$(hostname)"}
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to execute the hostname command, and please check the system configuration."
        return 1
    fi

    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        g_server1IP1=${g_server1IP1:-"$(hostname -i 2>> "${g_logFile}")"}
    else
        g_server1IP1=${g_server1IP1:-"$(sudo ${INSTALL_SUDO_PATH} get_localip)"}
    fi
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to execute the hostname -i command, and please deploy the /etc/hosts system file correctly."
        return 1
    fi

    # hostname -i Ψһʧ
    g_server1IP2_count=$(echo $g_server1IP1 | awk '{print $2}' | wc -w)
    if [ $g_server1IP2_count -gt 0 ] ; then
        showLog_error "${LINENO}" "Host names must correspond to IP addresses. Check whether hostname -i is unique."
        return 1
    fi

    # ipΪʱ
    if [ -z "${g_wsFloatIP}" ] && [ -z "${g_omFloatIP}" ]; then
        # ˫ģʽ򱨴˫ģʽʱipΪ
        if [ "${g_haMode}" = 'double' ]; then
            showLog_error "${LINENO}" "At least one float ip should be input in double mode."
            return 1
        fi

        # ǵģʽѱ˵ipΪip
        g_wsFloatIP=${g_server1IP1};
        g_omFloatIP=${g_server1IP1};

    # ipͬʱΪʱΪյĸipȡΪյĸipΪĬֵ
    else
        g_wsFloatIP=${g_wsFloatIP:-"${g_omFloatIP}"}
        g_omFloatIP=${g_omFloatIP:-"${g_wsFloatIP}"}
    fi

    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        local defaultInterface=$(ip addr | grep ${g_server1IP1} | awk -F ' ' '{print $NF}')
    else
        local defaultInterface=$(sudo ${INSTALL_SUDO_PATH} get_interface ${g_server1IP1})
    fi
    g_wsFloatIPInterface=${g_wsFloatIPInterface:-"${defaultInterface}"}
    g_wsFloatIPNetmask=${g_wsFloatIPNetmask:-"255.255.255.0"}
    g_omFloatIPNetmask=${g_omFloatIPNetmask:-"${g_wsFloatIPNetmask}"}
    g_omFloatIPInterface=${g_omFloatIPInterface:-"${g_wsFloatIPInterface}"}

    g_ntpServerIP="$(echo "${g_ntpServerIP}" | sed "s/[[:space:]]//g")"
    local -a ntpIPs=( $(echo "${g_ntpServerIP}" | sed 's/,/ /g') )
    local -i ntpIPsNum=${#ntpIPs[@]}
    if [ $ntpIPsNum -gt $MAX_NTP_NUM ]; then
        showLog_error "${LINENO}" "The ntp_server_ip number must be less or equal than $MAX_NTP_NUM."
        return 1
    fi

    if [ -z "$g_ntpServerIP" ]; then
        g_ntpServerIP="127.127.1.0"
    else
        g_ntpServerIP=${g_ntpServerIP}',127.127.1.0'
    fi

    if [ -z "${g_realmParseIp}" ]; then
        g_realmParseIp="10.10.10.10"
    else
        g_realmParseIp=${g_realmParseIp}
    fi

    log_info "${LINENO}" "Succeed to set default installation parameters."

    return 0
}

################################################################################
# Function: get_config_param
# Description: ļлȡò
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_config_param()
{
    log_info "${LINENO}" "Start to get installation parameters from config file."
    if [ ! -f "${CONFIG_FILE}" ] ; then
        showLog_error "${LINENO}" "The ${CONFIG_FILE} file does not exist."
        return ${INS_FILE_NOT_EXIST}
    fi

    g_haMode=$(get_key_value HA ha_mode ${CONFIG_FILE}) || return $?

    g_server1IP1=$(get_key_value HA local_ip1 ${CONFIG_FILE}) || return $?
    g_server1IP2=$(get_key_value HA local_ip2 ${CONFIG_FILE}) || return $?
    g_server1IP3=$(get_key_value HA local_ip3 ${CONFIG_FILE}) || return $?
    g_server1IP4=$(get_key_value HA local_ip4 ${CONFIG_FILE}) || return $?
    g_server1Name=${g_server1IP1//./-}

    g_server2IP1=$(get_key_value HA peer_ip1 ${CONFIG_FILE}) || return $?
    g_server2IP2=$(get_key_value HA peer_ip2 ${CONFIG_FILE}) || return $?
    g_server2IP3=$(get_key_value HA peer_ip3 ${CONFIG_FILE}) || return $?
    g_server2IP4=$(get_key_value HA peer_ip4 ${CONFIG_FILE}) || return $?
    g_server2Name=${g_server2IP1//./-}

    g_wsFloatIPInterface=$(get_key_value HA ws_float_ip_interface ${CONFIG_FILE}) || return $?
    g_wsFloatIP=$(get_key_value HA ws_float_ip ${CONFIG_FILE}) || return $?
    g_wsFloatIPNetmask=$(get_key_value HA ws_float_ip_netmask ${CONFIG_FILE}) || return $?
    g_wsGateway=$(get_key_value HA ws_gateway ${CONFIG_FILE}) || return $?
    g_omFloatIPInterface=$(get_key_value HA om_float_ip_interface ${CONFIG_FILE}) || return $?
    g_omFloatIP=$(get_key_value HA om_float_ip ${CONFIG_FILE}) || return $?
    g_omFloatIPNetmask=$(get_key_value HA om_float_ip_netmask ${CONFIG_FILE}) || return $?
    g_omGateway=$(get_key_value HA om_gateway ${CONFIG_FILE}) || return $?
    g_ntpServerIP=$(get_key_value HA ntp_server_ip ${CONFIG_FILE}) || return $?
    g_mediatorIP=$(get_key_value HA om_mediator_ip ${CONFIG_FILE}) || return $?
    g_ssoip=$(get_key_value HA sso_ip ${CONFIG_FILE}) || return $?
    g_ssoport=$(get_key_value HA sso_port ${CONFIG_FILE}) || return $?
    g_productHome=$(get_key_value HA bigdata_home ${CONFIG_FILE}) || return $?
    g_clsNodeNum=$(get_key_value HA cluster_nodes_scale ${CONFIG_FILE}) || return $?
    while [ "${g_productHome:((${#g_productHome} - 1))}" = "/" ] ; do
        g_productHome=${g_productHome%/*}
    done
    g_productDataHome=$(get_key_value HA bigdata_data_home ${CONFIG_FILE}) || return $?
    while [ "${g_productDataHome:((${#g_productDataHome} - 1))}" = "/" ] ; do
        g_productDataHome=${g_productDataHome%/*}
    done
    
    g_tls_protocol_min=$(get_key_value HA tls_protocol_min ${CONFIG_FILE}) || return $?
    g_realmParseIp=$(get_key_value HA realm_parse_ip ${CONFIG_FILE}) || return $?
    g_kerberos_realm=$(get_key_value HA kerberos_realm ${CONFIG_FILE}) || return $?
    g_log_archive_time="21600"
    log_info "${LINENO}" "Succeed to get installation parameters from config file."
    return 0
}

################################################################################
# Function: save_input_param
# Description: 浽oms-config.iniļֱ浽globalParam.iniļ
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
save_input_param()
{
    log_info "${LINENO}" "Start to save installation parameters."
    # ²浽oms-config.iniļ
    echo "[HA]" > ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ha_mode=${g_haMode}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server1_name=${g_server1Name}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server1_ip1=${g_server1IP1}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server1_ip2=${g_server1IP2}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server1_ip3=${g_server1IP3}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server1_ip4=${g_server1IP4}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}

    echo "server2_name=${g_server2Name}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server2_ip1=${g_server2IP1}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server2_ip2=${g_server2IP2}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server2_ip3=${g_server2IP3}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "server2_ip4=${g_server2IP4}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}

    echo "ws_float_ip_interface=${g_wsFloatIPInterface}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ws_float_ip=${g_wsFloatIP}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ws_float_ip_netmask=${g_wsFloatIPNetmask}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ws_gateway=${g_wsGateway}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}

    echo "om_float_ip_interface=${g_omFloatIPInterface}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "om_float_ip=${g_omFloatIP}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "om_float_ip_netmask=${g_omFloatIPNetmask}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "om_gateway=${g_omGateway}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "sso_ip=${g_ssoip}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "sso_port=${g_ssoport}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ntp_server_ip=${g_ntpServerIP}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "log_archive_time=${g_log_archive_time}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "mediator_ip=${g_mediatorIP}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "ha_net_timeout=20" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    
    #ȡtlsãΪupgrade
    if [ "${g_operatorType}" = "$UPGRADE_OPERATOR" -a "${g_tls_protocol_min}" = "" ];then
        g_tls_protocol_min="upgrade"
    fi
    
    echo "tls_protocol_min=${g_tls_protocol_min}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "realmParseIp=${g_realmParseIp}" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "[/HA]" >> ${CONFIG_FILE} || return ${INS_WRITE_FILE_FAILURE}

    # ²浽globalParam.iniļ,ͨļѱֵݸshell
    # GLOBAL_PARAM_FILEǸshellĻ
    echo "g_productHome=${g_productHome}" > ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_productDataHome=${g_productDataHome}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_logHome=${g_logHome}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_ntpServerIP=${g_ntpServerIP}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_omFloatIP=${g_omFloatIP}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_operatorType=${g_operatorType}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_installFile=${g_installFile}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_clsNodeNum=${g_clsNodeNum}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_realmParseIp=${g_realmParseIp}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_kerberos_realm=${g_kerberos_realm}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}

    log_info "${LINENO}" "Succeed to save installation parameters ."
    return 0
}

################################################################################
# Function: parse_input
# Description: װ
# Parameter:
#   input:
#   print_usageﶨĲ
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
parse_input()
{
    # ûʾʽ
    if [ $# -eq 0 ]; then
        print_usage
        return 1
    fi
    log_info "${LINENO}" "Start to parse installation parameters."
    # ǰװǷ-i  -o 
    local -i opti=0
    local -i opto=0
    while getopts "m:h:i:o:t:f:g:p:d:l:U:I:P:T:R:k:n:c" option; do
        case ${option} in
            m)
                g_haMode=${OPTARG}
                ;;
            h)
                local tmp=$(echo ${OPTARG} | awk -F ":" '{print $1}')
                eval $(echo ${tmp} | awk -F "," '{printf "g_server1IP1=%s;g_server1IP2=%s;g_server1IP3=%s;g_server1IP4=%s;",$1,$2,$3,$4}')
                g_server1Name=${g_server1IP1//./-}

                tmp=$(echo ${OPTARG} | awk -F ":" '{print $2}')
                eval $(echo ${tmp} | awk -F "," '{printf "g_server2IP1=%s;g_server2IP2=%s;g_server2IP3=%s;g_server2IP4=%s;",$1,$2,$3,$4}')
                g_server2Name=${g_server2IP1//./-}
                ;;
            o)
                eval $(echo ${OPTARG} | awk -F "," '{printf "g_wsFloatIPInterface=%s;g_wsFloatIP=%s;g_wsFloatIPNetmask=%s;g_wsGateway=%s",$1,$2,$3,$4}')
                ;;
            i)
                eval $(echo ${OPTARG} | awk -F "," '{printf "g_omFloatIPInterface=%s;g_omFloatIP=%s;g_omFloatIPNetmask=%s;g_omGateway=%s",$1,$2,$3,$4}')
                ;;
            t)
                g_ntpServerIP=${OPTARG}
                ;;
            g)
                g_mediatorIP=${OPTARG}
                ;;
            f)
                if [ -f "${OPTARG}" ]; then
                    g_installFile=${OPTARG}
                    cat "${OPTARG}" > "${CONFIG_FILE}"
                    # ļлȡװò
                    get_config_param
                elif [ -f "${INSTALLSH_PATH}/${OPTARG}" ]; then
                    g_installFile="${INSTALLSH_PATH}/${OPTARG}"
                    cat "${g_installFile}" > "${CONFIG_FILE}"
                    # ļлȡװò
                    get_config_param
                else
                    showLog_error "${LINENO}" "The ${OPTARG} file does not exist."
                    return 1
                fi
                ;;
            p)
                g_productHome="${OPTARG}"
                while [ "${g_productHome:((${#g_productHome} - 1))}" = "/" ] ; do
                    g_productHome=${g_productHome%/*}
                done
                ;;
            d)
                g_productDataHome="${OPTARG}"
                while [ "${g_productDataHome:((${#g_productDataHome} - 1))}" = "/" ] ; do
                    g_productDataHome=${g_productDataHome%/*}
                done
                ;;
            l)
                g_logHome="${OPTARG}"
                ;;
            U)
                g_operatorType="${OPTARG}"
                ;;
            c)
                g_combination="NOTNULL"
                ;;
            I)
                g_ssoip="${OPTARG}"
                ;;
            P)
                g_ssoport="${OPTARG}"
                ;;
            T)
                g_tls_protocol_min="${OPTARG}"
                ;;
            R)  
                g_realmParseIp="${OPTARG}"
                ;;
            k)  
                g_kerberos_realm="${OPTARG}"
                ;;
            n)
                g_clsNodeNum="${OPTARG}"
                ;;
            ?)
                print_usage
                return 1
                ;;
            :)
                print_usage
                return 1
                ;;
            *)
                print_usage
                return 1
                ;;
        esac
    done
    log_info "${LINENO}" "Finish to parse installation parameters."
    return $?
}

################################################################################
# Function: get_userConfig_param
# Description: userid.iniļлȡò
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_userConfig_param()
{
    local userConfigFile=${PWD%/*/*}/${CONFIG_FILE_USERID}
    if [ ! -f "${userConfigFile}" ] ; then
        showLog_error "${LINENO}" "The ${userConfigFile} file does not exist."
        return ${INS_FILE_NOT_EXIST}
    fi

    g_ommid=`cat ${userConfigFile} | grep "ommid" | awk -F '=' '{print $2}' | sed "s/^[[:space:]]*//g;s/[[:space:]]*$//g"`
    g_ommdbaid=`cat ${userConfigFile} | grep "ommdbaid" | awk -F '=' '{print $2}' | sed "s/^[[:space:]]*//g;s/[[:space:]]*$//g"`

    # ²浽${GLOBAL_PARAM_FILE}ļ,ͨļѱֵݸshell
    # GLOBAL_PARAM_FILEǸshellĻ
    echo "g_ommid=${g_ommid}" >>  ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    echo "g_ommdbaid=${g_ommdbaid}" >> ${GLOBAL_PARAM_FILE} || return ${INS_WRITE_FILE_FAILURE}
    return 0
}


getOsType()
{
    BUILD_OS_VERSION="OTHER_NOT_SUPPORT_OS"

    if [ -f "/etc/SuSE-release" ]; then
        BUILD_OS_VERSION="${SUSE_OS_TYPE}"
    fi
    
    if [ -f "/etc/redhat-release" ];then
        BUILD_OS_VERSION="${RED_HAT_OS_TYPE}"
    fi

    if [ -f "/etc/os-release" ]; then
        if [ "suse" = "$(cat "/etc/os-release" | grep "^ID_LIKE=" | awk -F "\"" '{print $2}')" ]; then
            version="$(cat "/etc/os-release" | grep "^VERSION_ID=" | awk -F "\"" '{print $2}')"
            bVersion="$(echo "${version}" | awk -F "." '{print $1}')"
            if [ "15" = "${bVersion}" ];then
                BUILD_OS_VERSION="${SUSE15_OS_TYPE}"
            fi            
        fi
    fi

    echo "${BUILD_OS_VERSION}"
}

validateInputTLS()
{
    local protocol_min=0
    local tls_protocol_min="${1}"
    
    if [ "${tls_protocol_min}" = "upgrade" ];then
        return 0
    fi

    if [ "${tls_protocol_min}" = "sslv3" ];then
        protocol_min=0
    elif [ "${tls_protocol_min}" = "tlsv1.0" ];then
        protocol_min=1
    elif [ "${tls_protocol_min}" = "tlsv1.1" ];then
        protocol_min=2
    elif [ "${tls_protocol_min}" = "tlsv1.2" ];then
        protocol_min=3
    elif [ -z "${tls_protocol_min}" ]; then
    
        if [ ${os_support_min} -eq 0 ] ;then
            g_tls_protocol_min="sslv3"
        elif [ ${os_support_min} -eq 1 ] ;then 
            g_tls_protocol_min="tlsv1.0"
        else
            g_tls_protocol_min="tlsv1.1"
        fi
      
        return 0
    else
        return 1
    fi
    
    if [ ${protocol_min} -le ${os_support_min} ]; then
        os_support_min=${protocol_min}
        return 0
    else
        showLog_error "${LINENO}" "Configuration tls_protocol_min=${tls_protocol_min} is not supported."
        return 1
    fi
}

getSSLSwitch()
{
    os_support_min=0
   
    local ldapversion=$(${g_slapd_run_command} -VV 2>&1 | grep "OpenLDAP: slapd" | tr -cd "[0-9 .]" | awk '{print $1}' | sed -e "s/ //g")
    
    version_compare "${ldapversion}" "2.4.39"  
    local check_re_1=$?
    
    version_compare "${ldapversion}" "2.4.40"
    local check_re_2=$?
    
    local ssl_bin="/usr/bin/openssl"
    local sslversion=$(${ssl_bin} version 2>&1 | grep "OpenSSL" | tr -cd "[0-9 .]" | awk '{print $1}' | sed -e "s/ //g")
    version_compare "${sslversion}" "1.0.1"
    local check_re_3=$?

    if [ "${check_re_1}" -eq "${version_err}" -o "${check_re_2}" -eq "${version_err}" ];then
        showLog_error "${LINENO}"  "Detect openldap version failed. Please ensure openldap has been installed correctly."
        return
    else
        if [ "${check_re_2}" -le "${version_eq}" ];then
            if [ "${check_re_3}" -eq "${version_err}" ];then
                showLog_error "${LINENO}"  "Detect openssl version failed. Please ensure openssl has been installed correctly."
            else
                if [ "${check_re_3}" -le "${version_eq}" ];then
                    os_support_min=2
                    return
                fi
            fi
        elif [ "${check_re_1}" -le "${version_eq}" ];then
            os_support_min=1            
        fi
    fi
}

version_compare()
{
    version_eq=1
    version_err=3
    if [ $# -ne 2 ]; then
        echo "version_compare need two parameter"
        return 3
    fi
    old_version=$( echo "$1" | sed -e "s/ //g")
    new_version=$( echo "$2" | sed -e "s/ //g")
    if [ "${old_version}" != "" ] && [ "${new_version}" != "" ]; then
        old_version_array=( $(echo "${old_version}" | cut -d "." --output-delimiter=" " -f 1-) )
        new_version_array=( $(echo "${new_version}" | cut -d "." --output-delimiter=" " -f 1-) )
        old_version_array_length=${#old_version_array[@]}
        new_version_array_length=${#new_version_array[@]}

        length=$((${new_version_array_length}>${old_version_array_length}?${old_version_array_length}:${new_version_array_length}))
        index=0
        eq_tag=3
        while [ $index -lt "${length}" ]
        do
            v1=${old_version_array[$index]}
            v2=${new_version_array[$index]}
            if [ "${v1}" -lt "${v2}" ]; then
                return 2
            elif [ "${v1}" -gt "${v2}" ] ; then
                return 0
            elif [ "${v1}" -eq "${v2}" ] ; then
                eq_tag=1
                let index+=1
                continue
            else
                return 3
            fi
        done
        return ${eq_tag}
    else
        echo "parameters can not be null" 
        return 3
    fi
}

################################################################################
# Function: main
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
main()
{
    umask 027

    retVal=0
       
    # ȡ
    parse_input "$@"
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi
    
    g_os_type="$(getOsType)"
    if [ "${g_os_type}" == "${RED_HAT_OS_TYPE}" ];then
        g_slapd_run_command="/usr/sbin/slapd"
    elif [ "${g_os_type}" == "${SUSE15_OS_TYPE}" ];then
        g_slapd_run_command="/usr/sbin/slapd"
    else
        g_slapd_run_command="/usr/lib/openldap/slapd"
    fi
    
    #жtls_protocol_minǷϷ
    getSSLSwitch    
    validateInputTLS "${g_tls_protocol_min}"
    if [ $? -ne 0 ];then
        showLog_error "${LINENO}"  "Invalid param tls_protocol_min=${g_tls_protocol_min}."
        return ${INS_INVALID_TLS_PROTOCOl_MIN}
    fi
    
    # жcontrollerǷѾװ
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        is_controller_installed
        if [ $? -ne 0 ] ; then
            return 1
        fi
    fi
    
    # sudoűҪõĻļ
    if [ $(id -u) -eq 0 ] ; then        
        mkdir -p /etc/profile.d
        rm -rf ${g_sudo_profile}
        touch ${g_sudo_profile}
    else
        sudo ${INSTALL_SUDO_PATH} re_create_sudo_profile
    fi
    # װĸУĳЩûãĬֵ
    set_default_config
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to set the default value of input parameters."
        return ${retVal}
    fi

    # УЧ
    validate_input
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi

    # ļ
    save_input_param
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi

    # ȡuserid.iniеĲ浽GLOBAL_PARAM_FILEйű
    get_userConfig_param
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi

    return 0
}

# ---------------------------------------------------------------------------- #
#                                 ȡǰ·                                 #
# ---------------------------------------------------------------------------- #
get_cur_path
cd "${g_curPath}"

# ---------------------------------------------------------------------------- #
#                                 ʼ־ļ                               #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/func/log.sh" || { echo "[${g_scriptName}:${LINENO}] ERROR: Failed to load ${g_curPath}/func/log.sh."; exit 1;}

# ---------------------------------------------------------------------------- #
#                                   ͷļ                                 #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/func/constants.sh" || { log_error "${LINENO}" "Failed to load ${g_curPath}/func/constants.sh."; exit 1; }
. "${g_curPath}/func/functions.sh" || { log_error "${LINENO}" "Failed to load ${g_curPath}/func/functions.sh."; exit 1; }

# ---------------------------------------------------------------------------- #
#                                 űʼ                                 #
# ---------------------------------------------------------------------------- #
main "$@"
