#!/bin/bash

declare g_curPath=""

getCurPath() {
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="$(pwd)"
    cd - >/dev/null
}

function permissionSet() {
    find $BIGDATA_HOME -maxdepth 1 -type d -name "FusionInsight_*" | xargs -I{} chown omm:ficommon -R "{}"
    chmod 755 $BIGDATA_HOME/components
}

main() {
    showLog_info "${LINENO}" "Start executing postinstall."
    permissionSet
    showLog_info "${LINENO}" "Execute postinstall end."
}

# 判断是否为 root 用户
if [ "$(whoami)" != "root" ]; then
    echo "Only root user can execute this script."
    exit 1
fi

getCurPath
. "${g_curPath}/../../func/log.sh" || {
    echo "Failed to load log.sh."
    exit 1
}
. "/etc/profile.d/sudoProfile.sh" || {
    echo "Failed to load sudoProfile.sh."
    exit 1
}

main
