#!/bin/bash

################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    cancel heartbeat check
## Description:
################################################################################
function getCurPath() {
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="$(pwd)"
    cd - >/dev/null
}


# 取消心跳檢查
function main()
{
    showLog_info "${LINENO}" "Cancel heartbeat check settings."
    local controller_propties="${CONTROLLER_HOME}/etc/om/controller.properties"
    local om_heartbeat_check=$(grep -w "controller.node.heartbeat.check.enable" "${controller_propties}" | grep -v "^#")
    local om_heartbeat_check_new="controller.node.heartbeat.check.enable=false"

    sed -i "s#${om_heartbeat_check}#${om_heartbeat_check_new}#g" "${controller_propties}"
    if [ $? -ne 0 ]; then
        echo "Change RPC encrypt mode failed."
        return 1
    fi

    ${CONTROLLER_HOME}/sbin/restart-controller.sh
}

if [ "$(whoami)" != "omm" ]; then
    echo "Only omm user can execute this script."
    exit 1;
fi
source $HOME/.profile >/dev/null 2>&1

getCurPath
# ---------------------------------------------------------------------------- #
#                                 导入头文件                                     #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/../func/functions.sh" || {
    echo "Failed to load functions.sh."
    exit 1
}
. "${g_curPath}/../func/log.sh" || {
    echo "Failed to load log.sh."
    exit 1
}
. "${g_curPath}/../func/constants.sh" || {
    echo "Failed to load constants.sh."
    exit 1
}

main "$@"
