#!/bin/bash

# ----------------------------------------------------------------------------- #
#                                                                       #
# ----------------------------------------------------------------------------- #
declare g_localFile=""    #ϵͳLOCALļ
declare g_currentPath=""    #ǰűھ·
declare PATCH_VERSION="6.5.1.6"    #ÿβ޸Ҫ޸İ汾
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"   #ļݵַ
declare g_updateElectronicTagScrpit="/usr/local/HDExclusiveMachine/updateElectronicTag.sh"    #ִнűȫ·
declare g_productNameFusionInsight="FusionInsight"    #HDһ



######################################################################
#   DESCRIPTION: ȡϵͳLOCALļ
######################################################################
function get_localFile()
{
    #Red Hat汾
    if [ -f "/etc/redhat-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #redhatlocalĿ¼
        return 0
    fi

    #SuSE汾
    if [ -f "/etc/SuSE-release" ]; then
        g_localFile="/etc/rc.d/after.local" #suselocalĿ¼
        return 0
    fi

    #CentOS汾
    if [ -f "/etc/centos-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #CentOSlocalĿ¼
        return 0
    fi

    #EulerOS汾
    if [ -f "/etc/euleros-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #EulerOSlocalĿ¼
        return 0
    fi

    #ʶ汾
    log_and_show "ERROR" "${LINENO}" "The os version does not match."
    return 1
}

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        log_and_show "ERROR" "${LINENO}" "current path is null."
        return 1
    fi

    g_currentPath=$(dirname "$path")

    if [ -z "$g_currentPath" ]; then
        log_and_show "ERROR" "${LINENO}" "Init parameter g_currentPath failed."
        return 1
    fi

    return 0
}

###################################################
#
# ·֮ǰȽбݲ
#
###################################################
backup_osFile()
{
    log_and_show "INFO" "${LINENO}" "start backup osFile."
    if [ ! -d "${BACKUP_HOME}" ]; then
        mkdir -p "${BACKUP_HOME}"
    elif [ -f "${BACKUP_HOME}/rc.local" ] || [ -f "${BACKUP_HOME}/after.local" ]; then
        log_and_show "INFO" "${LINENO}" "${BACKUP_HOME}/*.local exist, skip backup file."
        return 0
    fi

    if [ -f "${g_localFile}" ]; then
        cp -rf "${g_localFile}" "${BACKUP_HOME}"
        log_and_show "INFO" "${LINENO}" "copy the osFile to ${BACKUP_HOME} finished."
        return $?
    fi

    return 0
}

################################################################################
# Function: m_copy_scrpitToLocal
# Description: copy updateElectronicTag scrpit to /usr/local/
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_copy_scrpitToLocal()
{
    local copyScrpit="${g_currentPath}/common/updateElectronicTag.sh"

    if [ ! -f "${copyScrpit}" ]; then
        log_and_show "ERROR" "${LINENO}" "copy source scrpit does not exist."
        return 1
    fi

    #ű޸Ȩ
    mkdir -p /usr/local/HDExclusiveMachine/
    cp "${copyScrpit}" /usr/local/HDExclusiveMachine/ -f
    chmod 755 /usr/local/HDExclusiveMachine/ -R

    #תʽִ
    hash dos2unix > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        find /usr/local/HDExclusiveMachine/ -maxdepth 5 -mindepth 1 -type f -name "*" | while read line
        do
            dos2unix "$line" > /dev/null 2>&1
        done
    fi

    chown 0:0 /usr/local/HDExclusiveMachine -R
    return $?
}

################################################################################
# Function: m_writeToOsLocalFile
# Description: write the path name of updateElectronicTag.sh to the OsLocalFile
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_writeToOsLocalFile()
{
    backup_osFile
    if [ $? -ne 0 ]; then
        log_and_show "ERROR" "${LINENO}" "backup osFile failed,exit."
        return 1
    fi

    echo "/bin/bash ${g_updateElectronicTagScrpit}" >> "${g_localFile}"
    chmod 755 "${g_localFile}"

    return 0
}



main()
{
    local ipmiName=""
    local fusionInsightApplianceConfig="/etc/fusionInsightAppliance"

    #init path constants
    get_path
    if [ $? -ne 0 ]; then
        return 1
    fi

    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_currentPath}/common/log.sh"

    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       return 1
    fi

    log_and_show "INFO" "${LINENO}" "Start to write the path name of updateElectronicTag.sh to the OsLocalFile."

    #HDһĳֱ˳
    ipmiName=$(ipmitool fru print 0 |grep "Product Name" |awk -F ':' '{print$2}'|sed -e "s/^[ ]*//g" 2>/dev/null);
    if [ "${g_productNameFusionInsight}" != "${ipmiName}" ]; then
        log_and_show "INFO" "${LINENO}" "Non-exclusive machine environment,do not need to write the path to the osFile,skipped."
        return 0
    fi

    #/usr/local/HDExclusiveMachine/Ŀ¼ִнűڣӲиִнűĿ¼
    if [ ! -f "${g_updateElectronicTagScrpit}" ]; then
        #ִнű/usr/local/HDExclusiveMachineĿ¼
        m_copy_scrpitToLocal
        #Ƴɹ󣬽ִнűȫ·д뵽ϵͳlocalļݲͬϵͳ
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "copy the updateElectronicTag.sh to the os local directory failed."
            return 1
        fi

        #ȡϵͳlocalļ
        get_localFile
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "get the local file failed."
            return 1
        fi

        #ִ·/usr/local/HDExclusiveMachine/updateElectronicTag.sh׷ӵrc.localafter.localļ
        m_writeToOsLocalFile
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "write the path name of updateElectronicTag.sh to the OsLocalFile failed."
            return 1
        fi

        #дɹҪִһupdateElectronicTag.sh
        if [ ! -f "${fusionInsightApplianceConfig}" ]; then
            log_and_show "INFO" "${LINENO}" "start to execute updateElectronicTag.sh."

            sh "${g_updateElectronicTagScrpit}" >/dev/null 2>&1

            if [ $? -ne 0 ]; then
                log_and_show "ERROR" "${LINENO}" "execute updateElectronicTag.sh failed."
                return 1
            fi

            log_and_show "INFO" "${LINENO}" "finish to execute updateElectronicTag.sh."
        fi
    fi

    log_and_show "INFO" "${LINENO}" "finish to write the path name of updateElectronicTag.sh to the OsLocalFile."
    return 0
}

main
exit $?
