#!/bin/bash
declare g_rootPath=""
declare g_bigdataHome=""
declare PATCH_VERSION="6.5.1.6"
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        echo "current path is null."
        return 1
    fi

    g_rootPath=$(dirname "$path")
    echo "g_rootPath=$g_rootPath."
    if [ -z "$g_rootPath" ]; then
        echo "Init parameter g_rootPath failed."
        return 1
    fi

    return 0
}

main()
{
    #init path constants
    get_path
    if [ $? -ne 0 ]; then        
        return 1
    fi
    
    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_rootPath}/common/log.sh"
    
    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       log_and_show "ERROR" "${LINENO}" "replace datanode_notify.sh failed."
       return 1
    fi
    
    log_and_show "INFO" "${LINENO}" "Start to remove backup dir."
    
    #Ŀ¼
    rm -rf "${BACKUP_HOME}"
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "remove backup dir failed."
        return 1
    fi
    
    log_and_show "INFO" "${LINENO}" "commit successfully."
    return 0
    
}

main
exit $?