#!/bin/bash
declare g_rootPath=""
declare g_bigdataHome=""
declare PATCH_VERSION="6.5.1.6"
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"
declare WORK_HOME="/opt/os_optimization_tool_${PATCH_VERSION}"
declare agent_tar="agent-0.0.1.tar.gz"

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        echo "current path is null."
        return 1
    fi

    g_rootPath=$(dirname "$path")
    echo "g_rootPath=$g_rootPath."
    if [ -z "$g_rootPath" ]; then
        echo "Init parameter g_rootPath failed."
        return 1
    fi

    return 0
}

backup_datanode_notify()
{ 
    log_and_show "INFO" "${LINENO}" "Enter backup datanode_notify.sh file."
    
    if ! [ -d "${BACKUP_HOME}" ];then
        mkdir -p "${BACKUP_HOME}"
    elif [ -f  "${BACKUP_HOME}/datanode_notify.sh" ];then 
        log_and_show "INFO" "${LINENO}" "${BACKUP_HOME}/datanode_notify.sh exist, skip backup file."
        return 0
    fi
    
    if [ -f "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh" ];then
        cp -rf "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh" "${BACKUP_HOME}"
    else
        log_and_show "INFO" "${LINENO}" "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh not exist, can not backup file."
        return 1
    fi

    log_and_show "INFO" "${LINENO}" "Leave backup datanode_notify.sh file."
    
    return 0
}

replace_file()
{
    log_and_show "INFO" "${LINENO}" "Enter replace file."
    
    if [ -f "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh" ];then
       chmod 750 "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh"
       cp -fr "$g_rootPath/common/datanode_notify.sh" "/usr/local/diskmgt/ini-plugin/notify/"
       if [ $? -ne 0 ];then
           log_and_show "ERROR" "${LINENO}" "copy $g_rootPath/common/datanode_notify.sh to /usr/local/diskmgt/ini-plugin/notify/ failed."
           return 1
       fi
    fi

    log_and_show "INFO" "${LINENO}" "Leave replace file."
}

main()
{
    #init path constants
    get_path
    if [ $? -ne 0 ]; then        
        return 1
    fi
    
    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_rootPath}/common/log.sh"
    
    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       log_and_show "ERROR" "${LINENO}" "replace datanode_notify.sh failed."
       return 1
    fi
    
    g_bigdataHome=$(su - omm -c 'echo $BIGDATA_HOME')
    if [ $? -ne 0 ];then
       log_and_show "ERROR" "${LINENO}"  "ERROR:get bigdata home failed."
       return 1
    fi

    g_controllerHome=$(su - omm -c 'echo $CONTROLLER_HOME')
    if [ $? -ne 0 ];then
       log_and_show "ERROR" "${LINENO}"  "ERROR:get controller home failed."
       return 1
    fi

    g_nodeagentHome=$(su - omm -c 'echo $NODE_AGENT_HOME')
    if [ $? -ne 0 ];then
       log_and_show "ERROR" "${LINENO}"  "ERROR:get agent home failed."
       return 1
    fi
    
    log_and_show "INFO" "${LINENO}" "Start to replace datanode_notify.sh."
    
    backup_datanode_notify
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "backup datanode_notify.sh file failed."
    fi

    replace_file
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "replace datanode_notify.sh file failed."
        return 1
    fi

    log_and_show "INFO" "${LINENO}" "replace datanode_notify.sh files successful."
    return 0
    
}

main
exit $?