#!/bin/bash

# ----------------------------------------------------------------------------- #
#                                                                       #
# ----------------------------------------------------------------------------- #
declare g_localFile=""    #ϵͳLOCALļ
declare g_currentPath=""    #ǰűھ·
declare PATCH_VERSION="6.5.1.6"    #ÿβ޸Ҫ޸İ汾
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"   #ļݵַ



######################################################################
#   DESCRIPTION: ȡϵͳLOCALļ
######################################################################
function get_localFile()
{
    #Red Hat汾
    if [ -f "/etc/redhat-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #redhatlocalĿ¼
        return 0
    fi

    #SuSE汾
    if [ -f "/etc/SuSE-release" ]; then
        g_localFile="/etc/rc.d/after.local" #suselocalĿ¼
        return 0
    fi

    #CentOS汾
    if [ -f "/etc/centos-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #CentOSlocalĿ¼
        return 0
    fi

    #EulerOS汾
    if [ -f "/etc/euleros-release" ]; then
        g_localFile="/etc/rc.d/rc.local"         #EulerOSlocalĿ¼
        return 0
    fi

    #ʶ汾
    log_and_show "ERROR" "${LINENO}" "The os version does not match."
    return 1
}

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        log_and_show "ERROR" "${LINENO}" "current path is null."
        return 1
    fi

    g_currentPath=$(dirname "$path")

    if [ -z "$g_currentPath" ]; then
        log_and_show "ERROR" "${LINENO}" "Init parameter g_currentPath failed."
        return 1
    fi

    return 0
}

###################################################
#
# ָlocalļ
#
###################################################
restore_file()
{
    if [ ! -d "${BACKUP_HOME}" ]; then
        log_and_show "ERROR" "${LINENO}" "$BACKUP_HOME directory is not exist, may have been unloaded. "
        return 1
    fi

    #ȡϵͳlocalļ
    get_localFile
    if [ $? -ne 0 ]; then
        log_and_show "ERROR" "${LINENO}" "get the local file failed."
        return 1
    fi

    if [ -f "${BACKUP_HOME}/rc.local" ]; then
        cp -fr "${BACKUP_HOME}/rc.local" "${g_localFile}"
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/rc.local to /etc/rc.d/rc.local failed."
            return 1
        fi
    elif [ -f "${BACKUP_HOME}/after.local" ]; then 
        cp -fr "${BACKUP_HOME}/after.local" "${g_localFile}"
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/after.local to /etc/rc.d/after.local failed."
            return 1
        fi
    fi
    
    rm -rf "/usr/local/HDExclusiveMachine"
    if [ $? -ne 0 ]; then
        log_and_show "ERROR" "${LINENO}" "remove HDExclusiveMachine failed."
        return 1
    fi

    return 0
}



main()
{
    #init path constants
    get_path
    if [ $? -ne 0 ]; then
        return 1
    fi

    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_currentPath}/common/log.sh"

    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       return 1
    fi

    log_and_show "INFO" "${LINENO}" "start to restore the local file."
    restore_file
    if [ $? -ne 0 ]; then
        log_and_show "ERROR" "${LINENO}" "restore the local file failed."
        return 1
    fi

    log_and_show "INFO" "${LINENO}" "finish to restore the local file."
    return 0
}


main
exit $?