#!/bin/bash
declare g_rootPath=""
declare g_bigdataHome=""

#ÿβ޸İBACKUP_HOME
declare PATCH_VERSION="6.5.1.6"
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"
declare agent_tar="agent-0.0.1.tar.gz"

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        echo "current path is null."
        return 1
    fi
    
    g_rootPath=$(dirname "$path")
    echo "g_rootPath=$g_rootPath."
    if [ -z "$g_rootPath" ]; then
        echo "Init parameter g_rootPath failed."
        return 1
    fi

    return 0
}

restore_file()
{
    if [ ! -d "${BACKUP_HOME}" ]; then
        log_and_show "INFO" "${LINENO}" "$BACKUP_HOME directory is not exist, may have been unloaded. "
        return 1
    fi
    
    log_and_show "INFO" "${LINENO}" "Enter restore file."
    
    if [ -d "/usr/local/diskmgt/ini-plugin/notify" ];then    
        cp -fr "${BACKUP_HOME}/datanode_notify.sh" "/usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh"
        if [ $? -ne 0 ];then
            log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/datanode_notify.sh to /usr/local/diskmgt/ini-plugin/notify/datanode_notify.sh failed."
            return 1
        fi
    fi

    log_and_show "INFO" "${LINENO}" "Leave restore file."
}

main()
{
    #init path constants
    get_path
    if [ $? -ne 0 ]; then        
        return 1
    fi
    
    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_rootPath}/common/log.sh"
    
    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       return 1
    fi
    
    g_bigdataHome=$(su - omm -c 'echo $BIGDATA_HOME')
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "ERROR:get bigdata home failed."
        return 1
    fi
    
    g_controllerHome=$(su - omm -c 'echo $CONTROLLER_HOME')
    if [ $? -ne 0 ];then
       log_and_show "ERROR" "${LINENO}"  "ERROR:get controller home failed."
       return 1
    fi

    log_and_show "INFO" "${LINENO}" "Start to restore datanode_notify.sh."
    restore_file
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "ERROR:restore datanode_notify.sh failed."
        return 1
    fi
     
    log_and_show "INFO" "${LINENO}" "restore datanode_notify.sh successful."
    
    log_and_show "INFO" "${LINENO}" "remove $BACKUP_HOME successfully"
    return 0
}


main
exit $?