#!/bin/bash
declare g_rootPath=""
declare g_bigdataHome=""

#ÿβ޸İBACKUP_HOME
declare PATCH_VERSION="6.5.1.6"
declare BACKUP_HOME="/opt/os_optimization_tool_backup_${PATCH_VERSION}"
declare agent_tar="agent-0.0.1.tar.gz"

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        echo "current path is null."
        return 1
    fi
    
    g_rootPath=$(dirname "$path")
    echo "g_rootPath=$g_rootPath."
    if [ -z "$g_rootPath" ]; then
        echo "Init parameter g_rootPath failed."
        return 1
    fi

    return 0
}

restore_file()
{
    if [ ! -d "${BACKUP_HOME}" ]; then
        log_and_show "INFO" "${LINENO}" "$BACKUP_HOME directory is not exist, may have been unloaded. "
        return 1
    fi
    
    log_and_show "INFO" "${LINENO}" "Enter restore file."
    
    if [ -d "/var/lib/sudo/Bigdata/sudo/runtime/" ];then    
        cp -fr "${BACKUP_HOME}/sudoExecute.sh" "/var/lib/sudo/Bigdata/sudo/runtime/sudoExecute.sh"
        if [ $? -ne 0 ];then
            log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/sudoExecute.sh to /var/lib/sudo/Bigdata/sudo/runtime/sudoExecute.sh failed."
            return 1
        fi
    fi
    
    if [ -d "${g_bigdataHome}/om-agent/nodeagent/bin/sudo/runtime/" ];then
        cp -fr "${BACKUP_HOME}/sudoExecute.sh" "${g_bigdataHome}/om-agent/nodeagent/bin/sudo/runtime/"
        if [ $? -ne 0 ];then
           log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/sudoExecute.sh to ${g_bigdataHome}/om-agent/nodeagent/bin/sudo/runtime/ failed."
           return 1
        fi
    fi

    if [ -d "${g_bigdataHome}/om-server/om/" ];then
        restore_agent_pkg || return $?
    fi

    log_and_show "INFO" "${LINENO}" "Leave restore file."
}

restore_agent_pkg()
{
    log_and_show "INFO" "${LINENO}" "$(hostname -i) is OMS node, replace oms patch."
    cp -fr "${BACKUP_HOME}/sudoExecute.sh" "${g_bigdataHome}/om-server/om/sbin/sudo/runtime/"
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "copy ${BACKUP_HOME}/sudoExecute.sh to ${g_bigdataHome}/om-server/om/sbin/sudo/runtime/ failed."
        return 1
    fi

    all_agent_tars=($(find ${BACKUP_HOME} -name ${agent_tar}))
    if [ -z ${all_agent_tars} ]; then
        log_and_show "ERROR" "${LINENO}" "no agent pkg found,restore failed,maybe already restored."
        return 1
    fi
    
    for((i=0;i<${#all_agent_tars[@]};i++))
    do
        path=${all_agent_tars[$i]}
        origin_file=${path#$BACKUP_HOME}
        origin_dir=$(dirname $origin_file)
        cp -af ${path}*  ${origin_dir}
        if [ $? -ne 0 ]; then
            log_and_show "ERROR" "${LINENO}" "restore $path to $origin_file failed."
            return 1
        fi
        #Ȩ޿
        chown root:wheel "${origin_file}"
        chmod 640 "${origin_file}"
        chown omm:wheel "${origin_file}.sha256"
        chmod 600 "${origin_file}.sha256"
    done
    
    log_and_show "INFO" "${LINENO}" "succeed to restore agent.tar"
    return 0
}

main()
{
    #init path constants
    get_path
    if [ $? -ne 0 ]; then        
        return 1
    fi
    
    #־
    [ -f "/home/omm/.profile" ] && source "/home/omm/.profile"
    source "${g_rootPath}/common/log.sh"
    
    if [ "$USER" != "root" ]; then
       log_and_show "ERROR" "${LINENO}" "ERROR:current user is not root."
       return 1
    fi
    
    g_bigdataHome=$(su - omm -c 'echo $BIGDATA_HOME')
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "ERROR:get bigdata home failed."
        return 1
    fi
    
    g_controllerHome=$(su - omm -c 'echo $CONTROLLER_HOME')
    if [ $? -ne 0 ];then
       log_and_show "ERROR" "${LINENO}"  "ERROR:get controller home failed."
       return 1
    fi

    log_and_show "INFO" "${LINENO}" "Start to restore sudoExecute.sh agent.tar."
    restore_file
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "ERROR:restore sudoExecute.sh and agent.tar failed."
        return 1
    fi
     
    log_and_show "INFO" "${LINENO}" "restore sudoExecute.sh successful."
    
    log_and_show "INFO" "${LINENO}" "remove $BACKUP_HOME successfully"
    return 0
}


main
exit $?