#!/bin/bash

#import common log function provided by manager
SCRIPT_NAME="$(basename "${BASH_SOURCE-$0}")"
LOG_FUNC_FILE="$(dirname "$0")"/../../function/log.sh
. "${LOG_FUNC_FILE}" || { echo "[$(date -d today +'%Y-%m-%d %H:%M:%S')] [ERROR]: Failed to load ${LOG_FUNC_FILE}. [${SCRIPT_NAME}:${LINENO}]($$)"; exit 1;}

HOST_IP=$1
function checksftp(){
  log "[INFO]" "${LINENO}" "${HOST_IP}: start checking ClickHouse."
  getos="$(cat /etc/*-release|grep "NAME"|head -n 1|awk -F '"' '{print $2}')"
  if [ "${getos}" != "SLES" ];then
      statinfo="$(stat -c %a /usr/libexec/openssh/sftp-server)"
    else
      statinfo="$(stat -c %a /usr/lib/ssh/sftp-server)"
  fi
  log "[INFO]" "${LINENO}" "${HOST_IP}: stat of sftp-server is ${statinfo}."
  if [ ${statinfo}X != "755X" ]; then
    log "[ERROR]" "${LINENO}" "${HOST_IP}: stat of /usr/libexec/openssh/sftp-server is not ok for ClickHouse."
    return 1
  else
    log "[INFO]" "${LINENO}" "${HOST_IP}: stat of /usr/libexec/openssh/sftp-server is ok for ClickHouse."
    return 0
  fi
}

function main(){
  checksftp
}

main
