#!/bin/bash

declare HOST_IP=$1               ##本机IP
declare DBSERVICE_PORT=20051     ##DBService对外提供数据库服务的端口号

##############################################日志打印说明######################################################################
##需要打印的信息级别有以下几类：
## [INFO]
## [WARN]
## [ERROR_DEBUG] 供开发人员调试的错误信息
## [ERROR]
## 所有项都打印到log文件中，不会显示在控制台。
#################################################################################################################################
checkPort()
{
    log "[INFO]" "${LINENO}" "${HOST_IP}: start checking port."
   
    local tmpstr=""
    [ -f /usr/sbin/ss ] && tmpstr=$(/usr/sbin/ss | grep ":$DBSERVICE_PORT")
    [ -f /bin/netstat ] && tmpstr=$(netstat -na | grep ":$DBSERVICE_PORT")
    if [ $? -eq 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${HOST_IP}: check port failed, port $DBSERVICE_PORT is in use, check result is: $tmpstr."
        
        ##输出到界面的日志
        log "[ERROR]" "${LINENO}" "${HOST_IP}: The port $DBSERVICE_PORT is in use. Please disable the port."
        return 1
    fi
    
    return 0
}

main()
{
    ## 端口号检查
    checkPort

}

#导入公共日志函数
SCRIPT_NAME="$(basename "${BASH_SOURCE-$0}")"
LOG_FUNC_FILE="$(dirname "$0")"/../../function/log.sh
. "${LOG_FUNC_FILE}" || { echo "[$(date -d today +'%Y-%m-%d %H:%M:%S')] [ERROR]: Failed to load ${LOG_FUNC_FILE}. [${SCRIPT_NAME}:${LINENO}]($$)"; exit 1;}

main
exit $?
