#!/bin/bash

#import common log function provided by manager
SCRIPT_NAME="$(basename "${BASH_SOURCE-$0}")"
LOG_FUNC_FILE="$(dirname "$0")"/../../function/log.sh
. "${LOG_FUNC_FILE}" || { echo "[$(date -d today +'%Y-%m-%d %H:%M:%S')] [ERROR]: Failed to load ${LOG_FUNC_FILE}. [${SCRIPT_NAME}:${LINENO}]($$)"; exit 1;}

RET_ERR=1
RET_OK=0
HOST_IP=$1
function checkClib(){
  log "[INFO]" "${LINENO}" "${HOST_IP}: start checking impala."
  targetLib=`strings /usr/lib64/libstdc++.so.6 | grep GLIBC | grep GLIBCXX_3.4.11`
  
  if [ "${targetLib}x" != "x" ]; then
     log "[INFO]" "${LINENO}" "GLIBCXX_3.4.11 was installed, check impala dependency for GLIBCXX ok!"
     return $RET_OK;
  else
     log "[WARNING]" "${LINENO}" "GLIBCXX_3.4.11 was not found, this would cause Impala service unvailable, if you select to install impala components in cluster installation"
     return $RET_ERR;
  fi
}

function main(){
  checkClib
}

main
