#!/bin/bash

checkCPUEnergyEfficiencyMode()
{
    local ip="$1"
    log "[INFO]" "${LINENO}" "${ip}: start checking the CPU energy efficiency mode of the operating system"
    local powersaveMode="powersave"
    local performanceMode="performance"
    local curCPUMode="$(${CMD_CHKCRN} /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor)"
    if [ ! -z "${curCPUMode}" ]; then
        curCPUMode="$(echo ${curCPUMode} | tr '[:upper:]' '[:lower:]')"
        if [ "${curCPUMode}" == "${powersaveMode}" ]; then
            log "[WARNING]" "${LINENO}" "${ip}: The current CPU performance mode is energy-saving[${powersaveMode}], which affects the performance. You are advised to change it to performance."
        fi
    fi
}