#!/bin/bash

################################################
# Usage: checkPermission.sh
# :  ļȨ
#
################################################

###################################################
#
# ļȨ
#
###################################################
function check_permission()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking file permission."
    
    #ļȨ飬ʽΪĿ¼:ļͼȨ::顱ԪԿոָ
    local key_file_array=(/tmp:drwxrwxrwt:root:root)

    for element in "${key_file_array[@]}";
    do
        local FILE=$(echo ${element} | awk  -F ':' '{print $1}')
        local PERMISSION=$(echo ${element} | awk  -F ':' '{print $2}')
        local OWNER=$(echo ${element} | awk  -F ':' '{print $3}')
        local GROUP=$(echo ${element} | awk  -F ':' '{print $4}')
        
        if [ -z "${FILE}" -o -z "${PERMISSION}" -o -z "${OWNER}" -o -z "${GROUP}" ]; then
            log "[WARNING]" "${LINENO}" "${ip}: Wrong format of item ${element}."
            continue
        fi

        local owner=$(${CMD_CHKSTAT} -c %U ${FILE})
        [ X${owner} != X${OWNER} ] && log "[WARNING]" "${LINENO}" "${ip}: The owner for ${FILE} is ${owner} instead of the expected ${OWNER}."
        
        local group=$(${CMD_CHKSTAT} -c %G ${FILE})
        [ X${group} != X${GROUP} ] && log "[WARNING]" "${LINENO}" "${ip}: The group for ${FILE} is ${group} instead of the expected ${GROUP}."
    done
}

function check_mounted_attribute()
{
    ip=$1
    PRECHECK_CONSTANTS_FILE="$(dirname "$0")/../../precheck_constants"
    INSTALL_HOME=$(cat ${PRECHECK_CONSTANTS_FILE} | grep "g_install_home" | awk -F "=" '{print $2}')
    SUDO_HOME="/var/lib/sudo"
    local mount_partition_array=(${INSTALL_HOME}:noexec ${SUDO_HOME}:noexec "/etc":nosuid "/var":nosuid)
    for element in "${mount_partition_array[@]}";
    do
        local CHECK_DIR=$(echo ${element} | awk  -F ':' '{print $1}')
        local ATTRIBUTE=$(echo ${element} | awk  -F ':' '{print $2}')

        if [ -z "${CHECK_DIR}" -o -z "${ATTRIBUTE}" ]; then
            log "[WARNING]" "${LINENO}" "${ip}: Wrong format of item ${element}."
            continue
        fi
        
        while [ ! -d "${CHECK_DIR}" ]; do
            CHECK_DIR=$(dirname "${CHECK_DIR}")
        done

        MOUNT_POINT=$(${CMD_CHKDFP} "${CHECK_DIR}" | grep "^/dev" | awk '{print $6}')

        if [ ! -d "${MOUNT_POINT}" ]; then
            log "[ERROR]" "${LINENO}" "${ip}: The mount point is not a directory."
            continue
        fi
        
        if [ "${MOUNT_POINT}" == "/" ]; then
            continue
        fi

        cat /proc/mounts | grep "${MOUNT_POINT}[[:space:]]" | grep ${ATTRIBUTE} >/dev/null 2>&1
        if [ $? -eq 0 ]; then
            log "[ERROR]" "${LINENO}" "${ip}: The mount point ${MOUNT_POINT} has ${ATTRIBUTE} attribute."
        fi
    done
}
