#!/bin/bash
function checkPython()
{
    log "[INFO]" "${LINENO}" "${ip}: start checking the python version."  
    ip=$1
    hash python3 > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Python3 is not installed."
        return 1
    fi
    
    local min="3.0.0"
    local cur="$(python3 -V 2>&1 | awk '{print $2}')"
    local min_ver=0    
    local cur_ver=0

    min_ver=$(echo "${min}" | awk -F'.' '{printf ("%d%03d%03d",$1,$2,$3)}')
    cur_ver=$(echo "${cur}" | awk -F'.' '{printf ("%d%03d%03d",$1,$2,$3)}')
    
    if [ "$cur_ver" -lt "$min_ver"]; then
        log "[ERROR]" "${LINENO}" "${ip}: The python3 version is not supported, cur:${cur}, min:${min}."
    fi
}
