#!/bin/bash

################################################
# Usage: checkRpms.sh
# :  ȡrpmб
#
################################################

###################################################
#
# ȡOS
#
###################################################
function get_osname()
{
    local cent_release="/etc/centos-release"
    local ole_release="/etc/oracle-release"
    local rhel_release="/etc/redhat-release"
    local sles_release="/etc/SuSE-release"
    local sles15_release="/etc/os-release"
    local euler_release="/etc/euleros-release"
    local neokylin_relase="/etc/neokylin-release"
    local kylin_productinfo="/etc/.productinfo"
    local bclinux_release="/etc/bclinux-release"
    local openeuler_release="/etc/openEuler-release"
    local kylin_relase="/etc/kylin-release"
    local linxos_release="/etc/linxos-release"
    local name=""

    if [ -f "${linxos_release}" ]; then
        name=$(awk '{print $1"-"$2}' ${linxos_release})
        echo "$name"
        return 0
    fi
    
    #ȡEulerİ汾, Eulerosдredhat-releaseCentOS-releaseȼ    
    if [ -f "${euler_release}" ]; then
        if grep -q "release" "${euler_release}"; then
            name="$(cat $euler_release | sed 's/x86_64//g' | awk -F " |SP|)" '{print "euleros-"$3"sp"$5}')"
        else
            name="euleros-$(cat "${euler_release}" | awk '{print $2}' | cut -d "V" -f 2 | tr 'A-Z' 'a-z')"
        fi
        echo "$name"
        return 0
    fi
    
    if [ -f "${neokylin_relase}" ];then
        if grep -q "release" "${neokylin_relase}"; then
            name="$(cat "${neokylin_relase}" | awk '{print $6}' | cut -d "V" -f 2 | tr 'A-Z' 'a-z')"
            if [ -z "${name}" ];then
                name="$(cat "${neokylin_relase}" | awk '{print $4}' | cut -d "V" -f 2 | tr 'A-Z' 'a-z')"
            fi
            name="neokylin-$(echo ${name/update/'.'})"
        fi
        echo "$name"
        return 0
    fi
    
    if [ -f "${bclinux_release}" ];then
        if grep -q "Euler" "${bclinux_release}";then
             name="bclinux-$(cat "${bclinux_release}" | awk '{print $7}' | awk -F. '{print $1"."$2}')"
        else
             name="bclinux-$(cat "${bclinux_release}" | awk '{print $5}' | awk -F. '{print $1"."$2}')"
        fi
        echo "$name"
        return 0
    fi    
    
    #ע: CentOSҲ /etc/redhat-release ļ
    #redhat֮ǰ
    if [ -f "${cent_release}" ]; then
        if grep -q "Linux" "${cent_release}"; then
            name="centos-$(cat "${cent_release}" | awk '{print $4}' | awk -F. '{print $1"."$2}')"
        else
            name="centos-$(cat "${cent_release}" | awk '{print $3}')"
        fi
        echo "$name"
        return 0
    fi

    #ע: oracle linuxҲ /etc/redhat-release ļ
    #redhat֮ǰ
    if [ -f "${ole_release}" ]; then
        name="oracle-$(cat "${ole_release}" | awk '{print $5}')"
        echo "$name"
        return 0
    fi

    #ȡRedHatİ汾
    if [ -f "${rhel_release}" ]; then
        name="redhat-$(cat "${rhel_release}" | awk '{print $7}')"
        echo "$name"
        return 0
    fi

    #ȡSuSEİ汾
    if [ -f "${sles_release}" ]; then
        name="suse-$(cat "${sles_release}" | grep "^VERSION" | awk '{print $3}')"
        name="${name}.$(cat "${sles_release}" | grep "^PATCHLEVEL" | awk '{print $3}')"
        echo "$name"
        return 0
    fi
    if [ -f "${kylin_relase}" ] && [ "KylinSec" = "$(cat "${kylin_relase}" |awk -F " " '{print $1}')" ]; then
        name="kylinSecOS-$(grep "^VERSION_ID=" "${sles15_release}" | awk -F "\"" '{print $2}')"
        echo "$name"
        return 0
    fi
    #ȡSuSE15İ汾
    if [ -f "${sles15_release}" ]; then
        if [ "suse" = "$(cat "${sles15_release}" | grep "^ID_LIKE=" | awk -F "\"" '{print $2}')" ]; then
            name="suse-$(cat "${sles15_release}" | grep "^VERSION_ID=" | awk -F "\"" '{print $2}')"
            echo "$name"
            return 0
        fi
        local idLike=$(grep "^ID_LIKE=" "${sles15_release}" | awk -F "\"" '{print $2}')
        local ID=$(grep "^ID=" "${sles15_release}" | awk -F '=' '{print $2}' | tr -d '"')
        local VERSION_ID=$(grep "^VERSION_ID=" "${sles15_release}" | awk -F "\"" '{print $2}')
        if [ "${ID}" = "kylin" ] && [ "${idLike}" = "fedora" ]; then
            name="$ID-${VERSION_ID}-fedora"
            echo "$name"
            return 0
        fi
        if [ -f "${kylin_productinfo}" ] && [ "${ID}" = "kylin" ]; then
            local MINOR_VERSION=$(grep "${VERSION_ID}" "${kylin_productinfo}" | awk -F "(" '{print $2}' | awk -F ")" '{print $1}')
            name="$ID-${VERSION_ID}-${MINOR_VERSION}"
            echo "$name"
            return 0
        fi
        if [ "${ID}" = "uos" ]; then
            name="$ID-$(cat /etc/os-version | grep MinorVersion | awk -F "=" '{print $2}')"
            echo "$name"
            return 0
        fi
        #ȡopenEuler-SPxİ汾
        if [ -f "${openeuler_release}" ] && [ "${ID}" = "openEuler" ]; then
           local MINOR_VERSION=$(cat "${openeuler_release}" | awk -F "-" '{print $2}' | awk -F ")" '{print $1}')
           #openEuler-20.03-SP1֮ǰĹȡ汾
           local MINOR_VERSION_ID="${VERSION_ID}-${MINOR_VERSION}"
           if [ -n "${MINOR_VERSION}" -a "${MINOR_VERSION_ID}" != "20.03-SP1" ] ; then
               name="$ID-${VERSION_ID}-${MINOR_VERSION}"
               echo "$name"
               return 0
           fi
        fi
        name="$ID-$VERSION_ID"
        echo "$name"
        return 0
    fi
    
    return 1
}

################################################
#
# ȡϵͳȱʧrpmб
#
################################################
function checkRpms()
{
    
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking rpms."
    local must_rpms=""           #ϵͳбеrpmб
    local missing_rpms=""        #ڱȱʧrpmбļ
    local osname=""              #os(suse/redhat)
    local line=""                #ļÿе
    local newline=""             #תе(ȥո)

    #ȡOS
    osname="$(get_osname)"
    if [ $? -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: get_osname(${osname}) failed."
        log "[ERROR]" "${LINENO}" "${ip}: Failed to obtain the rpm package."
        return 1
    fi

    #ȡбļ űͬһĿ¼£
    
    

    if [ `uname -p` == "aarch64" ]; then
       must_rpms="$(dirname "$0")/../../rpm_lists/${osname}_must-rpms-aarch64.lst"
    else
       must_rpms="$(dirname "$0")/../../rpm_lists/${osname}_must-rpms.lst"
    fi
    
    if [ `uname -p` == "aarch64" ]; then
       missing_rpms="$(dirname "$0")/../../rpm_lists/${osname}_${ip}_missing-rpms-aarch64.lst"
    else
       missing_rpms="$(dirname "$0")/../../rpm_lists/${osname}_${ip}_missing-rpms.lst"
    fi

    #ļ
    if [ ! -f "${must_rpms}" ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: ${must_rpms} is not a file in me."
        log "[ERROR]" "${LINENO}" "${ip}: Failed to obtain the rpm package."
        return 1
    fi

    #ֱдļ,дʧ,ֱӷ
    echo "# Missing rpms list of host ${ip}" > "${missing_rpms}"
    if [ $? -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: ${missing_rpms} is invalid, write failed."
        log "[ERROR]" "${LINENO}" "${ip}: Failed to obtain the rpm package."
        return 1
    fi

    echo "# This list was generated on $(date)" >> "${missing_rpms}"
    echo "# os: ${osname}" >> "${missing_rpms}"

    while read line
    do
        #ųĸֿͷ
        if [ -z "$(echo "$line" | grep "^[[:alnum:]]")" ]; then
            continue
        fi

        #ɾпո
        newline="$(echo "$line" | tr -d '[:space:]')"

        #жϵͳǷҪrpm
        version=$(rpm -q "${newline}")
        if [  $? -ne 0 ]; then
            echo "${newline}" >> "${missing_rpms}"
            log "[ERROR]" "${LINENO}" "${ip}: need to install : ${newline}"
        else
            #ver=$(echo $version |cut -f2 -d '-')
            echo "[RPM_VER]#${ip}#${newline}#${version}"
        fi
        
    done < "${must_rpms}"

    echo "" >> "${missing_rpms}"
}
