#!/bin/bash

checkWheelGroupID()
{
    local ip="$1"
    log "[INFO]" "${LINENO}" "${ip}: start checking wheel group ID"
    local defaultWheelGroupID="10"
    local curWheelGroupID="$(${CMD_CHKCRN} /etc/group | grep -w wheel | awk -F ':' '{print $3}')"
    if [ ! -z "${curWheelGroupID}" ] && [ "${curWheelGroupID}" != "${defaultWheelGroupID}" ]; then
        log "[ERROR]" "${LINENO}" "${ip}: The wheel group ID of the operating system is not ${defaultWheelGroupID}. Change the wheel group ID."
    fi
}