#!/usr/bin/env python3

from __future__ import absolute_import
import argparse
import xml.etree.ElementTree as ET
import logging


def count(shard, parent_map, args, tmp):
    flag = ''
    logging.info("+++++++++shard+++++++++++++")
    replica = shard.find('replica')

    if str.encode('macros') in ET.tostring(parent_map.get(shard)):
        logging.info("this is macro defination, no need to check replica.")
        logging.info("----------shard------------")
        return tmp

    if replica is None:
        logging.error('shard %s is not statisfy. ', ET.tostring(shard))
        return tmp

    logging.info("After if condition, shard: %s", ET.tostring(shard))
    for host in shard.iter('host'):
        flag = '{}{}{}'.format(flag, host.text, " ")
        if args.current_hostname in flag:
            tmp = flag
    logging.info("----------shard------------")
    return tmp


def main():
    parser = argparse.ArgumentParser(description='Check whether all nodes of each shard is running or not')
    parser.add_argument('--metrika_file', required=True, help='the metrika file')
    parser.add_argument('--log_file', required=True, help='the log file')
    parser.add_argument('--current_hostname', required=True, help='hostname of current node')
    args = parser.parse_args()
    tree = ET.parse(args.metrika_file)
    parent_map = {c: p for p in tree.iter() for c in p}

    LOG_FORMAT = "%(asctime)s - %(levelname)s - %(message)s"
    logging.basicConfig(filename=args.log_file, level=logging.INFO, format=LOG_FORMAT)

    # pylint: disable=print-statement
    tmp = ''
    for shard in tree.iter('shard'):
        tmp = count(shard, parent_map, args, tmp)
    print(tmp)


if __name__ == "__main__":
    main()
