#!/bin/bash

###################################################
#
# 功能:  在远端配置ipmi配置的crontab，如果是一体机形态，
#        则在每个节点的root crontab中添加一个crontab任务
#        监控主板的产品名称以及即时刷新主板的产品名称
#
###################################################
function config_ipmi_r() {
    local remoteIp=$1
    local applianceConfig="/etc/gaussdbAppliance"
    local crontabFile="/var/spool/cron/root"
    local productNameM110=" GaussDB M110 V1"
    local asciiM110="0x02 0x47 0x61 0x75 0x73 0x73 0x44 0x42 0x20 0x4d 0x31 0x31 0x30 0x20 0x56 0x31"
    local productNameA150=" GaussDB A150 V1"
    local asciiA150="0x02 0x47 0x61 0x75 0x73 0x73 0x44 0x42 0x20 0x41 0x31 0x35 0x30 0x20 0x56 0x31"
    local productNameA160=" GaussDB A160 V1"
    local asciiA160="0x02 0x47 0x61 0x75 0x73 0x73 0x44 0x42 0x20 0x41 0x31 0x36 0x30 0x20 0x56 0x31"

    # 只有一体机形态下有这个文件
    if [ -f ${applianceConfig} ] ; then
        exec_cmd_r "${remoteIp}" "120" "crontab -l | grep \"/etc/gaussdbAppliance\" >>/dev/null"
        if [ $? -ne 0 ] ; then
            exec_cmd_r "${remoteIp}" "120" "echo \"*/5 * * * * configName=\\\`cat /etc/gaussdbAppliance\\\`;if [ \\\"\\\${configName}\\\" = \\\"${productNameM110}\\\" ]; then finalAscii=\\\"${asciiM110}\\\"; elif [ \\\"\\\${configName}\\\" = \\\"${productNameA150}\\\" ]; then finalAscii=\\\"${asciiA150}\\\"; elif [ \\\"\\\${configName}\\\" = \\\"${productNameA160}\\\" ]; then finalAscii=\\\"${asciiA160}\\\"; fi; ipmiName=\\\`ipmitool fru print 0 | grep \\\"Product Name\\\" | awk -F\\\":\\\" '{print \\\$2}'\\\`; if [ \\\"\\\${configName}\\\" != \\\"\\\${ipmiName}\\\" ] ; then ipmitool raw 0x30 0x90 0x04 0x00 0x03 0x01 0x00 0x10 \\\${finalAscii};ipmitool raw 0x30 0x90 0x04 0x00 0x06 0x01 0x00 0x10 \\\${finalAscii};ipmitool raw 0x30 0x90 0x06 0x00 0xaa;fi;\" >> ${crontabFile}"
            if [ $? -ne 0 ] ; then
                return 1
            fi
        fi
    fi

    return 0
}
