#/bin/bash

function main()
{
    local config_file="/etc/sysctl.conf"
    #delete old config
    sed -i -e   '/net.core.netdev_max_backlog/d'        ${config_file}
    sed -i -e   '/net.ipv4.tcp_tw_reuse/d'              ${config_file} 
    sed -i -e   '/net.ipv4.tcp_fin_timeout/d'           ${config_file}
    sed -i -e   '/net.ipv4.ip_forward/d'                ${config_file}
    
    #set new config
    echo "net.core.netdev_max_backlog = 16384"            >> ${config_file}
    echo "net.ipv4.tcp_tw_reuse = 1"                      >> ${config_file}
    echo "net.ipv4.tcp_fin_timeout = 30"                  >> ${config_file}
    echo "net.ipv4.ip_forward = 0"                        >> ${config_file}
    
    os_version=`cat /etc/os-release  | grep EulerOS`
    if [ "Y${os_version}" != "Y" ]
    then
        sed -i -e   '/net.ipv4.tcp_challenge_ack_limit/d'   ${config_file}    
        echo "net.ipv4.tcp_challenge_ack_limit=999999999"   >> ${config_file} 
    fi
    
    sysctl -p > /dev/null

    ## adjust txqueuelen ###
    local eth_devices=`ls /sys/class/net/  | grep -v lo`
    if [ "X$eth_devices" == "X" ]; then
        echo "can not find any eth devices."
        return
    fi

    for ethx in ${eth_devices}
    do
        ifconfig ${ethx} txqueuelen 4000
    done
}

main
