#!/bin/bash
###################################################
# 功能: 进行OS设置
###################################################

###################################################
# 入口函数 
# 备注:
#   模块文件夹规则: 三位的数字 + . + 名字
#                   名字只能是英文和下划线
#   例如: 050.setup 中的名字为 setup
#
#   入口函数规则:   模块文件夹的[名字] + _main
###################################################
function osperf_main()
{

    local path="$1"
    local file=""

    debug "[${path}]Enter [${FUNCNAME}:${LINENO}]"


    file="${gc_mian_path}/${path}/${gc_optimize}/install.sh"

    if [ ! -f "${file}" ]; then
        error "[${FUNCNAME}:${LINENO}]" "Don't find ${gc_optimize} conf"

        #设置进度
        echo "17" > "${gc_sched_file}"

        return 21
    fi

    #运行设置OS的脚本
    bash ${file} 
    if [ $? -ne 0 ]; then
        error "[${FUNCNAME}:${LINENO}]" "run ${file} failed"
        return 20
    fi

    #设置进度
    echo "17" > "${gc_sched_file}"

    debug "Leave [${FUNCNAME}:${LINENO}]"

    return 0
}
