#!/bin/bash


###############################################################################
#author:   none
#date:     2015/04/30
#function: LSI 2208 RAID
###############################################################################



pushd $(dirname "$0") >/dev/null 2>&1
CUR_DIR="$(pwd)"
popd >/dev/null 2>&1

LOG_SCRIPT="${CUR_DIR}/log.sh"

#־
. ${LOG_SCRIPT}



#ļ
LOCKFILE="${HOME}/diskmgtdraid.lock"


#ÿRAIDҪ޸ĴӦRAIDͺ
RAID_NAME="MegaRAID SAS 2208"
RAID_CMD="storcli"



RAID_LEVEL=""
ALL_CTL_INDEX="${HOME}/all_ctl_index"
PHYSICAL_DRIVES_TMP="${HOME}/raid_physical_drives_tmp"


########################################################################
#  ʾϢ
# 1˵
#
# ֵ   0 ɹ
########################################################################
function show_help()
{
    echo
    echo "Usage: `basename $0` [option]"
    echo "options:"
    echo "-n         Notes: check raid controller."
    echo "-c         Notes: check raid health."
    echo "-g         Notes: get_raid_disk."
    echo
    echo "Example:"
    echo "`basename $0` -n"
    echo "`basename $0` -c"
    echo "`basename $0` -g"
    echo "`basename $0` -h"
    echo
    
    return 0
}



########################################################################
#  жϵǰRAIDǲǸűģ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹMegaRAID SAS 2208
#            1 ʧܣMegaRAID SAS 2208޷϶(ȱٲѯ)
########################################################################
function is_lsi_2208()
{
    local raid_cmd_exsit=1
    local pci_cmd_exsit=1
    local find_2208_raid=1
    
    #ȼǷRAIDھΪNONRAID
    which "${RAID_CMD}" > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] can not find command ${RAID_CMD}."
        cmd_exsit=0
    fi
    
    #ټӲǷԤڵһֱ
    which lspci > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] can not find command lspci."
        pci_cmd_exsit=0
    fi
    
    lspci | grep "${RAID_NAME}" > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] can not find MegaRAID SAS 2208 RAID controller."
        find_2208_raid=0
    fi
    
    #κһĻô޷϶MegaRAID SAS 2208
    if [ $raid_cmd_exsit -ne 1 -o $pci_cmd_exsit -ne 1 -o $find_2208_raid -ne 1 ]; then
        return 1
    fi
    
    return 0
}


########################################################################
#  鵱ǰraidĽ״̬
#            űҪʵָúúʱΪ
# 1˵
#
# ֵ   0 
#            1 
########################################################################
function check_raid_health()
{
    return 0
}


########################################################################
#  ȡǰڵмRAIDıǶ٣
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_raid_ctl_info()
{
    #ȡڵϵĿID
    ${RAID_CMD} show | awk '{if($2=="SAS2208")print $1}' > "${ALL_CTL_INDEX}" 2>/dev/null
    if [ ! -e "${ALL_CTL_INDEX}" ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] can not get MegaRAID SAS 2208 RAID controller indexexecute command ${RAID_CMD} show failed."
        return 1
    fi
    
    return 0
}



########################################################################
#  ȡMegaRAID SAS 2208 RAID controllerӵĵе豸
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_physical_drives()
{
    local ctl_index=0
    local success_count=0
    
    while read ctl_index
    do
        #ȡȫ豸
        "${RAID_CMD}" /c$ctl_index/eall/sall show | \
        awk '{if(NF==13 && $1 ~ "[[:digit:]]:[[:digit:]]")print $0}' > "${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives"
        if [ ! -e "${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives" ]; then
            #ڵǰĿȡʧܣôͻȡһ¸Ƶ豸
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] can not get physical drivesexecute command /c$ctl_index/eall/sall show failed."
            continue
        else
            ((success_count++))
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] get physical drives success for $ctl_index controller."
        fi
    done < "${ALL_CTL_INDEX}"
    
    if [ $success_count -eq 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] can not get physical drives for all controller."
        return 1
    fi
    
    return 0
}


########################################################################
#  ǰcontrollerӵе豸״̬Ϊ
#             UBadôŽ״̬ΪUGood
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function set_physical_drives_good()
{
    local ctl_index=0
    
    local eid=0
    local sid=0
    
    while read ctl_index
    do
        #ǰcontrollerûκ豸߻ȡӵ豸ʧܵĻͺԡ
        ctl_physical_drives=${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives
        if [ ! -e "${ctl_physical_drives}" ]; then
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives is not exsit."
            continue
        fi
        
        #ҳ״̬Unconfigured Bad豸
        cat ${ctl_physical_drives} | awk '{if($3=="UBad")print $1}' > "${PHYSICAL_DRIVES_TMP}" 2>/dev/null
        while read line
        do
            eid="$(echo $line | awk -F: '{print $1}')"
            sid="$(echo $line | awk -F: '{print $2}')"
            
            #ָ豸״̬ΪUnconfigured Goodʧܣһ豸
            ${RAID_CMD} /c$ctl_index/e${eid}/s${sid} set good > /dev/null 2>&1
            if [ $? -ne 0 ]; then
                logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index/e${eid}/s${sid} set good failed."
                continue
            fi
            
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index/e${eid}/s${sid} set good success."
        done < "${PHYSICAL_DRIVES_TMP}"
    done < "${ALL_CTL_INDEX}"
    
    return 0
}


########################################################################
#  жϵǰRAIDǲǸűģ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function import_foreign_configurations()
{
    local foreign_drive_groups=0
    
    foreign_drive_groups=$(${RAID_CMD} /call/fall show  | tr -d " " | awk -F= '{if($1 ~ "Totalforeigndrivegroups")print $2}')
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /call/fall show failed."
        return 1
    fi
    
    if [ -z "${foreign_drive_groups}" ]; then
        logme 2 "[INFO] [${FUNCNAME}:${LINENO}] need not import foreign drive groups for all controller."
        return 0
    fi
    
    if [ $foreign_drive_groups -eq 0 ]; then
        logme 2 "[INFO] [${FUNCNAME}:${LINENO}] need not import foreign drive groups for all controller."
        return 0
    fi
    
    "${RAID_CMD}" /call/fall import >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /call/fall import failed."
        return 0
    fi
    
    return 0
}


########################################################################
#  жϵǰRAIDǲǸűģ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function check_min_ug_physical_drives()
{
    local raid_level=$1
    
    
    #豸״̬Ϣ
    get_physical_drives
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_physical_drives failed."
        return 1
    fi
    
    while read ctl_index
    do
        #ǰcontrollerûκ豸߻ȡӵ豸ʧܵĻͺԡ
        ctl_physical_drives="${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives"
        if [ ! -e "${ctl_physical_drives}" ]; then
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives is not exsit."
            continue
        fi
        
        #ȡ״̬ΪUnconfigured GoodҲκVG豸
        ug_count=$(cat ${ctl_physical_drives} | awk '{if($3=="UGood" && $4=="-")print $0}' | wc -l)
        if [ "X${raid_level}" == "Xraid0" ]; then
            if [ ${ug_count} -ge 1 ]; then
                return 0
            fi
        elif [ "X${raid_level}" == "Xraid1" ]; then
            if [ ${ug_count} -ge 2 ]; then
                return 0
            fi
        else
            #󣬵ǰִֻ֧RAID0RAID1
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] ${raid_level} para is null."
            return 1
        fi
    done < "${ALL_CTL_INDEX}"
    
    logme 2 "[INFO] [${FUNCNAME}:${LINENO}] can not find enough UGood physical drives."
    return 1
}

########################################################################
#  ǰеĿռĴ̴RAID
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function create_raid_all()
{
    local raid_level=$1
    
    #ȡMegaRAID SAS 2208 RAID controllerϢʧܣֱӷ
    get_raid_ctl_info
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_raid_ctl_info failed."
        return 1
    fi
    
    #ȡcontrollerӵ豸ʧܣֱӷ
    get_physical_drives
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_physical_drives failed."
        return 1
    fi
    
    #ʧܣҪֱӷأЩ̵״̬UBadȵһ
    #һٴδRAIDʱܾͻɹ
    set_physical_drives_good
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] set_physical_drives_good failed."
    fi
        
    #̵״̬foreignôҲҪimportпǴ̱(ԭ̣ûл)
    import_foreign_configurations
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] import_foreign_configurations failed."
    fi
    
    while :;
    do
        check_min_ug_physical_drives "${raid_level}"
        if [ $? -eq 1 ]; then
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] create raid all success."
            return 0
        fi
        #豸״̬Ϣ
        get_physical_drives
        if [ $? -ne 0 ]; then
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_physical_drives failed."
            return 1
        fi
        
        #RAID
        create_raid "${raid_level}"
        if [ $? -ne 0 ]; then
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] create_raid failed."
            return 1
        fi
    done
    
    logme 2 "[INFO] [${FUNCNAME}:${LINENO}] create raid all success."
    return 0
}


########################################################################
#  RAID
# 1˵RAIDļ𣬵ǰֻ֧raid0raid1
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function create_raid()
{
    local raid_level=$1
    
    if [ "X${raid_level}" == "Xraid0" ]; then
        #raid0
        create_raid0
        if [ $? -ne 0 ]; then
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] create_raid0 failed."
            return 1
        fi
        
        logme 2 "[INFO] [${FUNCNAME}:${LINENO}] create raid 0 success."
    elif [ "X${raid_level}" == "Xraid1" ]; then
        #raid1
        create_raid1
        if [ $? -ne 0 ]; then
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] create_raid1 failed."
            return 1
        fi
        
        logme 2 "[INFO] [${FUNCNAME}:${LINENO}] create raid 1 success."
    else
        #󣬵ǰִֻ֧RAID0RAID1
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] ${raid_level} para is null."
        return 1
    fi
    
    return 0
}


########################################################################
#  RAID 1
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function create_raid0()
{
    local ctl_index=0
    local drives_id=""
    local ug_count=0
    local ug_physical_drives=""
    local ctl_physical_drives=""
    
    local success_count=0
    
    while read ctl_index
    do
        if [ $success_count -gt 0 ]; then
            return 0
        fi
        
        #ǰcontrollerûκ豸߻ȡӵ豸ʧܵĻͺԡ
        ctl_physical_drives="${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives"
        if [ ! -e "${ctl_physical_drives}" ]; then
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives is not exsit."
            continue
        fi
        
        #ȡ״̬ΪUnconfigured GoodҲκVG豸
        cat ${ctl_physical_drives} | awk '{if($3=="UGood" && $4=="-")print $0}' > "${PHYSICAL_DRIVES_TMP}"
        ug_count=$(cat ${PHYSICAL_DRIVES_TMP} | wc -l)
        if [ ${ug_count} -lt 1  ]; then
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] current controller have not UGood physical drives."
            continue
        fi
        
        for ((index_i=1; index_i<=${ug_count}; index_i++))
        do
            drives_id=$(awk "{if(NR=="${index_i}")print \$1}" < ${PHYSICAL_DRIVES_TMP})
            
            #ָ豸״̬ΪUnconfigured Goodʧܣһ豸
            "${RAID_CMD}" /c$ctl_index add vd type=r0 drives=$drives_id > /dev/null 2>&1
            if [ $? -eq 0 ]; then
                logme 2 "[INFO] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index add vd type=r0 drives=$drives_id success."
                ((success_count++))
                break
            fi
            
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index add vd type=r0 drives=$drives_id failed."
        done
    done < "${ALL_CTL_INDEX}"
    
    if [ $success_count -gt 0 ]; then
        return 0
    fi
    
    return 1
}



########################################################################
#  RAID 1
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function create_raid1()
{
    local ctl_index=0
    local ug_count=0
    local ug_physical_drives=""
    
    local primary_drives=""
    local secondary_drives=""
    
    #RAID 1̵ID
    local primary_drives_id=""
    local secondary_drives_id=""
    
    local success_count=0
    
    while read ctl_index
    do
        if [ $success_count -gt 0 ]; then
            return 0
        fi
    
        #ǰcontrollerûκ豸߻ȡӵ豸ʧܵĻͺԡ
        ctl_physical_drives="${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives"
        if [ ! -e "${ctl_physical_drives}" ]; then
            logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${HOME}/MegaRAIDSAS2208_${ctl_index}_physical_drives is not exsit."
            continue
        fi
        
        #ȡ״̬ΪUnconfigured GoodҲκVG豸
        cat ${ctl_physical_drives} | awk '{if($3=="UGood" && $4=="-")print $0}' > "${PHYSICAL_DRIVES_TMP}"
        ug_count=$(cat ${PHYSICAL_DRIVES_TMP} | wc -l)
        if [ ${ug_count} -lt 2  ]; then
            logme 2 "[INFO] [${FUNCNAME}:${LINENO}] current controller have not UGood physical drives."
            continue
        fi

        
        for ((index_i=1; index_i<=${ug_count}; index_i++))
        do
            primary_drives_id=$(awk "{if(NR=="${index_i}")print \$1}" < ${PHYSICAL_DRIVES_TMP})
            
            for((index_j=index_i+1; index_j<=${ug_count}; index_j++))
            do
                secondary_drives_id=$(awk "{if(NR=="${index_j}")print \$1}" < ${PHYSICAL_DRIVES_TMP})
                
                #ָ豸״̬ΪUnconfigured Goodʧܣһ豸
                ${RAID_CMD} /c$ctl_index add vd type=r1 drives=$primary_drives_id,$secondary_drives_id > /dev/null 2>&1
                if [ $? -eq 0 ]; then
                    logme 2 "[INFO] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index add vd type=r1 drives=$primary_drives_id,$secondary_drives_id success."
                    ((success_count++))
                    break
                fi
                
                logme 2 "[WARN] [${FUNCNAME}:${LINENO}] ${RAID_CMD} /c$ctl_index add vd type=r1 drives=$primary_drives_id,$secondary_drives_id failed."
            done
            
            if [ $success_count -gt 0 ]; then
                return 0
            fi
        done
    done < "${ALL_CTL_INDEX}"
    
    if [ $success_count -gt 0 ]; then
        return 0
    fi
    
    return 1
}



########################################################################
#  ȡеRAIḌûУҪ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_blank_disk_from_raid()
{
    #ȡMegaRAID SAS 2208 RAID controllerϢʧܣֱӷ
    get_raid_ctl_info
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_raid_ctl_info failed."
        return 1
    fi
    
    #ȡcontrollerӵ豸ʧܣֱӷ
    get_physical_drives
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] get_physical_drives failed."
        return 1
    fi
    
    #RAID
    create_raid "${RAID_LEVEL}"
    if [ $? -ne 0 ]; then
        #ʧܣҪֱӷأЩ̵״̬UBadȵһ
        #һٴδRAIDʱܾͻɹ
        set_physical_drives_good
        if [ $? -ne 0 ]; then
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] set_physical_drives_good failed."
        fi
        
        #̵״̬foreignôҲҪimportпǴ̱(ԭ̣ûл)
        import_foreign_configurations
        if [ $? -ne 0 ]; then
            logme 2 "[ERROR] [${FUNCNAME}:${LINENO}] import_foreign_configurations failed."
        fi
        
        return 1
    fi
    
    logme 2 "[INFO] [${FUNCNAME}:${LINENO}] get_blank_disk_from_raid success."
    return 0
}


########################################################################
#  
# 1˵
#
# ֵ   
########################################################################
function clean_lock()
{
    rm -rf "${LOCKFILE}"
}


########################################################################
#  źŴ
# 1˵
#
# ֵ   2 źŴ
########################################################################
function sig_catch()
{
    logme 2 "[EMER] [${FUNCNAME}:${LINENO}] catch signal!!"
    clean_lock
    exit 2
}

#ź
trap "sig_catch" INT TERM QUIT
backup_log_file

########################################################################
#  Ϊ㺯ķΧ
# 1˵ű
#
# ֵ   0 ɹ
#            1 ͨʧܴ
#            2 źŴ
#            3 ȡʧܴ
#            4 ϴαǿɱ̵µ
#            5 ̨Ӳ̹
########################################################################
{    
    flock -n 3
    #ȡʧܣҪж֮ǰǷǱǿɱ̵
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [none:${LINENO}] `basename $0` locked by another user."
        exit 3
    fi
    
    IS_CHECK=0
    IS_GETDISK=0
    IS_GETNAME=0
    IS_INIT=0
    
    #űвĴ
    while getopts "ni:c:g:h" options;
    do
        case ${options} in
            c)
                IS_CHECK=1  #齡
                RAID_LEVEL=${OPTARG}
                ;;
                
            g)
                IS_GETDISK=1  #ȡհ׵Ĵ
                RAID_LEVEL=${OPTARG}
                ;;
                
            n)
                IS_GETNAME=1 #ȡRAIDͺ
                ;;
            i)
                IS_INIT=1    #ʼRAIDеĴ̶RAID
                RAID_LEVEL=${OPTARG}
                ;;
            h)
                show_help  #
                exit $?
                ;;
                
            *)
                logme 2 "[ERROR] [none:${LINENO}] invalid input!!"  #Ƿ
                show_help
                exit 1
                ;;
        esac
    done
    
    #ֹֽͣӿ
    if [ ${IS_GETNAME} -eq 1 ]; then
        is_lsi_2208
    elif [ ${IS_CHECK} -eq 1 ]; then
        check_raid_health
    elif [ ${IS_GETDISK} -eq 1 ]; then 
        get_blank_disk_from_raid
    elif [ ${IS_INIT} -eq 1 ]; then 
        create_raid_all "${RAID_LEVEL}"
    else
        logme 2 "[ERROR] [none:${LINENO}] invalid input!!!"
        show_help
        exit 1
    fi
    
    #ɹʧܺͳһӡ
    RESULT=$?
    if [ ${RESULT} -ne 0 ]; then
        logme 2 "[ERROR] [none:${LINENO}] execute `basename $0` failed."
    else
        logme 2 "[INFO] [none:${LINENO}] execute `basename $0` successfully."
    fi
    
    #ض
    clean_lock
    exit ${RESULT}
} 3<>"${LOCKFILE}"



