#!/bin/bash


###############################################################################
#author:   none
#date:     2015/04/30
#function: ȡǰϵͳRAIDͺ
###############################################################################

pushd $(dirname "$0") >/dev/null 2>&1
CUR_DIR="$(pwd)"
popd >/dev/null 2>&1
ADAPTER_DIR="${CUR_DIR}/adapter/"

ADAPTER_NAME=""
ADAPTER_SCRIPT=""


########################################################################
#  ȡǰRAIDű
# 1˵RAID
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_raid_adapter_script() {
    local raid_level=$1
    local all_adapter_script=""
    
    ADAPTER_SCRIPT="${ADAPTER_DIR}/nonraid_adapter.sh"
    
    if [ "X${raid_level}" = "Xnonraid" ]; then
        return 0
    fi
    
    all_adapter_script="$(find ${ADAPTER_DIR} -type f -name "*_adapter.sh" | tr "\n" " " 2>/dev/null)"
    if [ -z "${all_adapter_script}" ]; then
        echo "can not get any raid adapter script."
        return 0
    fi
    
    adapter_cnt=$(echo ${all_adapter_script} | awk '{print NF}')
    for ((index=1; index<=${adapter_cnt}; index++))
    do
        adapter_item=$(echo "${all_adapter_script}" | awk "{print \$${index}}")
        adapter_name=$(basename "${adapter_item}")
        if [ "$adapter_name" == "nonraid_adapter.sh" ]; then
            continue
        fi
        
        bash "${adapter_item}" -n >/dev/null 2>&1
        if [ $? -eq 0 ]; then
            ADAPTER_SCRIPT="${adapter_item}"
            break
        fi
    done
    
    return 0
}


########################################################################
#  RAID豸ļ״
# 1˵RAID
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function check_raid_health()
{
    local raid_level=$1
   
    get_raid_adapter_script "${raid_level}"
    
    bash ${ADAPTER_SCRIPT} -c "${raid_level}" >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "check raid health failed."
        return 1
    fi
    
    return 0
}


########################################################################
#  RAIDлȡһ̣ûеĻҪ
# 1˵RAID
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_blank_disk_from_raid()
{
    local raid_level=$1
    
    get_raid_adapter_script "${raid_level}"
    
    bash "${ADAPTER_SCRIPT}" -g "${raid_level}" >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "${ADAPTER_SCRIPT} get blank disk from raid failed."
        return 1
    fi
    
    return 0
}


########################################################################
#  ʼRAID豸
# 1˵RAID
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function init_raid_adapter()
{
    local raid_level=$1
    
    get_raid_adapter_script "${raid_level}"
    
    bash "${ADAPTER_SCRIPT}" -i "${raid_level}" >/dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "${ADAPTER_SCRIPT} ${raid_level} init raid dev by adapter failed."
        return 1
    fi
    
    return 0
}



#õǰumask
UMASK=0027
umask "$UMASK"

while getopts "c:g:i:h" options; 
do  
    case ${options} in
        c)  
                check_raid_health "${OPTARG}"
                exit $? 
                ;;  
        g)  
                get_blank_disk_from_raid "${OPTARG}"
                exit $?  
                ;; 
        i)
                init_raid_adapter "${OPTARG}"   
                exit $?  
                ;;                
        h)  
                show_help
                exit $?                
                ;;  
        *)
                show_help   
                exit 1
                ;;                
    esac   
done 
