#!/bin/bash

###################################################
# 功能: 完成preinstall之后,进行检查
# 返回值范围: 101-120
# 101  : swap is on
# 102  : 
###################################################

###################################################
# 入口函数 
# 备注:
#   模块文件夹规则: 三位的数字 + . + 名字
#                   名字只能是英文和下划线
#   例如: 099.post 中的名字为 post
#
#   入口函数规则:   模块文件夹的[名字] + _main
###################################################
function post_main()
{
    local path="$1"
    local file=""
    local ret=0
    
    debug "[${path}]Enter [${FUNCNAME}:${LINENO}]"
        
    file="${gc_mian_path}/${path}/script/setup.sh"
    
    if [ ! -f "${file}" ]; then
        info "[${FUNCNAME}:${LINENO}]" "Don't need to check swap about ${name}"
        
        #设置进度
        echo "99" > "${gc_sched_file}"
        
        return 0
    fi
    
    #运行设置OS的脚本
    bash ${file}
    ret=$?
    
    #设置进度
    echo "99" > "${gc_sched_file}"
    
    debug "Leave [${FUNCNAME}:${LINENO}]"
    
    return $ret
}
