##############################################################
## @Param ־
## @param 
## @param ־
## @Usage log $TIP $functionName $lineNo $Msg
## @Return 
## @Description ¼־
##############################################################
omm_log()
{
    local logType="$1"
    local functionName="$2"
    local lineNo="$3"
    local logMsg="$4"
    
    #־ļ
    if [ -n "$LOG_FILE" -a ! -f "$LOG_FILE" ]; then
        touch $LOG_FILE
        chmod 600 $LOG_FILE
    fi
        
    #д־ļ
    echo "[$(date +'%Z %Y-%m-%d %H:%M:%S')] $logType: [$(basename "$0") $functionName $lineNo]: ${logMsg}" >> "$LOG_FILE"
    
    return 0
}

omm_chmod()
{
    local check_str="/var/log/uninstall.log$|/var/log/gaussdbuninstall.log$|/var/log/gaussdbinstall.log$|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oma.sh$|/etc/profile.d/omm-sudo-oms.sh$|$OMA_RUN_PATH$|$OMA_RUN_PATH/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|$OMA_LOG_PATH$|$OMA_LOG_PATH/|$(dirname $OMA_LOG_PATH$)|$(dirname $OMA_LOG_PATH)/|$OMS_LOG_PATH$|$OMS_LOG_PATH/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|$OMS_TMP_PATH$|$OMS_TMP_PATH/|$OMS_USER_PROFILE$|$DB_INST_USR_HOME$|$DB_INST_USR_HOME/|$DATA_PATH$|$DATA_PATH/|sudo/runtime/change_user_exc.sh$|sudo/runtime/config_db_chg_user.sh$|${BIGDATA_ROOT_HOME}/Bigdata_gaussdb"
    if [ "$#" -eq 2 ] && [[ $2 =~ ($check_str) ]] && [[ ! $2 =~ "/.." ]] ; then
        #жļǷӲ
        if [ -f $2 ] && [ $(ls -l $2 | awk '{print $2}') -ge 2 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$2 is illegal hard link file, chmod $*"
            return
        fi
        #жļǷ
        if [ -L $2 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$2 is illegal soft link file, chmod $*"
            return
        fi
        if [ $2 == "/etc/profile.d/omm-oms.sh" ] && [ $1 != "644" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "chmod $*"
            return
        fi
        if [ $2 == "/etc/profile.d/omm-sudo-oma.sh" ] || [ $2 == "/etc/profile.d/omm-sudo-oms.sh" ] && [ $1 != "600" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "chmod $*"
            return
        fi
        
        chmod "$@"
    elif [ "$#" -eq 3 ] && [ $1 == "-R" ] && [[ $3 =~ ($check_str) ]] && [[ ! $3 =~ "/.." ]] ; then
    
        if [ $3 == "/etc/profile.d/omm-oms.sh" ] && [ $2 != "644" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "chmod $*"
            return
        fi
        if [ $3 == "/etc/profile.d/omm-sudo-oma.sh" ] || [ $3 == "/etc/profile.d/omm-sudo-oms.sh" ] && [ $2 != "600" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "chmod $*"
            return
        fi
        
        #жǷӲļ
        local check_hard_ln_str=$(find $3 -type f -ls | awk '{print $4}' | grep -vw 1)
        if [ -n "$check_hard_ln_str" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$3 have illegal hard link file, chmod $*"
            return
        fi
        #޸ķļ
        find $3 -not -type l | xargs chmod $2 2>/dev/null        
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "chmod $*"
    fi
}

omm_chown()
{
    local check_str="/var/log/uninstall.log$|$OMA_RUN_PATH$|$OMA_RUN_PATH/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|$OMA_LOG_PATH$|$OMA_LOG_PATH/|$(dirname $OMA_LOG_PATH$)|$(dirname $OMA_LOG_PATH)/|$OMS_LOG_PATH$|$OMS_LOG_PATH/|$(dirname $OMS_LOG_PATH$)|$(dirname $OMS_LOG_PATH)/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|$OMS_TMP_PATH$|$OMS_TMP_PATH/|$OMS_USER_PROFILE$|$DB_INST_USR_HOME$|$DB_INST_USR_HOME/|$DATA_PATH$|$DATA_PATH/|$OMS_USER_HOME/omm-sudo-oms.sh.bak$|sudo/runtime/change_user_exc.sh$|sudo/runtime/config_db_chg_user.sh$|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 2 ] && [[ $2 =~ ($check_str) ]] && [[ ! $2 =~ "/.." ]] ; then
        #жļǷӲ
        if [ -f $2 ] && [ $(ls -l $2 | awk '{print $2}') -ge 2 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$2 is illegal hard link file, chown $*"
            return
        fi
        #жļǷ
        if [ -L $2 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$2 is illegal soft link file, chown $*"
            return
        fi
        chown "$@"
    elif [ "$#" -eq 3 ] && [ $1 == "-R" ] && [[ $3 =~ ($check_str) ]] && [[ ! $3 =~ "/.." ]] ; then
        #жǷӲļ
        local check_hard_ln_str=$(find $3 -type f -ls | awk '{print $4}' | grep -vw 1)
        if [ -n "$check_hard_ln_str" ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$3 have illegal hard link file, chown $*"
            return
        fi
        
        #޸ķļ
        find $3 -not -type l | xargs chown $2 2>/dev/null
        
        if [ -L $3 ];then
            chown -R $2 $3 2>/dev/null
        fi        
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "chown $*"
    fi
}

omm_cp()
{
    local check_str="$DB_INST_USR_HOME/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|$DATA_PATH$|$DATA_PATH/|$(dirname $DATA_PATH)/|$BIGDATA_HOME/upgrade_backup|$OMS_USER_PROFILE|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oms.sh$|/etc/profile.d/omm-sudo-oms.sh.bak$|sudo/runtime/change_user_exc.sh$|sudo/runtime/config_db_chg_user.sh|${BIGDATA_ROOT_HOME}"
    if [ "$#" -lt 3 -o "$#" -gt 20 ];then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "cp $*"
        return
    fi
    
    local param=$1
    if [[ ! $param =~ (-) ]] ; then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "cp $*"
        return
    fi
    shift
    
    for((i=1; i<=$#; i++))
    do
        if [[ ${!i} =~ ($check_str) ]] && [[ ! ${!i} =~ "/.." ]] ; then
            continue
        else
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "cp $param $*"
            return
        fi                
    done
    
    \cp $param "$@"    
}

omm_mkdir()
{
    local check_str="$OMA_RUN_PATH$|$OMA_RUN_PATH/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|$OMA_LOG_PATH$|$OMA_LOG_PATH/|$OMS_LOG_PATH$|$OMS_LOG_PATH/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|$OMS_TMP_PATH$|$OMS_TMP_PATH/|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 2 ] && [ $1 == "-p" ] && [[ $2 =~ ($check_str) ]] && [[ ! $2 =~ "/.." ]] ; then
        mkdir "$@"
    elif [ "$#" -eq 4 ] && [ $1 == "-m" -a $3 == "-p" ] && [[ $4 =~ ($check_str) ]] && [[ ! $4 =~ "/.." ]] ; then
        mkdir "$@"        
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "mkdir $*"
    fi
}

omm_touch()
{
    local check_str="/var/log/uninstall.log$|/var/log/uninstall_oms.log$|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oma.sh$|/etc/profile.d/omm-sudo-oms.sh$|$OMS_USER_PROFILE$|$OMA_LOG_PATH/|$OMS_LOG_PATH/|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 1 ] && [[ $1 =~ ($check_str) ]] && [[ ! $1 =~ "/.." ]] ; then
        touch "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "touch $*"
    fi
}

omm_sysctl()
{
    sysctl -p
}

omm_sed()
{
    local check_str="/etc/sysctl.conf$|$DB_INST_USR_HOME/.bashrc$|/etc/ld.so.conf$|/etc/sudoers$|$OMS_USER_PROFILE$|$OMS_RUN_PATH/|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 3 ] && [ $1 == "-i" ] && [[ $3 =~ ($check_str) ]] && [[ ! $3 =~ "/.." ]] ; then
        sed "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "sed $*"
    fi
}

omm_echo_sudo()
{      
    local check_str="OMA_LOG_PATH$|SHM_KEY$|MSQ_KEY$|OMA_USER$|SYS_PARA_NAME$|SYS_PARA_VAL$|SYS_PARA_FILE$"
    if [ "$#" -eq 2 ] && [[ $1 =~ ($check_str) ]]; then
        grep $1 /etc/profile.d/omm-sudo-oma.sh > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            echo export $1=$2 >> /etc/profile.d/omm-sudo-oma.sh
        else
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "echo env $1=$2 to omm-sudo-oma.sh"
        fi       
    fi
}

omm_echo_sysctl()
{      
    if [ "$#" -eq 2 ] && [ $1 == "kernel.msgmnb" ]; then
        grep $1 /etc/sysctl.conf > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            echo $1 = $2 >> /etc/sysctl.conf
        else
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "echo env $1=$2 to /etc/sysctl.conf"
        fi       
    fi
}

omm_find()
{   
    local check_str="$OMA_RUN_PATH$|$OMA_RUN_PATH/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|$OMS_TMP_PATH$|$OMS_TMP_PATH/|$DATA_PATH$|$DATA_PATH/|${BIGDATA_ROOT_HOME}"
    if [[ $1 =~ ($check_str) ]] && [[ ! $1 =~ "/.." ]] ; then
        find "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "find $*"
    fi
}

omm_sh()
{   
    local check_str="/var/log/uninstall.log$|/var/log/uninstall_oms.log$|/etc/sysctl.conf$|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oma.sh$|/etc/profile.d/omm-sudo-oms.sh$|$OMA_RUN_PATH/|$OMS_RUN_PATH/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|find $OMA_TMP_PATH -maxdepth|$OMS_TMP_PATH$|$OMS_TMP_PATH/|$OMA_LOG_PATH/|$OMS_LOG_PATH/|$DB_INST_USR_HOME/|/etc/sudoers$|$OMS_USER_PROFILE$|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 2 ] && [ $1 == "-c" ] && [[ $2 =~ ($check_str) ]] && [[ ! $2 =~ "/.." ]] && [[ ! $2 =~ ";" ]] ; then
        sh "$@"
        ret=$?
        if [ $ret -eq 0 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "omm_sh1 failed, sh $*,ret $ret"
            return $ret
        fi
    elif [ "$#" -eq 2 ] && [ $1 == "${OMS_RUN_PATH}/workspace/ha/uninstall.sh" ] && [ $2 == "-q" ] ; then
        #жļǷӲ
        if [ -f $1 ] && [ $(ls -l $1 | awk '{print $2}') -ge 2 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$1 is illegal hard link file, sh $*"
            return
        fi
        #жļǷ
        if [ -L $1 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "$1 is illegal soft link file, sh $*"
            return
        fi
        
        sh "$@"
        ret=$?
        if [ $ret -eq 0 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "omm_sh2 failed, sh $*,ret $ret"
            return $ret
        fi
    elif [ "$#" -eq 7 ] && [[ $1 =~ ($OMS_RUN_PATH/) ]] && [[ ! $1 =~ "/.." ]] && [ $2 == "-p" ] && [ $4 == "-u" ] && [ $6 == "-g" ] ; then
        sh "$@"
        ret=$?
        if [ $ret -eq 0 ]; then
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "omm_sh3 failed, sh $*,ret $ret"
            return $ret
        fi
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "sh $*"
    fi
}

omm_kill()
{
  
    local check_str="$OMA_RUN_PATH/|$OMS_RUN_PATH/"       
    if [ "$#" -lt 2 -o "$#" -gt 20 ];then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "kill $*"
        return
    fi
    local param=$1
    if [ ! $param == "-9" ] ; then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "kill $*"
        return
    fi
    shift
    
    for((i=1; i<=$#; i++))
    do
        local str=$(ps -ef | grep ${!i} | grep -v grep | grep -v "omm kill")        
        if [[ $str =~ ($check_str) ]] ; then
            continue
        else
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "kill $param $*, kill process is [$str]."
            return
        fi                
    done
    
    kill $param "$@" 
}

omm_ipcrm()
{
    if [ "$#" -eq 2 ] && [ $1 == "-Q" -o $1 == "-M" ] && [[ $2 =~ ($SHM_KEY$|$MSQ_KEY$) ]] ; then
        ipcrm "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "ipcrm $*"
    fi
}

omm_rm()
{
    local check_str="/var/log/omm_sudoExecute_Error.log$|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oma.sh$|/etc/profile.d/omm-sudo-oms.sh$|$OMA_RUN_PATH$|$OMA_RUN_PATH/|$OMS_RUN_PATH$|$OMS_RUN_PATH/|${OMS_RUN_PATH}_bak$|$(dirname $OMA_LOG_PATH$)|$(dirname $OMA_LOG_PATH)/|$(dirname $OMS_LOG_PATH$)|$(dirname $OMS_LOG_PATH)/|$OMA_TMP_PATH$|$OMA_TMP_PATH/|$OMS_TMP_PATH$|$OMS_TMP_PATH/|$DB_INST_USR_HOME/.bashrc.bak$|$GAUSSDATA|$OMS_USER_PROFILE|/etc/profile.d/omm-oms.sh.bak$|/etc/profile.d/omm-sudo-oms.sh.bak$|${BIGDATA_ROOT_HOME}"
    
    if [ "$#" -lt 2 -o "$#" -gt 20 ];then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "rm $*"
        return
    fi
    local param=$1
    if [[ ! $param =~ (-) ]] ; then
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "rm $*"
        return
    fi
    shift
    
    for((i=1; i<=$#; i++))
    do
        if [[ ${!i} =~ ($check_str) ]] && [[ ! ${!i} =~ "/.." ]] ; then
            continue
        else
            omm_log "ERROR" "$FUNCNAME" "$LINENO" "rm $param $*"
            return
        fi                
    done
    
    rm $param "$@"
}

omm_chattr()
{
    chattr -i /etc/profile >/dev/null 2>&1
}

omm_su()
{
    if [ "$#" -eq 4 ] && [ $1 == "-" -a $2 == "$DB_INST_USR" -a $3 == "-c" ] ; then
        su "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "su $*"
    fi
}

omm_ldconfig()
{
    ldconfig
}

omm_ln()
{
    local check_str="${BIGDATA_ROOT_HOME}"
    if [[ $1 == "-sT" ]] && [[ $2 =~ "workspace" ]] && [[ ! $2 =~ ".." ]] && [[ $3 =~ ($check_str) ]] ; then
        ln $1 $2 $3
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "mv $*"
        exit 1
    fi
    
}

omm_init()
{
    init q
}

omm_mv()
{
    local check_str="${OMS_RUN_PATH}$|${OMS_RUN_PATH}_bak$|$DB_INST_USR_HOME/.bashrc$|$DB_INST_USR_HOME/.bashrc.bak$|$BIGDATA_HOME/upgrade_backup|/etc/profile.d/omm-oms.sh$|/etc/profile.d/omm-sudo-oms.sh$|/etc/profile.d/omm-sudo-oms.sh.bak$|$OMS_USER_HOME/omm-sudo-oms.sh.bak$|${OMS_RUN_PATH}|${BIGDATA_ROOT_HOME}/Bigdata_gaussdb|${BIGDATA_ROOT_HOME}"
    if [ "$#" -eq 2 ] && [[ $1 =~ ($check_str) ]] && [[ $2 =~ ($check_str) ]] ; then
        mv "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "mv $*"
        exit 1
    fi  
}

omm_python3()
{
    local check_str="${OMS_RUN_PATH}/"
    if [[ $1 =~ ($check_str) ]] && [[ ! $1 =~ "/.." ]] ; then
        python3 "$@"
    else
        omm_log "ERROR" "$FUNCNAME" "$LINENO" "python $*"
    fi  
}

#ػ
[ -f "/etc/profile" ] && source "/etc/profile"
[ -f "/etc/profile.d/omm-oms.sh" ] && source "/etc/profile.d/omm-oms.sh"
[ -f "/etc/profile.d/omm-sudo-oma.sh" ] && source "/etc/profile.d/omm-sudo-oma.sh"
[ -f "/etc/profile.d/omm-sudo-oms.sh" ] && source "/etc/profile.d/omm-sudo-oms.sh"
[ -f "/etc/profile.d/sudoProfile.sh" ] && source "/etc/profile.d/sudoProfile.sh"
# ΪʹĬֵ
[ -z "$OMA_RUN_PATH" ] && OMA_RUN_PATH="/opt/huawei/Bigdata/OMA-V100R001C00.x86_64"
[ -z "$OMS_USER" ] && OMS_USER="omm"
[ -z "$DB_INST_USR" ] && DB_INST_USR="ommdba"
[ -z "$OMA_LOG_PATH" ] && OMA_LOG_PATH="/var/log/Bigdata/omm/oma"
[ -z "$OMS_RUN_PATH" ] && OMS_RUN_PATH="/opt/huawei/Bigdata/OMSV100R001C00x8664"
[ -z "$OMS_LOG_PATH" ] && OMS_LOG_PATH="/var/log/Bigdata/omm/oms"
[ -z "$DATA_PATH" ] && DATA_PATH="/srv/BigData/dbdata_om"
[ -z "$GAUSSDATA" ] && GAUSSDATA="${DATA_PATH}/db"
[ -z "$OMS_TMP_PATH" ] && OMS_TMP_PATH="/home/omm/tmp"
[ -z "$OMA_TMP_PATH" ] && OMA_TMP_PATH="/home/omm/tmp"
[ -z "$OMS_USER_HOME" ] && OMS_USER_HOME="/home/omm"
[ -z "$DB_INST_USR_HOME" ] && DB_INST_USR_HOME="/home/$DB_INST_USR"
[ -z "$OMS_USER_PROFILE" ] && OMS_USER_PROFILE="/home/$OMS_USER/.profile"
[ -z "$GAUSSHOME" ] && GAUSSHOME="/opt/huawei/Bigdata/OMSV100R001C00x8664/gaussdb"
[ -z "$SHM_KEY" ] && SHM_KEY="6667"
[ -z "$MSQ_KEY" ] && MSQ_KEY="7777"
[ -z "$BIGDATA_HOME" ] && BIGDATA_HOME="/opt/huawei/Bigdata"

#־ļ
LOG_FILE="/var/log/omm_sudoExecute_Error.log"
