#!/bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    constants.sh
## Description: constant parameters
## Version:     FusionInsight Hadoop V100R002C02
## Created:     Wednesday, May 15, 2013
################################################################################
# ---------------------------------------------------------------------------- #
#                                   变量定义                                    #
# ---------------------------------------------------------------------------- #
if [ -f "/home/omm/.profile" ];then
    source /home/omm/.profile
fi

# 8.1.x版本之后，运行时sudo路径调整为${BIGDATA_ROOT_HOME}/Bigdata_func，如/opt/huawei/Bigdata_func
if [ -n "${BIGDATA_HOME}" ];then
    BIGDATA_SUDO_HOME=$(readlink -m ${BIGDATA_HOME}/../Bigdata_func)
else
    BIGDATA_SUDO_HOME="/var/lib/sudo/Bigdata"
fi

# 用户相关常量
declare -r INSTALL_USER="omm"
declare -r RUN_USER="omm"
declare -r RUN_USER_GROUP="wheel"
declare -r RUN_DB_USER="ommdba"
declare -r OMM_USER_HOME="/home/omm"
declare -r HOME_BASHRC="/home/${INSTALL_USER}/.bashrc"
declare -r HOME_ENV_FILE="/home/${INSTALL_USER}/env_file"
declare -r FI_COMMON_GROUP="ficommon"
declare -r FI_COMMON_GROUP_ID="9998"

# 8.0.2.x及之前版本sudo脚本路径
declare -r OLD_SUDO_HOME="/var/lib/sudo/Bigdata"
declare -r OLD_SUDO_HOME_BACKUP="/var/lib/sudo/Bigdata_backup"

# installsudo脚本路径，所有版本都为：/var/lib/sudo/Bigdata/setuptool/installSudoExecute.sh
declare -r INSTALL_SUDO_NAME="installSudoExecute.sh"
declare -r INSTALL_SUDO_DIR="${OLD_SUDO_HOME}/setuptool"
declare -r INSTALL_SUDO_PATH="${INSTALL_SUDO_DIR}/${INSTALL_SUDO_NAME}"

# sudo配置文件
declare -r SUDOERS="/etc/sudoers"

# root用户使用的INSTALL_USER
declare -r ETC_SUDO_PROFILE="/etc/profile.d/sudoProfile.sh"

