################################################################################
# Function: spin_wait
# Description: ִУʾȲȴ
################################################################################
#!/bin/bash
##############################################################
## @Company: HUAWEI Tech. Co., Ltd.
## @Filename functions.sh
## @Usage . functions
## @Description functions
## @Options
## @History
## @Version V100R002C70
## @Created 2017.06.12
##############################################################
declare -ri CANNOT_CONNECT_HOST=2
declare -ri EXECUTED_CMD_FAILED=1
declare -ri PERMISSION_DENIED=3
declare -ri HOST_KEY_VERIFIED_FAILED=4
declare -ri REMOTE_CMD_LOSS_TRUST=7                             #ʧ
declare -ri REMOTE_CMD_TIMEOUT=5                                #ʱ


decryptScc()
{
    local STR_SRC="${1}"
    local encType="${2}"

    local encryptDecryptTool=""
    if [ -f "${CONTROLLER_HOME}/tools/encryptDecryptTool.sh" ]; then
        encryptDecryptTool="${CONTROLLER_HOME}/tools/encryptDecryptTool.sh"
    elif [ -f "${NODE_AGENT_HOME}/tools/encryptDecryptTool.sh" ]; then
        encryptDecryptTool="${NODE_AGENT_HOME}/tools/encryptDecryptTool.sh"
    else
        log_error "${LINENO}" "The encryptDecryptTool.sh is not exist!";
        return 1;
    fi
    source "${encryptDecryptTool}"
    tools_getDecryptWord "${STR_SRC}" "${encType}"
}

decryptWcc()
{
    local STR_SRC="${1}"
    local encType="${2}"

    local wcc=$(find ${CONTROLLER_HOME}/share/om/controller/lib/ -maxdepth 1 -name '*wc2frm*.jar')
    local log4j=$(find ${CONTROLLER_HOME}/share/om/controller/lib -maxdepth 1 -name 'log4j*.jar')
    local commons=$(find ${CONTROLLER_HOME}/share/om/controller/lib -maxdepth 1 -name 'commons-codec*.jar')
    local classpath="${wcc}:${log4j}:${commons}:${CONTROLLER_HOME}/tools/main.jar"
    local javaArgs="-Dbeetle.application.home.path=${WCC_PROFILE_DIR}"
    local className="com.omm.encrypt.DecryptCommandWithoutParam"
    local javaCommand="${JAVA_HOME}/bin/java -cp ${classpath} ${javaArgs} ${className}"
    log_debug $LINENO "Java command: $javaCommand"
    su - omm -c "${javaCommand} <<EOF
strSrc:$STR_SRC
encType:$encType
EOF"
}

################################################################################
# Function: decrypt_ciphertext
# Description: decrypt ciphertext
# Parameter:
#   input:
#   output:
#   N/A
# Return: 
# Others: N/A
################################################################################
decrypt_ciphertext()
{
    local str_src="${1}"
    local enc_type="${2}"
    local KEY=""

    if [ -f "${CONTROLLER_HOME}/tools/encryptDecryptTool.sh" ] || [ -f "${NODE_AGENT_HOME}/tools/encryptDecryptTool.sh" ]; then
        decryptScc "$str_src" "${enc_type}"
    else
        decryptWcc "$str_src" "${enc_type}"
    fi
}

##############################################################
## @Usage delete_known_hosts
## @Input
##      $1  ip
##      $2  user
## @Return
## @Description ɾknow_hostsļýڵϢֹǰ
##              ϢʧЧԺʱ
##############################################################
delete_known_hosts()
{
    local hostIP="$1"

    # ûɾýڵipknow_hostsϢ
    [ -f "${USER_HOME}/.ssh/known_hosts" ] && sed -i "/${hostIP}/d" "${USER_HOME}/.ssh/known_hosts"
}

##############################################################
## @Usage exec_remote_cmd
## @Input
##      $1  timeout
##      $2  ip  
##      $3  command
## @Return
## @Description ½controllerִ
##############################################################
exec_remote_cmd()
{
    local timeout="$1" ; shift
    local remote_ip="$1" ; shift
    local command="$*"

    # ɾknow_hostsļýڵϢֹǰϢʧЧԺʱ
    delete_known_hosts "${remote_ip}"

    if [ ! -x "${CURRENT_PATH}/func/tool/execRemoteCmd.exp" ]; then
        log_error "${LINENO}" "The ${CURRENT_PATH}/func/tool/execRemoteCmd.exp file cannot be executed."
        return 1
    fi
    
    local passFile=$(readlink -m "${CURRENT_PATH}/../password.ini")
    if [ -f "${passFile}" ]; then
        local rootPwd=$(grep -w "${remote_ip}" "${passFile}" | grep -vE "^#" | awk '{print $2}')
        if [ -z "${rootPwd}" ]; then
            log_error "${LINENO}" "Not found the password of the ${remote_ip} in ${passFile}."
            return 1
        else
            ROOT_PASSWD="${rootPwd}"
        fi
    fi
    
    ${CURRENT_PATH}/func/tool/execRemoteCmd.exp "${remote_ip}" "${ROOT_USER}" "${ROOT_PASSWD}" "${timeout}" "${command}"
    retVal=$?
    if [ ${retVal} -eq ${REMOTE_CMD_TIMEOUT} ] ; then
        log_error "${LINENO}" "Executing the ${command} command timed out."
    elif [ ${retVal} -eq ${REMOTE_CMD_LOSS_TRUST} ] ; then
        log_error "${LINENO}" "The node $agentIP has lost trust."
    elif [ ${retVal} -eq 0 ]; then
        log_info "${LINENO}" "Execute the ${command} command succeed."
    else
        log_error "${LINENO}" "Execute the ${command} command  failed, return ${retVal}."
    fi
    
    return ${retVal}
}


##############################################################
## @Usage upload_file
## @Input
##      $1  Զip
##      $2  Զû
##      $3  Զ
##      $4  Ҫϴļ·
##      $5  ҪŵԶ̵λ
## @Return
## @Description ϴļ
##############################################################
upload_file()
{
    local remoteIP=$1
    local uploadFile=$2
    local uploadPath=$3
    local cmdTimeout=$4
    local -i retVal=0
    
    local passFile=$(readlink -m "${CURRENT_PATH}/../password.ini")
    if [ -f "${passFile}" ]; then
        local rootPwd=$(grep -w "${remoteIP}" "${passFile}" | grep -vE "^#" | awk '{print $2}')
        if [ -z "${rootPwd}" ]; then
            log_error "${LINENO}" "Not found the password of the ${remoteIP} in ${passFile}."
            return 1
        else
            ROOT_PASSWD="${rootPwd}"
        fi
    fi
    
    bash $G_REMOTE_SCRIPT -i "$remoteIP" -F "$g_ip_model" -P "$SSH_PORT" -u "$ROOT_USER" -p "$ROOT_PASSWD" \
              -t "$cmdTimeout" -m "scp-out" -s "$uploadFile" -d "$uploadPath" >> "${LOG_FILE}" 2>&1
    retVal=$?
    if [ $retVal -ne 0 ]; then
        log_error "$LINENO" "Failed to upload file ${uploadFile} to ${remoteIP}:${uploadPath} errorCode=$retVal"
    fi
        
    return ${retVal}
}

##############################################################
## @Usage upload_file_to_remote_check
## @Input
##      $1  Ҫϴļ·
##      $2  ҪŵԶ̵λ
## @Return
## @Description ϴļ
##############################################################
upload_file_to_remote_check()
{
    local uploadFile="$1"
    local uploadPath="$2"
    local G_PEER_IP="$3"
    local checkFile="$4"
    local -i retVal=0
    
    #/bin/rm -rf $checkFile
    #sha256sum  $uploadFile > $checkFile
    #if [ ! -f $checkFile ] ; then
    #    log_error "${LINENO}" "Failed to create the check file[$checkFile]."
    #    return 1
    #fi
    
    #ϴļ
    upload_file "${G_PEER_IP}" "${uploadFile}" "${uploadPath}" -1 >> ${G_LOG_FILE} 2>&1
    if [ $? -ne 0 ] ; then
        log_error "${LINENO}" "Failed to upload the ${uploadPath} file to remost host."
        return 1
    fi
    
    #ϴУļ
    upload_file "${G_PEER_IP}" "${checkFile}" "${uploadPath}" -1 >> ${G_LOG_FILE} 2>&1
    if [ $? -ne 0 ] ; then
        log_error "${LINENO}" "Failed to upload the ${uploadPath}.sha256 file to remost host."
        return 1
    fi
    
    #ִУ
    exec_remote_cmd 30 "$G_PEER_IP" "[ \$(sha256sum  \"${uploadPath}/$(basename $uploadFile)\" | awk '{printf(\"%s\",\$1)}') = \$(cat \"${uploadPath}/$(basename ${checkFile})\" | awk '{printf(\"%s\",\$1)}') ]" >> ${G_LOG_FILE} 2>&1
    if [ $? -ne 0 ] ; then
        log_error "${LINENO}" "Failed to verify the sha256 value in the ${G_PEER_IP}:/${uploadPath}/${uploadFile##*/} file."
        return 1
    fi
    
    #УͨɾԶ˺ͱУļ
    exec_remote_cmd 30 "$G_PEER_IP" "rm -rf \"${uploadPath}/${checkFile}\"" >> ${G_LOG_FILE} 2>&1
    
    return 0
}

##############################################################
## @Usage upload_dir_to_remote_check
## @Input
##      $1  Ҫϴļ·
##      $2  ҪŵԶ̵λ
## @Return
## @Description ϴļ
##############################################################
upload_dir_to_remote_check()
{
    local tmpDir="/tmp"
    local srcPath="$1"
    local tgtPath="$2"
    local remoteIp="$3"
    
    if [ ! -d "$srcPath" ]; then
        log_error "${LINENO}" "$srcPath is not a directory."
        return 1
    fi
    
    # Ŀ¼
    local dir_name="$(basename $srcPath)"
    local temp_tgz_pkg="$tmpDir/${dir_name}_temp.tar.gz"
    tar -C "$(dirname $srcPath)" -czf "$temp_tgz_pkg" "$dir_name"  >> ${G_LOG_FILE} 2>&1
    if [ $? -ne 0 ]; then
        log_error "${LINENO}" "compress $srcPath failed."
        rm -rf "$temp_tgz_pkg"
        cd - >/dev/null 2>&1
        return 1
    fi
    
    exec_remote_cmd 180 "$remoteIp" "rm -rf ${tgtPath}/${dir_name}" >> ${G_LOG_FILE} 2>&1
    upload_file_to_remote_check "$temp_tgz_pkg" "$tmpDir" "$remoteIp" || return 1
    exec_remote_cmd 180 "$remoteIp" "tar -xzf $temp_tgz_pkg -C ${tgtPath}/" >> ${G_LOG_FILE} 2>&1 || return 1
    
    #ʱļʧܲ˳ֻǴӡ־
    exec_remote_cmd 30 "$remoteIp" "rm -rf $temp_tgz_pkg" >> ${G_LOG_FILE} 2>&1
    rm -rf "$temp_tgz_pkg" >> ${G_LOG_FILE} 2>&1
}


#################################################################################
# Function: concurrent_exec
# Description:ִнűúֶ֧ͬʱã
# Parameter: $1:ͣϢбΪص, Ϊգոָ
# Parameter: $2:Ҫִеĺ÷ĵһΪϢڶΪ$3
# Parameter: $3:ص, "null" ʾ޲
# Parameter: $4:߳ null ĬΪ30
# Parameter: $5:ʼȣΧ0--100Ϊգý
# Parameter: $6:ȣΧ0--100Ϊգý
# Return: SUCESS -- ִгɹ  FAILED -- ִʧ
# Others: N/A
################################################################################
function concurrent_exec()
{
    local params="$1"
    local func="$2"
    local call_back_param="$3"
    local thread_num="$4"
    
    #ûص
    if [ "$call_back_param" = "null" ];then
        call_back_param=""
    fi 
    
    if [ "$thread_num" = "null" ];then
        #Ĭֵ30
        thread_num=30
    fi 
        
    local tmp_fifofile="/tmp/$.fifo"
    mkfifo $tmp_fifofile || { log_error $LINENO "Another concurrent_exec is running."; return 1; }
    exec 6<>$tmp_fifofile

    local -a task_info_list=($(echo "${params}" | awk -F ' ' '{for(i=1; i<=NF; i++){print $i;};}'))
    
    log_info $LINENO "parameters: $params, $func, $call_back_param, $thread_num."
    
    local total_task=${#task_info_list[@]}
    if [ "$total_task" = "0" ];then
        log_error $LINENO "IP list is empty."
        return 1
    fi
   
    for ((i=0;i<$thread_num;i++));do
        echo
    done >&6
    
    local tmp_file="/tmp/concurrent_exec_result.ini"
    echo "STATUS=SUCCESS" > "$tmp_file"
    echo "G_FAILED_TASK_LIST=" >> "$tmp_file"
    
    #ִǰļ
    rm -rf "/tmp/${func}.lock"
        
    local ret_value=0
    for task in "${task_info_list[@]}" ; do
        read -u6
        {
            $func "${task}" "$call_back_param" >> ${G_LOG_FILE} 2>&1 && {
                log_info $LINENO "exec $func ${task} $call_back_param success."
            } || {
                log_error $LINENO "exec $func ${task} $call_back_param failed."
                flock -x "/tmp/${func}.lock" -c "sed -i \"s/G_FAILED_TASK_LIST=/G_FAILED_TASK_LIST=$task /g\" $tmp_file;\
                    sed -i \"s/STATUS=.*/STATUS=FAILED/g\" $tmp_file"
            }
            
            echo >&6
        } &
    done
    wait
    exec 6>&-
    rm -f $tmp_fifofile
    
    G_FAILED_TASK_LIST=$(grep "G_FAILED_TASK_LIST=.*" "$tmp_file" | awk -F '=' '{print $2}')
    STATUS=$(grep "STATUS=.*" "$tmp_file" | awk -F '=' '{print $2}')
    
    /bin/rm -rf "$tmp_file"
       
    if [ "$STATUS" == "SUCCESS" ]; then
        return 0
    else
        return 1
    fi
}

function spin_wait()
{
    STEP_INFO="$1"

    local -i pid=0
    if [ -z "$2" ]; then
        pid=$!
    else
        pid=$2
    fi

    local -i placeholder_num=73

    printf "%-${placeholder_num}s [ %s ]\r" "${STEP_INFO}" "$BLANK"

    while ps | grep -w $pid >/dev/null 2>&1
    do
        for X in '-' '\' '|' '/'
        do 
        printf "%-${placeholder_num}s [ %s ]\r" "${STEP_INFO}" "${X}"
        sleep 0.3
        done 
    done

    wait $pid
    local ret=$?
    if [ $ret -ne 0 ]; then
        printf "%-${placeholder_num}s [\033[31;1m%s\e[m]\r" "${STEP_INFO}" "fail"
    else
        printf "%-${placeholder_num}s [\033[32;1m%s\e[m]\r" "${STEP_INFO}" "done"
    fi
    echo

    return $ret
}