#!/bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    installjre.sh
## Description: install jre
## Version:     FusionInsight Hadoop V100R002C02
## Created:     Friday, June 21, 2013
################################################################################
# ---------------------------------------------------------------------------- #
#                                   变量定义                                   #
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
#                                   常量定义                                   #
# ---------------------------------------------------------------------------- #
declare -i INS_SUCCESS=0

# ---------------------------------------------------------------------------- #
#                                   函数定义                                   #
# ---------------------------------------------------------------------------- #
################################################################################
# Function: get_cur_path
# Description: 获取脚本所在的目录及脚本名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - > /dev/null
}

################################################################################
# Function: clean_tomcat
# Description: 安装jre
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clean_tomcat()
{    
    if [ -d "/tmp/upgrade_work_tmp/" ];then
        rm -rf /tmp/upgrade_work_tmp
    fi
    
    if [ -d "/tmp/upgrade_tomcat_back" ];then
        rm -rf /tmp/upgrade_tomcat_back
    fi
    return ${INS_SUCCESS}
}
################################################################################
# Function: main
# Description: 主函数
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
main()
{
    clean_tomcat
    
    return 0
}

# ---------------------------------------------------------------------------- #
#                                 获取当前路径                                 #
# ---------------------------------------------------------------------------- #
get_cur_path
cd "${g_curPath}"

# ---------------------------------------------------------------------------- #
#                                 脚本开始运行                                 #
# ---------------------------------------------------------------------------- #
source /home/omm/.profile
main "$@"
retVal=$?

exit ${retVal}
