#!/bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    installjre.sh
## Description: install jre
## Version:     FusionInsight Hadoop V100R002C02
## Created:     Friday, June 21, 2013
################################################################################
# ---------------------------------------------------------------------------- #
#                                   变量定义                                   #
# ---------------------------------------------------------------------------- #
declare g_bigdataHome=""                    # bigdata目录
declare g_jreInstallDir=""                  # jre安装后的路径
declare g_jreBinFileName=""                 # jre安装文件名
declare g_jreInstallFileDir=""              # jre安装文件存放目录
declare g_curPath=""                        # 当前脚本所在的目录
declare g_scriptName=""                     # 当前脚本的脚本名称
declare g_currentJreVersion=""
declare g_currentJreInstallDir=""
declare -i retVal=0                         # 返回值

# ---------------------------------------------------------------------------- #
#                                   常量定义                                   #
# ---------------------------------------------------------------------------- #


# ---------------------------------------------------------------------------- #
#                                   函数定义                                   #
# ---------------------------------------------------------------------------- #
################################################################################
# Function: get_cur_path
# Description: 获取脚本所在的目录及脚本名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - > /dev/null
}

################################################################################
# Function: main
# Description: 主函数
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
main()
{
    local compoent_package_name="${1}"    
    local component_src_path="${2}"
    local g_mess="${3}"
    local component_tmp_target_path="/tmp/upgrade_work_tmp/"
    local preinstall_scp_tool="${g_curPath}/../../preinstall/tools/cluster/clusterscp.sh"    
    
    local preinstall_cmd_tool="${g_curPath}/../../preinstall/tools/cluster/clustercmd.sh"
    
    sh ${preinstall_cmd_tool} "mkdir -p /tmp/upgrade_work_tmp/" "${g_mess}"
    
    sh ${preinstall_scp_tool} put ${component_src_path} ${component_tmp_target_path} "${g_mess}"
    return 0
}

# ---------------------------------------------------------------------------- #
#                                 获取当前路径                                 #
# ---------------------------------------------------------------------------- #
get_cur_path
cd "${g_curPath}"

# ---------------------------------------------------------------------------- #
#                                 脚本开始运行                                 #
# ---------------------------------------------------------------------------- #
main "$@"
retVal=$?

exit ${retVal}
