#!/bin/bash

declare g_old_tomcatHome=""
declare g_tomcatHome=""
declare current_tomcat_name=""
declare target_tomcat_name=""
declare g_bigdataOMHome=""
declare g_controllerHome=""

function install_tomcat()
{
    if [ ! -d "${g_tomcatHome}/conf/security/" ];then
        su - omm -c "mkdir -p "${g_tomcatHome}/conf/security/""
    fi
    
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/security/tomcat* ${g_tomcatHome}/conf/security/"
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/security/jaas.conf ${g_tomcatHome}/conf/security/"
    
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/web.xml ${g_tomcatHome}/conf/"
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/server.xml ${g_tomcatHome}/conf/"
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/logging.properties ${g_tomcatHome}/conf/"
    su - omm -c "cp -f ${g_old_tomcatHome}/conf/context.xml ${g_tomcatHome}/conf/"
    su - omm -c "cp -f ${g_old_tomcatHome}/bin/startup.sh ${g_tomcatHome}/bin/"
    su - omm -c "cp -f ${g_old_tomcatHome}/bin/shutdown.sh ${g_tomcatHome}/bin/"
    su - omm -c "cp -f ${g_old_tomcatHome}/bin/checkInitLogin.sh ${g_tomcatHome}/bin/"
    su - omm -c "cp -f ${g_old_tomcatHome}/bin/catalina.sh ${g_tomcatHome}/bin/"
    
    su - omm -c "cp -f ${g_old_tomcatHome}/lib/wc2frm-v1r2c60-20160429.jar ${g_tomcatHome}/lib/"
    su - omm -c "cp -f ${g_old_tomcatHome}/lib/OMMHttp11-2.1.jar ${g_tomcatHome}/lib/"
    su - omm -c "cp -f ${g_old_tomcatHome}/lib/log4j-1.2.17.jar ${g_tomcatHome}/lib/"
    su - omm -c "cp -f ${g_old_tomcatHome}/lib/crypter-0.0.6.jar ${g_tomcatHome}/lib/"
    su - omm -c "cp -f ${g_old_tomcatHome}/lib/commons-codec-1.9.jar ${g_tomcatHome}/lib/"
    su - omm -c "cp -f ${g_old_tomcatHome}/bin/catalina.sh ${g_tomcatHome}/bin/"
    
    
    su - omm -c "cp -f ${g_old_tomcatHome}/accessfailed.html ${g_tomcatHome}/"
    su - omm -c "cp -f ${g_old_tomcatHome}/500.html ${g_tomcatHome}/"
    su - omm -c "cp -f ${g_old_tomcatHome}/415.html ${g_tomcatHome}/"
    su - omm -c "cp -f ${g_old_tomcatHome}/404.html ${g_tomcatHome}/"
    su - omm -c "cp -f ${g_old_tomcatHome}/404.html ${g_tomcatHome}/"

    su - omm -c "cp -rf ${g_old_tomcatHome}/webapps/* ${g_tomcatHome}/webapps/"
    
    chmod 700 ${g_tomcatHome} -R
    find "${g_tomcatHome}/conf" -type f -name "*" | xargs -I{} chmod 600 "{}"

    if [ "${target_tomcat_name}" == 'apache-tomcat-8.5.28' ];then
        local key_remove="<Listener className=\"org.apache.catalina.core.JasperListener\" />"
        local key_replace_str="<\!--Listener className=\"org.apache.catalina.core.JasperListener\" /-->"
        local tomcat_server_config="${g_tomcatHome}/conf/server.xml"
        sed -i "s:${key_remove}:${key_replace_str}:g" "${tomcat_server_config}" || return 1   
    fi
    
    echo "leave install_tomcat." >> "${log_file}"
    return 0
}

main()
{
    local backup_dir="$1"
    local log_file="$2"
    local current_tomcat_name="$3"
    local target_tomcat_name="$4"    
    local tomcat_tmp_dir="/tmp/upgrade_work_tmp/"
    local tomcat_dir_parent="${BIGDATA_HOME}/om-server/"
    
    if [ ! -d "${tomcat_dir_parent}" ];then
        tomcat_dir_parent="${BIGDATA_HOME}/"
    fi
    
    local new_tomcat_package="${tomcat_tmp_dir}/${target_tomcat_name}.tar.gz"
    local time=$(date)
    echo "$time ready to pach backup_dir=$backup_dir log_file=$log_file target_tomcat_name=$target_tomcat_name current_tomcat_name=$current_tomcat_name" >> "${log_file}"
    
    if [ ! -f "${log_file}" ];then
        mkdir -p "$(dirname ${log_file})"         
    fi
    
    if [ ! -f "${new_tomcat_package}" ];then
        echo "no tomcat gz package" >> "${log_file}"
        return 1
    fi
    
    tar -zxf "${new_tomcat_package}" -C "${tomcat_dir_parent}"
    if [ $? -ne 0 ];then
        echo "decompress gz file failed." >> "${log_file}"
        return 1
    fi
    
    g_old_tomcatHome="${tomcat_dir_parent}/${current_tomcat_name}"    
    local bak_dir="$(echo ${current_tomcat_name}|rev)""_bak"
    g_old_tomcatHome_bak="${tomcat_dir_parent}/${bak_dir}"
    g_tomcatHome="${tomcat_dir_parent}/${target_tomcat_name}"  
    g_omsHome="${OMS_RUN_PATH}/workspace/"
    g_httpdHome="${OM_HTTPD_HOME}"
    g_controllerHome="${CONTROLLER_HOME}"
    g_bigdataOMHome="${g_controllerHome}/../"
    
    chmod 700 "${g_tomcatHome}" -R
    chown omm:wheel "${g_tomcatHome}" -R
    install_tomcat
    if [ $? -ne 0 ];then
        echo "install tomcat error." >> "${log_file}"
        return 1
    fi
    
    if [ "${target_tomcat_name}" == 'apache-tomcat-8.5.28' ];then
        mv "${g_bigdataOMHome}/${target_tomcat_name}/webapps/web/WEB-INF/lib/jul-to-slf4j-1.7.5.jar" "${backup_dir}"
        mv "${g_bigdataOMHome}/${target_tomcat_name}/webapps/web/WEB-INF/lib/log4j-over-slf4j-1.7.5.jar" "${backup_dir}"
        mv "${g_bigdataOMHome}/${target_tomcat_name}/webapps/cas/WEB-INF/lib/jul-to-slf4j-1.7.5.jar" "${backup_dir}"
        mv "${g_bigdataOMHome}/${target_tomcat_name}/webapps/cas/WEB-INF/lib/log4j-over-slf4j-1.7.5.jar" "${backup_dir}"
    fi

    su - omm -c "mv -f "${g_old_tomcatHome}" "${g_old_tomcatHome_bak}"" >> "${log_file}"
    su - omm -c "mv -f "${g_tomcatHome}" "${g_old_tomcatHome}"" >> "${log_file}"
    
    local omsStatus=$($OMS_RUN_PATH/workspace/ha/module/hacom/script/get_harole.sh | head -n 1)
    local ha_mode=$($OMS_RUN_PATH/workspace/ha/module/hacom/script/config_ha.sh -a |grep "^HaMode" |awk '{ print $2 }')

    if [ ${ha_mode} = "double" -a ${omsStatus} = "active" ] ;then
        ps -ef |grep ${current_tomcat_name}| grep ${BIGDATA_HOME} |awk '{print $2}'|xargs kill -9
        su - omm -c "sh ${g_bigdataOMHome}/tomcat/bin/startup.sh"
    elif [ ${ha_mode} = "single" ];then
        ps -ef |grep ${current_tomcat_name} | grep ${BIGDATA_HOME} |awk '{print $2}'|xargs kill -9
        su - omm -c "sh ${g_bigdataOMHome}/tomcat/bin/startup.sh"
    fi
    local time=$(date)
    echo "$time install tomcat patch succced." >> "${log_file}"
    return 0
}
source /home/omm/.profile
main "$@"
exit $?