/*******************************************************************************
* Copyright @ Huawei Technologies Co., Ltd. 1998-2014. All rights reserved.
*********************************************************************************/
#ifndef SC_TYPE_H
#define SC_TYPE_H

#ifdef __cplusplus

extern "C"
{
#endif

#include "kms_kmc_callback_common.h"

/************************************************************************
 *  macro defines
************************************************************************/
#define SEC_FALSE          (0)
#define SEC_TRUE           (1)

#define PATH_LEN            (1024)
#define FILE_NAME_LEN       (32)
#define RANDOM_DEV_LEN      (16)
/************************************************************************
 *  type defines
************************************************************************/
typedef int SEC_ERR_T;
typedef int SEC_BOOL;

typedef struct {
    char *confPath;
    char *primaryKeyStoreFile;
    char *standbyKeyStoreFile;
    char *backupFolderName;
    char *logPath;
    char *logFileName;
    char *randomDevice;
    int logLever;
    int domainCount;
    int defaultAlgorithm;
    int enableChangeFilePermission;
    int semKey;
    int semPerm;
    int enableHw;
    kmc_sig_params_t kmcSigParams;
    int enableSSLVerify;
    int splitUserLog;
} configuration;


#ifdef SC_OS_WINDOW
#define FILE_SEPARATOR '\\'
#else
#define FILE_SEPARATOR '/'
#endif

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif/* SC_TYPE_H */
