#!/bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    installSudoExecute.sh
## Description: can execute sudo command via this script
## Version:     FusionInsight V100R002C60
## Created:     Friday, 11 17, 2015
################################################################################
declare g_sudo_profile="/etc/profile.d/sudoProfile.sh" # sudo脚本中用到的环境变量文件
if [ -f ${g_sudo_profile} ] ; then
    source ${g_sudo_profile}
fi
declare g_curPath=""                                   # 当前脚本所在的路径
declare g_scriptName=""                                # 当前脚本的脚本名称
declare -r OMM_USER="omm"
declare -r BACKUP_USER="backup"
declare -r WHEEL_GROUP="wheel"
declare -r DB_CREATER="ommdba"
declare -r FI_COMMON_GROUP="ficommon"                          # ficommon用户组
declare -r FI_COMMON_GROUP_ID="9998"                          # ficommon用户组id
declare -r OMM_USER_HOME="/home/omm"
declare -r DB_CREATER_HOME="/home/ommdba"
declare -r DB_INSTALL_DIR="gaussdb"
declare -r DB_CTL_CMD="bin/gs_ctl"
declare -r LOG_HOME="/var/log"
declare -r DB_HOME=$(su - omm -c 'echo ${GAUSSDATA}')
declare -r NODEAGENT_LOG_FILE="${BIGDATA_LOG_HOME}/nodeagent/scriptlog/install.log"
declare -r OMS_LOG_FILE="${BIGDATA_LOG_HOME}/controller/scriptlog/install.log"
declare -r OMS_UNINSTALL_LOG_FILE="${LOG_HOME}/bigdataControllerUninstall.log"
declare -r SUDO_LOG_FILE="${BIGDATA_LOG_HOME}/sudo/sudo.log"
declare -r G_CUR_PATH="$(readlink -f "$0" | xargs dirname)"
declare  REDHAT_CRONTAB_FILE='/var/spool/cron/omm'
declare  SUSE_CRONTAB_FILE='/var/spool/cron/tabs/omm'
declare -r UPGRADE_OPERATOR="upgrade"
declare -r OM_DATA_DIR="Manager"                                # Manager数据目录
declare -r G_OM_SERVER_HOME_NAME="om-server"
declare -r G_OMM_SERVER_HOME_NAME="OMS"
declare -r IPV4_MODEL="IPv4"
declare -r IPV6_MODEL="IPv6"
declare -r G_SUDO_PATH=$(pushd $(dirname $BASH_SOURCE) > /dev/null; pwd; popd >/dev/null)
declare BASE_CHARS="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVXYZ01223456789~!@#$%^&*-_=+|[];,<.>/?"
declare BASE_SPEC_CHARS="~!@#$%^&*-_=+|[];,<.>/?"
declare DIGIT_CHARS="0123456789"
declare ALP_CHARS="abcdefghijklmnopqrstuvwxyz"
declare PWD_LEN=16
declare -r g_fuctionArray=(Add_host2 AuthManager_getFloatIpNetmask AuthManager_getFloatIpInterface DIManager_getFloatIpNetmask DIManager_getFloatIpInterface DSManager_getFloatIpNetmask DSManager_getFloatIpInterface execute_addHost2 restrict_mkdir security_nodeagent_software_dir_and_file_chown_root security_software_dir_and_file_chown_root forbid_ommdba_login remove_forbid_ommdba_login addPathPermission addPermissionToLog addTrustHost add_data_dir_permission add_install_dir_permission add_log_dir_permission add_omm_user add_ommdba_user config_ommdba_umask add_route_tables add_route_tables_ntp add_user add_user_group backup_postgresql_conf cat_fstab cat_sysctl change_file_placeholder check_dfP check_ethtool check_hosts check_iftop check_mounta check_find_ls check_find check_dd check_pvs check_smartctl check_stat check_sysctl check_tail check_cron check_sudoers check_service checkController checkFloat_ip checkInterface_inet checkInterface_inet_addr chkconfig_ctl chmod_chown_om_profile chmod_database_sql_dir chmod_ntp_conf chmod_oms_install_script chown_tmp chowntimestamp clear_route_config clear_source_profile clear_sudoers clear_timer_feed_watchdog configOMSDiskManger config_crontab config_limits config_new_limits config_nodeagent_oma config_nodeagent_sshd config_ntp uninstall_ntp_sys_conf config_oms_oma config_sshd config_sysctl controller_install_mkdir_chown copy_ommsudo cp_lk_package creat_uninstall_oms_log create_sudo_profile delete_bigdata_dir delete_crontabInfo delete_dbdata_om delete_log_dir delete_nodeagent_dir delete_om_profile delete_ommProfile delete_omm_home  delete_omm_process delete_omm_user delete_ommdba_user delete_packages_dir delete_tmp_txt download effective_sysctl exec_omm_cmd genNtpKeyFile gen_aos_pluginfile get_interface get_localip get_omm_env init_omm_user init_ommdba_user init_upgrade_log install_rpm_package query_rpm_package update_rpm_package is_db_running kill_ntp_process log log_File_touch log_chmod log_dir_chmod log_dir_chown log_mkdir m_add_crontab m_add_tmp_dir_permission m_chown_log m_clear_ntp_config m_config_sudoers m_config_tcp_ip m_copy_scrpitToLocal m_exec_osperf m_init_localFile m_init_logFile m_modify_ntp_file m_remove_from_cron_file backup_ntp_sys_conf m_replace_ntp_conf m_restart_cron m_save_setupScriptToLocal m_uninstallOsperf update_crontab_logman m_update_drift modify_oms_sudo_script nodeagent_addTrustHost_chmod nodeagent_dir_chown_omm nodeagent_download_chown_chmod nodeagent_home_chmod nodeagent_home_mkdir nodeagent_initdir_chmod nodeagent_install_chmod nodeagent_installagent_chmod nodeagent_scp_chown_chmod nodeagent_setUpgradeModel_exe nodeagent_tmp_mkdir nodeagent_tmpdir_chown_omm ntpdate_sync_time ntpq_np preinstall_add_to_fstab preinstall_blkid preinstall_cat preinstall_chmod preinstall_add_to_crypttab preinstall_cryptsetup preinstall_chmod_r preinstall_chown preinstall_chown_r preinstall_cp preinstall_cp_so preinstall_create_softlink preinstall_dd_clean_zero preinstall_dos2unix preinstall_echo_proc_scsi preinstall_fdisk_l preinstall_parted preinstall_file_s preinstall_findfs preinstall_fuser_mk preinstall_install preinstall_is_dir preinstall_is_file preinstall_mkdir_p preinstall_init_data_dir preinstall_mkfs_ext3 preinstall_mkfs_ext4 preinstall_mount preinstall_touch preinstall_move preinstall_parted_s_mk_gpt preinstall_parted_s_mk_logical preinstall_parted_unit_print preinstall_partprobe preinstall_readlink_e preinstall_readlink_m preinstall_redhat_update_etc_hostname preinstall_remove_etc_hosts preinstall_remove_hostname_etc_hosts preinstall_invalidate_cgroup expand_ipv6 hex2dec compress_ipv6 preinstall_rm_f preinstall_rm_rf preinstall_rngd_start preinstall_rngd_stop preinstall_sfdisk_g preinstall_start_diskmgt preinstall_addDiskmgt2reboot preinstall_stop_diskmgt preinstall_suse_update_etc_hostname preinstall_swap_off preinstall_swapon_s preinstall_umount preinstall_update_etc_hosts preinstall_wait preinstall_which preinstall_config_coredump redhat_config_language remount_ctl remove_DNS_config remove_crontab remove_ntp_keyFile remove_tmp replace_fstab replace_sysctl res_mount_cgroup res_rm_cgroup_dir res_set_cgroup res_set_syscontrol res_unmount_cgroup restart_crontab_service restart_diskmgt restrict_cp restrict_mv restrict_rm scp services_ctl set_cmd_to_sudoers set_ommdba_code set_sudoers sha256sum_NodeAgentPackage sntp_sync_time software_data_chmod software_data_chown software_data_mkdir software_dir_chown software_dir_chown_omm create_softlink_for_libnsl create_softlink_for_libnsl3 configPerlHome software_install_chmod software_install_mkdir software_log_chmod software_log_mkdir software_log_rm start_diskmgt stop_diskmgt stop_redhat_iptables stop_euleros_iptables suse_config_clock suse_config_language sync_time tmp_log_chmod tmp_log_chown tmp_log_cp tmp_log_mkdir tmp_log_touch uninstall_datanode uninstall_diskmgt uninstall_kerberos uninstall_nodeagent_script_executive_chmod uninstall_script_executive_chmod unmount_Loader validate_dir_exist validate_file_system validate_software_dir_is_empty verify_path wdt_stop write_sudo_profile get_db_sync_status force_stop_database delete_root_env delete_not_root_env validate_file_exist clear_install_user delete_common_group clear_bashrc change_user_supplementary_group security_dir_chown_omm_wheel security_file_chown_omm_wheel jre_dir_chown_ficommon add_ficommon_for_nodeagent write_sudo_profile_agent check_dataHome_space rm_manager_dataHome copy_managerData check_Manager_dataHome_type delete_Manager re_create_sudo_profile preinstall_for_upgrading chown_data_home stop_suse_iptables delete_manager_backup_link high_os_version_check system_ctl system_ctl_reload disable_selinux preinstall_mkfs_xfs modify_rngd_service cp_sudo_file preinstall_parted_unit_gb_print preinstall_parted_s_mk_opt_logical preinstall_pvscan_s security_dir_chown_ficommon mk_components_sudo_dir m_upgrade_backup_crontab m_upgrade_backup_profile restart_database cancel_hardLink add_file delete_file replace_file delete_innerFile update_innerFile back_file restrict_chmod restrict_chown delete_sudo_config delete_backup_sudo_config delete_oms_sudo_config delete_profile_env mk_bigdata_sudo_home_dir adjust_ntp_apparmor_config ntpdService_file_preset backup_sudo_file delete_sudo_bakup_file recovery_backup_sudo_file systemd_chown systemd_chmod config_coredump_dir clean_coredump_dir configHostRecovery cleanHostRecovery backup_hosts_file recovery_backup_hosts_file node_hardware_type sed_file recoverIp config_mrs_crontab generate_archivelog find_log_file find_file_with_log_prefix ldapc_install_backupConfig_cpf switch_executor_knox_workspace mk_path_knox_executor del_files_for_mrs delete_omm_tmpFiles preinstall_copy_libboost create_soft_link_for_libssl_libcrypto create_soft_link_for_libboost process_ssh_for_local change_tmp_dir rm_fake_controller_home preinstall_creatsoftlink execute_gsql nodeagent_init_home_dir execute_statment_gsql get_omm_encrypt_pwd reset_omm_pwd delete_linux_user config_disable_ipv6 delete_profile_env_client scc_log_chown_omm_ficommon security_scc_dir_chown_omm_ficommon bigdata_common_tools_dir_chown_omm_ficommon clear_scc_semaphore create_soft_link_for_ldlinux create_soft_link_for_openldap preinstall_add_diskmgt_optimized_to_local manager_copy_cross_platform_secc check_cloud_init)
# ---------------------------------------------------------------------------- #
#                                   返回码                                     #
# ---------------------------------------------------------------------------- #
declare -ri INS_SUCCESS=0                                       # 执行成功
declare -ri INS_FAILURE=1                                       # 执行失败
declare -ri INS_DEBUG_ERROR=2                                   # 调试时可发现的错误
declare -ri INS_CANCEL_INSTALL=3                                # 取消安装操作
declare -ri INS_OMA_ALREADY_EXIST=4                             # OMA已经被安装
declare -ri INS_OMS_ALREADY_EXIST=5                             # OMS已经被安装
declare -ri INS_PATH_NOT_EXIST=6                                # 指定目录不存在
declare -ri INS_FILE_NOT_EXIST=7                                # 指定文件不存在
declare -ri INS_INSTALL_OMS_FAILURE=8                           # 安装OMS失败
declare -ri INS_CONFIG_OMS_FAILURE=9                            # 配置OMS失败
declare -ri INS_INSTALL_OMA_FAILURE=10                          # 安装OMA失败
declare -ri INS_CONFIG_OMA_FAILURE=11                           # 配置OMA失败
declare -ri INS_START_PROC_FAILURE=12                           # 启动进程失败
declare -ri INS_INSTALL_JDK_FAILURE=13                          # 安装JRE失败
declare -ri INS_INSTALL_JRE_FAILURE=14                          # 安装JRE失败
declare -ri INS_FILE_NOT_UNIQUE=15                              # 文件不唯一
declare -ri INS_CREATE_FILE_FAILURE=16                          # 创建文件失败
declare -ri INS_WRITE_FILE_FAILURE=17                           # 写文件失败
declare -ri INS_COMPRESS_FAILURE=18                             # 压缩文件失败
declare -ri INS_DECOMPRESS_FAILURE=19                           # 解压文件失败
declare -ri INS_USER_GROUP_NOT_EXIST=20                         # 指定用户组不存在
declare -ri INS_DELETE_USER_FAILURE=21                          # 删除用户失败
declare -ri INS_ADD_USER_FAILURE=22                             # 增加用户失败
declare -ri INS_CHANGE_PASSWD_FAILURE=23                        # 修改密码失败
declare -ri INS_USER_ALREADY_EXIST=24                           # 用户已存在
declare -ri INS_RELOAD_CONFIG_EXIST=25                          # 加载配置失败
declare -ri INS_EXEC_SQL_FAILURE=26                             # 执行sql失败
declare -ri INS_GTE_DB_STATUS_FAILURE=27                        # 获取数据库运行状态失败
declare -ri INS_EXEC_SH_FAILURE=28                              # 执行脚本失败
declare -ri INS_CONFIG_TRUST_FAILURE=29                         # 配置互信失败
declare -ri INS_COPY_FILE_FAILURE=30                            # 拷贝文件失败
declare -ri INS_MKDIR_FAILURE=31                                # 创建目录失败
declare -ri INS_CONFIG_TOMCAT_FAILURE=32                        # 配置tomcat失败
declare -ri INS_MODIFY_FILE_FAILURE=33                          # 修改文件失败
declare -ri INS_OMA_INS_PACKAGE_NOT_EXIST=34                    # oma安装包不存在
declare -ri INS_LIBSTDC_INS_PACKAGE_NOT_EXIST=35                # LIBSTDC安装包不存在
declare -ri INS_INPUT_PARMA_INVALID=36                          # 入参无效
declare -ri INS_CONFIG_SUDO_FAILURE=37                          # 配置sudoers失败
declare -ri INS_NO_EXEC_AUTHORITY=38                            # 文件不具有可执行权限
declare -ri INS_UNINSTALL_OMA_FAILURE=39                        # 卸载OMA失败
declare -ri INS_MARKER_NOT_UNIQUE=40                            # 标示符不唯一
declare -ri INS_MODIG_AUTHORITY_FAILURE=41                      # 修改文件权限失败
declare -ri INS_INSTALL_BIND_CHROOTENV_PACK_FAILURE=42          # 安装BIND_CHROOTENV_PACK失败
declare -ri INS_INSTALL_BIND_PACK_FAILURE=43                    # 安装BIND_PACK失败
declare -ri INS_INSTALL_START_NAMED_FAILURE=44                  # 启动named服务失败
declare -ri INS_LDAP_FAILED=45                                  # install Ldap 失败
declare -ri INS_KERBEROS_FAILED=46                              # install Kerberos 失败
declare -ri INS_CREATE_FI_COMMON_GROUP_FAILED=47                # 创建ficommon用户组失败

###########################升级错误码100-150#################################
declare -ri UPG_OPT_ILLEGAL_PATH=100                            # 操作非法目录或文件
declare -ri PARAMETERS_ILLEGAL=101                              # 参数不合法
declare -ri STOP_DATABASE_FAIL=102

######################################################################################

# ---------------------------------------------------------------------------- #
#                                   函数定义                                   #
# ---------------------------------------------------------------------------- #
################################################################################
# Function: get_cur_path
# Description: 获取脚本所在的目录及脚本名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - > /dev/null
}

################################################################################
# Function: tmp_log_chmod
# Description: chmod 700 /tmp/scriptlog
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
tmp_log_chmod()
{
    local tmp_log="/tmp/scriptlog"
    if [ "${1}" = "${tmp_log}"  ] ; then
        /bin/chmod 700 "${1}" -R
        return $?
    fi
    return 1
}
######################################################################################

################################################################################
# Function: security_dir_chown_ficommon
# Description: 修改"${BIGDATA_HOME}"/common/runtime*目录属组
################################################################################
security_dir_chown_ficommon()
{
    local common_workspace="$1"
    local log_file="$2"
    verify_path "${common_workspace}" || return 1

    log "INFO" "${LINENO}" "security_dir_chown_ficommon start." "${log_file}"

    local keydir="${common_workspace}"/security
    if [ -d "${keydir}" ]; then
        /bin/chown ${OMM_USER}:${FI_COMMON_GROUP} "${keydir}" -R >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Failed to change group of ${keydir} to ${FI_COMMON_GROUP}." "${log_file}"
            return 1
        fi
    fi
    return 0
}

################################################################################
# Function: Add_host2
# Description: hosts文件里写入ip主机名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function Add_host2(){
    temppath="$1"
    hostFile="$2"
    verify_path "${temppath}" || return 1
    verify_path "${hostFile}" || return 1
    if [ ! -d "${temppath}" ]; then
        return 1
    fi
    if [ ! -f "${hostFile}" ]; then
        return 1
    fi
    cp /etc/hosts $temppath
    cat $hostFile|while read line
    do
        if grep -q "$line" $temppath/hosts;then
            echo NULL
        else
            echo $line >> $temppath/hosts
        fi
    done
    cp $temppath/hosts /etc/
    return 0
}

################################################################################
# Function: AuthManager_getFloatIpNetmask
# Description: 获取子网掩码
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function AuthManager_getFloatIpNetmask(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi

    mask=$( ${IFCONFIG} -a |grep -w -F "${service_ip}" | awk '{print $4}' | tr -d 'Mask:' )
    echo ${mask}

    exit 0
}

################################################################################
# Function: AuthManager_getFloatIpInterface
# Description: 获取网卡信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function AuthManager_getFloatIpInterface(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi
    ether=$( ${IFCONFIG} -a | grep -B1 -w "${service_ip}" | head -n 1 | awk '{print $1}')
    if [ -z "${ether}" ];then
        echo ""
        exit 0
    fi
    echo ${ether%:*}:AUM
    exit 0
}

################################################################################
# Function: DIManager_getFloatIpNetmask
# Description: 获取子网掩码
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function DIManager_getFloatIpNetmask(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi

    mask=$( ${IFCONFIG} -a |grep -w -F "${service_ip}" | awk '{print $4}' | tr -d 'Mask:' )
    echo ${mask}

    exit 0
}

################################################################################
# Function: DIManager_getFloatIpInterface
# Description: 获取网卡信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function DIManager_getFloatIpInterface(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi
    ether=$( ${IFCONFIG} -a | grep -B1 -w "${service_ip}" | head -n 1 | awk '{print $1}')
    if [ -z "${ether}" ];then
        echo ""
        exit 0
    fi
    echo ${ether%:*}:DIM
    exit 0
}
################################################################################
# Function: DSManager_getFloatIpNetmask
# Description: 获取子网掩码
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function DSManager_getFloatIpNetmask(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi

    mask=$( ${IFCONFIG} -a |grep -w -F "${service_ip}" | awk '{print $4}' | tr -d 'Mask:' )
    echo ${mask}

    exit 0
}

################################################################################
# Function: DSManager_getFloatIpInterface
# Description: 获取网卡信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function DSManager_getFloatIpInterface(){
    service_ip="$1"
    if [ -z "${service_ip}" ];then
        echo ""
        exit 0
    fi
    ether=$( ${IFCONFIG} -a | grep -B1 -w "${service_ip}" | head -n 1 | awk '{print $1}')
    if [ -z "${ether}" ];then
        echo ""
        exit 0
    fi
    echo ${ether%:*}:DSM
    exit 0
}

function execute_gsql(){
    user=${1}
    dbname=${2}
    port=${3}
    file=${4}
    cp ${file} ${BIGDATA_HOME}/tmp/fi_tmp_file.sql
    chown ommdba:wheel ${BIGDATA_HOME}/tmp/fi_tmp_file.sql
    su - ommdba -c "sh ${BIGDATA_HOME}/../Bigdata_gaussdb/workspace/creatTable.sh ${user} ${dbname} ${port} ${BIGDATA_HOME}/tmp/fi_tmp_file.sql"
    ret=$?
    rm -f ${BIGDATA_HOME}/tmp/fi_tmp_file.sql
    return ${ret}
}

function execute_statment_gsql(){
    user=${1}
    passwd=${2}
    dbname=${3}
    port=${4}
    statment="${5}"
    touch /tmp/fi_tmp_statment.sql
    echo "${statment}" > /tmp/fi_tmp_statment.sql
    chown ommdba:wheel /tmp/fi_tmp_statment.sql
    su - ommdba -c "gsql -U ${user} -W ${passwd} -d ${dbname} -h localhost -p ${port} -f /tmp/fi_tmp_statment.sql"
    return $?
}

################################################################################
# Function: execute_addHost2
# Description: hosts文件里写入ip主机名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
execute_addHost2(){
    local hostFile="$1"
    local type="$2"
    local linkname="$3"
    local CDMHOME="$4"

    verify_path "${CDMHOME}" || return 1
    if [ ! -d "${CDMHOME}" ]; then
        return 1
    fi
    temppath="$CDMHOME/tomcat/webapps/sqoop/WEB-INF/classes/$type/$linkname/$type/temp"
    chattr +S /etc/hosts
    cp /etc/hosts $temppath
    cat $hostFile|while read line
    do
        if grep -q "$line" $temppath/hosts;then
            echo NULL
        else
            echo $line >> $temppath/hosts
            if test $? -ne 0 ; then
                echo "add hosts  feature failed"
                return 1
            fi
        fi
    done
    cp $temppath/hosts /etc/
    rm $temppath/hosts -rf
    chattr -S /etc/hosts
    return 0
}

################################################################################
# Function: change_tmp_dir
# Description: chmod o-t /tmp
#
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
change_tmp_dir()
{
   chmod o-t /tmp
}

################################################################################
# Function: tmp_log_mkdir
# Description: mkdir -p /tmp/scriptlog/
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog/"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
tmp_log_mkdir()
{
    local tmp_log_dir="/tmp/scriptlog"
    if [ "${1}" = "${tmp_log_dir}"  ] ; then
        /bin/mkdir -p "${1}"
        return $?
    fi
    return 1
}


################################################################################
# Function: tmp_log_touch
# Description: touch /tmp/scriptlog/install.log
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog/install.log"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
tmp_log_touch()
{
    local tmp_log="/tmp/scriptlog/install.log"
    if [ "${1}" = "${tmp_log}"  ] ; then
        /bin/touch "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: tmp_log_chown
# Description: chown  ${OMM_USER} /tmp/scriptlog/ -R
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog/"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
tmp_log_chown()
{
    local tmp_log_dir="/tmp/scriptlog"
    if [ "${1}" = "${tmp_log_dir}" ] ; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${1}" -R
        return $?
    fi
    return 1
}

################################################################################
# Function: software_install_mkdir
# Description: mkdir -p ${BIGDATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_install_mkdir()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to create installation home." "$logFile"
    if [ "${1}" = "${BIGDATA_HOME}" ] ; then
        /bin/mkdir -p "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to create installation home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,g_productHome=${1},but BIGDATA_HOME=${BIGDATA_HOME}." "$logFile"
    return 1
}
################################################################################
# Function: rm_manager_dataHome
# Description: rm -rf ${BIGDATA_DATA_HOME}/Manager
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}/Manager"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
rm_manager_dataHome()
{
    local logFile="${2}"
    if [ "${1}" = "${BIGDATA_DATA_HOME}/${OM_DATA_DIR}" ] ; then
        /bin/rm -rf "${1}" > /dev/null 2>&1
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to delete Manager data home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_DATA_HOME}/${OM_DATA_DIR} != ${1}." "$logFile"
    return 1
}
################################################################################
# Function: add_install_dir_permission
# Description: 为安装目录及其各级父目录的其他用户增加可读和可执行权限
# Parameter:
#   input:
#   $1 -- currentDir 当前目录
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_install_dir_permission()
{
    local currentDir="$1"
    if [ "${currentDir}" = "${BIGDATA_HOME}" ] ; then
      chmod u+rwx,g+rx,o+rx "${currentDir}"
      ret=$?
      if [ "${ret}" -ne 0 ]; then
        return ${ret}
      fi
      while [ "$(dirname "${currentDir}")" != "/" ] ; do
          chmod u+rx,g+x,o+rx "$(dirname "${currentDir}")"
          ret=$?
          if [ "${ret}" -ne 0 ]; then
             return ${ret}
          fi
          currentDir="$(dirname "${currentDir}")"
      done
      return 0
    fi

    return 1
}

################################################################################
# Function: software_install_chmod
# Description: chmod 770 ${BIGDATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_install_chmod()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to chmod installation home." "$logFile"
    if [ "${1}" = "${BIGDATA_HOME}" ] ; then
        /bin/chmod 770 "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to chmod installation home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_DATA_HOME}/${OM_DATA_DIR} != ${1}." "$logFile"
    return 1
}

################################################################################
# Function: uninstall_script_executive_chmod
# Description: 修改OMS卸载脚本的uninstall.sh权限
# Parameter:
#   input:
#         ${1}:<controller_home>/inst/uninstall.sh
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
uninstall_script_executive_chmod()
{
    local uninstall_script_dir="$1"
    verify_path "$uninstall_script_dir"
    /bin/chmod +x "${1}"
    return $?
}

################################################################################
# Function: software_data_mkdir
# Description: mkdir -p ${BIGDATA_DATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_data_mkdir()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to create date home." "$logFile"
    if [ "${1}" = "${BIGDATA_DATA_HOME}" ] ; then
        /bin/mkdir -p "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to create date home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_DATA_HOME} != ${1}." "$logFile"
    return 1
}

################################################################################
# Function: add_data_dir_permission
# Description: 为数据目录及其各级父目录的其他用户增加可读和可执行权限
# Parameter:
#   input:
#   $1 -- currentDir 当前目录
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_data_dir_permission()
{
    local currentDir="$1"
    if [ "${currentDir}" = "${BIGDATA_DATA_HOME}" ] ; then
      chmod u+rwx,g+rx,o+rx "${currentDir}"
      ret=$?
      if [ "${ret}" -ne 0 ]; then
         return ${ret}
      fi
      while [ "$(dirname "${currentDir}")" != "/" ] ; do
          chmod u+rx,g+x,o+rx "$(dirname "${currentDir}")"
          ret=$?
          if [ "${ret}" -ne 0 ]; then
             return ${ret}
          fi
          currentDir="$(dirname "${currentDir}")"
      done
      return 0
    fi

    return 1
}

################################################################################
# Function: software_data_chmod
# Description: chmod 770 ${BIGDATA_DATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_data_chmod()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to chmod data home." "$logFile"
    if [ "${1}" = "${BIGDATA_DATA_HOME}" ] ; then
        /bin/chmod 770 "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to chmod data home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_DATA_HOME} != ${1}." "$logFile"
    return 1
}


################################################################################
# Function: software_log_mkdir
# Description: mkdir -p ${BIGDATA_LOG_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_LOG_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_log_mkdir()
{
    log "INFO" "${LINENO}" "Start to create log home."
    if [ "${1}" = "${BIGDATA_LOG_HOME}" ] ; then
        /bin/mkdir -p "${1}"
        if [ $? -eq 0 ] ; then
            log "INFO" "${LINENO}" "Succeed to create log home."
            return 0
        else
            log "ERROR" "${LINENO}" "Failed to create log home."
            return 1
        fi  
    fi
    log "ERROR" "${LINENO}" "Failed to create log home."
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_LOG_HOME} != ${1}."
    return 1
}

################################################################################
# Function: add_log_dir_permission
# Description: 为日志目录及其各级父目录的其他用户增加可读和可执行权限
# Parameter:
#   input:
#   $1 -- currentDir 当前目录
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_log_dir_permission()
{
    local currentDir="$1"
    if [ "${currentDir}" = "${BIGDATA_LOG_HOME}" ] ; then
      chmod u+rwx,g+rx,o+rx "${currentDir}"
      ret=$?
      if [ "${ret}" -ne 0 ]; then
        return ${ret}
      fi
      while [ "$(dirname "${currentDir}")" != "/" ] ; do
          chmod u+rx,o+rx "$(dirname "${currentDir}")"
          ret=$?
          if [ "${ret}" -ne 0 ]; then
             return ${ret}
          fi
          currentDir="$(dirname "${currentDir}")"
      done
      return 0
    fi

    return 1
}

################################################################################
# Function: software_log_chmod
# Description: chmod 770 ${BIGDATA_LOG_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_LOG_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_log_chmod()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to chmod log home." "$logFile"
    if [ "${1}" = "${BIGDATA_LOG_HOME}" ] ; then
        /bin/chmod 770 "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to chmod log home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_LOG_HOME} != ${1}." "$logFile"
    return 1
}

################################################################################
# Function: software_log_rm
# Description: rm -rf ${BIGDATA_LOG_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_LOG_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_log_rm()
{
    local logFile="${2}"
    log "INFO" "${LINENO}" "Start to delete log home." "$logFile"
    if [ "${1}" = "${BIGDATA_LOG_HOME}" ] ; then
        /bin/rm -rf "${1}"
        return $?
    fi
    log "ERROR" "${LINENO}" "Failed to delete log home." "$logFile"
    log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_LOG_HOME} != ${1}." "$logFile"
    return 1
}

################################################################################
# Function: get_localip
# Description:
# Parameter:
#   input:
#   output:
#   local ip
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_localip()
{
    echo $(hostname -i)
}

################################################################################
# Function: get_interface
# Description:
# Parameter:
#   input:
#   output:
#   interface
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_interface()
{
    local ip="$1"
    local ipModel="$2"
    if [ ${ipModel} == ${IPV6_MODEL} ]; then
        ip=$(compress_ipv6 "${ip}")
        ip addr | tr "\n" " " | awk -F ${ip} '{print $1}' | awk -F ': <' '{print $(NF-1)}' |  awk '{print $NF}'
    else
        ip addr | grep -w -F "${ip}" | awk -F ' ' '{print $NF}'
        return $?
    fi
}

################################################################################
# Function: log_dir_chmod
# Description: chmod 700 ${LOG_HOME}/Bigdata/controller/scriptlog -R
# Parameter:
#   input:
#         ${1}:"${LOG_HOME}/Bigdata/controller/scriptlog"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
log_dir_chmod()
{
    local log_dir="${BIGDATA_LOG_HOME}/controller/scriptlog"
    if [ "${1}" = "${log_dir}"  ] ; then
        find "${log_dir}" -type f |  xargs -I{} chmod 600 "{}" || return $?
        find "${log_dir}" -type d |  xargs -I{} chmod 700 "{}" || return $?
    fi
    
    return 0
}
######################################################################################

################################################################################
# Function: log_chmod
# Description: chmod 600 ${LOG_HOME}/Bigdata/controller/scriptlog/install.log
# Parameter:
#   input:
#         ${1}:"${LOG_HOME}/Bigdata/controller/scriptlog/install.log"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
log_chmod()
{
    local log_file="${BIGDATA_LOG_HOME}/controller/scriptlog/install.log"
    if [ "${1}" = "${log_file}"  ] ; then
        /bin/chmod 600 "${1}"
        return $?
    fi
    return 1
}
######################################################################################


################################################################################
# Function: log_mkdir
# Description: mkdir -p ${LOG_HOME}/Bigdata/controller/scriptlog
# Parameter:
#   input:
#         ${1}:"${LOG_HOME}/Bigdata/controller/scriptlog"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
log_mkdir()
{
    local log_dir="${BIGDATA_LOG_HOME}/controller/scriptlog"
    if [ "${1}" = "${log_dir}"  ] ; then
        /bin/mkdir -p "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: tmp_log_cp
# Description: cp /tmp/scriptlog/install.log ${LOG_HOME}/Bigdata/controller/scriptlog
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
tmp_log_cp()
{
    cat "/tmp/scriptlog/install.log" >> "${BIGDATA_LOG_HOME}/controller/scriptlog/install.log"
    return $?
}


################################################################################
# Function: log_File_touch
# Description: touch ${BIGDATA_LOG_HOME}/controller/scriptlog/install.log
# Parameter:
#   input:
#         ${1}:"${BIGDATA_LOG_HOME}/controller/scriptlog/install.log"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
log_File_touch()
{
    local log_file="${BIGDATA_LOG_HOME}/controller/scriptlog/install.log"
    if [ "${1}" = "${log_file}"  ] ; then
        /bin/touch "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: log_dir_chown
# Description: chown  ${OMM_USER}:${WHEEL_GROUP} ${BIGDATA_LOG_HOME}/controller/scriptlog -R
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog/"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
log_dir_chown()
{
    local log_dir="${BIGDATA_LOG_HOME}"
    if [ "${1}" = "${log_dir}"  -a "${2}" = "${INSTALL_USER}" ] ; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${1}" -R
        return $?
    fi
    return 1
}

################################################################################
# Function: software_dir_chown
# Description: chown  ${OMM_USER}:${WHEEL_GROUP} ${BIGDATA_HOME} -R
# Parameter:
#   input:
#         ${1}:"${BIGDATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_dir_chown()
{
    local software_dir="${BIGDATA_HOME}"
    if [ "${1}" = "${software_dir}"  -a "${2}" = "${INSTALL_USER}" ] ; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: chown_bigdata_data_home_safe
# Description: 
# 1. for ModelArts
# 2. fix timeout problem when execute chown ${OMM_USER}:${WHEEL_GROUP} ${BIGDATA_DATA_HOME} -R
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chown_bigdata_data_home_safe()
{
    # fix: 排除ModleArts特有的两个数据目录sharedata & Registry, 防止超时递归
    if [[ "${1}" = "${BIGDATA_DATA_HOME}" ]]; then
        find "${1}" -type d \( -path "${1}/sharedata" -o -path "${1}/Registry" \) -prune -o \
            \( ! -user "${OMM_USER}" -or ! -group "${WHEEL_GROUP}" \) -type f -links 1 | \
            xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
        find "${1}" -type d \( -path "${1}/sharedata" -o -path "${1}/Registry" \) -prune -o \
            \( ! -user "${OMM_USER}" -or ! -group "${WHEEL_GROUP}" \) -type d ! -type l | \
            xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
        return $?
    fi
    return 1
}

################################################################################
# Function: software_data_chown
# Description: chown  ${OMM_USER}:${WHEEL_GROUP} ${BIGDATA_DATA_HOME} -R
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_data_chown()
{
    local data_dir="${BIGDATA_DATA_HOME}"
    if [ "${1}" = "${data_dir}"  -a "${2}" = "${INSTALL_USER}" ] ; then
        chown_bigdata_data_home_safe "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: chown_data_home
# Description: chown  ${OMM_USER}:${WHEEL_GROUP} ${BIGDATA_DATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_DATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chown_data_home()
{
    local data_dir="${BIGDATA_DATA_HOME}"
    if [ "${1}" = "${data_dir}" ] ; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${1}"
        return $?
    fi
    return 1
}


################################################################################
# Function: controller_install_mkdir_chown
# Parameter:
#   input:
#         ${1}:""<controller home>""
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
controller_install_mkdir_chown()
{
    local controller_home="${1}"
    
    verify_path "$controller_home" || return 1
    
    if [ "${2}" = "${INSTALL_USER}" ] ; then
        /bin/rm -rf ${controller_home}
        ret=$?
        if [ $ret -ne 0 ];then
           return $ret
        fi

        /bin/mkdir -p "${controller_home}"
        ret=$?
        if [ $ret -ne 0 ];then
           return $ret
        fi

        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${controller_home}" -R
        return $?
    fi
    
    return 1
}

rand(){

    min=$1

    max=$(($2-$min+1))

    num=$(cat /proc/sys/kernel/random/uuid | cksum | awk -F ' ' '{print $1}')

    echo $(($num%$max+$min))

}

genRandPWD()
{
    local len=${#BASE_CHARS}
    local randpwd=""
    for((i=0; i<=$PWD_LEN; i=i+1))
    do
        if [ $i -eq 3 ];then
            len=${#ALP_CHARS}
            let len=len-1
            rnd=$(rand 1 $len)
            randpwd="$randpwd"${ALP_CHARS:$rnd:1}
        elif [ $i -eq 6 ];then
            len=${#BASE_SPEC_CHARS}
            let len=len-1
            rnd=$(rand 1 $len)
            randpwd="$randpwd"${BASE_SPEC_CHARS:$rnd:1}
        elif [ $i -eq 9 ];then
            len=${#DIGIT_CHARS}
            let len=len-1
            rnd=$(rand 1 $len)
            randpwd="$randpwd"${DIGIT_CHARS:$rnd:1}
        else
            let len=len-1
            rnd=$(rand 1 $len)
            randpwd="$randpwd"${BASE_CHARS:$rnd:1}
        fi
    done
    
    echo "$randpwd"
}

validatePwd()
{
    local inpwd="$1"
    if [ -z "${inpwd}" ] ; then
        log  "${LINENO}" "ERROR" "the passwd is null."
        return 1
    fi 
    
    #字符串长度
    echo "${inpwd}" | grep -E "^.{16,32}$" 1>/dev/null
    if [ $? -ne 0 ] ; then
       log  "${LINENO}" "ERROR" "the passwd does not meet the password policy,length not engouth."
       return 1
    fi
    
    #判断是否包含' \ 或 " 当前不支持
    echo "${inpwd}" | grep -P "[\\\'\"]" 1>/dev/null
    if [ $? -eq 0 ];then
       log  "${LINENO}" "ERROR"  "the passwd may contains unsupported char, such as ' \\ or \""
       return 1
    fi
    
    #判断是否包含特殊字符
    echo "${inpwd}" | grep -P "[\x21-\x2F\x3A-\x40\x5B-\x60\x7B-\x7E _-]" 1>/dev/null
    local charvalue=$?
    if [ $charvalue -ne 0 ];then
       log  "${LINENO}" "ERROR"  "the passwd must contains special char"
       return 1
    fi
     
    #判断是否包数字
    local temp_pwd=($(echo "${inpwd}" | sed "s/[\x21-\x2F\x3A-\x40\x5B-\x60\x7B-\x7E _-|]//g"))
    echo "${temp_pwd}" | grep -E "[0-9]{1,}" 1>/dev/null
    local digitvalue=$?
    if [ $digitvalue -ne 0 ];then
       log  "${LINENO}" "ERROR"  "the passwd must contains digit char"
       return 1
    fi
    
    #判断是否包小写字母
    echo "${inpwd}" | grep -E "[a-z]{1,}" 1>/dev/null
    local lowercasevalue=$?
    if [ $lowercasevalue -ne 0 ];then
       log  "${LINENO}" "ERROR"  "the passwd must contains lowercase char"
       return 1
    fi
      
    #判断是否包大写字母
    echo "${inpwd}" | grep -E "[A-Z]{1,}" 1>/dev/null
    local uppercasevalue=$?
    
    #至少包含大写字母，小写字母，数字，特殊字符中三种，如果四个返回值的和大于等于2，则说明不满足至少包含三种，返回失败。
    local valid_value=`expr $digitvalue + $uppercasevalue + $lowercasevalue + $charvalue`
    if [ $valid_value -ge 2 ];then
       log  "${LINENO}" "ERROR" "the new passwd does not meet the password policy,digitvalue=$digitvalue,uppercasevalue=$uppercasevalue,lowercasevalue=$lowercasevalue,charvalue=$charvalue."
       return 1
    fi
    
    return 0
}

getRandpwd()
{
    local rndpwd=""
    for((i=0; i<=1000; i=i+1))
    do
        rndpwd=$(genRandPWD)
        validatePwd "$rndpwd"
        if [ $? -ne 0 ];then
            continue
        else
            echo "$rndpwd"
            return 0
        fi
    done
    
    echo "$rndpwd"
    return 1
}

get_omm_encrypt_pwd()
{
    local encrypt_pwd=""
    if [ -f /etc/shadow ];then
        encrypt_pwd=$(cat /etc/shadow |grep -w "^omm" | awk -F ':' '{print $2}')
        echo "$encrypt_pwd"
        return 0
    fi
    
    return 1
}

################################################################################
# Function: init_omm_user
# Description: 创建omm用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_omm_user()
{
    log_file="${2}"
    local inputpwd="${3}"
    
    # 检查omm用户是否存在
    if [ "${INSTALL_USER}" = "root" ] ;then   
    log "INFO" "${LINENO}" "Check whether the ${OMM_USER} user already exist." "${log_file}"
    id -u "${OMM_USER}" > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        if [ "$(id -u "${OMM_USER}")" != "${1}" ] ; then
            log "ERROR" "${LINENO}" "A user whose name is ${OMM_USER} with $(id -u ${OMM_USER}) already exists." "${log_file}"
            return 1
        else
            local group=$(groups ${OMM_USER} | awk -F ' ' '{print $3}')
            if [ "${group}" != "${WHEEL_GROUP}" ]; then
              log "ERROR" "${LINENO}" "${OMM_USER_HOME} user already exists, but its group is not ${WHEEL_GROUP}." "${log_file}"
                    return 1
                fi
            local omm_home=$(cat /etc/passwd | grep "^${OMM_USER}:" | awk -F: '{print $6}')
            if [ "${OMM_USER_HOME}" != "${omm_home}" ]; then
              log "ERROR" "${LINENO}" "${OMM_USER_HOME} user already exists, but its home dir is not ${OMM_USER_HOME}." "${log_file}"
              return 1
            fi
            mkdir -p /home/${OMM_USER}
            chown ${OMM_USER}:${WHEEL_GROUP} /home/${OMM_USER} || return 1
            chmod 750 /home/${OMM_USER} || return 1
            log "WARN" "${LINENO}" "A user whose name is ${OMM_USER} with ${1} already exists." "${log_file}"
            return 0
        fi
    else
        add_omm_user "${1}" "${log_file}" || return 1
    fi
    else
        chmod 750 ${OMM_USER_HOME}  -R
    fi
    
    local EncryptOmmPasswd="$inputpwd"
    if [ -z "$EncryptOmmPasswd" ];then
        EncryptOmmPasswd=$(getRandpwd)
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to generate random password for omm user."
            return ${INS_CHANGE_PASSWD_FAILURE}
        fi
    fi
    
    EncryptOmmPasswd=$(/usr/bin/python3 -c "import crypt,getpass,sys;pw=sys.argv[1];print(crypt.crypt(pw))" "$EncryptOmmPasswd")
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to generate encrypt random password for omm user."
        return ${INS_CHANGE_PASSWD_FAILURE}
    fi
    
    # 修改omm用户密码
    echo "${OMM_USER}:${EncryptOmmPasswd}" | chpasswd -e > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to change the password of omm user."
        return ${INS_CHANGE_PASSWD_FAILURE}
    fi
    
    return 0
}

################################################################################
# Function: init_ommdba_user
# Description: 创建ommdba用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_ommdba_user()
{
    log_file="${2}"
    local inputpwd="${3}"
    
    id -u "${DB_CREATER}" > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        if [ "$(id -u "${DB_CREATER}")" != "${1}" ] ; then
            log "ERROR" "${LINENO}" "A user whose name is ${DB_CREATER} already exists." "${log_file}"
            return 1
        else
            userdel -rf "${DB_CREATER}"
            if [ $? -ne 0 ] ; then
                log "WARN" "${LINENO}" "Failed to delete the ${DB_CREATER} user." "${log_file}"
                rm -rf /home/${DB_CREATER}
                mkdir -p /home/${DB_CREATER}
                if [ $? -ne 0 ] ; then
                    log "ERROR" "${LINENO}" "Failed to create the /home/${DB_CREATER} path." "${log_file}"
                    return 1
                fi
                cp -arf /etc/skel/. /home/${DB_CREATER} || return 1
                [ -f /home/${DB_CREATER}/.bash_history ] || touch /home/${DB_CREATER}/.bash_history
                chown ${DB_CREATER}:${WHEEL_GROUP} /home/${DB_CREATER} -R || return 1
                chmod 750 /home/${DB_CREATER} -R || return 1
                chmod 600 /home/${DB_CREATER}/.bash_history > /dev/null 2>&1
                chmod 640 /home/${DB_CREATER}/.profile > /dev/null 2>&1
            else
                add_ommdba_user "${1}" "${log_file}" || return 1
            fi
        fi
    else
        add_ommdba_user "${1}" "${log_file}" || return 1
    fi
    
    local EncrypedOmmdbaPasswd="$inputpwd"
    if [ -z "$EncrypedOmmdbaPasswd" ];then
        EncrypedOmmdbaPasswd=$(getRandpwd)
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to generate random password for omm user."
            return ${INS_CHANGE_PASSWD_FAILURE}
        fi
    fi
    
    EncrypedOmmdbaPasswd=$(/usr/bin/python3 -c "import crypt,getpass,sys;pw=sys.argv[1];print(crypt.crypt(pw))" "$EncrypedOmmdbaPasswd")
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to generate encrypt random password for ommdba user."
        return ${INS_CHANGE_PASSWD_FAILURE}
    fi
    

    # 修改ommdba用户密码
    echo "${DB_CREATER}:${EncrypedOmmdbaPasswd}" | chpasswd -e > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to change the password of ommdba user."
        return ${INS_CHANGE_PASSWD_FAILURE}
    fi

    return 0
}

reset_omm_pwd()
{
    local rand_password=$(getRandpwd)
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to generate random password for omm user."
        return ${INS_CHANGE_PASSWD_FAILURE}
    fi
    
    passwd "${OMM_USER}"<<EOF
${rand_password}
${rand_password}
EOF
}

delete_linux_user()
{
    local linuxuser="linux"
    log "INFO" "${LINENO}" "start to delete linux user."
    #如果omm用户存在，则删除用户
    id -u "${linuxuser}"
    if [ $? -eq 0 ] ; then
        # 删除omm用户
        userdel -rf ${linuxuser} > /dev/null
        if [ $? -ne 0 ] ; then
            log "WARN" "${LINENO}" "Failed to delete ${linuxuser} user."
            rm -rf /home/${linuxuser} > /dev/null
        fi
    fi
    return ${INS_SUCCESS}
}

################################################################################
# Function: add_omm_user
# Description: 添加omm用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_omm_user()
{
    ommid="$1"
    log_file="$2"

    log "INFO" "${LINENO}" "Add the ${OMM_USER} user." "${log_file}"

    # 检查用户所属组是否存在，若不存在则退出安装
    cat /etc/group | cut -d ":" -f 1 | grep -w "${WHEEL_GROUP}" > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "The ${WHEEL_GROUP} group does not exist." "${log_file}"
        return ${INS_USER_GROUP_NOT_EXIST}
    fi

    # 北京凝思6.0.99 x86上删除用户后，再创建同样id的用户时会失败，需要先清除uid
    grep -qi 'LinxOS' /etc/os-release
    if [ $? -eq 0 ]; then
      linx_uidcheck -r ${ommid}
    fi
    
    #添加omm用户
    useradd "${OMM_USER}" -m -d "${OMM_USER_HOME}" -g "${WHEEL_GROUP}" -u "${ommid}" -s /bin/bash
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to add the ${OMM_USER} user." "${log_file}"
        return ${INS_ADD_USER_FAILURE}
    fi
    chmod 750 ${OMM_USER_HOME}  -R
    [ -f ${OMM_USER_HOME}/.bash_history ] || touch ${OMM_USER_HOME}/.bash_history
    chown ${OMM_USER}: ${OMM_USER_HOME}/.bash_history > /dev/null 2>&1
    chmod 600 ${OMM_USER_HOME}/.bash_history > /dev/null 2>&1


    return ${INS_SUCCESS}
}

################################################################################
# Function: add_ommdba_user
# Description: 添加ommdba用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_ommdba_user()
{
    ommdbaid="$1"
    log_file="$2"

    log "INFO" "${LINENO}" "Add the ${DB_CREATER} user." "${log_file}"

    # 检查用户所属组是否存在，若不存在则退出安装
    cat /etc/group | cut -d ":" -f 1 | grep -w "${WHEEL_GROUP}" > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "The ${WHEEL_GROUP} group does not exist." "${log_file}"
        return ${INS_USER_GROUP_NOT_EXIST}
    fi
    
    # 北京凝思6.0.99 x86上删除用户后，再创建同样id的用户时会失败，需要先清除uid
    grep -qi 'LinxOS' /etc/os-release
    if [ $? -eq 0 ]; then
        linx_uidcheck -r ${ommdbaid}
    fi
    
    # 增加用户ommdba
    useradd ${DB_CREATER} -m -d ${DB_CREATER_HOME} -g "${WHEEL_GROUP}" -u ${ommdbaid} -s /bin/bash
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to add the ${DB_CREATER} user." "${log_file}"
        return ${INS_ADD_USER_FAILURE}
    fi
    chmod 750 ${DB_CREATER_HOME}  -R
    [ -f ${DB_CREATER_HOME}/.bash_history ] || touch ${DB_CREATER_HOME}/.bash_history
    chown ${DB_CREATER}: ${DB_CREATER_HOME}/.bash_history > /dev/null 2>&1
    chmod 600 ${DB_CREATER_HOME}/.bash_history > /dev/null 2>&1
    chmod 640 ${DB_CREATER_HOME}/.profile > /dev/null 2>&1


    return ${INS_SUCCESS}
}

################################################################################
# Function: config_ommdba_umask
# Description: 配置 ommdba 用户 umask
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_ommdba_umask()
{
    su - ${DB_CREATER} -c "umask 0027"
    if [ $? -ne 0 ] ; then
        return 1
    fi

    su - ${DB_CREATER} -c "echo 'umask 0027' >> ${DB_CREATER_HOME}/.bash_profile"
    return $?
}

################################################################################
# Function: add_user_group
# Description:创建ficommon组
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_user_group()
{
    log_file="$1"
    log "INFO" "${LINENO}" "add_user_group start." "${log_file}"

    #检查是否存在ficommon用户组，如果没有进行创建
    cat /etc/group | cut -d ":" -f 1 | grep -w "${FI_COMMON_GROUP}" >> "${log_file}" 2>&1
    if [ $? -ne 0 ] ; then
        log "INFO" "${LINENO}" "The ${FI_COMMON_GROUP} group does not exist. Create it now." "${log_file}"
        groupadd  "${FI_COMMON_GROUP}" -g "${FI_COMMON_GROUP_ID}" -o >> "${log_file}" 2>&1
        if [ $? -ne 0 ] ; then
             log "ERROR" "${LINENO}" "The ${FI_COMMON_GROUP} group create failed." "${log_file}"
             return  "${INS_CREATE_FI_COMMON_GROUP_FAILED}"
        fi
    else
        #如果存在ficommon但id不是9998则报错
        groupid=$(cat /etc/group | grep -w "${FI_COMMON_GROUP}" | cut -d ":" -f 3 ) >> "${log_file}" 2>&1
        if [ "${groupid}" -ne "${FI_COMMON_GROUP_ID}" ]; then
            log "ERROR" "${LINENO}" "The ${FI_COMMON_GROUP} group already exists, but the id is not ${FI_COMMON_GROUP_ID}." "${log_file}"
            return 1
        fi
    fi

    log "INFO" "${LINENO}" "add_user_group end." "${log_file}"
}

################################################################################
# Function: is_Suse11
# Description: 是否suse11
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: OS类型
# Others: N/A
################################################################################
function is_Suse11()
{
    local sles_release="/etc/SuSE-release"
    local name=""

    if [ -f "${sles_release}" ]; then
        name="suse-$(cat "${sles_release}" | grep "^VERSION" | awk '{print $3}')"
        if [ "$name" = "suse-11" ];then
            return 0
        fi
        return 1
    fi
    return 1
}

################################################################################
# Function: add_user_to_group
# Description:将用户添加入指定用户组
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_user_to_group()
{
    user_name="$1"
    group_name="$2"
    log_file="$3"
    
    #suse11使用usermod -A, redhat6、7和suse12和centOS6、7均使用usermod -a -G
    is_Suse11
    if [ $? -eq 0 ]; then
        usermod -A "$group_name" "$user_name" >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Add user ($user_name) to group ($group_name) failed."
            return 1
        fi
        return 0
    fi
    
    usermod -a -G "$group_name" "$user_name" >> "${log_file}" 2>&1
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "Add user ($user_name) to group ($group_name) failed."
        return 1
    fi
    return 0
}

################################################################################
# Function: change_user_supplementary_group
# Description:修改用户附属组
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
change_user_supplementary_group()
{
    log_file="$1"
    log "INFO" "${LINENO}" "change_user_supplementary_group start." "${log_file}"

    add_user_to_group "${OMM_USER}" "${FI_COMMON_GROUP}" "${log_file}"
    if [ $? -ne 0 ] ; then
          log "ERROR" "${LINENO}" "Failed to change ${OMM_USER} user supplementary group to ${FI_COMMON_GROUP}." "${log_file}"
          return 1
    fi

    add_user_to_group "${DB_CREATER}" "${FI_COMMON_GROUP}" "${log_file}"
    if [ $? -ne 0 ] ; then
          log "ERROR" "${LINENO}" "Failed to change ${DB_CREATER} user supplementary group to ${FI_COMMON_GROUP}." "${log_file}"
          return 1
    fi
    log "INFO" "${LINENO}" "change_user_supplementary_group end." "${log_file}"
}


################################################################################
# Function: add_ficommon_for_nodeagent
# Description:为nodeagent节点添加ficommon组并修改omm附属组
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_ficommon_for_nodeagent()
{
    log "INFO" "${LINENO}" "add_ficommon_for_nodeagent start."

    add_user_group "${SUDO_LOG_FILE}" >> "${SUDO_LOG_FILE}" 2>&1
    if [ $? -ne 0 ] ; then
          log "ERROR" "${LINENO}" "Failed to add ${FI_COMMON_GROUP} group."
          return 1
    fi
    
    add_user_to_group "${OMM_USER}" "${FI_COMMON_GROUP}" "${SUDO_LOG_FILE}"
    if [ $? -ne 0 ] ; then
          log "ERROR" "${LINENO}" "Failed to change ${OMM_USER} user supplementary group to ${FI_COMMON_GROUP}."
          return 1
    fi
    
    log "INFO" "${LINENO}" "add_ficommon_for_nodeagent end."
}
################################################################################
# Function: security_dir_chown_omm_wheel
# Description: 修改"${BIGDATA_HOME}"/security目录属组
################################################################################
security_dir_chown_omm_wheel()
{
    local common_workspace="$1"    
    local log_file="$2"
    verify_path "${common_workspace}" || return 1
    
    log "INFO" "${LINENO}" "security_dir_chown_omm_wheel start." "${log_file}"
    
    local keydir="${common_workspace}"/security
    if [ -d "${keydir}" ]; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${keydir}" -R >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then        
            log "ERROR" "${LINENO}" "Failed to change group of ${keydir} to ${WHEEL_GROUP}." "${log_file}"
            return 1
        fi
    fi

    local scckeydir="${common_workspace}"/securityforscc
    if [ -d "${scckeydir}" ]; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${scckeydir}" -R >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Failed to change group of ${scckeydir} to ${WHEEL_GROUP}." "${log_file}"
            return 1
        fi
    fi

    return 0
}

################################################################################
# Function: security_file_chown_omm_wheel
# Description: 修改keystore.xml文件属组
################################################################################
security_file_chown_omm_wheel()
{
    log_file="$1"
    log "INFO" "${LINENO}" "security_file_chown_omm_wheel start." "${log_file}"
    
    local keyfile="${BIGDATA_COMMON}"/security/keystore/keystore.xml
    if [ -f "${keyfile}" ]; then
        /bin/chown ${OMM_USER}:${WHEEL_GROUP} "${keyfile}" >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then        
            log "ERROR" "${LINENO}" "Failed to change group of ${keyfile} to ${WHEEL_GROUP}." "${log_file}"
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "security_file_chown_omm_wheel end." "${log_file}"
    return 0
}

################################################################################
# Function: jre_dir_chown_ficommon
# Description: 修改jre目录属组
################################################################################
jre_dir_chown_ficommon()
{
    local jre_version="$1"
    local bigdataCommonWorkspace="$2"

    log "INFO" "${LINENO}" "jre_dir_chown_ficommon start." "${OMS_LOG_FILE}"
    
    local jredir="${bigdataCommonWorkspace}/${jre_version}"
    if [ -d "${jredir}" ]; then
        /bin/chown ${OMM_USER}:${FI_COMMON_GROUP} "${jredir}" -R >> "${OMS_LOG_FILE}" 2>&1
        if [ $? -ne 0 ]; then        
            log "ERROR" "${LINENO}" "Failed to change group of ${jredir} to ${FI_COMMON_GROUP}." "${OMS_LOG_FILE}"
            return 1
        fi
    fi
    
    chmod g+r "${jredir}" -R
    log "INFO" "${LINENO}" "jre_dir_chown_ficommon end." "${OMS_LOG_FILE}"
    return 0
}

################################################################################
# Function: scc_log_chown_omm_ficommon
# Description: 修改scc日志属组(${BIGDATA_LOG_HOME}/scc)
################################################################################
scc_log_chown_omm_ficommon()
{
    log_file="$1"
    log "INFO" "${LINENO}" "scc_log_chown_omm_ficommon start." "${log_file}"

    local sccLogDir="${BIGDATA_LOG_HOME}/scc"
    if [ -d "${sccLogDir}" ]; then
        /bin/chown ${OMM_USER}:${FI_COMMON_GROUP} "${sccLogDir}" -R
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Failed to change group of ${sccLogDir} to ${FI_COMMON_GROUP}." "${log_file}"
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "scc_log_chown_omm_ficommon end." "${log_file}"
    return 0
}

################################################################################
# Function: security_scc_dir_chown_omm_ficommon
# Description: 修改"${BIGDATA_COMMON}"/securityforscc 目录属组
################################################################################
security_scc_dir_chown_omm_ficommon()
{
    local common_workspace="$1"
    local log_file="$2"
    verify_path "${common_workspace}" || return 1

    log "INFO" "${LINENO}" "security_scc_dir_chown_omm_ficommon start." "${log_file}"

    local sccKeyDir="${common_workspace}"/securityforscc
    if [ -d "${sccKeyDir}" ]; then
        /bin/chown ${OMM_USER}:${FI_COMMON_GROUP} "${sccKeyDir}" -R >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Failed to change group of ${sccKeyDir} to ${FI_COMMON_GROUP}." "${log_file}"
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "security_scc_dir_chown_omm_ficommon end." "${log_file}"

    return 0
}

################################################################################
# Function: manager_copy_cross_platform_secc
# Description:拷贝scc
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
manager_copy_cross_platform_secc()
{
    log "INFO" "${LINENO}" "start to copy cross platform secc." "${log_file}"
    local sourceSeccPath="${1}"
    local osType="${2}"
    local cpuType="${3}"
    local log_file="${4}"
    
    if [ ! -f "${sourceSeccPath}" ]; then
        log "ERROR" "${LINENO}" "File ${sourceSeccPath} doesn't exist." "${log_file}"
        return 1
    fi
    
    if [ -z "${osType}" -o -z "${cpuType}" ]; then
        log "ERROR" "${LINENO}" "OS type (${osType}) or cpu type (${cpuType}) is empty." "${log_file}"
        return 1  
    fi
    
    if [[ "${osType}" =~ ".." ]] || [[ "${cpuType}" =~ ".." ]]; then
        log "ERROR" "${LINENO}" "Parameter ${osType} or $cpuType is invalid." "${log_file}"
        return 1
    fi
    
    local setupPackageDir="${BIGDATA_HOME}/../Bigdata_setup/om/packaged-distributables/"
    local targetSeccPath="${setupPackageDir}/${osType}-${cpuType}/"
    if [ ! -d "${targetSeccPath}" ]; then
        mkdir ${targetSeccPath}
        chmod 750 ${targetSeccPath}
        chown root:wheel ${targetSeccPath}
    fi

    local rpmPackName=$(basename "${sourceSeccPath}")
    if [ ! -f ${targetSeccPath}/${rpmPackName} ]; then
        log "INFO" "${LINENO}" "Start to copy seccomponent package from ${sourceSeccPath} to ${targetSeccPath}." "${log_file}"
        cp -pf ${sourceSeccPath} ${targetSeccPath}
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}"  "Failed to cp -pf ${sourceSeccPath} ${targetSeccPath}." "${log_file}"
            return 1
        fi
        
        cd ${targetSeccPath}
        sha256sum ${rpmPackName} > ${rpmPackName}.sha256
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}"  "Failed to execute [ sha256sum ${rpmPackName} > ${rpmPackName}.sha256 ]." "${log_file}"
            return 1
        fi
        chmod 750 ${rpmPackName}*
        chown root:wheel ${rpmPackName}*
        cd -
    else
        log "INFO" "${LINENO}" "${targetSeccPath}/${rpmPackName} already exists." "${log_file}"
    fi

    log "INFO" "${LINENO}" "success to copy seccomponent." "${log_file}"
    return 0
}

################################################################################
# Function: bigdata_common_tools_dir_chown_omm_ficommon
# Description: 修改"${BIGDATA_COMMON}"/tools 目录属组
################################################################################
bigdata_common_tools_dir_chown_omm_ficommon()
{
    local common_workspace="$1"
    local log_file="$2"
    verify_path "${common_workspace}" || return 1

    log "INFO" "${LINENO}" "bigdata_common_tools_dir_chown_omm_ficommon start." "${log_file}"

    local commonToolsDir="${common_workspace}"/tools
    if [ -d "${commonToolsDir}" ]; then
        /bin/chown ${OMM_USER}:${FI_COMMON_GROUP} "${commonToolsDir}" -R >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "Failed to change group of ${commonToolsDir} to ${FI_COMMON_GROUP}." "${log_file}"
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "bigdata_common_tools_dir_chown_omm_ficommon end." "${log_file}"

    return 0
}

################################################################################
# Function: software_dir_chown_omm
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
software_dir_chown_omm()
{
    local om_server_workspace="${1}"
    operatorType=${2}
    
    verify_path "$om_server_workspace" || return 1
    
    if [ "$operatorType" = "$UPGRADE_OPERATOR" ]; then
        /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${om_server_workspace}" -R
        return 0
    fi

    chown_bigdata_data_home_safe "${BIGDATA_DATA_HOME}"
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${BIGDATA_HOME}" -R
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${BIGDATA_LOG_HOME}" -R
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${om_server_workspace}" -R

    #区分用户执行任务修改属组
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_DATA_HOME}"
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_HOME}"
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_LOG_HOME}"
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_HOME}/tmp"
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${om_server_workspace}/tmp"
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_HOME}/common" -R

    return 0
}

################################################################################
# Function: create_softlink_for_libnsl
# Description: create softlink for libnsl
#
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
create_softlink_for_libnsl()
{
    if [ -f "/lib64/libnsl.so.2" -a ! -f "/lib64/libnsl.so.1" ];then
        ln -s /lib64/libnsl.so.2  /lib64/libnsl.so.1
        return $?
    fi

    return 0
}

create_softlink_for_libnsl3()
{
    if [ -f "/usr/lib64/libnsl.so.3" -a ! -f "/usr/lib64/libnsl.so.1" ];then
        ln -s /usr/lib64/libnsl.so.3 /usr/lib64/libnsl.so.1
        return $?
    fi

    return 0
}

################################################################################
# Function: configPerlHome
# Description: 修改/etc/profile.d/perl-homedir.sh文件，设置PERL_HOMEDIR=0
# 用于规避GaussDB在欧拉2.3以及CentOS7.5等环境上出现的，初次切换用户时，
# 输出warnning信息”Attempting to create directory /home/sjy/perl5“，
# 导致GaussDB安装失败的问题
# Parameter:
#   input:
#   Y
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
configPerlHome()
{
    local perlConfigFile="/etc/profile.d/perl-homedir.sh"

    if [ ! -f "${perlConfigFile}" ]; then
        echo "File $perlConfigFile doesn't exist. Skip configuring it."
        return 0
    fi
    
    sed -i "s/^[[:blank:]]*PERL_HOMEDIR=1/PERL_HOMEDIR=0/g" $perlConfigFile
    return $?
}

function single_chmod()
{
    local mode="$1"
    local file="$2"

    if [ -L "$file" ]; then
        return 1
    fi

    if [ -d "$file" ] ; then
        chmod "$mode" "$file"
        return 0
    elif [ -f "$file" ]; then
        #硬链接都不做修改
        local -i hardlinkNum=0
        hardlinkNum=$(stat -c %h "$file")

        if [ $? -eq 0 ]; then
            if [ $hardlinkNum -gt 1 ]; then
                cancel_hardLink "$file" || return 1
            fi
            chmod "$mode" "$file"
            return 0
        fi
    fi

    return 1
}

function single_chown()
{
    local usergroup="$1"
    local file="$2"

    if [ -L "$file" ]; then
        return 1
    fi

    if [ -d "$file" ] ; then
        chown "$usergroup" "$file"
        return 0
    elif [ -f "$file" ]; then
        #硬链接都不做修改
        local -i hardlinkNum=0
        hardlinkNum=$(stat -c %h "$file")

        if [ $? -eq 0 ]; then
            if [ $hardlinkNum -gt 1 ]; then
                cancel_hardLink "$file" || return 1
            fi
            chown "$usergroup" "$file"
            return 0
        fi
    fi

    return 1
}

################################################################################
# Function: nodeagent_init_home_dir
# Description: init_home_dir() 初始化根目录：创建目录，修改权限等  ${g_logHome}/nodeagent
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_init_home_dir()
{
    echo "Init nodeagent home start."

    local action_type="${1}"
    local common_workspace="${2}"
    verify_path "${common_workspace}" || return 1

    # 改变日志目录权限和所属用户
    if [ -L "${BIGDATA_HOME}/om-server" ]; then
        #普通文件，排除硬链接后chown；目录，排除软链接后chown
        find "${BIGDATA_LOG_HOME}/nodeagent" -type f -links 1 | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
        find "${BIGDATA_LOG_HOME}/nodeagent" -type d ! -type l | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
    else
        find "${BIGDATA_LOG_HOME}" -type f -links 1 | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
        find "${BIGDATA_LOG_HOME}" -type d ! -type l | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'

        if [ "${action_type}" != upgrade ]; then
            software_data_mkdir "${BIGDATA_LOG_HOME}"
            ownerUser=$(stat -c %U "${BIGDATA_LOG_HOME}")
            ownerGroup=$(stat -c %G "${BIGDATA_LOG_HOME}")
            if [ "${ownerUser}" != "${OMM_USER}" -o "${ownerGroup}" != "${FI_COMMON_GROUP}" ];then
                # fix: 排除ModleArts特有的两个数据目录sharedata & Registry, 防止超时递归
                find "${BIGDATA_LOG_HOME}" -type d \( -path "${BIGDATA_LOG_HOME}/sharedata" -o -path "${BIGDATA_LOG_HOME}/Registry" \) -prune -o \( ! -user "${OMM_USER}" -or ! -group "${WHEEL_GROUP}" \) -type f -links 1 | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
                find "${BIGDATA_LOG_HOME}" -type d \( -path "${BIGDATA_LOG_HOME}/sharedata" -o -path "${BIGDATA_LOG_HOME}/Registry" \) -prune -o \( ! -user "${OMM_USER}" -or ! -group "${WHEEL_GROUP}" \) -type d ! -type l | xargs -I{} chown "${OMM_USER}:${WHEEL_GROUP}" '{}'
            fi
        fi
    fi

    single_chmod "770" "${BIGDATA_DATA_HOME}"
    single_chmod "o+t" "${BIGDATA_DATA_HOME}"

    software_install_mkdir "${BIGDATA_HOME}"
    single_chmod "750" "${BIGDATA_HOME}"

    tmp_dir="${BIGDATA_HOME}/tmp"
    mkdir -p "${tmp_dir}" || return ${INS_MKDIR_FAILURE}
    single_chmod "1770" "${tmp_dir}"

    # 区分用户执行任务特性，修改目录属组
    single_chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${BIGDATA_LOG_HOME}"
    chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${BIGDATA_LOG_HOME}/scc" -R
    single_chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${BIGDATA_DATA_HOME}"
    single_chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${BIGDATA_HOME}"
    single_chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${tmp_dir}"
    single_chown "${OMM_USER}":"${FI_COMMON_GROUP}" "${common_workspace}"
    find "${common_workspace}/security" -type f -links 1 | xargs -I{} chown "${OMM_USER}:${FI_COMMON_GROUP}" '{}'
    find "${common_workspace}/security" -type d ! -type l | xargs -I{} chown "${OMM_USER}:${FI_COMMON_GROUP}" '{}'

    echo "Init nodeagent home end."
    return ${INS_SUCCESS}
}

################################################################################
# Function: security_nodeagent_software_dir_and_file_chown_root
# Description: chown  root:wheel
#
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
security_nodeagent_software_dir_and_file_chown_root()
{
    local bigdata_setup="${1}"
    local g_nodeagentHome="${2}"

    mkdir -vp ${bigdata_setup}/nodesetup/setup
    mkdir -vp ${bigdata_setup}/func

    mv ${g_nodeagentHome}/setup/uninstall.sh ${bigdata_setup}/nodesetup/setup
    cp ${g_nodeagentHome}/setup/func/constants.sh ${bigdata_setup}/func
    cp ${g_nodeagentHome}/setup/func/functions.sh ${bigdata_setup}/func
    cp ${g_nodeagentHome}/setup/func/log.sh ${bigdata_setup}/func

    root_owner_file_list="
        ${bigdata_setup}:750
        ${bigdata_setup}/nodesetup/:750
        ${bigdata_setup}/nodesetup/setup/:750
        ${bigdata_setup}/nodesetup/setup/uninstall.sh:550
        ${bigdata_setup}/func/constants.sh:550
        ${bigdata_setup}/func/functions.sh:550
        ${bigdata_setup}/func/log.sh:550
        ${bigdata_setup}/func/:750
    "
    for f in $root_owner_file_list; do
        file_path=`echo ${f} | awk  -F ':' '{print $1}'`
        permission=`echo ${f} | awk  -F ':' '{print $2}'`
        chmod ${permission}  ${file_path}
        chown "root:${WHEEL_GROUP}" ${file_path}
    done

    # 设置sudoExecute.sh为500
    chmod 750 "`dirname ${bigdata_setup}`/Bigdata_func"
    chmod -R 500 "`dirname ${bigdata_setup}`/Bigdata_func/sudo/"

    return 0
}

################################################################################
# Function: security_software_dir_and_file_chown_root
# Description: chown  root:wheel
#
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
security_software_dir_and_file_chown_root()
{
    local setup_home="${1}"
    local om_server_workspace="${2}"
    local package_dir=$(ls ${om_server_workspace}/om/packaged-distributables/*-* -d)
    local package_dir_basename=$(basename ${package_dir})
    
    mkdir -p ${setup_home}/nodesetup
    mkdir -p ${setup_home}/om/inst
    mkdir -p ${setup_home}/om/packaged-distributables/${package_dir_basename}
    mkdir -p ${setup_home}/func
    chown "root:${WHEEL_GROUP}" ${setup_home}/om/packaged-distributables/ -R
    
    mv ${om_server_workspace}/om/etc/om/nodesetup/nodesetup.xml ${setup_home}/nodesetup/
    mv ${om_server_workspace}/om/inst/uninstall.sh ${setup_home}/om/inst
    mv ${om_server_workspace}/om/packaged-distributables/${package_dir_basename}/seccomponent* ${setup_home}/om/packaged-distributables/${package_dir_basename}/
    cp ${om_server_workspace}/om/inst/func/constants.sh ${setup_home}/func
    cp ${om_server_workspace}/om/inst/func/functions.sh ${setup_home}/func
    cp ${om_server_workspace}/om/inst/func/log.sh ${setup_home}/func

    root_owner_file_list="
        ${setup_home}:750
        ${setup_home}/om/inst/uninstall.sh:550
        ${setup_home}/om/packaged-distributables/${package_dir_basename}/seccomponent*:750
        ${setup_home}/nodesetup/nodesetup.xml:640
        ${setup_home}/nodesetup/:750
        ${setup_home}/func/constants.sh:550
        ${setup_home}/func/functions.sh:550
        ${setup_home}/func/log.sh:550
        ${setup_home}/func/:750
    "
    for f in $root_owner_file_list; do
        file_path=`echo ${f} | awk  -F ':' '{print $1}'`
        permission=`echo ${f} | awk  -F ':' '{print $2}'`
        chmod ${permission}  ${file_path}
        chown "root:${WHEEL_GROUP}" ${file_path}
    done

    return 0
}

################################################################################
# Function: set_ommdba_code
# Description: 将用户dba环境编码格式改为'en_US.UTF-8'
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
set_ommdba_code()
{
    log "INFO" "${LINENO}" "Start to set ommdba code."

    if [ ! -f "${DB_CREATER_HOME}/.profile" ] ; then
        touch "${DB_CREATER_HOME}/.profile" || return ${INS_WRITE_FILE_FAILURE}
    fi
    grep "^export[[:space:]]*LC_ALL='en_US.UTF-8'[[:space:]]*$" "${DB_CREATER_HOME}/.profile" > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        echo "export LC_ALL='en_US.UTF-8'">> "${DB_CREATER_HOME}/.profile" || return ${INS_WRITE_FILE_FAILURE}
    fi
    chown "${DB_CREATER}":"${WHEEL_GROUP}" "${DB_CREATER_HOME}/.profile"
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to chown the ${DB_CREATER_HOME}/.profile."
        return ${INS_MODIG_AUTHORITY_FAILURE}
    fi
    log "INFO" "${LINENO}" "Succeed to set ommdba code."

    return 0
}

config_defult_su()
{
   if [ -f /etc/default/su  ] ; then
        grep '^[[:space:]]*ALWAYS_SET_PATH'  /etc/default/su >/dev/null 2>&1
        if [ $? -ne 0 ] ; then
           echo 'ALWAYS_SET_PATH=yes' >> /etc/default/su
        fi
    fi
    if [ -f /etc/login.defs ] ; then
        grep '^[[:space:]]*ALWAYS_SET_PATH' /etc/login.defs >/dev/null 2>&1
        if [ $? -ne 0 ] ; then
           echo 'ALWAYS_SET_PATH=yes' >> /etc/login.defs
        fi
    fi

    grep 'ALWAYS_SET_PATH=no' /etc/default/su >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i 's/ALWAYS_SET_PATH=no/ALWAYS_SET_PATH=yes/g'  /etc/default/su >/dev/null 2>&1
    fi

    grep 'ALWAYS_SET_PATH=no' /etc/login.defs >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i 's/ALWAYS_SET_PATH=no/ALWAYS_SET_PATH=yes/g'  /etc/login.defs >/dev/null 2>&1
    fi

    grep 'ALWAYS_SET_PATH[[:space:]]*no' /etc/login.defs >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i 's/ALWAYS_SET_PATH[[:space:]]*no/ALWAYS_SET_PATH yes/g'  /etc/login.defs >/dev/null 2>&1
    fi

}

################################################################################
# Function: set_sudoers
# Description: 配置/etc/sudoers
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
set_sudoers()
{
    log "INFO" "${LINENO}" "Start to config /etc/sudoers."
    if ! [ -f "/etc/SuSE-release" ] ; then
        grep '^[[:space:]]*Defaults[[:space:]]*requiretty[[:space:]]*$'  /etc/sudoers >/dev/null 2>&1
        if [ $? -eq 0 ] ; then
            sed -i s/'^[[:space:]]*Defaults[[:space:]]*requiretty[[:space:]]*$'/'Defaults !requiretty'/g /etc/sudoers
        fi

        grep '^[[:space:]]*Defaults[[:space:]]*!visiblepw[[:space:]]*$'  /etc/sudoers >/dev/null 2>&1
        if [ $? -eq 0 ] ; then
            sed -i s/'^[[:space:]]*Defaults[[:space:]]*!visiblepw[[:space:]]*$'/'Defaults visiblepw'/g /etc/sudoers
        fi

        grep '^[[:space:]]*Defaults[[:space:]]*visiblepw[[:space:]]*$'  /etc/sudoers >/dev/null 2>&1
        if [ $? -ne 0 ] ; then
           echo 'Defaults visiblepw' >> /etc/sudoers
        fi
    fi

    grep '^[[:space:]]*omm[[:space:]]*ALL=(ALL)[[:space:]]*NOPASSWD:[[:space:]]*ALL'  /etc/sudoers >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i -e '/^[[:space:]]*omm[[:space:]]*ALL=(ALL)[[:space:]]*NOPASSWD:[[:space:]]*ALL/d'  /etc/sudoers >/dev/null 2>&1
    fi

    grep '^[[:space:]]*%wheel[[:space:]]*ALL=(ALL)[[:space:]]*NOPASSWD:[[:space:]]*ALL'  /etc/sudoers >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i -e '/^[[:space:]]*%wheel[[:space:]]*ALL=(ALL)[[:space:]]*NOPASSWD:[[:space:]]*ALL/d'  /etc/sudoers >/dev/null 2>&1
    fi

    grep '^[[:space:]]*%wheel[[:space:]]*ALL=(ALL)[[:space:]]*ALL'  /etc/sudoers >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
        sed -i -e '/^[[:space:]]*%wheel[[:space:]]*ALL=(ALL)[[:space:]]*ALL/d'  /etc/sudoers >/dev/null 2>&1
    fi

    grep '^[[:space:]]*Defaults[[:space:]]*targetpw[[:space:]]*$'  /etc/sudoers >/dev/null 2>&1
    if [ $? -ne 0 ] ; then
       echo 'Defaults targetpw' >> /etc/sudoers
    fi

    grep "Defaults passwd_timeout=.*" /etc/sudoers >/dev/null 2>&1
    if [ $? -ne 0 ];then
        echo "Defaults passwd_timeout=1" >> /etc/sudoers
    else
        sed -i s/'^[[:space:]]*Defaults passwd_timeout=.*'/'Defaults passwd_timeout=1'/g /etc/sudoers >/dev/null 2>&1
    fi

    # 匹配Default !env_reset，如果存在则替换!为空
    sed -i '/^[[:space:]]*Defaults[[:space:]]*.env_reset/{s#!##g}' /etc/sudoers >/dev/null 2>&1

    chmod 0440 /etc/sudoers

    config_defult_su

    log "INFO" "${LINENO}" "Succeed to config /etc/sudoers."
}

################################################################################
# Function: set_cmd_to_sudoers
# Description: 提权一条命令
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
set_cmd_to_sudoers()
{
    cmd="${1}"
    log "INFO" "${LINENO}" "Start to config ${cmd} to /etc/sudoers."

    grep "^${OMM_USER} ALL=(root) NOPASSWD: ${cmd}[[:space:]]*$" /etc/sudoers >/dev/null 2>&1
    if [ $? -ne 0 ] ; then
        echo "${OMM_USER} ALL=(root) NOPASSWD: ${cmd}" >> /etc/sudoers
    fi

    log "INFO" "${LINENO}" "Succeed to config ${cmd} to /etc/sudoers."
}

################################################################################
# Function: stop_redhat_iptables
# Description: 关闭redhat系列OS防火墙(centos、redhat), 高版本操作系统均两层防火
#              墙，低版本是一层。从应用角度，只要开启均应关掉，不再区分OS版本   
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
stop_redhat_iptables()
{
    log "INFO" "${LINENO}" "Start to stop iptables."

    service iptables status > /dev/null 2>&1
    if [ 0 -eq $? ]; then
        service iptables stop > /dev/null 2>&1
        if [ 0 -ne $? ]; then
           log "ERROR" "${LINENO}" "Failed to stop iptables."
           return 1
        fi

        chkconfig iptables off
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop iptables."
            return 1
        fi
    fi
    
    service firewalld status > /dev/null 2>&1
    if [ 0 -eq $? ]; then
        service firewalld stop > /dev/null 2>&1
        if [ 0 -ne $? ]; then
           log "ERROR" "${LINENO}" "Failed to stop iptables."
           return 1
        fi

        chkconfig firewalld off
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop iptables."
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "Succeed to stop iptables."
}

################################################################################
# Function: stop_euleros_iptables
# Description: 关闭 euler OS防火墙, 高版本操作系统均两层防火
#              墙，低版本是一层。从应用角度，只要开启均应关掉，不再区分OS版本
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
stop_euleros_iptables()
{
    log "INFO" "${LINENO}" "Start to stop euler OS iptables."

    service iptables status > /dev/null 2>&1
    if [ 0 -eq $? ]; then
        service iptables stop > /dev/null 2>&1
        if [ 0 -ne $? ]; then
           log "ERROR" "${LINENO}" "Failed to stop iptables."
           return 1
        fi

        chkconfig iptables off
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop iptables."
            return 1
        fi
    fi

    service firewalld status > /dev/null 2>&1
    if [ 0 -eq $? ]; then
        service firewalld stop > /dev/null 2>&1
        if [ 0 -ne $? ]; then
           log "ERROR" "${LINENO}" "Failed to stop iptables."
           return 1
        fi

        chkconfig firewalld off
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop iptables."
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "Succeed to stop iptables."
}

################################################################################
# Function: stop_suse_iptables
# Description: 关闭suse防火墙
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
stop_suse_iptables()
{
    log "INFO" "${LINENO}" "Start to stop suse iptables."

    ## suse12关闭防火墙
    if [ -f "/etc/SuSE-release" ]; then
        VERSION=$(cat /etc/SuSE-release | grep "VERSION" | awk -F '=' '{print $2}')
        if [ "${VERSION}" -eq "12" ]; then
            systemctl disable SuSEfirewall2.service
            if [ $? -ne 0 ]; then
                log "ERROR" "${LINENO}" "systemctl disable SuSEfirewall2.service failed."
                return 1
            fi
            
            systemctl disable SuSEfirewall2_init.service
            if [ $? -ne 0 ]; then
                log "ERROR" "${LINENO}" "systemctl disable SuSEfirewall2_init.service failed."
                return 1
            fi
            
            systemctl stop SuSEfirewall2.service
            if [ $? -ne 0 ]; then
                log "ERROR" "${LINENO}" "systemctl stop SuSEfirewall2.service failed."
                return 1
            fi
            
            systemctl stop SuSEfirewall2_init.service
            if [ $? -ne 0 ]; then
                log "ERROR" "${LINENO}" "systemctl stop SuSEfirewall2_init.service failed."
                return 1
            fi         
            
            systemctl status SuSEfirewall2.service | grep "Active: active"
            if [ $? -eq 0 ]; then
                log "ERROR" "${LINENO}" "Failed to stop SuSEfirewall2.service."
                return 1
            fi
            
            systemctl status SuSEfirewall2_init.service | grep "Active: active"
            if [ $? -eq 0 ]; then
                log "ERROR" "${LINENO}" "Failed to stop SuSEfirewall2_init.service."
                return 1
            fi
            
            log "INFO" "${LINENO}" "Succeed to stop suse iptables."
            return 0
        fi
    fi

    # suse15 使用通用关闭方法
    if ! disable_fileWall_General; then
        # suse11等低版本os关闭防火墙
        chkconfig --level 0123456 SuSEfirewall2_setup off && chkconfig --level 0123456 SuSEfirewall2_init off > /dev/null
        #检测是否关闭成功
        chkconfig --list | grep "fire" | grep "on"
        if [ $? -eq 0 ]; then
            log "ERROR" "${LINENO}" "Failed to stop suse iptables."
            return 1
        fi
    fi

    log "INFO" "${LINENO}" "Succeed to stop suse iptables."
    return 0
}

################################################################################
# Function: disable_fileWall_General
# Description: 关闭防火墙通用方法
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
disable_fileWall_General(){
    systemctl status firewalld > /dev/null 2>&1
    if [ 0 -eq $? ]; then
        systemctl stop firewalld > /dev/null 2>&1
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop firewalld."
            return 1
        fi

        chkconfig firewalld off
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to stop firewalld."
            return 1
        fi
    fi
    return 0
}
################################################################################
# Function: config_sysctl
# Description: 配置sysctl
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_sysctl()
{
    log "INFO" "${LINENO}" "Start to config /etc/sysctl.conf."

    sed -i s/'^[[:space:]]*net.bridge.bridge-nf-call-ip6tables'/'#net.bridge.bridge-nf-call-ip6tables'/g /etc/sysctl.conf
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/sysctl.conf."
        return 1
    fi

    sed -i s/'^[[:space:]]*net.bridge.bridge-nf-call-iptables'/'#net.bridge.bridge-nf-call-iptables'/g /etc/sysctl.conf
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/sysctl.conf."
        return 1
    fi

    sed -i s/'^[[:space:]]*net.bridge.bridge-nf-call-arptables'/'#net.bridge.bridge-nf-call-arptables'/g /etc/sysctl.conf
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/sysctl.conf."
        return 1
    fi

    log "INFO" "${LINENO}" "Succeed to config /etc/sysctl.conf."
}

# 配置ipv6开关
config_disable_ipv6()
{
    log "INFO" "${LINENO}" "Start to config /etc/sysctl.conf."

    if [ ! -f "/etc/sysctl.conf" ];then
        return 0
    fi

    cat /etc/sysctl.conf |grep "net.ipv6.conf.all.disable_ipv6 = 1"
    if [ $? -eq 0 ];then
        sed -i s/'^[[:space:]]*net.ipv6.conf.all.disable_ipv6 = 1'/'net.ipv6.conf.all.disable_ipv6 = 0'/g /etc/sysctl.conf
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to config /etc/sysctl.conf."
            return 1
        fi
    fi

    cat /etc/sysctl.conf |grep "net.ipv6.conf.default.disable_ipv6 = 1"
    if [ $? -eq 0 ];then
        sed -i s/'^[[:space:]]*net.ipv6.conf.default.disable_ipv6 = 1'/'net.ipv6.conf.default.disable_ipv6 = 0'/g /etc/sysctl.conf
        if [ 0 -ne $? ]; then
            log "ERROR" "${LINENO}" "Failed to config /etc/sysctl.conf."
            return 1
        fi
    fi

    sysctl -p 2>/dev/null

    log "INFO" "${LINENO}" "Succeed to config /etc/sysctl.conf."
}

################################################################################
# Function: config_limits
# Description: 配置limits
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_limits()
{
    log "INFO" "${LINENO}" "Start to config /etc/security/limits.d/omm-nproc.conf."

    local limit_dir="/etc/security/limits.d"
    local omm_limit_config_file="$limit_dir/omm-nproc.conf"

    mkdir -p ${limit_dir}
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/security/limits.d/omm-nproc.conf."
        return 1
    fi
    echo "omm          soft    nproc     60000" > ${omm_limit_config_file}
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/security/limits.d/omm-nproc.conf."
        return 1
    fi
    echo "omm          hard    nproc     60000" >> ${omm_limit_config_file}
    if [ 0 -ne $? ]; then
        log "ERROR" "${LINENO}" "Failed to config /etc/security/limits.d/omm-nproc.conf."
        return 1
    fi

    log "INFO" "${LINENO}" "Succeed to config /etc/security/limits.d/omm-nproc.conf."
}

################################################################################
# Function: is_db_running
# Description: db 是否运行
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
is_db_running()
{
    #Manager版本号
    local om_server_workspace_name="$1"
    
    local dbCMD="${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/${DB_INSTALL_DIR}/${DB_CTL_CMD}"
    if [ ! -f "${dbCMD}" ] ; then
        log "ERROR" "${LINENO}" "The ${dbCMD} script does not exist."
        return ${INS_FILE_NOT_EXIST}
    fi

    su - ${DB_CREATER} -c "${dbCMD} query  >/dev/null 2>&1 "
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "The database is not running."
        return ${INS_GTE_DB_STATUS_FAILURE}
    fi

    return 0
}

################################################################################
# Function: config_gaussdb_ssl
# Description: 配置ommdb数据库开启ssl
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_gaussdb_ssl()
{
    #生成ommdba证书地址
    local omm_db_ssl_dir="$1"
    local dbSslCMD="${BIGDATA_HOME}/om-server/${G_OMM_SERVER_HOME_NAME}/setup/update_database_ssl.sh"
    local logScriptDir="${BIGDATA_HOME}/om-server/${G_OMM_SERVER_HOME_NAME}/setup/log_tool.sh"
    if [ ! -f "${dbSslCMD}" ] ; then
        log "ERROR" "${LINENO}" "The ${dbSslCMD} script does not exist."
        return ${INS_FILE_NOT_EXIST}
    fi
    if [ ! -d "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup" ] ; then
        mkdir -p ${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup
    fi
    if [ ! -f "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/update_database_ssl.sh" ] ; then
       cp "${dbSslCMD}"  "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/"
    fi
    if [ ! -f "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/log_tool.sh" ] ; then
       cp "${logScriptDir}"  "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/"
    fi
    chown ommdba:wheel  ${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup -R

    local ommdbsslDir="${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/ommdbsslDir"
    if [ ! -d "${ommdbsslDir}" ] ; then
        mkdir -p ${ommdbsslDir}
    else
       su - ${DB_CREATER} -c "sh ${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/update_database_ssl.sh off ${ommdbsslDir}/ommdbserver.crt ${ommdbsslDir}/ommdbserver.pem  ${ommdbsslDir}/ca.crt >/dev/null 2>&1"
    fi
    cp -ar ${omm_db_ssl_dir}/* ${ommdbsslDir}/
    chmod 600 ${ommdbsslDir}/* -R
    chown ommdba:wheel ${ommdbsslDir} -R

    su - ${DB_CREATER} -c "sh ${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/setup/update_database_ssl.sh on ${ommdbsslDir}/ommdbserver.crt ${ommdbsslDir}/ommdbserver.pem  ${ommdbsslDir}/ca.crt >/dev/null 2>&1"
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "config ommdb ssl failed."
        return ${INS_GTE_DB_STATUS_FAILURE}
    fi

    local dbCMD="${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/${DB_INSTALL_DIR}/${DB_CTL_CMD}" 
    if [ ! -f "${dbCMD}" ] ; then
       log "ERROR" "${LINENO}" "The ${dbCMD} script does not exist."
       return ${INS_FILE_NOT_EXIST}
    fi
    su - ${DB_CREATER} -c "${dbCMD} restart -w -t 300" >/dev/null 2>&1
	if [[ $? -ne 0 ]]; then
       sleep 5
       su - ${DB_CREATER} -c "${dbCMD} restart -w -t 300" >/dev/null 2>&1
       if [[ "$?" -ne 0 ]]; then
           log "ERROR" "${LINENO}" "Fail to restart database."
           return 1
       fi
    fi
    return 0
}

################################################################################
# Function: add_route_tables
# Description: 建立路由表项
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
# Note: 201已经规化给NTP
################################################################################
add_route_tables()
{
   local route_table_file="/etc/iproute2/rt_tables"
   
   echo "200 om_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
   echo "202 snmp_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
   echo "203 syslog_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
   echo "204 drp_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
   echo "205 urp_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
}

add_route_tables_ntp()
{
    local route_table_file="/etc/iproute2/rt_tables"
    if [ ! -f "${route_table_file}" ]; then
        log "ERROR" "${LINENO}" "Failed to add ntp route, cause route table file does not exist."
        return 1
    fi
    cat "${route_table_file}" | grep "^201 *ntp_rt$" | grep -v grep
    if [ $? -ne 0 ]; then
        echo "201 ntp_rt" >> "${route_table_file}" || return ${INS_WRITE_FILE_FAILURE}
    fi
    
}

################################################################################
# Function: config_sshd
# Description: 配置SSHD服务相关参数
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_sshd()
{
    local g_logFile="$1"
    sed -i '/UseDNS/d' /etc/ssh/sshd_config >> "${g_logFile}" 2>&1
    sed -i '/MaxStartups/d' /etc/ssh/sshd_config >> "${g_logFile}" 2>&1
    #sshd_config文件语法规范：Match User语句块必须在配置文件的最后，否则会导致文件语法错误。因此在向该文件中插入内容时，必须要插入到Match User的前边
    local matchPoint="$(sed -n '/^[[:space:]]*Match User/=' /etc/ssh/sshd_config|sed -n '1'p)"
    if [ -n "${matchPoint}" ] ; then
        sed -i "${matchPoint}i\UseDNS no" /etc/ssh/sshd_config
        sed -i "${matchPoint}i\MaxStartups 1000" /etc/ssh/sshd_config
    else
        echo >>/etc/ssh/sshd_config
        echo 'UseDNS no' >>/etc/ssh/sshd_config
        echo 'MaxStartups 1000' >>/etc/ssh/sshd_config
    fi

    echo 'StrictHostKeyChecking no' >/home/omm/.ssh/config
    echo 'UserKnownHostsFile /dev/null' >>/home/omm/.ssh/config

    chown ${OMM_USER}:${WHEEL_GROUP} /home/omm/.ssh/config

    chmod 600 /home/omm/.ssh -R
    chmod 700 /home/omm/.ssh

    service sshd restart >> "${g_logFile}" 2>&1
}

################################################################################
# Function: config_crontab
# Description: 配置crontab:把ha和审计日志的监控脚本加入crontab,让其定期执行
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_crontab()
{
    local mail="MAILTO"
    local crontabFile="${1}"
    local CRON_SERVICE_NAME="${2}"

    # 重置crontab文件权限
    if [ ! -f "${crontabFile}" ] ; then
        touch "${crontabFile}" || return ${INS_CREATE_FILE_FAILURE}
        chmod 400 "${crontabFile}"
    fi

    #由于安全加固关闭了postfix服务，使系统邮件无法处理，要配置不往root发邮件
    grep "${mail}" "${crontabFile}" > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        sed -i "1i ${mail}=\"\"" "${crontabFile}"
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to add mail config to crontab."
            return ${INS_CREATE_FILE_FAILURE}
        fi
    fi

    #重启crontab服务
    service "${CRON_SERVICE_NAME}" restart > /dev/null 2>&1

    return 0
}

################################################################################
# Function: configOMSDiskManger
# Description: 配置OMS节点的磁盘管理进程
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
configOMSDiskManger()
{
    local controller_home="${1}"
    verify_path "$controller_home" || return 1
    
    local diskMgt="${controller_home}/sbin/dbdata_om_notify.sh"
    local DISKMANAGER_DIR="/usr/local/diskmgt/ini-plugin/notify"

    log "INFO" "${LINENO}" "Start to config OMS diskManger." "${OMS_LOG_FILE}"
    if [ ! -d  "${DISKMANAGER_DIR}" ]; then
        log "WARN" "${LINENO}"  " no diskManger to operation" "${OMS_LOG_FILE}"
        return 0
    else
       rm -f "${DISKMANAGER_DIR}/dbdata_om_notify.sh"
       cp ${diskMgt}  ${DISKMANAGER_DIR}
       if [ $? -ne 0 ] ;then
            log "ERROR" "${LINENO}" "Failed to copy configFile configDiskManger." "${OMS_LOG_FILE}"
            return 1
       fi
    fi

    #启动diskmanger
    start_diskmgt  >/dev/null
    if [ $? -ne 0 ] ;then
        log "ERROR" "${LINENO}" "Failed to diskManagerOperation." "${OMS_LOG_FILE}"
        return 1
    fi
    log "INFO" "${LINENO}" "Succeed to diskManagerOperation." "${OMS_LOG_FILE}"
    return 0
}


###########################################################
#    Description:  Start disk mgt script
#    Parameter:   no
#    Return:
##########################################################
function start_diskmgt()
{
    local ret=0
    if [ ! -e "/usr/local/diskmgt/script/diskmgt.sh" ]; then
        echo "No /usr/local/diskmgt/script/diskmgt.sh for start!"
        return 0
    fi
    
    local DISKMGT_UNIT_FILE="/usr/lib/systemd/system/diskmgt.service"
    if [ -f "${DISKMGT_UNIT_FILE}" ]; then
        systemctl start diskmgt.service
        ret=$?
    else
        bash /usr/local/diskmgt/script/diskmgt.sh -s
        ret=$?
    fi
    
    return $ret
}

###########################################################
#    Description:  Stop disk mgt script
#    Parameter:   no
#    Return:
##########################################################
function stop_diskmgt()
{
    local ret=0
    if [ ! -e "/usr/local/diskmgt/script/diskmgt.sh" ]; then
        echo "No /usr/local/diskmgt/script/diskmgt.sh for stop!"
        return 0
    fi
    
    local DISKMGT_UNIT_FILE="/usr/lib/systemd/system/diskmgt.service"
    if [ -f "${DISKMGT_UNIT_FILE}" ]; then
        systemctl stop diskmgt.service
        ret=$?
    else
        bash /usr/local/diskmgt/script/diskmgt.sh -k
        ret=$?
    fi

    return $ret
}

###########################################################
#    Description:  Restart disk mgt script
#    Parameter:   no
#    Return:
##########################################################
function restart_diskmgt()
{
    local ret=0
    if [ ! -e "/usr/local/diskmgt/script/diskmgt.sh" ]; then
        echo "No /usr/local/diskmgt/script/diskmgt.sh for restart!"
        return 0
    fi
    
    local DISKMGT_UNIT_FILE="/usr/lib/systemd/system/diskmgt.service"
    if [ -f "${DISKMGT_UNIT_FILE}" ]; then
        systemctl restart diskmgt.service
        ret=$?
    else
        bash /usr/local/diskmgt/script/diskmgt.sh -r
        ret=$?
    fi
    
    return $ret
}

###################################################################
#    Description:  C80升级 备份sudo文件 用于回滚时恢复低版本sudo
#    Parameter:   no
#    Return:
###################################################################
backup_sudo_file()
{
    local bidata_sudo_home="/var/lib/sudo/Bigdata/"

    if [ ! -d ${bidata_sudo_home} ]; then
        return 1
    fi

    local backupDir="/var/lib/sudo/Bigdata/backup"
    mkdir -p "${backupDir}"
    chmod 700 "${backupDir}"

    check_linkfile "${bidata_sudo_home}/sudo/runtime/sudoExecute.sh" || return 1
    check_linkfile "${backupDir}" || return 1

    cp -pf ${bidata_sudo_home}/sudo/runtime/sudoExecute.sh "${backupDir}" || return $?
}

###################################################################
#    Description:  升级备份hosts文件 用于回滚时恢复
#    Parameter:   no
#    Return:
###################################################################
backup_hosts_file()
{
    local bidata_sudo_home="/var/lib/sudo/Bigdata/"

    if [ ! -d ${bidata_sudo_home} ]; then
        return 1
    fi

    local backupDir="/var/lib/sudo/Bigdata/backup"
    if [ ! -d "${backupDir}" ]; then
        mkdir -p "${backupDir}"
        chmod 700 "${backupDir}"
    fi

    check_linkfile "/etc/hosts" || return 1
    check_linkfile "${backupDir}" || return 1

    cp -pf "/etc/hosts" "${backupDir}" || return $?
}

###################################################################
#    Description: C80升级备份sudo文件 用于提交或回滚时删除备份sudo
#    Parameter:   no
#    Return:
###################################################################
delete_sudo_bakup_file()
{
    local backupDir="/var/lib/sudo/Bigdata/backup"
    if [ ! -d ${backupDir} ]; then
        return 0
    fi

    check_linkfile "${backupDir}" || return 1

    rm -rf "${backupDir}"
    return $?
}

###################################################################
#    Description: C80升级备份sudo文件 用于回滚时恢复低版本sudo
#    Parameter:   no
#    Return:
###################################################################
recovery_backup_sudo_file()
{
    local backupDir="/var/lib/sudo/Bigdata_backup"
    local bidata_sudo_home="/var/lib/sudo/Bigdata"

    if [ ! -d ${backupDir} ]; then
        echo "WARN: the /var/lib/sudo/Bigdata/backup does not exist"
        return 0
    fi

    if [ ! -d ${bidata_sudo_home} ]; then
        return 1
    fi

    if [ -d "${bidata_sudo_home}/sudo" ]; then
        rm -rf "${bidata_sudo_home}/sudo"
    fi

    cp -rpf ${backupDir}/sudo ${bidata_sudo_home}/
    return $? 
}

###################################################################
#    Description: 升级备份hosts文件 用于回滚时恢复低版本
#    Parameter:   no
#    Return:
###################################################################
recovery_backup_hosts_file()
{
    local backupDir="/var/lib/sudo/Bigdata/backup"

    if [ ! -f "${backupDir}/hosts" ]; then
        echo "WARN: the /var/lib/sudo/Bigdata/backup/hosts does not exist"
        return 0
    fi

    check_linkfile "${backupDir}/hosts" || return 1

    cp -pf ${backupDir}/hosts /etc/
    if [ $? -ne 0 ]; then 
        return 1
    fi

    chmod 644 /etc/hosts
    return $? 
}

################################################################################
# Function: modify_oms_sudo_script
# Description: 修改oms节点sudo脚本权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
modify_oms_sudo_script()
{
   # 改变sudoExecute.sh及其父的权限：root: 500
    chown -R "root":"root" ${BIGDATA_SUDO_HOME}/sudo/
    chmod -R 500 "${BIGDATA_SUDO_HOME}/sudo/"
}

################################################################################
# Function: log
# Description: 记录到日志文件
# usage: log "ERROR" "${LINENO}" "operation failed." "${BIGDATA_LOG_HOME}/sudo/sudo.log"
# Parameter: $1 logLevel
#            $2 lineNo
#            $3 logContent
#            $4 logFile(defaultLogFile: ${BIGDATA_LOG_HOME}/sudo/sudo.log)
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others:
################################################################################
log()
{
    local logLevel="$1"
    shift

    local lineNO="$1"
    shift

    local contentBuff="$1"
    shift

    local logFile="$1"
    if [ -z $logFile ]; then
        logFile="${BIGDATA_LOG_HOME}/sudo/sudo.log"
        mkdir -p $(dirname "${logFile}") -m 700
        chown omm:wheel $(dirname "${logFile}")
    else
        mkdir -p $(dirname "${logFile}")
    fi

    #不采用=~的方式是因为shellcheck检查，=~属于Bash 3.0或者rsh的特性
    if [ $(expr "${logFile}" : "^${LOG_HOME}") -eq 0 ]; then
       return 1
    fi

    if ! [ -f "${logFile}" ]; then
        touch "${logFile}"
        chown omm:wheel "${logFile}"
        chmod 600 "${logFile}"
    fi

    # 打印时间、日志级别、日志内容、脚本名称、调用日志打印函数的函数、打印时的行号及脚本的进程号
    local logTime="$(date -d today +'%Y-%m-%d %H:%M:%S')"
    local funcName="${FUNCNAME[1]}"
    printf "[${logTime}] ${logLevel} ${contentBuff} [$0(${funcName}):${lineNO}]($$)\n" \
        >> "${logFile}" 2>&1

    return 0
}

################################################################################
# Function: get_omm_env
# Description: 获取omm用户的环境变量
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_omm_env()
{
    local -i retVal=0

    env="${1}"

    log "INFO" "${LINENO}" "get env: ${env}"

    env_value=$(su - ${OMM_USER} -c 'source /home/omm/.profile > /dev/null 2>&1; source ${BIGDATA_OM_AGENT_HOME}/.om_profile > /dev/null 2>&1; source ${BIGDATA_OM_SERVER_HOME}/.controller_profile > /dev/null 2>&1; echo $'${env}'')
    ret=$?
    if [ -z ${env_value} ] || [ ${ret} -ne 0 ]; then
        log "ERROR" "${LINENO}" "Failed to get env: ${env}"
        return ${ret}
    fi

    echo ${env_value}

    return 0
}

################################################################################
# Function: exec_omm_cmd
# Description: 执行omm用户命令
# Parameter:
#   input:
#   $1 -- cmd  要执行的命令
#   $2 -- parameters 执行命令需要的参数
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
exec_omm_cmd()
{
    local -i retVal=0

    cmd="$@"

    value=$(su - ${OMM_USER} -c "${cmd}")

    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to execute the command, errorCode:${retVal}"
        return ${retVal}
    fi
    if ! [ -z "${value}" ]; then
        echo ${value}
    fi
    return 0
}

################################################################################
# Function: gen_aos_pluginfile
# Description: 生成aos插件所需要的配置文件
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
gen_aos_pluginfile()
{
    local controller_home="$1"
    verify_path "${controller_home}" || return 1
    
    local aosPluginDir="${controller_home}/share/om/aos/plugin"
    local plugin_file_name="${aosPluginDir}/Manager.properties"
    local plugin_path="path=${controller_home}/etc/components/Manager"
    
    echo  ${plugin_path} > ${plugin_file_name}
    
    if [ -f ${plugin_file_name} ];then
        if [ -L ${plugin_file_name} ];then
            return 1
        fi

        local inodeValue=$(ls -l ${plugin_file_name} | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
    fi

    chown omm:wheel ${plugin_file_name}
    chmod 700 ${plugin_file_name}
}

################################################################################
# Function: chmod_ntp_conf
# Description: 修改ntp配置文件
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chmod_ntp_conf()
{
    chmod 0644 /etc/ntp.conf
}

################################################################################
# Function: ntpq_np
# Description: 修改ntp配置文件
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
ntpq_np()
{
    systemctl daemon-reload
    ntpq -np 2>/dev/null | grep "^\*" > /dev/null 2>&1
    return $?
}

################################################################################
# Function: ntpService_file_preset
# Description: redhat7.X和centOS7.X版本预修改ntpd.service，支持ntp升级到高版本
# Parameter: none
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
ntpdService_file_preset()
{
    local ntpd_service_file="/usr/lib/systemd/system/ntpd.service"
    local ntpdPathFormPath=$(which ntpd 2>/dev/null)
    if [ -z "${ntpdPathFormPath}" ]; then
        #ntpd not install
        return 10
    fi

    local ntpdPathOrigin=$(cat ${ntpd_service_file} | grep "^ExecStart=" | awk -F '=' '{print $2}' | awk -F ' ' '{print $1}')

    #sudo脚本中which获取的ntpd与root用户下which获取到的ntpd路径可能不一样，优先使用原配置。
    if [ ! -z "${ntpdPathOrigin}" ]; then
        local modifyTo="ExecStart=${ntpdPathOrigin} \$OPTIONS"
    else
        local modifyTo="ExecStart=${ntpdPathFormPath} \$OPTIONS"
    fi

    local realmConfig="\n[Service]\nType=forking\nEnvironmentFile=-/etc/sysconfig/ntpd\n${modifyTo}\nPrivateTmp=true\n"
    local addConfig="\[Service\]\n${modifyTo}"
    local realmName="\[Service\]"

    if [ -f "${ntpd_service_file}" ];then
        if [ -L "${ntpd_service_file}" ];then
            return 1
        fi

        local isRealmExists=$(cat ${ntpd_service_file} | grep "\[Service\]")
        if [ -z "${isRealmExists}" ]; then
            echo -e "${realmConfig}" >> "${ntpd_service_file}"
            if [ $? -ne 0 ]; then
                return 2
            fi
        else
            local is_ExecStart_Exists=$(cat ${ntpd_service_file} | grep "^ExecStart=")
            local localtion_No=$(cat -n ${ntpd_service_file} | grep "ExecStart=" | grep -v "#" | awk -F ' ' '{print $1}')
            if [ -z "${is_ExecStart_Exists}" ]; then
                sed -i "s#${realmName}#${addConfig}#g" "${ntpd_service_file}"
                if [ $? -ne 0 ]; then
                    return 3
                fi
            else
                if [ "${modifyTo}" != "${is_ExecStart_Exists}" ]; then
                    sed -i "${localtion_No}c ${modifyTo}" "${ntpd_service_file}"
                    if [ $? -ne 0 ]; then
                        return 4
                    fi
                fi
            fi
        fi
    fi

}

################################################################################
# Function: adjust_ntp_apparmor_config
# Description: 修改apparmor ntp配置，增加对ntp.pid的权限
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
adjust_ntp_apparmor_config()
{
    local ntp_pid_config="/var/lib/ntp/var/run/ntp/ntpd.pid rw,"
    local apparmor_ntp_config="/etc/apparmor.d/usr.sbin.ntpd"
    local apparmor_ntp_config_tmp="/etc/apparmor.d/usr.sbin.ntpd_tmp"
    local line_no=0
    
    check_linkfile "${apparmor_ntp_config}"
    if [ $? -ne 0 ]; then
         log "ERROR" "${LINENO}" "${apparmor_ntp_config} is link file."
        return 1
    fi 
    
    check_linkfile "${apparmor_ntp_config_tmp}"
    if [ $? -ne 0 ]; then
         log "ERROR" "${LINENO}" "${apparmor_ntp_config_tmp} is link file."
        return 1
    fi
    
    grep "${ntp_pid_config}" "${apparmor_ntp_config}"
    if [ $? -ne 0 ]; then
        cp "${apparmor_ntp_config}" "${apparmor_ntp_config_tmp}"
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "cp ${apparmor_ntp_config} to ${apparmor_ntp_config_tmp} failed."
            rm -f "${apparmor_ntp_config_tmp}"
            return 1
        fi
        
        sed -i "/\/var\/lib\/ntp\/var\/run\/ntp\/ntpd.pid/d" "${apparmor_ntp_config_tmp}"
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "delete /var/lib/ntp/var/run/ntp/ntpd.pid from  ${apparmor_ntp_config_tmp} failed."
            rm -f "${apparmor_ntp_config_tmp}"
            return 1
        fi
        
        line_no=$(grep -nw "}" "${apparmor_ntp_config_tmp}" | awk -F ':' '{print $1}')
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "get line No of ${apparmor_ntp_config_tmp} failed."
            rm -f "${apparmor_ntp_config_tmp}"
            return 1
        fi
        
        sed -i "${line_no} i \ \ ${ntp_pid_config}" "${apparmor_ntp_config_tmp}"
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "insert ${ntp_pid_config}to ${apparmor_ntp_config_tmp} failed."
            rm -f "${apparmor_ntp_config_tmp}"
            return 1
        fi
        
        cp "${apparmor_ntp_config_tmp}" "${apparmor_ntp_config}" 
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "cp ${apparmor_ntp_config_tmp} to ${apparmor_ntp_config} failed."
            rm -f "${apparmor_ntp_config_tmp}"
            return 1
        fi
        
        rm -f "${apparmor_ntp_config_tmp}"
        
        service apparmor restart
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "restart apparmor failed."
            return 1
        fi
        
        log "INFO" "${LINENO}" "Success to set ${ntp_pid_config} to ${apparmor_ntp_config}."
    fi
    
    return 0
}

################################################################################
# Function: genNtpKeyFile
# Description: 生成ntp认证文件
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function genNtpKeyFile()
{
    local controller_home="$1"
    verify_path "${controller_home}" || return 1

    local ntp_key_file_pattern="ntpkey_MD5key_*.*"

    mkdir -p Fi_ntp
    cd Fi_ntp
    rm -rf ./*
    if [ ! -f "/root/.rnd" ]; then
        echo "$(head -10 /dev/random | cksum | cut -f1 -d" ")" > "/root/.rnd"
    fi

    /usr/sbin/ntp-keygen -M
    if [ $? -ne 0 ]; then
        cd ..
        rm -rf Fi_ntp
        echo "ERROR:/usr/sbin/ntp-keygen -M failed."
        return 1
    fi
    
    ntp_key_file=$(basename $(find . -name "ntpkey_MD5key_*.*"))
    if [ -z "${ntp_key_file}" ]; then
        cd ..
        rm -rf Fi_ntp
        echo "ERROR:ntp_key_file is null."
        return 1
    fi
    
    ntp_key=$(cat ${ntp_key_file} | grep "^ 8" | awk '{ print $3 }')
    echo "${ntp_key}" > ./ntpKeyFile

    cp -f ./ntpKeyFile "${controller_home}/packaged-distributables/"
    
    if [ -f "${controller_home}/packaged-distributables/ntpKeyFile" ];then
        if [ -L "${controller_home}/packaged-distributables/ntpKeyFile" ];then
            return 1
        fi

        local inodeValue=$(ls -l "${controller_home}/packaged-distributables/ntpKeyFile" | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
    fi

    chown omm:wheel "${controller_home}/packaged-distributables/ntpKeyFile"
    chmod 600 "${controller_home}/packaged-distributables/ntpKeyFile"

    cd ..
    rm -rf Fi_ntp
    return 0
}

################################################################################
# Function: m_update_drift
# Description: m_update_drift
# Parameter:
#   input:
#   $1   content of the line
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_update_drift()
{
    #修改suse的内核频率，初始化为0。（redhat会自动初始化为0）
    which adjtimex > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        adjtimex -f 0
    fi

    #redhat版本没有/var/lib/ntp/drift目录，需要创建这个目录
    if [ ! -d "/var/lib/ntp/drift" ]; then
        if [ -f "/var/lib/ntp/drift" ]; then
        #如果drift是个文件，需要先删除这个文件，否则创建drift目录失败。
        rm -rf /var/lib/ntp/drift
        fi

        mkdir /var/lib/ntp/drift
        if [ -d /var/lib/ntp/drift -a -L /var/lib/ntp/drift ];then
            return 1
        fi
        chown ntp:ntp /var/lib/ntp/drift
        chmod 755 /var/lib/ntp/drift
    fi
}

####################################################################
#  FUNCTION     : backup_ntp_sys_conf
#  DESCRIPTION  : 备份系统配置文件
#  INPUT        : $1: 源文件
#  OUTPUT       : NA
#  RETURN       : 0: success
####################################################################
backup_ntp_sys_conf()
{
    local ntp_conf_location="/etc/ntp.conf"
    local ntp_keys_location=""
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        ntp_keys_location="/etc/ntp.keys"
    else
        ntp_keys_location="/etc/ntp/ntpkeys"
    fi
    
    
    local backup_dir="${BIGDATA_HOME}/om-agent_?[A-Z0-9]*/configbackup/"
    
    local inodeValue=0
    if [ -f ${2} ];then
        if [ -L ${2} ];then
            return 1
        fi        
        inodeValue=$(ls -l ${2} | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
    fi
    
    echo "${2}"   | grep -E "^${backup_dir}" >/dev/null 2>&1
    if [ $? -eq 0 ] ;then
        if [ "${1}" = "${ntp_conf_location}" ] ; then
            /bin/cp -f "${1}" "${2}"
        return $?
        elif [ "${1}" = "${ntp_keys_location}" ] ; then
            /bin/cp -f "${1}" "${2}"
        return $?
        fi
    fi

    return 1
}
################################################################################
# Function: m_replace_ntp_conf
# Description: replace /etc/ntp.conf with ${nodeagent_home}/ntp.conf.agent
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_replace_ntp_conf()
{
    local ntpFile="${1}"
    verify_path "${ntpFile}" || return $?
    #cp前面加斜杠是为了不使用alias中的cp -i命令，免去确认是否覆盖文件
    \cp ${ntpFile} /etc/ntp.conf
    ret=$?
    if [ $ret -ne 0 ]; then
        return $ret
    fi

    return 0
}

####################################################################
#  FUNCTION     : m_modify_ntp_file
#  DESCRIPTION  : 修改ntp配置文件/etc/sysconfig/ntpd(redhat)/etc/sysconfig/ntp(suse)
#  INPUT        : NA
#  OUTPUT       : NA
#  RETURN       : 0: success,  非0：错误码
####################################################################
function m_modify_ntp_file()
{
    local ntpd_options="$1"
    local ntpd_options_file="$2"
    local log_file="$3"
    local ntpd_file=""
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    local ntpd_options_check=""
    if [ -n "$IS_SUSE_OS" ]; then
        ntpd_file="/etc/sysconfig/ntp"
        ntpd_options_check="NTPD_OPTIONS"
    else
        ntpd_file="/etc/sysconfig/ntpd"
        ntpd_options_check="OPTIONS"
    fi   
    if [ "${ntpd_file}" == "${ntpd_options_file}" -a "${ntpd_options}" == "${ntpd_options_check}" ]; then
        chmod 0644 /etc/ntp.conf
        sed -i "s:${ntpd_options}=.*:${ntpd_options}=\"-x -l /var/log/ntp.log -u ntp\:ntp -f /var/lib/ntp/drift/ntp.drift\":g" "${ntpd_options_file}"
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to config the ${ntpd_options_file} file." "${log_file}"
            return ${INS_MODIFY_FILE_FAILURE}
        fi
    else
        return 1
    fi

    #配置suse系统的ntpd启动时不强制同步时间。默认配置为"no"
    sed -i 's/^NTPD_FORCE_SYNC_ON_STARTUP="yes"/NTPD_FORCE_SYNC_ON_STARTUP="no"/g' "${ntpd_options_file}"   
}

####################################################################
#  FUNCTION     : chowntimestamp
#  DESCRIPTION  : 修改ntp配置文件/etc/sysconfig/ntpd(redhat)/etc/sysconfig/ntp(suse)
#  INPUT        : NA
#  OUTPUT       : NA
#  RETURN       : 0: success,  非0：错误码
####################################################################
function chowntimestamp()
{
    local ntptimestamp_txt=$BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
    local restart_stamp=$BIGDATA_LOG_HOME/timestamp/restart_stamp
    local inodeValue=0
    
    if [ -d $BIGDATA_LOG_HOME/timestamp/ ];then
        if [ -L $BIGDATA_LOG_HOME/timestamp/ ];then
            return 1
        fi
        chown omm:wheel $BIGDATA_LOG_HOME/timestamp/
        
        if [ -f ${ntptimestamp_txt} ];then
            if [ -L ${ntptimestamp_txt} ];then
                return 1
            fi
            inodeValue=$(ls -l ${ntptimestamp_txt} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
        fi
        
        if [ -f ${restart_stamp} ];then
            if [ -L ${restart_stamp} ];then
                return 1
            fi
            
            inodeValue=$(ls -l ${restart_stamp} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/restart_stamp
        fi
    fi
}

################################################################################
# Function: config_ntp
# Description: 配置ntp
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_ntp()
{
    local ntp_server_ip=""

    # 创建ntp配置文件
    local -a ntpIPs=( $(echo "${1}" | sed 's/,/ /g') )
    local -i ntpIPsNum=${#ntpIPs[@]}

    local NTPD_OPTIONS="${2}"
    local NTPD_OPTIONS_FILE="${3}"
    local g_omFloatIP="${4}"
    local if_upgrade_operation="${5}"
    local g_omsServerWorkspace="${6}"
    local deployOnCloud="${7}"
    local g_wsFloatIP="${8}"
    local g_local_businessIp="${9}"
    local fusion_release="/etc/FusionOS-release"
    verify_path "$g_omsServerWorkspace" || return 1
    
    local -i i=0

    local ommServerHome="${g_omsServerWorkspace}/${G_OMM_SERVER_HOME_NAME}"
    local controllerHome="${g_omsServerWorkspace}/om"
    
    local activeFile="${controllerHome}/inst/conf/ntp.conf.active"
    local standbyFile="${controllerHome}/inst/conf/ntp.conf.standby"
    
    touch "${activeFile}"
    if [ $? -ne 0 ] ; then
        log "INFO" "${LINENO}" "Failed to create the ${activeFile} file."
        return ${INS_CREATE_FILE_FAILURE}
    fi
    
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        ntpd_file="/etc/sysconfig/ntp"
        ntpd_options_check="NTPD_OPTIONS"
    else
        ntpd_file="/etc/sysconfig/ntpd"
        ntpd_options_check="OPTIONS"
    fi
    if [ "${NTPD_OPTIONS}" != "${ntpd_options_check}" -o "${NTPD_OPTIONS_FILE}" != "${ntpd_file}" ] ; then
        return 1
    fi 
    if [ -z "$g_omFloatIP" ]; then
        log "ERROR" "${LINENO}" "omFloatIP is empty."
        return 1
    fi
    for ((i=0; i<ntpIPsNum; i++)) ; do
        grep "${ntpIPs[$i]}" "${activeFile}" >/dev/null 2>&1
        if [ $? -eq 0 ]; then
            continue
        fi

        if [ "${ntpIPs[$i]}" == "127.127.1.0" ]; then
            echo "server ${ntpIPs[$i]} prefer burst iburst minpoll 4 maxpoll 4" >> "${activeFile}"
        else
            echo "server ${ntpIPs[$i]} noselect burst iburst minpoll 4 maxpoll 4" >> "${activeFile}"
        fi
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to write \"server ${ntpIPs[$i]}\" to the ${activeFile} file."
            return ${INS_CREATE_FILE_FAILURE}
        fi

        if [ -z "${ntp_server_ip}" -a "${ntpIPs[$i]}" != "127.127.1.0" ]; then
            ntp_server_ip=${ntpIPs[$i]}
        fi
    done

    local local_ip="$(cat ${BIGDATA_HOME}/om-server/om/inst/conf/oms-config.ini | grep "server1_ip1" | awk -F '=' '{print $2}')"

    if [ -z "$local_ip" ] ; then
        log "ERROR" "the local_ip is empty."
        return 1
    fi

    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
    cat <<EOF >> "${activeFile}"
fudge 127.127.1.0 stratum 0
restrict -4 default kod notrap nomodify nopeer noquery
restrict -6 default kod notrap nomodify nopeer noquery
restrict 127.0.0.1
restrict ::1
interface ignore wildcard
interface listen ${g_omFloatIP}
tinker step 0
tinker panic 0
disable monitor
enable kernel
enable auth
keys /etc/ntp.keys
trustedkey 1
requestkey 1
controlkey 1
EOF
    else
    cat <<EOF >> "${activeFile}"
fudge 127.127.1.0 stratum 0
restrict -4 default kod notrap nomodify nopeer noquery
restrict -6 default kod notrap nomodify nopeer noquery
restrict 127.0.0.1
restrict ::1
interface ignore wildcard
interface listen ${g_omFloatIP}
tinker step 0
tinker panic 0
disable monitor
enable kernel
enable auth
keys /etc/ntp/ntpkeys
trustedkey 1
requestkey 1
controlkey 1
EOF
    fi
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to modify ${activeFile} file."
        return ${INS_CREATE_FILE_FAILURE}
    fi
    if [ "${local_ip}"x != "${g_omFloatIP}"x ];then
        echo "interface listen ${local_ip}" >>${activeFile}
    fi
    if [ "${local_ip}"x != "${g_local_businessIp}"x ];then
        echo "interface listen ${g_local_businessIp}" >>${activeFile}
    fi
    if [ "${g_omFloatIP}"x != "${g_wsFloatIP}"x ];then
        echo "interface listen ${g_wsFloatIP}" >>${activeFile}
    fi

    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
    cat <<EOF > "${standbyFile}"
server ${g_omFloatIP} key 1 prefer burst iburst minpoll 4 maxpoll 4
restrict -4 default kod notrap nomodify nopeer noquery
restrict -6 default kod notrap nomodify nopeer noquery
restrict 127.0.0.1
restrict ::1
interface ignore wildcard
interface listen ${local_ip}
tinker step 0
tinker panic 0
disable monitor
enable kernel
enable auth
keys /etc/ntp.keys
trustedkey 1
requestkey 1
controlkey 1
EOF
    else
    cat <<EOF > "${standbyFile}"
server ${g_omFloatIP} key 1 prefer burst iburst minpoll 4 maxpoll 4
restrict -4 default kod notrap nomodify nopeer noquery
restrict -6 default kod notrap nomodify nopeer noquery
restrict 127.0.0.1
restrict ::1
interface ignore wildcard
interface listen ${local_ip}
tinker step 0
tinker panic 0
disable monitor
enable kernel
enable auth
keys /etc/ntp/ntpkeys
trustedkey 1
requestkey 1
controlkey 1
EOF
    fi
    if [ $? -ne 0 ] ; then
        log "ERROR"  "${LINENO}" "Failed to modify ${standbyFile} file."
        return ${INS_MODIFY_FILE_FAILURE}
    fi

    local inodeValue=0
    # 修改文件权限
    if [ -f ${activeFile} ];then
        if [ -L ${activeFile} ];then
            return 1
        fi
        inodeValue=$(ls -l ${activeFile} | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
        chown "${OMM_USER}":"${WHEEL_GROUP}"  "${activeFile}"
        chmod 600 "${activeFile}"
    fi
    
    if [ -f ${standbyFile} ];then
        if [ -L ${standbyFile} ];then
            return 1
        fi        
        inodeValue=$(ls -l ${standbyFile} | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
        chown "${OMM_USER}":"${WHEEL_GROUP}"  "${standbyFile}"
        chmod 600 "${standbyFile}"
    fi

    #修改suse的内核频率，初始化为0。（redhat会自动初始化为0）
    which adjtimex > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        adjtimex -f 0
    fi

    # 配置ntp系统文件
    if [ -f "${fusion_release}" ];then
        sed -i "s:${NTPD_OPTIONS}=.*:${NTPD_OPTIONS}=\"-x -l ${LOG_HOME}/ntp.log -f /var/lib/ntp/drift/ntp.drift\":g" "${NTPD_OPTIONS_FILE}"
    else
        sed -i "s:${NTPD_OPTIONS}=.*:${NTPD_OPTIONS}=\"-x -l ${LOG_HOME}/ntp.log -u ntp\:ntp -f /var/lib/ntp/drift/ntp.drift\":g" "${NTPD_OPTIONS_FILE}"
    fi
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to config the ${NTPD_OPTIONS_FILE} file."
        return ${INS_MODIFY_FILE_FAILURE}
    fi

    #配置suse系统的ntpd启动时不强制同步时间。默认配置为"no"
    sed -i 's/^NTPD_FORCE_SYNC_ON_STARTUP="yes"/NTPD_FORCE_SYNC_ON_STARTUP="no"/g' "${NTPD_OPTIONS_FILE}"

    local targetDir="${ommServerHome}/workspace/conf"
    # 拷贝时加上-p参数，以保持源文件的权限不变
    cp -p "${activeFile}" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    cp -p "${standbyFile}" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    
    #强制同步ntp服务器时间
    if [ ! -z "$ntp_server_ip" -a "${if_upgrade_operation}" -eq 0  -a "${deployOnCloud}" != "true" ]; then
        sync_time $ntp_server_ip
        if [ $? -ne 0 ]; then
            #如果刚好ntpMonitor又把ntpd服务拉起来，睡眠3秒再重试一次。
            sleep 3
            sync_time $ntp_server_ip
            if [ $? -ne 0 ]; then
                log "ERROR" "${LINENO}" "Ntp server [$ntp_server_ip] can not be synchronized. Please check whether ntp server is running and reachable."
                return ${INS_MODIFY_FILE_FAILURE}
            fi
        fi

        #将系统时钟写入硬件时钟
        hwclock --systohc
        if [ $? -ne 0 ]; then
            log "INFO" "${LINENO}" "hwclock --systohc failed."
        fi

        #强制同步时间后生成重启时间戳，防止主备倒换后备OMS没有重启时间戳
        mkdir -p ${BIGDATA_LOG_HOME}/timestamp > /dev/null 2>&1
        if [ -d ${BIGDATA_LOG_HOME}/timestamp -a -L ${BIGDATA_LOG_HOME}/timestamp ];then
            return 1
        fi   
        chown omm:wheel ${BIGDATA_LOG_HOME}/timestamp
        local ntptimestamp_txt=$BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
        local restart_stamp=$BIGDATA_LOG_HOME/timestamp/restart_stamp
        if [ -f ${ntptimestamp_txt} ];then
            if [ -L ${ntptimestamp_txt} ];then
                return 1
            fi
            inodeValue=$(ls -l ${ntptimestamp_txt} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
        fi
        
        if [ -f ${restart_stamp} ];then
            if [ -L ${restart_stamp} ];then
                return 1
            fi
            
            inodeValue=$(ls -l ${restart_stamp} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/restart_stamp
        fi
        chmod 700 ${BIGDATA_LOG_HOME}/timestamp
        su - omm -c "date -d \"\$(LANG=en_US.UTF-8 && who -b | sed 's/system boot//g')\" +%s" > ${BIGDATA_LOG_HOME}/timestamp/restart_stamp

        if [ -d ${BIGDATA_LOG_HOME}/timestamp -a -L ${BIGDATA_LOG_HOME}/timestamp ];then
            return 1
        fi   
        chown omm:wheel ${BIGDATA_LOG_HOME}/timestamp
        local ntptimestamp_txt=$BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
        local restart_stamp=$BIGDATA_LOG_HOME/timestamp/restart_stamp
        if [ -f ${ntptimestamp_txt} ];then
            if [ -L ${ntptimestamp_txt} ];then
                return 1
            fi
            inodeValue=$(ls -l ${ntptimestamp_txt} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/ntptimestamp.txt
        fi
        
        if [ -f ${restart_stamp} ];then
            if [ -L ${restart_stamp} ];then
                return 1
            fi
            
            inodeValue=$(ls -l ${restart_stamp} | awk '{print $2}')
            if [ ${inodeValue} -ge 2 ];then
                return 1
            fi
            chown omm:wheel $BIGDATA_LOG_HOME/timestamp/restart_stamp
        fi
    fi

    #redhat版本没有/var/lib/ntp/drift目录，需要创建这个目录
    if [ ! -d "/var/lib/ntp/drift" ]; then
        if [ -f "/var/lib/ntp/drift" ]; then
            #如果drift是个文件，需要先删除这个文件，否则创建drift目录失败。
            rm -rf /var/lib/ntp/drift
        fi

        mkdir /var/lib/ntp/drift
        if [ -d /var/lib/ntp/drift -a -L /var/lib/ntp/drift ];then
            return 1
        fi
        chown ntp:ntp /var/lib/ntp/drift
        chmod 755 /var/lib/ntp/drift
    fi

    return ${INS_SUCCESS}
}

####################################################################
#  FUNCTION     : uninstall_ntp_sys_conf
#  DESCRIPTION  : 还原ntp配置文件
#  INPUT        : $1: 
#  OUTPUT       : NA
#  RETURN       : 0: success
####################################################################
uninstall_ntp_sys_conf()
{
    local ntp_conf_location="/etc/ntp.conf"
    
    local ntp_keys_location=""
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        ntp_keys_location="/etc/ntp.keys"
    else
        ntp_keys_location="/etc/ntp/ntpkeys"
    fi
    
    local backup_dir="${BIGDATA_HOME}/om-agent/configbackup/"
        
    
    local inodeValue=0
    # 修改文件权限
    if [ -f ${1} ];then
        if [ -L ${1} ];then
            return 1
        fi        
        inodeValue=$(ls -l ${1} | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
    fi
    
    echo "${1}" | grep  "^${backup_dir}" >/dev/null 2>&1
    
    if [ $? -eq 0 ] ;then
        if [ "${2}" = "${ntp_conf_location}" ] ; then
            /bin/cp -f "${1}" "${2}"
        return $?
        elif [ "${2}" = "${ntp_keys_location}" ] ; then
            /bin/cp -f "${1}" "${2}"
        return $?
        fi
    fi

    return 1
}


################################################################################
# Function: m_restart_cron
# Description: restart omm agent
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_restart_cron()
{
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        service cron restart
    else
        service crond restart
    fi

}




################################################################################
# Function: m_add_crontab
# Description: m_add_crontab
# Parameter:
#   input:
#   $1   content of the line
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_add_crontab()
{
    local crontabFile=""
    local ntpChecker=$1
    local mail=$2
    local log_file=$3

    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        crontabFile="/var/spool/cron/tabs/omm"
    else
        crontabFile="/var/spool/cron/omm"
    fi

    if [ -f "${crontabFile}" ]; then
        touch ${crontabFile}
        chmod 400 "${crontabFile}"
    fi

    grep "${ntpChecker}" "${crontabFile}" >> "${log_file}" 2>&1
    if [ $? -ne 0 ] ; then
        echo "* * * * * sh ${ntpChecker} >/dev/null 2>&1" >> "${crontabFile}"
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to add ${ntpChecker} to crontab." "$log_file"
            return 1
        fi
    fi

    #由于安全加固关闭了postfix服务，使系统邮件无法处理，要配置不往root发邮件
    grep "${mail}" "${crontabFile}" >> "${log_file}" 2>&1
    if [ $? -ne 0 ] ; then
        sed -i "1i ${mail}=\"\"" "${crontabFile}"
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to add mail config to crontab." "$log_file"
            return 1
        fi
    fi

   return 0
}

################################################################################
# Function: sntp_sync_time
# Description: 使用sntp命令同步ntp服务器的时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
sntp_sync_time()
{
    local ntp_server_ip=$1
    if [ -z "$ntp_server_ip" ]; then
        log "ERROR" "${LINENO}" "ntp_server_ip is empty."
        return 1
    fi
    
    local log_file="$2"
    if [ -z "${log_file}" ]; then
        log_file="${OMS_LOG_FILE}"
    fi
    
    #sntp协议的时间戳最大支持2036年2月7日6:28:15(UTC)，如果系统时间年份大于等于2036年，就把系统时间改为2035年01月01日(UTC)，确保sntp强制同步成功。
    if [ $(date '+%Y') -ge 2036 ]; then
        log "ERROR" "${LINENO}" "system time is going to change to 20350101(UTC) ."
        date -u -s '20350101' >> "${log_file}" 2>&1
    fi

    sntp -v -P no -r ${ntp_server_ip} >> "${log_file}" 2>&1
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "sntp -P no -r ${ntp_server_ip} failed."
        
        sntp -S ${ntp_server_ip} >> "${log_file}" 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "sntp -S ${ntp_server_ip} failed."
            return 1
        else
            log "DEBUG" "${LINENO}" "sntp -S ${ntp_server_ip} successfully."
            return 0
        fi
    else
        log "DEBUG" "${LINENO}" "sntp -P no -r ${ntp_server_ip} successfully."
        return 0
    fi
}

################################################################################
# Function: ntpdate_sync_time
# Description: 使用ntpdate命令同步ntp服务器的时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
ntpdate_sync_time()
{
    local ntp_server_ip=$1
    if [ -z "$ntp_server_ip" ]; then
        log "ERROR" "${LINENO}" "ntp_server_ip is empty."
        return 1
    fi

    local log_file="$2"
    if [ -z "${log_file}" ]; then
        log_file="${OMS_LOG_FILE}"
    fi

    #等待3秒钟接收ntp服务器的相应并强制同步时间
    ntpdate -t 3 ${ntp_server_ip} >> "${log_file}" 2>&1
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "${LINENO}" "ntpdate ${ntp_server_ip} failed."
        return 1
    fi

    log "DEBUG" "${LINENO}" "ntpdate ${ntp_server_ip} successfully."

    return 0
}

################################################################################
# Function: sync_time
# Description: 同步ntp服务器时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function sync_time()
{
    local ntp_server_ip=$1

    local log_file="$2"
    if [ -z "${log_file}" ]; then
        log_file="${OMS_LOG_FILE}"
    fi
    
    log "DEBUG" "${LINENO}" "sync_time"

    if [ -z "$ntp_server_ip" ]; then
        log "ERROR" "${LINENO}" "ntp_server_ip is empty."
        return 1
    fi

    PING_CMD="ping"
    echo ${ntp_server_ip} | grep -E "([0-f]{0,4}:)+[0-f]"
    if [ $? -eq 0 ]
    then
        PING_CMD="ping6"
    fi

    ${PING_CMD} -c 1 ${ntp_server_ip} >> "${log_file}" 2>&1
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "ping ntp server ${ntp_server_ip} failed."
        return 1
    fi

    #precheck调用该函数时，不停止ntp服务
    echo "$log_file" | grep 'precheck' >> /dev/null 2>&1
    if [ $? -ne 0 ]; then
        log "DEBUG" "${LINENO}" "stop ntpd service."
        service ntpd stop >> "${log_file}" 2>&1
        service ntp stop >> "${log_file}" 2>&1
    fi

    if [ ! -f "/etc/euleros-release" ];then
        which sntp > /dev/null 2>&1
        if [ $? -eq 0 ]; then
            sntp_sync_time ${ntp_server_ip} ${log_file}
            return $?
        fi
    fi

    which ntpdate > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        ntpdate_sync_time ${ntp_server_ip} ${log_file}
        return $?
    fi

    log "ERROR" "${LINENO}" "can't find sntp or ntpdate programe."
    return 1
}

################################################################################
# Function: m_add_tmp_dir_permission
# Description: add tmp directory permission
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_add_tmp_dir_permission()
{
    chmod u+rwx,o+rwx /tmp >> /dev/null 2>&1
}



################################################################################
# Function: m_config_tcp_ip
# Description: conig tcp ip 配置tcp ip
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_config_tcp_ip()
{
    local configFile="/etc/sysctl.conf"
    if [ ! -f "${configFile}" ] ; then
        return 2
    fi

    # 如果有以下的配置项则删除
    sed -i '/net.ipv4.tcp_keepalive_time/d' "${configFile}"
    sed -i '/net.ipv4.tcp_keepalive_probes/d' "${configFile}"
    sed -i '/net.ipv4.tcp_keepalive_intvl/d' "${configFile}"
    sed -i '/net.ipv4.tcp_retries2/d' "${configFile}"

    echo "net.ipv4.tcp_keepalive_time = 30" >> "${configFile}" || return 3
    echo "net.ipv4.tcp_keepalive_probes = 3" >> "${configFile}" || return 4
    echo "net.ipv4.tcp_keepalive_intvl = 5" >> "${configFile}" || return 5
    echo "net.ipv4.tcp_retries2 = 7" >> "${configFile}" || return 6

    sysctl -p

    return 0
}

################################################################################
# Function: m_upgrade_backup_crontab
# Description: C60X到C70升级备份crontab任务
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_upgrade_backup_crontab()
{
    local backupDir="$1"
    verify_path "$backupDir" || return $?
    
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        crontabFile="/var/spool/cron/tabs/omm"
    else
        crontabFile="/var/spool/cron/omm"
    fi
    
    /bin/cp -rpf $crontabFile "${backupDir}" || return $?
}

################################################################################
# Function: m_upgrade_backup_profile
# Description: C60X到C70升级备份sudoProfile.sh文件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_upgrade_backup_profile()
{
    local backupDir="$1"
    verify_path "$backupDir" || return $?
    /bin/cp -rpf /etc/profile.d/sudoProfile.sh "${backupDir}" || return $?
}

################################################################################
# Function: add_user
# Description:
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

add_user()
{
    username=$1
    password=$2
    userid=$3
    bash ${BIGDATA_HOME}/tmp/addUser.sh ${username} ${password} ${userid} > /dev/null 2>&1

    ret=$?
    if [ ${ret} -ne 0 ]; then
       return ${ret}
    fi

    if [ "${INSTALL_USER}" != "root" ]; then
        user_home="/home/${INSTALL_USER}/.bashrc"
        grep INSTALL_SUDO_PATH "${user_home}" > /dev/null 2>&1
        if [ $? -eq 0 ]; then
        sed -i '/export INSTALL_SUDO_PATH.*/d' "${user_home}"
    fi
    get_cur_path
    echo "export INSTALL_SUDO_PATH=${g_curPath}/${g_scriptName}" >> "${user_home}"
    if [ $? -ne 0 ]; then
        return 1
    fi
    grep INSTALL_USER "${user_home}" > /dev/null 2>&1
        if [ $? -eq 0 ]; then
        sed -i '/export INSTALL_USER.*/d' "${user_home}"
        fi
        echo "export INSTALL_USER=${INSTALL_USER}" >> "${user_home}"
        if [ $? -ne 0 ]; then
        return 1
        fi
      source ${user_home}

      chown ${INSTALL_USER}: ${user_home}
    fi
return 0
}

################################################################################
# Function: nodeagent_install_chmod
# Description: chmod 750 ${BIGDATA_HOME}
# Parameter:
#   input:
#         ${1}:"${BIGDATA_HOME}"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_install_chmod()
{
    if [ "${1}" = "${BIGDATA_HOME}" ] ; then
        /bin/chmod 750 "${1}"
        return $?
    fi
    return 1
}

################################################################################
# Function: nodeagent_dir_chown_omm
# Description:
#              chown  omm: ${BIGDATA_HOME} -R
#
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_dir_chown_omm()
{
    /bin/chown "${OMM_USER}:${FI_COMMON_GROUP}" "${BIGDATA_HOME}"
    return 0
}


################################################################################
# Function: nodeagent_tmp_mkdir
# Description: mkdir -p /tmp/scriptlog/
# Parameter:
#   input:
#         ${1}:"/tmp/scriptlog/"
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_tmp_mkdir()
{
    if [ -d  "${1}" ] ; then
        return 0
    fi
    
    /bin/mkdir -p "${1}"
    return $?
}


################################################################################
# Function: nodeagent_tmpdir_chown_omm
# Description:
#              chown  omm: ${BIGDATA_HOME} -R
#               /opt/huawei/Bigdata/tmp
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_tmpdir_chown_omm()
{
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${BIGDATA_HOME}/tmp" -R
    return 0
}

################################################################################
# Function: nodeagent_addTrustHost_chmod
# Description:
#              chown  omm: ${BIGDATA_HOME} -R
#               /opt/huawei/Bigdata/tmp
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_addTrustHost_chmod()
{
    /bin/chmod +x ${BIGDATA_HOME}/tmp/addTrustHost.sh -R
    return 0
}

################################################################################
# Function: nodeagent_scp_chown_chmod
# Description:
#              chown  omm: ${BIGDATA_HOME} -R
#               /opt/huawei/Bigdata/tmp
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_scp_chown_chmod()
{
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${BIGDATA_HOME}/tmp/scp.sh" -R
    /bin/chmod 700 ${BIGDATA_HOME}/tmp/scp.sh -R
    return 0
}

################################################################################
# Function: nodeagent_download_chown_chmod
# Description:
#              chown  omm: ${BIGDATA_HOME} -R
#               /opt/huawei/Bigdata/tmp
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_download_chown_chmod()
{
    /bin/chown "${OMM_USER}:${WHEEL_GROUP}" "${BIGDATA_HOME}/tmp/download.sh" -R
    /bin/chmod 700 ${BIGDATA_HOME}/tmp/download.sh -R
    return 0
}



################################################################################
# Function: addPathPermission
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

addPathPermission()
{
    currentDir="$1"
    mkdir -p ${currentDir}
    chmod u+rwx,g+rx,o+rx "${currentDir}"
    while [ "$(dirname "${currentDir}")" != "/" ] ; do
        chmod u+rx,g+x,o+rx "$(dirname "${currentDir}")"
        currentDir="$(dirname "${currentDir}")"
    done
    return 0
}


################################################################################
# Function: addTrustHost
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

addTrustHost()
{

if [ ! -f "${OMM_USER_HOME}/.ssh/id_rsa" ] || [ ! -f "${OMM_USER_HOME}/.ssh/id_rsa.pub" ]; then
    #openssh 7.8及以上版本默认格式不是pem需要指定
    local verison="$(rpm -qi openssh| grep "Version"|awk -F ":" '{print $2}' | awk -F "p" '{print $1}' | tr -d  [:space:])"
    local baseVersion="$(echo ${verison}| awk -F "." '{print $1}')"
    local extendVersion="$(echo ${verison}| awk -F "." '{print $2}')"
    if [ ${baseVersion} -ge 7 -a ${extendVersion} -ge 8 ];then
        ssh-keygen -t rsa -m pem -P "" > /dev/null <<END

END
    else
        ssh-keygen -t rsa -P "" > /dev/null <<END

END
    fi
fi
cat ${OMM_USER_HOME}/.ssh/id_rsa.pub >> "${OMM_USER_HOME}/.ssh/authorized_keys"
echo "$1" >> "${OMM_USER_HOME}/.ssh/authorized_keys"
}


################################################################################
# Function: scp
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

scp()
{
/usr/bin/expect <<EOD
spawn scp $@
expect "*yes/no*"
send "yes\n"
expect eof
EOD
}


################################################################################
# Function: download
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

download()
{
for (( i=0; i<30; i=i+1 )) ; do
    scp "$@"
    if [ $? -eq 0 ] ; then
        exit 0
    else
        sleep 1
    fi
done
exit 1
}


################################################################################
# Function: checkController
# Description:
# Parameter:
#   input: controller ip
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

checkController()
{
    controllerIP="$1"
    bash ${BIGDATA_HOME}/tmp/checkController.sh ${controllerIP}
    return $?
}

################################################################################
# Function:  nodeagent_initdir_chmod
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_initdir_chmod()
{   
    umask 0077
    local nodeagent_home="${1}"
    verify_path "$nodeagent_home" || return 1
    
    /bin/rm -rf  ${nodeagent_home}

    mkdir -p  "${nodeagent_home}/package"
    
    local agent_workspace="$(dirname ${nodeagent_home})"
    chown ${OMM_USER}:${WHEEL_GROUP} ${agent_workspace} -R
    chmod 700 ${agent_workspace} -R

}

################################################################################
# Function:  nodeagent_setUpgradeModel_exe
# Description:
# Parameter:
#   input:
#
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
nodeagent_setUpgradeModel_exe()
{
    "${BIGDATA_HOME}/om-agent/nodeagent/bin/setUpgradeModel.sh" "${1}" "${2}"
}

##############################################################
## @Usage high_os_version_check
## @Return 0 : old version 1: high version
## @Description 检查是否是redhat7和suse12以上的OS版本
##############################################################
function high_os_version_check()
{
    local system_version=0
    local current_cpu_mount_dir
    #只支持bclinux7.6或更高的版本
    if [ -f "/etc/bclinux-release" ]; then
        return 1
    fi
    if [ -f "/etc/UnionTech-release" ]; then
        return 1
    fi
    if [ -f /etc/neokylin-release ];then
        local neokylin_name=$(head -1 /etc/neokylin-release|grep -i "NeoKylin")
        if [ ! -z "$neokylin_name" ]; then
            local neokylin_version="$(cat /etc/neokylin-release | awk '{print $6}' | cut -d "V" -f 2 | tr 'A-Z' 'a-z')"
            if [ -z "${neokylin_version}" ];then
                neokylin_version="$(cat /etc/neokylin-release | awk '{print $4}' | cut -d "V" -f 2 | tr 'A-Z' 'a-z')"
            fi
            neokylin_version="$(echo ${neokylin_version/update/'.'})"
            if [ $(echo "${neokylin_version} >= 7" | bc) -eq 1 ]; then
                return 1
            elif [ $(echo "${neokylin_version} >= 5" | bc) -eq 1  -a $(echo "${neokylin_version} < 6" | bc) -eq 1 ]; then
               return 1
            fi
        fi
    elif [ -f /etc/os-release ]; then
        local suse_name=$(head -1 /etc/os-release|grep -iE "SLES|SLE_HPC")
        local redhat_name=$(head -1 /etc/os-release|grep -i "Red Hat Enterprise Linux Server")
        local oracle_name=$(head -1 /etc/os-release|grep -i "Oracle Linux Server")
        local centos_name=$(head -1 /etc/os-release|grep -i "CentOS Linux")
        local euler_name=$(head -1 /etc/os-release|grep -i "EulerOS")
        local open_euler_name=$(head -1 /etc/os-release|grep -i "openEuler")
        local kylin_name=$(head -1 /etc/os-release|grep -i "Kylin")
        local fusion_name=$(head -1 /etc/os-release|grep -i "fusionos")
        local uos=$(head -1 /etc/os-release|grep -i "UnionTech OS")
        local el_name=$(head -1 /etc/os-release|grep -i "LinxOS")
        if [ ! -z "$suse_name" ]; then
            local suse_version=$(cat /etc/os-release |grep VERSION_ID|cut -d "=" -f 2 | sed 's/\"//g')
            if [ $(echo "${suse_version} >= 12" | bc) -eq 1 ]; then
                return 1
            fi
        elif [ ! -z "$redhat_name" ] || [ ! -z "$centos_name" ] || [ ! -z "$oracle_name" ] ; then
            local redhat_version=$(cat /etc/os-release |grep VERSION_ID|cut -d "=" -f 2 | sed 's/\"//g')
            if [ $(echo "${redhat_version} >= 7" | bc) -eq 1 ]; then
                return 1
            fi
        elif [ ! -z "$euler_name" ]; then
            local euler_name_version=$(cat /etc/os-release |grep VERSION_ID|cut -d "=" -f 2 | sed 's/\"//g' | cut -b 1)
            if [ $(echo "${euler_name_version} >= 2" | bc) -eq 1 ]; then
                return 1
            fi
        elif [ ! -z "${open_euler_name}" ];then
            return 1
        elif [ ! -z "${kylin_name}" ]; then
            return 1
        elif [ ! -z "${fusion_name}" ]; then
            return 1
        elif [ ! -z "${uos}" ];then
            return 1
        elif [ ! -z "${el_name}" ];then
            return 1
        fi
    else
        if [ -f /etc/SuSE-release ]; then
            system_version=$(cat /etc/SuSE-release | grep VERSION | cut -d " " -f 3)
            if [ "$system_version" -ge 12 ]; then
                return 1
            fi
        elif [ -f /etc/redhat-release ]; then
            system_version=$(cat /etc/redhat-release | cut -d " " -f 7)
            if [ -z "$system_version" ] && [ -f /etc/centos-release ]; then
                # centos system
                system_version=$(cat /etc/centos-release | cut -d " " -f 3)
            fi
            
            if [ $(echo "${system_version} >= 7" | bc) -eq 1 ]; then
                return 1
            fi
        else
            return 0
        fi
    fi
    return 0
}

###########################################################
#    Description:  init res cgroup env
#    Parameter:   no
#    Return:
##########################################################
function res_env_init()
{
    [ ! -z "$RES_ENV_INIT_FLAG" ] && return
    RES_ENV_INIT_FLAG="OK"

    high_os_version_check
    local os_version=$?
    if [ -z "$RES_CGROUP_ROOT_PATH" ];then 
        if [ "$os_version" == 0 ]; then
            RES_CGROUP_ROOT_PATH="/dev/cgroup"
        else
            RES_CGROUP_ROOT_PATH="/sys/fs/cgroup"
        fi
    fi
    
    if [ "$os_version" == 1 ]; then
        RES_CGROUP_CPU_MOUNT_PATH="${RES_CGROUP_ROOT_PATH}/cpu,cpuacct"
        NEW_OPERATING_SYSTEM_FLAG=1
    else
        RES_CGROUP_CPU_MOUNT_PATH="${RES_CGROUP_ROOT_PATH}/cpu"
        NEW_OPERATING_SYSTEM_FLAG=0
    fi
    RES_CGROUP_BLKIO_MOUNT_PATH="${RES_CGROUP_ROOT_PATH}/blkio"
    RES_CGROUP_CPUSET_MOUNT_PATH="${RES_CGROUP_ROOT_PATH}/cpuset"
    RES_CGROUP_CPUSET_CPUS="cpuset.cpus"
    RES_CGROUP_CPUSET_MEMS="cpuset.mems"
    RES_CGROUP_CPU_SHARES="cpu.shares"
    RES_CGROUP_BLKIO_WEIGHT="blkio.weight"
    RES_CGROUP_CPU_CFS_QUOTA_US="cpu.cfs_quota_us"
    RES_CGROUP_CPU_CFS_PERIOD_US="cpu.cfs_period_us"
    RES_CGROUP_TASKS="tasks"
    RES_RET_CODE_CGROUP_EXIST=32
}

###########################################################
#    Description:  mount cgroup
#    Parameter:   no
#    Return:
##########################################################
function res_mount_cgroup()
{
    res_env_init
    echo "start mount cgroup."
    if [ $NEW_OPERATING_SYSTEM_FLAG == 1 ]; then
        # set syscontrol
        res_set_syscontrol
        log "INFO" "${LINENO}" "New operating system version, auto mount cgroup to /sys/fs/cgroup." "${logFile}"
        return 0
    fi
    
    # create cgroup dir
    if [ ! -d "${RES_CGROUP_CPU_MOUNT_PATH}" ];then
        /bin/mkdir -p "${RES_CGROUP_CPU_MOUNT_PATH}"
    fi
    /bin/mount -t cgroup -o cpu cpu "${RES_CGROUP_CPU_MOUNT_PATH}"
    if [ ! -d "${RES_CGROUP_BLKIO_MOUNT_PATH}" ];then
        /bin/mkdir -p "${RES_CGROUP_BLKIO_MOUNT_PATH}"
    fi
    /bin/mount -t cgroup -o blkio blkio "${RES_CGROUP_BLKIO_MOUNT_PATH}"
    # change dir own and permissions
    /bin/chown -R omm:wheel "${RES_CGROUP_ROOT_PATH}"
    if [ $? -ne 0 ];then
        echo "change ${RES_CGROUP_ROOT_PATH} owner failed."
        return 1
    fi
    /bin/chmod -R 750 "${RES_CGROUP_ROOT_PATH}"
    if [ $? -ne 0 ];then
        echo "change ${RES_CGROUP_MOUNT_PATH} permission failed."
        return 1
    fi
    # check if cgroup file exist
    if [ ! -f "${RES_CGROUP_CPU_MOUNT_PATH}/${RES_CGROUP_CPU_SHARES}" ]; then
        echo "after mount cgroup ${RES_CGROUP_CPU_MOUNT_PATH} is not exist."
        return 1
    fi
    if [ ! -f "${RES_CGROUP_BLKIO_MOUNT_PATH}/${RES_CGROUP_BLKIO_WEIGHT}" ]; then
        echo "after mount cgroup ${RES_CGROUP_BLKIO_MOUNT_PATH} is not exist."
        return 1
    fi
    # set cgroup
    res_set_cgroup
    if [ $? -ne 0 ];then
        echo "set cgroup config failed."
        return 1
    fi
    echo "mount cgroup successed."
    # set syscontrol
    res_set_syscontrol
    return 0
}

###########################################################
#    Description:  remove cgroup dir
#    Parameter:   cgroup dir
#    Return:
##########################################################
function res_rm_cgroup_dir()
{
    res_env_init
    local cgroup_dir="${1}"
    echo "$cgroup_dir" |grep -e "^${RES_CGROUP_ROOT_PATH}*"
    if [ $? != 0 ];then
        echo "The dirname is not correct!"
        return 1
    fi
    
    if [ -d "${cgroup_dir}" ];then
        find "${cgroup_dir}" -type d | sort -r | grep -v "${cgroup_dir}"\$ | xargs -i cat {}/cgroup.procs | xargs -i kill {}
        sleep 3
        find "${cgroup_dir}" -type d | sort -r | grep -v "${cgroup_dir}"\$ | xargs -i cat {}/cgroup.procs | xargs -i kill -9 {}

        echo 3 > /proc/sys/vm/drop_caches

        nohup nice find "${cgroup_dir}" -type d | sort -r | xargs -i rmdir {} &

        local parentPid=$$
        local pid=$!

        local num=0
        local retVal=0
        ps -ef | grep ${parentPid} | grep ${pid} | grep -v grep > /dev/null 2>&1
        retVal=$?
        while [ ${retVal} -eq 0 ] ; do
                sleep 1
                num=$(( ${num}+1 ))
                if [ ${num} -gt 10 ] ;then
                   kill -9 ${pid}
                   break
                fi
                ps -ef | grep ${parentPid} | grep ${pid} | grep -v grep  > /dev/null 2>&1
                retVal=$?
        done

        fuser -k "${cgroup_dir}"
        if [ $NEW_OPERATING_SYSTEM_FLAG == 0 ]; then
            /bin/umount "${cgroup_dir}"
        fi
    fi
}

###########################################################
#    Description:  set cgroup config
#    Parameter:   no
#    Return:
##########################################################
function res_set_cgroup()
{
    local cpunum=$(($(cat /proc/cpuinfo | grep processor | wc -l)-1))
    local mem_num=$(cat /sys/devices/system/node/online)
    return 0
}
###########################################################
#    Description:  set sys control
#    Parameter:   no
#    Return:
##########################################################
function res_set_syscontrol()
{
    if [ -f /proc/sys/kernel/sched_shares_ratelimit ]; then
          sed -i '/'kernel.sched_shares_ratelimit'/d' /etc/sysctl.conf
          sed -i '$akernel.sched_shares_ratelimit=100000000' /etc/sysctl.conf
    fi
    if [ -f /proc/sys/kernel/sched_shares_window ]; then
          sed -i '/'kernel.sched_shares_window'/d' /etc/sysctl.conf
          sed -i '$akernel.sched_shares_window=100000000' /etc/sysctl.conf
    fi
    if [ -f /proc/sys/vm/panic_on_oom ]; then
          sed -i '/'vm.panic_on_oom'/d' /etc/sysctl.conf
          sed -i '$avm.panic_on_oom=0'  /etc/sysctl.conf
    fi
    /sbin/sysctl -p
}

################################################################################
# Function: m_config_sudoers
# Description: config sudoers
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_config_sudoers()
{
    
    local agentSudoPath="${BIGDATA_SUDO_HOME}/sudo/runtime/sudoExecute.sh"
    cmdArray=("${agentSudoPath}")
    for cmd in "${cmdArray[@]}" ; do
        
        if [ -z "${cmd}" ] ; then
            return 1
        fi


        # 若/etc/sudoers里没有配置该命令，则配置
        grep "^${OMM_USER} ALL=(root) NOPASSWD: ${cmd}[[:space:]]*$" /etc/sudoers
        if [ $? -ne 0 ] ; then
            echo "${OMM_USER} ALL=(root) NOPASSWD: ${cmd}" >> /etc/sudoers
        fi
        
        # 若/etc/sudoers里没有配置该命令，则配置
        grep "^${BACKUP_USER} ALL=(root) NOPASSWD: ${cmd}[[:space:]]*$" /etc/sudoers 
        if [ $? -ne 0 ] ; then
            echo "${BACKUP_USER} ALL=(root) NOPASSWD: ${cmd}" >> /etc/sudoers
        fi
        
        if [ $? -ne 0 ] ; then
            echo "Failed to config the ${cmd} command to /etc/sudoers." 
            return 1
        fi
    done

    return 0
}

################################################################################
# Function: chmod_database_sql_dir
# Description: 修改database目录
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chmod_database_sql_dir()
{
    local controller_home="${1}"
    local sqlDir="${controller_home}/share/om/database/"
    chmod 600 ${sqlDir}/* -R
}

################################################################################
# Function: chown_tmp
# Description: 修改${BIGDATA_HOME}/tmp的权限为
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chown_tmp()
{
    local bigdata_tmp="${1}"
    if [ -z "${bigdata_tmp}" ] ; then
        bigdata_tmp="${BIGDATA_HOME}/tmp"
    fi
    # 程序安装的临时tmp目录预期属主权限为1770 omm:ficommon
    # 此操作在安装集群发现节点时会在全部节点执行，
    # oms节点已经存在ficommon组，其他节点不存在ficommon组，只有wheel组
    # 故不存在ficommon组的节点先调整tmp属主为omm:wheel,在安装agent后会修改为omm:ficommon
    cat /etc/group | cut -d ":" -f 1 | grep -w "${FI_COMMON_GROUP}"  > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        chown ${OMM_USER}:${FI_COMMON_GROUP} "${bigdata_tmp}"
    else
        chown ${OMM_USER}:${WHEEL_GROUP} "${bigdata_tmp}"
    fi

    chmod 1770 "${bigdata_tmp}"
}
################################################################################
# Function: delete_tmp_txt
# Description: 删除bigdata_home下的tmp目录下的testAccess.txt文件
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function delete_tmp_txt()
{
    local bigdata_tmp="${1}"
    if [ -z "${bigdata_tmp}" ] ; then
        bigdata_tmp="${BIGDATA_HOME}/tmp"
    fi
    log "INFO" "${LINENO}" "Begin to delete testAccess.txt"
    rm -rf ${bigdata_tmp}/testAccess.txt
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Failed to delete testAccess.txt"
    fi
    log "INFO" "${LINENO}" "End to delete testAccess.txt" 
}
################################################################################
# Function: backup_postgresql_conf
# Description: 备份postgresql的配置文件
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
backup_postgresql_conf()
{
   local oms_server_workspace_name="$1"
   if [ -z "$oms_server_workspace_name" ]; then
        log "ERROR" "${LINENO}"  "Illegal parameter The oms server workspace can not be empty." "${OMS_LOG_FILE}"
        return 1
   fi
   
   local controller_home="${BIGDATA_HOME}/${oms_server_workspace_name}/om"
   /bin/cp "${DB_HOME}/postgresql.conf" "${controller_home}/etc/om/" > /dev/null 2>&1
   if [ $? -ne 0 ]; then
      log "ERROR" "${LINENO}"  "Failed to backup postgresql.conf to ${controller_home}/etc/om/." "${OMS_LOG_FILE}"
      return 1
   fi
   
   chown ${OMM_USER}:${WHEEL_GROUP}  ${controller_home}/etc/om/postgresql.conf > /dev/null 2>&1
   dbConfigBackupDir="${BIGDATA_ROOT_HOME}/Bigdata_gaussdb/workspace0/gaussdb/conf_bak"
   if [ ! -d "${dbConfigBackupDir}" ]; then
      mkdir -p "${dbConfigBackupDir}"
   fi
   chown ${DB_CREATER}:${WHEEL_GROUP} ${dbConfigBackupDir}
   /bin/cp -a ${DB_HOME}/postgresql.conf ${dbConfigBackupDir}/
   if [ $? -ne 0 ]; then
      log "ERROR" "${LINENO}"  "Failed to backup postgresql.conf to ${dbConfigBackupDir}." "${OMS_LOG_FILE}"
      return 1
   fi
   
   /bin/cp -a ${DB_HOME}/pg_hba.conf ${dbConfigBackupDir}/
   if [ $? -ne 0 ]; then
      log "WARN" "${LINENO}"  "Failed to backup pg_hba.conf to ${dbConfigBackupDir}." "${OMS_LOG_FILE}"
   fi
   return 0
}

#此后为新加方法

###################################################
#
# clear timer to feed watchdog
#
###################################################
function clear_timer_feed_watchdog()
{
    log "INFO" "${LINENO}" "start to clear_timer_feed_watchdog." "${OMS_UNINSTALL_LOG_FILE}"
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        if [ ! -f "/var/spool/cron/tabs/root" ]; then
               return 0
        fi

        sed -i '/wdt_running/d' "/var/spool/cron/tabs/root"
        if [ $? -ne 0 ];then
            log "ERROR" "${LINENO}" "clear_timer_feed_watchdog sed -i /wdt_running/d /var/spool/cron/tabs/root failed!" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi

        service cron restart
        if [ $? -ne 0 ];then
            log "ERROR" "${LINENO}" "clear_timer_feed_watchdog service cron restart failed!" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
    else
        if [ ! -f "/var/spool/cron/root" ]; then
               return 0
        fi

        sed -i '/wdt_running/d' "/var/spool/cron/root"
        if [ $? -ne 0 ];then
            log "ERROR" "${LINENO}" "clear_timer_feed_watchdog sed -i /wdt_running/d /var/spool/cron/root failed!" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi

        service crond restart
        if [ $? -ne 0 ];then
            log "ERROR" "${LINENO}" "clear_timer_feed_watchdog service crond restart failed!" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
    fi

    return 0
}

################################################################################
# Function: uninstall_kerberos
# Description: 卸载Kerberos
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
uninstall_kerberos()
{
    log "INFO" "${LINENO}" "start to uninstall kerberos." "${OMS_UNINSTALL_LOG_FILE}"
    ps -ef | grep krb5kdc  | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
    ps -ef | grep kadmind  | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1

    local omsRunPath="${BIGDATA_HOME}/${G_OM_SERVER_HOME_NAME}"

    #判断此节点是否为oms节点
    if [ ! -L "${omsRunPath}" ]; then
        clear_timer_feed_watchdog
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to clear_timer_feed_watchdog." "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
        wdt_stop
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "Failed to stop watchdog(wdt_stop)." "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
    fi
    return 0
}

###################################################
#
# 停止看门狗
#
###################################################
function wdt_stop()
{
    #停止看门狗
    log "INFO" "${LINENO}" "start to stop watchdog." "${OMS_UNINSTALL_LOG_FILE}"
    ipmitool bmc watchdog off > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "ipmitool bmc watchdog off failed" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi

    log "INFO" "${LINENO}" "Watchdog is stop." "${OMS_UNINSTALL_LOG_FILE}"

    return 0
}

################################################################################
# Function: uninstall_datanode
# Description: 卸载DataNode
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
uninstall_datanode()
{
    log "INFO" "${LINENO}" "start to uninstall datanode." "${OMS_UNINSTALL_LOG_FILE}"
    ps -ef | grep proc_datanode  | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        log "WARN" "${LINENO}" "Failed to uninstall datanode." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    return 0
}
################################################################################
# Function: delete_crontabInfo
# Description: 删除掉crontab中的垃圾信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################

delete_crontabInfo()
{
    log "INFO" "${LINENO}" "start to delete crontab garbage information." "${OMS_UNINSTALL_LOG_FILE}"
    # 删除掉crontab中的垃圾信息
    if [ "${1}" = "${REDHAT_CRONTAB_FILE}" -o "${1}" = "${SUSE_CRONTAB_FILE}" ] ; then
        if [ "${2}" = "crond" -o "${2}" = "cron" ] ; then
            CRONTAB_FILE=${1}
            CRON_SERVICE_NAME=${2}
            sed -i '/MAILTO/d' "${CRONTAB_FILE}"
            service "${CRON_SERVICE_NAME}" restart
            return 0
        else
            log "ERROR" "${LINENO}" "failed to delete crontab garbage information,the service name is incorrect" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
    else
        log "ERROR" "${LINENO}" "failed to delete crontab garbage information,the crontab file name is incorrect" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
}
################################################################################
# Function: remove_crontab
# Description:remove crontab
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
remove_crontab()
{
    log "INFO" "${LINENO}" "start to remove crontab." "${OMS_UNINSTALL_LOG_FILE}"
    if [ "${1}" = "${REDHAT_CRONTAB_FILE}" -o "${1}" = "${SUSE_CRONTAB_FILE}" ] ; then
        CRONTAB_FILE=${1}
        sed -i '/bkauditlogs.sh/d' "${CRONTAB_FILE}"
        sed -i '/MAILTO/d' "${CRONTAB_FILE}"
        sed -i '/ntpChecker/d' "${CRONTAB_FILE}"
        sed -i '/start_ha_monitor.sh/d' "${CRONTAB_FILE}"
        return 0
    else
        log "ERROR" "${LINENO}" "failed to remove crontab,the crontab file name is incorrect" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
}
################################################################################
# Function: restart_crontab_service
# Description:restart crontab service
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restart_crontab_service()
{
    log "INFO" "${LINENO}" "start to restart crontab service." "${OMS_UNINSTALL_LOG_FILE}"
    if [ "${1}" = "crond" -o "${1}" = "cron" ] ; then
        CRON_SERVICE_NAME=${1}
        log "INFO" "${LINENO}" "start to restart crontab service" "${OMS_UNINSTALL_LOG_FILE}"
        service "${CRON_SERVICE_NAME}" restart > /dev/null
        if [ $? -ne 0 ] ; then
            log "ERROR" "${LINENO}" "failed to restart crontab service" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        fi
        return 0
    else
        log "ERROR" "${LINENO}" "The service name is incorrect" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    return 0
}

###########################################################
#    Description:  unmount cgroup
#    Parameter:   no
#    Return:
##########################################################
function res_unmount_cgroup()
{
    res_env_init
    log "INFO" "${LINENO}" "start to unmount cgroup." "${OMS_UNINSTALL_LOG_FILE}"
    res_rm_cgroup_dir "${RES_CGROUP_CPU_MOUNT_PATH}"
    res_rm_cgroup_dir "${RES_CGROUP_BLKIO_MOUNT_PATH}"

    if [ -f /proc/sys/kernel/sched_shares_ratelimit ]; then
              sed -i '/'kernel.sched_shares_ratelimit'/d' /etc/sysctl.conf
              sed -i '$akernel.sched_shares_ratelimit=1000000' /etc/sysctl.conf
    fi
    if [ -f /proc/sys/kernel/sched_shares_window ]; then
              sed -i '/'kernel.sched_shares_window'/d' /etc/sysctl.conf
              sed -i '$akernel.sched_shares_window=1000000' /etc/sysctl.conf
    fi

    if [ -f /proc/sys/vm/panic_on_oom ]; then
              sed -i '/'vm.panic_on_oom'/d' /etc/sysctl.conf
              sed -i '$avm.panic_on_oom=2' /etc/sysctl.conf
    fi

    /sbin/sysctl -p
    return 0
}

################################################################################
# Function: remove_DNS_config
# Description: 清除DNS配置
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
remove_DNS_config()
{
    # 清除DNS配置
    log "INFO" "${LINENO}" "start to remove DNS config." "${OMS_UNINSTALL_LOG_FILE}"
    if [ "${1}" = "${OMS_UNINSTALL_LOG_FILE}" ] ; then
        local g_logFile=${1}
        sed -i "/^order /c\order hosts" /etc/host.conf >> "${g_logFile}" 2>&1
        echo > /etc/resolv.conf
        return 0
    else
        log "ERROR" "${LINENO}" "Failed to remove DNS config.the log path is incorrect." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi

}

################################################################################
# Function: remove_tmp
# Description: 清除/tmp目录下的临时文件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
remove_tmp()
{
    # 清除/tmp目录下的临时文件
    log "INFO" "${LINENO}" "start to remove the temporary files in the tmp directory." "${OMS_UNINSTALL_LOG_FILE}"
    if [ "${1}" = "${OMS_UNINSTALL_LOG_FILE}" ] ; then
        log_file=$1
        find /tmp -type f -user "${OMM_USER}" -group "${WHEEL_GROUP}" -print0 2>> "${log_file}" \
            | xargs -0 rm -rf >> "${log_file}" 2>&1
        find /tmp -type d -user "${OMM_USER}" -group "${WHEEL_GROUP}" -print0 2>> "${log_file}" \
            | xargs -0 rm -rf >> "${log_file}" 2>&1
    else
        log "ERROR" "${LINENO}" "Failed to remove the temporary files in the tmp directory.the log path is incorrect." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi

}

################################################################################
# Function: clear_sudoers
# Description: 清除/etc/soduers配置
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clear_sudoers()
{
    local g_logFile="${1}"
    log "INFO" "${LINENO}" "Start to clear etc/sudoers." "${g_logFile}"
    
    grep "^Defaults:omm !syslog" /etc/sudoers  > /dev/null 2>&1
    if [ $? -eq 0 ] ; then
        tmp=$(echo "^Defaults:omm !syslog" | sed -e 's/\//\\\//g')
       sed -i "/$tmp/d" /etc/sudoers
        if [ $? -ne 0 ] ; then
            echo  "Failed to clear /etc/sudoers."
            return 1
        fi
    fi
    
    while read line
    do
        echo $line | grep -e "omm ALL=(root) NOPASSWD" -e "backup ALL=(root) NOPASSWD" | grep -v installSudoExecute >/dev/null 2>&1
    if [ $? -eq 0 ]; then
        tmp=$(echo $line | sed -e 's/\//\\\//g')
        sed -i "/$tmp/d" /etc/sudoers
        if [ $? -ne 0 ] ; then
            echo  "Failed to clear /etc/sudoers."
            return 1
        fi
    fi
    done < /etc/sudoers

    log "INFO" "${LINENO}" "Succeed to clear /etc/sudoers." "${g_logFile}"
    return ${INS_SUCCESS}
}
################################################################################
# Function: unmount_Loader
# Description: 卸载Loader挂载的目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
unmount_Loader()
{
    log "INFO" "${LINENO}" "start to unmount Loader." "${OMS_UNINSTALL_LOG_FILE}"
    mount -l -t nfs | awk '{print $3}' | grep "^${nfs_mount_home}" | awk '{if($0 != ""){ system ("umount -l "$0"; rm -rf "$0) }}';
    if [ $? -ne 0 ] ; then
        log "INFO" "${LINENO}" "failed to unmount Loader." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    return 0
}

################################################################################
# Function: kill_ntp_process
# Description: 杀掉ntp监控进程
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
kill_ntp_process()
{
    log "INFO" "${LINENO}" "start to kill ntp process."
    local g_logFile=${OMS_UNINSTALL_LOG_FILE}
    kill -9 $(ps -ef | grep 'ntpMonitor' | grep -v grep | awk '{print $2}') >> "${g_logFile}" 2>&1
}

################################################################################
# Function: remove_ntp_keyFile
# Description: 清除ntpKeyFile
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
remove_ntp_keyFile()
{
    log "INFO" "${LINENO}" "start to remove ntp key file." "${OMS_UNINSTALL_LOG_FILE}"
    rm -rf /etc/ntp/ntpkeys
}

################################################################################
# Function: delete_common_group
# Description: 删除ficommon用户组
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_common_group()
{
    local g_logFile="${1}"
    log "INFO" "${LINENO}" "start to delete ${FI_COMMON_GROUP} group." "${g_logFile}"
    #如果ficommon用户组存在，则删除用户组
    cat /etc/group | cut -d ":" -f 1 | grep -w "${FI_COMMON_GROUP}" >> "${g_logFile}" 2>&1
    if [ $? -eq 0 ] ; then
        # 删除ficommon用户组
        groupdel  "${FI_COMMON_GROUP}" > /dev/null
        if [ $? -ne 0 ] ; then
            log "WARN" "${LINENO}" "Failed to delete ${FI_COMMON_GROUP} group." "${g_logFile}"
            return 1
        fi
    fi
    log "INFO" "${LINENO}" "Succeed to delete ${FI_COMMON_GROUP} group." "${g_logFile}"
    return ${INS_SUCCESS}
}

################################################################################
# Function: delete_omm_user
# Description: 删除omm用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_omm_user()
{
    local g_logFile="${1}"
    log "INFO" "${LINENO}" "start to delete omm user." "${g_logFile}"
    #如果omm用户存在，则删除用户
    id -u "${OMM_USER}" > /dev/null 2>&1
    if [ $? -eq 0 ] ; then
        # 删除omm用户
        local userID=$(id ${OMM_USER} -u)
        userdel -rf ${OMM_USER} > /dev/null
        if [ $? -ne 0 ] ; then
            log "WARN" "${LINENO}" "Failed to delete ${OMM_USER} user." "${g_logFile}"
            rm -rf /home/${OMM_USER} > /dev/null
        fi
        if [ -f /etc/uid_list ] ; then
            sed -i "/${userID}/d" /etc/uid_list
        fi
    fi
    return ${INS_SUCCESS}
}
################################################################################
# Function: delete_omm_process
# Description: 删除omm用户下的所有进程
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_omm_process()
{
    local g_logFile="${1}"
    log "INFO" "${LINENO}" "start to delete the process of omm user." "${g_logFile}"
    #如果omm用户存在，则omm用户下的所有进程
    id -u "${OMM_USER}" > /dev/null 2>&1
    if [ $? -eq 0 ] ; then
        # 删除用户前确保删除掉omm用户下的所有进程
        local OMM_USER_ID=`id -u ${OMM_USER}`
        ps -u "${OMM_USER_ID}" | grep -v "PID" | awk '{print $1}' | xargs kill -9 >> "${g_logFile}" 2>&1
        for (( i=0; i<=32; i=i+2 )) ; do
            if [ "$(ps -u "${OMM_USER_ID}" | grep -v "PID" | awk '{print $1}' | wc -l )" = "0" ] ; then
                break
            else
                if (( i>=32 )) ; then
                    log "WARN" "${LINENO}" "It can't kill all the omm user's process for 30s." "${OMS_UNINSTALL_LOG_FILE}"
                    break
                fi
            fi
            sleep 2
        done
    fi
    return ${INS_SUCCESS}
}
################################################################################
# Function: delete_ommdba_user
# Description: 删除ommdba用户
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_ommdba_user()
{
    log "INFO" "${LINENO}" "start to delete ommdba user." "${OMS_UNINSTALL_LOG_FILE}"
    local g_logFile=${OMS_UNINSTALL_LOG_FILE}
    #如果ommdba用户存在，则删除用户及进程
    id -u "${DB_CREATER}"
    if [ $? -eq 0 ] ; then
        # 删除用户前确保删除掉ommdba用户下的所有进程
        local DB_CREATER_ID=`id -u ${DB_CREATER}`
        ps -u "${DB_CREATER_ID}" | grep -v "PID" | awk '{print $1}' | xargs kill -9 >> "${g_logFile}" 2>&1
        for (( i=0; i<=32; i=i+2 )) ; do
            if [ "$(ps -u "${DB_CREATER_ID}" | grep -v "PID" | awk '{print $1}' | wc -l )" = "0" ] ; then
                break
            else
                if (( i>=32 )) ; then
                    log "WARN" "${LINENO}" "It can't kill all the ommdba user's process for 30s." "${OMS_UNINSTALL_LOG_FILE}"
                    break
                fi
            fi
            sleep 2
        done
        local userID=$(id ${DB_CREATER} -u)
        # 删除ommdba用户
        userdel -rf ${DB_CREATER}
        if [ $? -ne 0 ] ; then
            log "WARN" "${LINENO}" "Failed to delete ${OMM_USER} user." "${OMS_UNINSTALL_LOG_FILE}"
            rm -rf /home/${DB_CREATER}
        fi
        # 麒麟OS删除用户时需要删除uid
        if [ -f /etc/uid_list ] ; then
            sed -i "/${userID}/d" /etc/uid_list
        fi
    fi

    log "INFO" "${LINENO}" "Succeed to delete ommdba user." "${OMS_UNINSTALL_LOG_FILE}"
    return ${INS_SUCCESS}
}

################################################################################
# Function: addPermissionToLog
# Description:给日志目录赋权
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
addPermissionToLog()
{
    log "INFO" "${LINENO}" "start to add permission to log path." "${OMS_UNINSTALL_LOG_FILE}"
    chmod 755 ${LOG_HOME}
}

################################################################################
# Function: delete_bigdata_dir
# Description:删除bigdata_home目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_bigdata_dir()
{
    local bigdataHome="${1}"
    log "INFO" "${LINENO}" "start to delete ${bigdataHome}." "${OMS_UNINSTALL_LOG_FILE}"
    if [ "${bigdataHome}"X = "${BIGDATA_ROOT_HOME}"X ] || [ "${bigdataHome}"X = "${BIGDATA_HOME}"X ] || [ "${bigdataHome}"X = "$(dirname ${BIGDATA_HOME})"X ]; then
        rm -rf "$BIGDATA_ROOT_HOME/Bigdata" > /dev/null 2>&1
        if [ $? -ne 0 ] ; then
            return 1
        fi
        # 以下目录清理失败不阻塞
        rm -rf "$BIGDATA_ROOT_HOME/Bigdata_gaussdb" > /dev/null 2>&1
        rm -rf "$BIGDATA_ROOT_HOME/Bigdata_setup" > /dev/null 2>&1
    else
        log "ERROR" "${LINENO}" "Parameter error,${bigdataHome} != $BIGDATA_HOME or ${BIGDATA_ROOT_HOME}." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
}

################################################################################
# Function: delete_packages_dir
# Description:删除bigdata_home下的packages目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_packages_dir()
{
    log "INFO" "${LINENO}" "start to delete packages directory" "${OMS_UNINSTALL_LOG_FILE}"
    local packagesDir="${1}"
    if [ ${packagesDir} = "$BIGDATA_HOME/packages" ] ; then
        rm -rf ${packagesDir}
    fi
    if [ "$?" != "0" ] ; then
        log "ERROR" "${LINENO}" "Failed to delete ${packagesDir}" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    log "INFO" "${LINENO}" "success to delete packages directory." "${OMS_UNINSTALL_LOG_FILE}"
    return 0
}
################################################################################
# Function: delete_om_profile
# Description:删除bigdata_home下的.om_profile文件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_om_profile()
{
    log "INFO" "${LINENO}" "start to delete omProfile" "${OMS_UNINSTALL_LOG_FILE}"
    local omProfile="${1}"
    if [ "${omProfile}" = "$AGENT_WORKSPACE/.om_profile" ] ; then
        rm -rf ${omProfile}
    fi
    if [ "$?" != "0" ] ; then
        log "ERROR" "${LINENO}" "Failed to delete ${omProfile}" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    log "INFO" "${LINENO}" "success to delete ${omProfile}."  "${OMS_UNINSTALL_LOG_FILE}"
    return 0
}
################################################################################
# Function: delete_dbdata_om
# Description:删除dbdata_om目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_dbdata_om()
{
    log "INFO" "${LINENO}" "start to delete dbdata_om directory" "${OMS_UNINSTALL_LOG_FILE}"
    local dbdataDir="${1}"
    if [ ${dbdataDir} != "$BIGDATA_DATA_HOME/dbdata_om" ] ; then
        log "ERROR" "${LINENO}" "Parameter error, dbdata_om directory is not ${1}." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    
    rm -rf ${dbdataDir} 2>> "${OMS_UNINSTALL_LOG_FILE}"
    if [ "$?" != "0" ] ; then
        log "WARN" "${LINENO}" "Failed to delete ${dbdataDir}" "${OMS_UNINSTALL_LOG_FILE}"
    else 
        log "INFO" "${LINENO}" "Succeed to delete ${dbdataDir}" "${OMS_UNINSTALL_LOG_FILE}"
    fi

    return 0
}
################################################################################
# Function: delete_Manager
# Description:删除${BIGDATA_DATA_HOME}/Manager目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_Manager()
{
    log "INFO" "${LINENO}" "start to delete Manager directory" "${OMS_UNINSTALL_LOG_FILE}"
    local dbdataDir="${1}"
    if [ ${dbdataDir} = "$BIGDATA_DATA_HOME/${OM_DATA_DIR}" ] ; then
        rm -rf ${dbdataDir}
    fi
    if [ "$?" != "0" ] ; then
        log "ERROR" "${LINENO}" "Failed to delete ${dbdataDir}" "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    log "INFO" "${LINENO}" "success to delete ${dbdataDir}." "${OMS_UNINSTALL_LOG_FILE}"
    return 0
}
################################################################################
# Function: delete_manager_backup_link
# Description:删除${BIGDATA_DATA_HOME}/LocalBackup链接
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_manager_backup_link()
{
    local link="$1"
    log "INFO" "${LINENO}" "start to delete Manager backup link : $link." "${OMS_UNINSTALL_LOG_FILE}"
    if [ ${link} = "$BIGDATA_DATA_HOME/LocalBackup" ] && [ -L "$link" ]; then
        log "INFO" "${LINENO}" "delete Manager backup link : $link." "${OMS_UNINSTALL_LOG_FILE}"
        rm -rf "$link"
    fi
}
################################################################################
# Function: delete_log_dir
# Description:删除日志目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_log_dir()
{
    log "INFO" "${LINENO}" "Start to delete log directory" "${OMS_UNINSTALL_LOG_FILE}"
    local logDir="${1}"
    if [ -z "${BIGDATA_LOG_HOME}" ] ;then
        BIGDATA_LOG_HOME="/var/log/Bigdata"
    fi
    if [ ${logDir} = "$BIGDATA_LOG_HOME" ] ; then
        rm -rf ${logDir}
        if [ "$?" != "0" ] ; then
            log "ERROR" "${LINENO}" "Failed to delete ${logDir}" "${OMS_UNINSTALL_LOG_FILE}"
            return 1
        else
            log "INFO" "${LINENO}" "Succeed to delete log directory" "${OMS_UNINSTALL_LOG_FILE}"
            return 0
        fi
    else
        log "ERROR" "${LINENO}" "Failed to chmod log home." "${OMS_UNINSTALL_LOG_FILE}"
        log "ERROR" "${LINENO}" "Parameter error,${BIGDATA_LOG_HOME} != ${1}." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi  
}
################################################################################
# Function: delete_omm_home
# Description:删除omm用户目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_omm_home()
{
    log "INFO" "${LINENO}" "Start to delete ommHome directory." "${OMS_UNINSTALL_LOG_FILE}"
    local ommHomeDir="${1}"
    if [ ${ommHomeDir} = "/home/omm" ] ; then
        if [ -d "${ommHomeDir}" ] ; then
            rm -rf ${ommHomeDir}
            if [ "$?" != "0" ] ; then
                log "ERROR" "${LINENO}" "Failed to delete ${ommHomeDir}" "${OMS_UNINSTALL_LOG_FILE}"
                return 1
            else
                log "INFO" "${LINENO}" "Succeed to delete ${ommHomeDir}." "${OMS_UNINSTALL_LOG_FILE}"
                return 0
            fi
        fi
    else
        log "ERROR" "${LINENO}" "Failed to delete ommHome directory." "${OMS_UNINSTALL_LOG_FILE}"
        log "ERROR" "${LINENO}" "Parameter error,${ommHomeDir} != /home/omm." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi  
}
################################################################################
# Function: clear_route_config
# Description:清除路由配置
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clear_route_config()
{
    log "INFO" "${LINENO}" "start to clear route config" "${OMS_UNINSTALL_LOG_FILE}"
    sed -i '/200 om_rt/d' /etc/iproute2/rt_tables  > /dev/null 2>&1
    sed -i '/201 ntp_rt/d' /etc/iproute2/rt_tables > /dev/null 2>&1
    sed -i '/202 snmp_rt/d' /etc/iproute2/rt_tables > /dev/null 2>&1
    sed -i '/203 syslog_rt/d' /etc/iproute2/rt_tables > /dev/null 2>&1
    sed -i '/204 drp_rt/d' /etc/iproute2/rt_tables > /dev/null 2>&1
    sed -i '/205 urp_rt/d' /etc/iproute2/rt_tables > /dev/null 2>&1
}
################################################################################
# Function: creat_uninstall_oms_log
# Description:创建卸载OMS的日志文件并赋权
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
creat_uninstall_oms_log()
{
    log "INFO" "${LINENO}" "start to create the log file of uninstall oms" "${OMS_UNINSTALL_LOG_FILE}"
    local currentDir="$1"
    if [ "${currentDir}" = "${LOG_HOME}" ] ; then
      chmod u+rwx,g+rx,o+rx "${currentDir}"
      ret=$?
      if [ "${ret}" -ne 0 ]; then
        return ${ret}
      fi
      while [ "$(dirname "${currentDir}")" != "/" ] ; do
          chmod u+rx,o+rx "$(dirname "${currentDir}")"
          ret=$?
          if [ "${ret}" -ne 0 ]; then
             return ${ret}
          fi
          currentDir="$(dirname "${currentDir}")"
      done
    fi
    rm -rf ${LOG_HOME}/bigdataControllerUninstall.log
    rm -rf ${LOG_HOME}/bigdataControllerUninstallOsOptimization.log
    touch ${LOG_HOME}/bigdataControllerUninstall.log
    touch ${LOG_HOME}/bigdataControllerUninstallOsOptimization.log
    chown omm: ${LOG_HOME}/bigdataControllerUninstall.log
    chown omm: ${LOG_HOME}/bigdataControllerUninstallOsOptimization.log
    return 0
}

################################################################################
# Function: chmod_oms_install_script
# Description:给oms安装脚本添加执行权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
chmod_oms_install_script()
{
    log "INFO" "${LINENO}" "start to add permission to the install script file." "${OMS_LOG_FILE}"
    installOMSScript="${BIGDATA_HOME}/tmp/omsInstallFile/*OMS*/install.sh"
    chmod +x ${installOMSScript}

    return 0
}
################################################################################
# Function: delete_ommProfile
# Description: 删除omm用户的.profile文件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_ommProfile()
{
    log "INFO" "${LINENO}" "start to delete ommProfile." "${OMS_UNINSTALL_LOG_FILE}"
    rm -rf /home/omm/.profile > /dev/null 2>&1
}
################################################################################
# Function: clear_source_profile
# Description: 清除.bashrc和.bash_profile文件中的"source /home/omm/.profile"
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clear_source_profile()
{
    log "INFO" "${LINENO}" "start to clear .bashrc." "${OMS_UNINSTALL_LOG_FILE}"
    local str="source /home/omm/.profile"
    tmp=$(echo $str | sed -e 's/\//\\\//g')
    sed -i "/$tmp/d" /home/omm/.bashrc > /dev/null 2>&1
    log "INFO" "${LINENO}" "start to clear .bash_profile." "${OMS_UNINSTALL_LOG_FILE}"
    sed -i "/$tmp/d" /home/omm/.bash_profile > /dev/null 2>&1
}
################################################################################
# Function: m_clear_ntp_config
# Description: clear ntp configs
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
m_clear_ntp_config()
{
    log "INFO" "${LINENO}" "start to clear ntp config." "${OMS_UNINSTALL_LOG_FILE}"
    REDHAT_CRONTAB_FILE='/var/spool/cron/omm'
    REDHAT_CRON_SERVICE_NAME='crond'

    SUSE_CRONTAB_FILE='/var/spool/cron/tabs/omm'
    SUSE_CRON_SERVICE_NAME='cron'

    if [ -f "${REDHAT_CRONTAB_FILE}" ] ; then
        sed -i '/ntpChecker/d' "${REDHAT_CRONTAB_FILE}"
        service "${REDHAT_CRON_SERVICE_NAME}" restart
    elif [ -f "SUSE_CRONTAB_FILE" ]; then
        sed -i '/ntpChecker/d' "${SUSE_CRONTAB_FILE}"
        service "${SUSE_CRON_SERVICE_NAME}" restart
    else
        return 0
    fi

    return 0
}
################################################################################
# Function: checkInterface_inet
# Description: check interface_inet
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function checkInterface_inet()
{
   tmpdev="${1}"
   ifconfig ${tmpdev} | grep "inet" > /dev/null 2>&1
   return $?
}
################################################################################
# Function: checkInterface_inet_addr
# Description: check interface_inet_addr
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function checkInterface_inet_addr()
{
   interface="${1}"
   ifconfig ${interface} | grep "inet addr" > /dev/null 2>&1
   return $?
}
################################################################################
# Function: checkFloat_ip
# Description: check Float_ip
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function checkFloat_ip()
{
   tmpIP="${1}"
   ifconfig | grep -w -F ${tmpIP} > /dev/null 2>&1
   return $?
}
################################################################################
# Function: validate_software_dir_is_empty
# Description: validate software_dir_is_empty
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function validate_software_dir_is_empty()
{
   if [  "$1" != $UPGRADE_OPERATOR -a "$(ls -A ${BIGDATA_HOME})" != "" ] ; then
      return 1
   fi

   return 0
}
################################################################################
# Function: validate_file_system
# Description: validate file system
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function validate_file_system()
{
   local dir="${1}"
   if [ "$(df -T ${dir} | awk 'END {print $2}')" = "nfs" ] ; then
      return 1
   fi

   return 0
}
################################################################################
# Function: check_dataHome_space
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_dataHome_space()
{
   local dir="${1}"
   local space=$(df -m ${dir} | awk 'END {print $2}')
   if [ ${space} -lt $(expr 1024 \* 50) ] ; then
      return 0
   else
      return 1  
   fi 
}
################################################################################
# Function: check_Manager_dataHome_type
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_Manager_dataHome_type()
{
   if [ ! -L "${BIGDATA_DATA_HOME}/${OM_DATA_DIR}" ] ; then
       return 0
   else 
       return 1
   fi
}

################################################################################
# Function: copy_managerData
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function copy_managerData()
{
   cp -rfp "${BIGDATA_DATA_HOME}/${OM_DATA_DIR}"/* "${BIGDATA_HOME}/${OM_DATA_DIR}"
}
################################################################################
# Function: sha256sum_NodeAgentPackage
# Description: sha256sum NodeAgentPackage
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
sha256sum_NodeAgentPackage()
{
   nodeagentPackageName="$1"
   if [ $(sha256sum  ${nodeagentPackageName} | awk '{printf("%s", $1)}') = $(cat ${nodeagentPackageName}.sha256 | awk '{printf("%s", $1)}') ] ; then
      return 0
   else
      return 1
   fi
}
################################################################################
# Function: change_file_placeholder
# Description: 替换文件中的占位符
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function change_file_placeholder()
{
    local placeholder="$1"
    local targetString="$2"
    local -a targetFileList=($3)
    if [ -z "$placeholder" ]; then
        log "ERROR" "${LINENO}" "Input placeholder is null." "${NODEAGENT_LOG_FILE}"
    fi
    if [ -z "$targetString" ]; then
        log "ERROR" "${LINENO}" "Input targetString is null." "${NODEAGENT_LOG_FILE}"
    fi
    for targetFile in "${targetFileList[@]}"
    do
        log "INFO" "${LINENO}" "Configuring $targetFile,change $placeholder to ${targetString}." "${NODEAGENT_LOG_FILE}"
        sed -i -e "s:$placeholder:${targetString}:g" "$targetFile"
    done
}
################################################################################
# Function: chmod_chown_om_profile
# Description: 修改.om_profile的文件权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function chmod_chown_om_profile()
{
    profileFile=$1
    log "INFO" "${LINENO}" "chmod_chown_om_profile ${1}" "${OMS_LOG_FILE}"
    chown "${OMM_USER}":"${WHEEL_GROUP}" "${profileFile}"
    chmod 750 "${profileFile}"
}

#########################################logman################################
################################################################################
# Function: update_crontab_logman
# Description: update crontab file
# Parameter:
#   input:
#   $1   content of the line
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function update_crontab_logman()
{
    # 校验crontab文件是否存在，如果不存在则创建crontab文件，并修改权限
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        crontabFile="/var/spool/cron/tabs/omm"
    else
        crontabFile="/var/spool/cron/omm"
    fi
    if [ -z "${1}" ]; then
        echo "The argument is empty of update_crontab_logman: input argument is empty."
        return 1
    fi
    local crontab_tmp_file="/tmp/crontab.$(date +%s%N)"
    if [ ! -f "${crontabFile}" ]; then
        touch ${crontab_tmp_file}
        crontab -u omm "${crontab_tmp_file}" > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            error "update ${1} to crontab failed."
            rm -rf "${crontab_tmp_file}" > /dev/null 2>&1
            return 1
        fi
    fi
    
    crontab -u omm -l  | grep -v "^[[:space:]]*#" > "${crontab_tmp_file}"
    if [ ! -f "${crontab_tmp_file}" ]; then
        touch "${crontab_tmp_file}"
    fi   
    
    #先检查crontab中是否已经存在该crontab项，有就忽略不再添加
    find_str=$(echo "${1}" | sed 's:*:\\*:g')
    grep "${find_str}" "${crontab_tmp_file}" > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "${1}" >> "${crontab_tmp_file}"
        crontab -u omm "${crontab_tmp_file}" > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "update ${1} to crontab failed." "${OMS_LOG_FILE}"
            rm -rf "${crontab_tmp_file}" > /dev/null 2>&1
            return 1
        fi
    fi
    
    rm -rf "${crontab_tmp_file}" > /dev/null 2>&1
    if [ -f "/etc/init.d/cron" ]; then
        /etc/init.d/cron restart > /dev/null 2>&1
    fi
    
    if [ -f "/etc/init.d/crond" ]; then
        /etc/init.d/crond restart > /dev/null 2>&1
    fi
    
    return 0
}

################################################################################
# Function: m_remove_from_cron_file
# Description: backup omm crontab file
# Parameter:
#   input:
#   $1       backup crontab file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_remove_from_cron_file()
{
    local crontab_tmp_file="/tmp/crontab.$(date +%s%N)"
    local crontab_new_file="/tmp/crontab.new.$(date +%s%N)"
    local crontabFile=""
    
    if [ -z "${1}" ]; then
        log "ERROR" "${LINENO}" "The argument is empty of m_remove_from_cron_file: input argument is empty." "${OMS_UNINSTALL_LOG_FILE}"
        return 1
    fi
    IS_SUSE_OS="$(cat /proc/version | grep "SUSE")"
    if [ -n "$IS_SUSE_OS" ]; then
        crontabFile="/var/spool/cron/tabs/omm"
    else
        crontabFile="/var/spool/cron/omm"
    fi
    if [ ! -f "${crontabFile}" ]; then
        return 0
    fi
    
    crontab -u omm -l > "${crontab_tmp_file}" 2> /dev/null
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}" "get crontab file failed." "${OMS_UNINSTALL_LOG_FILE}"
        rm -rf "${crontab_tmp_file}" > /dev/null 2>&1
        return 1
    fi
    #先检查crontab中是否已经存在该crontab项，有就删除
    grep "${1}" "${crontab_tmp_file}" > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        cat "${crontab_tmp_file}" | grep -v "^[[:space:]]*#" | grep -v "${1}" > "${crontab_new_file}" 2>/dev/null
        crontab -u omm "${crontab_new_file}" > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            log "ERROR" "${LINENO}" "update ${1} to crontab failed." "${OMS_LOG_FILE}"
            rm -rf "${crontab_tmp_file}" "${crontab_new_file}"> /dev/null 2>&1
            return 1
        fi
    fi
    rm -rf "${crontab_tmp_file}" "${crontab_new_file}"> /dev/null 2>&1
    if [ -f "/etc/init.d/cron" ]; then
        /etc/init.d/cron restart > /dev/null 2>&1
    fi
    
    if [ -f "/etc/init.d/crond" ]; then
        /etc/init.d/crond restart > /dev/null 2>&1
    fi
    
    return 0
}
#########################################logman################################

#########################################osperf################################
################################################################################
# Function: m_init_logFile
# Description: mkdir
# Parameter:
#   input:
#   $1        dir path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_init_logFile()
{
    if [ $# -eq 0 ]; then
        echo "chown arguments ($1) is null."
        return 1
    fi
    
    #检查日志目录
    if [ ! -d "$1" ]; then
        mkdir -p "$1"
    fi
}

################################################################################
# Function: m_chown_log
# Description: change own
# Parameter:
#   input:
#   $1    own flag
#   $2    path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_chown_log()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "chown arguments ($1) ($2) is null."
        return 1
    fi
    
    if [ ! -e "$2" ]; then
        echo "chown path does not exist."
        return 1
    fi
    
    #检查日志目录
    chown "$1" "$2" -R
    return $?
}

################################################################################
# Function: m_copy_scrpitToLocal
# Description: copy scrpit to /usr/local/
# Parameter:
#   input:
#   $1    local file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_copy_scrpitToLocal()
{
    local copyPath="$1"
    
    if [ -z "${copyPath}" ]; then
        echo "copy source path is null."
        return 1
    fi
    
    if [ ! -e "${copyPath}" ]; then
        echo "copy source path does not exist."
        return 1
    fi
    
    #拷贝脚本修改权限
    mkdir -p /usr/local/osperf/
    cp ${copyPath}/* /usr/local/osperf/ -arf
    chmod 750 /usr/local/osperf/ -R
    
    #转换格式并执行    
    hash dos2unix > /dev/null 2>&1
    if [ $? -eq 0 ]; then 
        find /usr/local/osperf/ -maxdepth 5 -mindepth 1 -type f -name "*" | while read line
        do    
            dos2unix "$line" > /dev/null 2>&1
        done
    fi
    
    chown 0:0 /usr/local/osperf -R
    return $?
}


################################################################################
# Function: m_init_localFile
# Description: create local file
# Parameter:
#   input:
#   $1    local file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_init_localFile()
{
    local pathname=""
    local filename=""
    local localFile="$1"
    
    #空串时退出(不影响安装)
    if [ -z "${localFile}" ]; then
        echo  "The g_localFile is null."
        return 0
    fi
    
    pathname=$(dirname "${localFile}")
    filename=$(basename "${localFile}")
    
    #目录是否存在
    if [ ! -d $pathname ]; then
        return 1
    fi    
    
    #找到链接路径，重新组装LOCAL文件路径
    localFile="$(readlink -e $pathname)/$filename" 
  
    #文件不存在时创建
    if [ ! -f "${localFile}" ]; then 
        touch "${localFile}"
        if [ $? -ne 0 ]; then        
            return 1
        fi
    fi

    chmod 755 "${localFile}"        
    if [ $? -ne 0 ]; then        
        return 1
    fi
    
    return 0    
}

################################################################################
# Function: m_exec_osperf
# Description: create local file
# Parameter:
#   input:
#   $1    local file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_exec_osperf()
{
    local exec_file="/usr/local/osperf/script/setup.sh"
    
    if [ -f "${exec_file}" ]; then
        $(${exec_file})
        return $? 
    fi
    
    return 0
}

################################################################################
# Function: m_save_setupScriptToLocal
# Description: save osperf file to os local file
# Parameter:
#   input:
#   $1    local file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_save_setupScriptToLocal()
{    
    local os_local_file="$1"
    local perf_file="/usr/local/osperf/script/setup.sh"
    
    if [ -z "${os_local_file}" ]; then
        echo "os local file path is null."
        return 1
    fi
    
    if [ ! -e "${os_local_file}" ]; then
        echo "os local file path does not exist."
        return 1
    fi
    
    #往LOCAL文件登记REBOOT时执行的OS调优脚本
    sed -n '1,$p' ${os_local_file} | grep 'osperf' | grep 'script' > /dev/null
    if [ $? -ne 0 ]; then         
        echo "${perf_file}" >> ${os_local_file} 
    else
        echo "The script has been written down in the local file."
    fi
    
    echo "The setup script executing success."
    return 0
}

################################################################################
# Function: m_uninstallOsperf
# Description: uninstall osperf, code copy from original osperf uninstall script
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function m_uninstallOsperf()
{
    local g_localFile=''
    #Red Hat版本,且版本号为6.4
    if [ -f "/etc/redhat-release" ]; then  
        #版本号打印到运行日志,方便定位
        log "INFO" "$(cat /etc/redhat-release)"
        
        g_localFile="/etc/rc.local"         #redhat的local目录
    fi    
       
    #匹配SuSE11SP1
    if [ -f "/etc/SuSE-release" ]; then   
        #版本号打印到运行日志,方便定位
        log "INFO" "$(cat /etc/SuSE-release)"
    
        g_localFile="/etc/rc.d/after.local" #suse的local目录
    fi    
    
    #CentOS版本
    if [ -f "/etc/centos-release" ]; then  
        #版本号打印到运行日志,方便定位
        log "INFO" "$(cat /etc/centos-release)"
        
        g_localFile="/etc/rc.local"         #CentOS的local目录
    fi    
    
    if [ -z "${g_localFile}" ]; then
        log "ERROR" "Uninstall osperf failed, The os version does not match."
        return 0
    fi

    g_localFile=$(readlink -e "$g_localFile")
    
    #删除LOCAL文件登记的REBOOT时执行的OS调优脚本  
    if [ -f "${g_localFile}" ]; then 
        sed -i '/osperf\/script/d' ${g_localFile}
        if [ $? -ne 0 ]; then 
            log "ERROR" "Modify the g_localFile configure fails."
        fi    
    else
        log "INFO" "The g_localFile does not exist."
    fi        
    
    #删除拷贝目录
    if [ -n "/usr/local/osperf" ]; then
        rm -rf "/usr/local/osperf"        
        if [ $? -ne 0 ]; then 
            log "ERROR" "Delete the directory[/usr/local/osperf/] fails."
        fi    
    fi 
    
    return 0
}

#########################################osperf################################



#########################################preinstall################################
################################################################################
# Function: create_soft_link_for_libssl_libcrypto
# Description: create soft link for libssl libcrypto
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function create_soft_link_for_libssl_libcrypto()
{
    if [ ! -e /usr/lib64/libssl.so.0.9.8  ]; then
        libssl_file=`find /lib64/ /usr/lib64/ -maxdepth 1 -type f -name 'libssl.so*' | sort -r | awk 'NR==1'`
        ln -s ${libssl_file} /usr/lib64/libssl.so.0.9.8 >/dev/null 2>&1
    fi
    if [ ! -e /usr/lib64/libcrypto.so.0.9.8  ]; then
        libcrypto_file=`find /lib64/ /usr/lib64/ -maxdepth 1 -type f -name 'libcrypto.so*' | sort -r | awk 'NR==1'`
        ln -s ${libcrypto_file} /usr/lib64/libcrypto.so.0.9.8 >/dev/null 2>&1
    fi
}

################################################################################
# Function: create_soft_link_for_libboost
# Description: create soft link for libboost
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function create_soft_link_for_libboost()
{
    boost_version="${1}"
    dst_version="${boost_version}";
    files=`rpm -qa | grep -E "*boost[_-](system*|atomic-m*)" | xargs rpm -ql | grep lib64`;
    echo "$files" | tr ' ' '\n' | while read line
    do
        dst_file=`echo ${line} | sed "s/[0-9.]\+\$/.${dst_version}/g"`;  ln -s ${line} ${dst_file} >/dev/null 2>&1;
        dst_mt_file=`echo ${dst_file} | sed 's/-mt//g' | sed 's/.so/-mt.so/g'`; ln -s ${line} ${dst_mt_file} >/dev/null 2>&1;
        dst_no_mt_file=`echo ${dst_file} | sed 's/-mt//g'`; ln -s ${line} ${dst_no_mt_file} >/dev/null 2>&1;
    done
    return 0
}

################################################################################
# Function: create_soft_link_for_openldap
# Description: create soft link for openldap
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function create_soft_link_for_openldap()
{
    if [ ! -e /usr/lib64/liblber-2.4.so.2 ]; then
        liblber_file=$(find /lib64/ /usr/lib64/ -maxdepth 1 -type f -name 'liblber.so*' | sort -r | awk 'NR==1')
        ln -s ${liblber_file} /usr/lib64/liblber-2.4.so.2 >/dev/null 2>&1
    fi
    if [ ! -e /usr/lib64/libldap-2.4.so.2 ]; then
        libldap_file=$(find /lib64/ /usr/lib64/ -maxdepth 1 -type f -name 'libldap.so*' | sort -r | awk 'NR==1')
        ln -s ${libldap_file} /usr/lib64/libldap-2.4.so.2 >/dev/null 2>&1
    fi
}

################################################################################
# Function: create_soft_link_for_ldlinux
# Description: create soft link for ld-linux-aarch64.so.1
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function create_soft_link_for_ldlinux()
{
    if [ ! -e /lib64/ld-linux-aarch64.so.1 ] && [ -e /lib/ld-linux-aarch64.so.1 ]; then
        ln -s /lib/ld-linux-aarch64.so.1 /lib64/ld-linux-aarch64.so.1 >/dev/null 2>&1
    fi
}

################################################################################
# Function: install_rpm_package
# Description: install rpm package
# Parameter:
#   input:
#   $1    package file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function install_rpm_package()
{
    local package="$1"
    
    if [ -z ${package} ]; then
        echo "language file does not exist."
        return 1
    fi
    
    rpm -ivh "${package}"
    return $?
}

################################################################################
# Function: update_rpm_package
# Description: update seccomponent package
# Parameter:
#   input:
#   $1    package file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function update_rpm_package()
{
    local rpmName="$1"
    local rpmPath="$2"
    
    if [ -z ${rpmName} ]; then
        echo "RPM name ${rpmName} is empty."
        return 1
    fi
    
    if [ -z ${rpmPath} ]; then
        echo "RPM file ${rpmPath} does not exist."
        return 1
    fi
    
    rpm -q ${rpmName}
    if [ $? -eq 0 ]; then
        echo "RPM ${rpmName} is already installed."
        return 0
    fi
    
    rpm -q seccomponent
    if [ $? -eq 0 ]; then
        echo "Seccomponent with older version is already installed. Uninstall it firstly."
        rpm -e seccomponent
        if [ $? -ne 0 ]; then
            echo "Failed to uninstall seccomponent with older version."
            return 1
        fi
    fi
    
    echo "Start to install ${rpmPath}."
    rpm -ivh "${rpmPath}"
    return $?
}

################################################################################
# Function: query_rpm_package
# Description: query rpm package
# Parameter:
#   input:
#   $1    package file path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function query_rpm_package()
{
    local package="$1"
    
    if [ -z ${package} ]; then
        echo "language file does not exist."
        return 1
    fi
    
    rpm -q "${package}"
    return $?
}

################################################################################
# Function: clear_scc_semaphore
# Description: clear scc semaphore
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function clear_scc_semaphore() {
    local sccSemaphore="0x20161227"
    echo "start to clear scc semaphore(${sccSemaphore})"
    local sccSemID="$(ipcs -s | grep ${sccSemaphore} | awk -F ' ' '{print $2}')"
    if [ -z "${sccSemID}" ]; then
        echo "end   to clear scc semaphore(${sccSemaphore}), the semid of ${sccSemaphore} is empty"
        return 0
    fi

    ipcrm -s "${sccSemID}"
    if [ $? -ne 0 ]; then
        echo "failed to clear scc semaphore(${sccSemaphore}), semid(${sccSemID})"
        return 1
    fi
    echo "end   to clear scc semaphore(${sccSemaphore}), semid(${sccSemID})"
}

########################################################################
# 优化操作系统启动(操作系统启动时挂载加密分区)
########################################################################
function preinstall_add_diskmgt_optimized_to_local() {
    local osLocalFile="/etc/rc.local"
    local diskMgtServicePath="/usr/local/diskmgt"
    local crontabFile="/etc/crontab"
    local mountEncryptPartitionCmd="${diskMgtServicePath}/script/mount_encrypt_partition.sh"

    if [ -f "/etc/SuSE-release" ]; then
        osLocalFile="/etc/rc.d/after.local" #suse的local目录
    fi

    local realOsLocalFile=$(readlink -e "$osLocalFile")
    echo "os-local-file:[$osLocalFile], real-os-local-file:[${realOsLocalFile}]"
    if [ -z "${realOsLocalFile}" ] || [ ! -f "${realOsLocalFile}" ]; then
        echo "The rc-local.service file cannot be used to optimize the system startup. Therefore, the crontab scheduled task is used to optimize the system startup."
        cat "${crontabFile}" | grep "${mountEncryptPartitionCmd}" >/dev/null
        if [ $? -ne 0 ]; then
            echo "@reboot root sh ${mountEncryptPartitionCmd} 2>/dev/null" >> "${crontabFile}"
        else
            echo "The diskmgt-optimized script has been written down in the crontab-file[${crontabFile}]."
        fi
        return 0
    fi

    #往LOCAL文件登记REBOOT时执行的
    sed -n '1,$p' ${realOsLocalFile} | grep "${mountEncryptPartitionCmd}" >/dev/null
    if [ $? -ne 0 ]; then
        echo "sh ${mountEncryptPartitionCmd}" >>${realOsLocalFile}
    else
        echo "The diskmgt-optimized script has been written down in the local file."
    fi

    chmod +x "${realOsLocalFile}"
    echo "Written diskmgt-optimized script to ${realOsLocalFile} successfully."
    return 0
}

################################################################################
# Function: suse_config_language
# Description: config os language
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function suse_config_language()
{
    local lang_file=/etc/sysconfig/language
    
    if [ ! -f ${lang_file} ]; then
        echo "language file does not exist."
        return 1
    fi
    
    grep "^RC_LANG=" ${lang_file} > /dev/null
    if [ $? -ne 0 ]; then
        sed -i "1 a\RC_LANG=\"en_US.UTF-8\"" ${lang_file}
        if [ $? -ne 0 ]; then
            echo "Insert RC_LANG as UTF-8 failed."
            return 1
        fi
    else
        sed -i "s/^RC_LANG=.*/RC_LANG=\"en_US.UTF-8\"/g" ${lang_file}
        if [ $? -ne 0 ]; then
            echo "Instead RC_LANG as UTF-8 failed."
            return 1
        fi
    fi
    
    return 0
}

################################################################################
# Function: suse_config_clock
# Description: config os clock
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function suse_config_clock ()
{
    local clock_file=/etc/sysconfig/clock
    
    if [ ! -f ${clock_file} ]; then
        echo "clock file does not exist."
        return 1
    fi
    
    grep "^HWCLOCK=" ${clock_file} > /dev/null
    if [ $? -ne 0 ]; then
        sed -i "1 a\HWCLOCK=\"-u\"" ${clock_file}
        if [ $? -ne 0 ]; then
            echo "Insert clock as -u failed."
            return 1
        fi
    else
        sed -i "s/^HWCLOCK=.*/HWCLOCK=\"-u\"/g" ${clock_file}
        if [ $? -ne 0 ]; then
            echo "Instead clock as -u failed."
            return 1
        fi
    fi

    return 0
}


################################################################################
# Function: services_ctl
# Description: start or stop some services
# Parameter:
#   input:
#   $1     services name
#   $2     start or stop
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function services_ctl()
{
    local services_name="$1"
    local services_contrl="$2"
    local services_array=( crond sshd iptables cgconfig cron statmon ipmi ipmievd nscd sssd ntp ntpd rngd haveged)
    
    if [[ -z "$services_name" || -z "$services_contrl"  ]]; then
        echo "services can not be empty."
        return 1
    fi
    
    if [[ "X$services_contrl" != "Xstart" && "X$services_contrl" != "Xstop" ]]; then
        echo "services ctl must be start or stop."
        return 1
    fi
    
    for element in $(seq 0 $((${#services_array[@]} - 1)))
    do
        if [ "X$services_name" == "X${services_array[$element]}" ]; then
            service "${services_name}" "${services_contrl}"
            return $?
        fi
    done
    
    echo "unknow services name."
    return 1
}

################################################################################
# Function: chkconfig_ctl
# Description: on or off some services chkconfig
# Parameter:
#   input:
#   $1     services name
#   $2     on or off
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function chkconfig_ctl ()
{
    local services_name="$1"
    local services_contrl="$2"
    local services_array=( crond cron sshd iptables cgconfig statmon ipmi ipmievd nscd sssd ntp ntpd rngd haveged)
    
    if [[ -z "${services_name}" || -z "${services_contrl}"  ]]; then
        echo "services can not be empty."
        return 1
    fi
    
    if [[ "X${services_contrl}" != "Xon" && "X${services_contrl}" != "Xoff" ]]; then
        echo "chkconfig ctl must be on or off."
        return 1
    fi
    
    for element in $(seq 0 $((${#services_array[@]} - 1)))
    do
        if [ "X${services_name}" == "X${services_array[$element]}" ]; then
            chkconfig "${services_name}" "${services_contrl}"
            return $?
        fi
    done
    
    echo "unknow services name."
    return $?
}

################################################################################
# Function: cat_sysctl
# Description: cat /etc/sysctl.conf
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function cat_sysctl()
{
    local source_path="/etc/sysctl.conf" 

    cat "${source_path}"
    if [ $? -ne 0 ]; then
        echo "cat ${source_path} failed"
        return 1
    fi

    return 0
}

################################################################################
# Function: replace_sysctl
# Description: replace /etc/sysctl.conf
# Parameter:
#   input:
#   $1        replace path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function replace_sysctl()
{
    local replace_path="$1"
    local target_path="/etc/sysctl.conf"
    
    #检查配置文件
    if [ ! -f ${replace_path} ]; then
        echo "${replace_path} is not exist."
        return 1
    fi
    
    cat "$replace_path" > ${target_path}
    if [ $? -ne 0 ]; then
        echo "cat $replace_path > ${target_path} failed"
        return 1
    fi

    return 0
}

################################################################################
# Function: effective_sysctl
# Description: effective sysctl
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function effective_sysctl()
{
    sysctl -q -p
    return $?
}

################################################################################
# Function: config_limits
# Description: config limits
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function config_new_limits()
{
    local path="/etc/security/limits.d"
    local nproc="${path}/90-nproc.conf"
    local nofile="${path}/90-nofile.conf"
    local memlock="${path}/omm-memlock.conf"
    local omm_nproc="${path}/omm-nproc.conf"
    
    #创建limits.d目录
    if [ ! -d "${path}" ]; then
        mkdir -p ${path}
        if [ $? -ne 0 ]; then
            echo "mkdir -p ${path} failed"
            return 1
        fi
    fi
     
    echo "*          soft    nproc     60000" > ${nproc}
    echo "root       soft    nproc     unlimited">> ${nproc}
    
    echo "*          hard    nofile    640000" > ${nofile}
    echo "*          soft    nofile    640000" >> ${nofile}

    echo "omm        hard    memlock    unlimited" > ${memlock}
    echo "omm        soft    memlock    unlimited" >> ${memlock}

    echo "omm        hard    nproc     60000" > ${omm_nproc}
    echo "omm        soft    nproc     60000" >> ${omm_nproc}

    return 0
}

################################################################################
# Function: cat_fstab
# Description: cat /etc/fstab
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function cat_fstab()
{
    local source_path="/etc/fstab"
    
    cat "${source_path}"
    if [ $? -ne 0 ]; then
        echo "cat ${source_path} failed"
        return 1
    fi

    return 0
}


################################################################################
# Function: replace_fstab
# Description: replace /etc/fstab
# Parameter:
#   input:
#   $1        replace path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function replace_fstab()
{
    local replace_path="$1"
    local target_path="/etc/fstab"
    
    #检查配置文件
    if [ ! -f ${replace_path} ]; then
        echo "${replace_path} is not exist."
        return 1
    fi
    
    cat "${replace_path}" > "${target_path}"
    if [ $? -ne 0 ]; then
        echo "cat ${replace_path} > ${target_path} failed"
        return 1
    fi

    return 0
}


################################################################################
# Function: remount_ctl
# Description: remount path
# Parameter:
#   input:
#   $1        remount path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function remount_ctl()
{
    #检查配置文件
    if [ -z "$1" ]; then
        echo "$1 is null."
        return 1
    fi
    
    mount -o errors=panic,remount "$1"
    return 0
}


################################################################################
# Function: redhat_config_language
# Description: config os language
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function redhat_config_language()
{
    local lang_file=/etc/sysconfig/i18n
    
    #redhat 7.X
    which localectl > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        localectl set-locale LANG=en_US.UTF-8 > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            error "localectl command failed."
            return 1
        fi
        
        return 0
    fi
    
    #redhat 6.X
    if [ ! -f ${lang_file} ]; then
        echo "language file does not exist."
        return 1
    fi
    
    grep "^LANG=" ${lang_file} > /dev/null
    if [ $? -ne 0 ]; then
        sed -i "1 a\LANG=\"en_US.UTF-8\"" ${lang_file}
        if [ $? -ne 0 ]; then
            echo "Insert LANG as UTF-8 failed."
            return 1
        fi
    else
        sed -i "s/^LANG=.*/LANG=\"en_US.UTF-8\"/g" ${lang_file}
        if [ $? -ne 0 ]; then
            echo "Instead LANG as UTF-8 failed."
            return 1
        fi
    fi
    
    return 0
}

function process_ssh_for_local()
{
    if [ ! -f "/etc/euleros-release" ]; then
        return 0
    fi

    cat /etc/euleros-release | grep "^Euler" > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
        sed -i 's/^HostKeyAlgorithms/#HostKeyAlgorithms/' /etc/ssh/sshd_config
        sed -i 's/^PubkeyAcceptedKeyTypes/#PubkeyAcceptedKeyTypes/' /etc/ssh/sshd_config
        service sshd restart > /dev/null 2>&1
    fi
}

################################################################################
# Function: preinstall_update_etc_hosts
# Description: add config /etc/hosts
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_update_etc_hosts()
{
    local ipaddr="$1"
    local hostname="$2"
    
    #检查配置文件
    if [ -z "${ipaddr}" -o -z "${hostname}" ]; then
        echo "ipaddr=${ipaddr} or hostname=${hostname} is null."
        return 1
    fi
    
    echo "${ipaddr} ${hostname}" >> /etc/hosts
    if [ $? -ne 0 ]; then
        echo "echo ${ipaddr} ${hostname} >> /etc/hosts failed"
        return 1
    fi

    return 0
}


################################################################################
# Function: preinstall_remove_etc_hosts
# Description: add config /etc/hosts
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_remove_etc_hosts()
{
    local ipaddr="$1"
    local hostname="$2"
    
    #检查配置文件
    if [ -z "${ipaddr}" -o -z "${hostname}" ]; then
        echo "ipaddr=${ipaddr} or hostname=${hostname} is null."
        return 1
    fi
    
    sed -i '/^[[:space:]]*'$ipaddr' /d' /etc/hosts
    if [ $? -ne 0 ]; then
        echo "remove $ipaddr from /etc/hosts failed"
        return 1
    fi
    
    sed -i '/ '$hostname'[[:space:]]*$/d' /etc/hosts
    if [ $? -ne 0 ]; then
        echo "remove $ipaddr from /etc/hosts failed"
        return 1
    fi

    return 0
}

################################################################################
# Function: preinstall_remove_hostname_etc_hosts
# Description: add config /etc/hosts
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_remove_hostname_etc_hosts()
{
    local hostname="$1"

    #检查配置文件
    if [ -z "${hostname}" ]; then
        echo "hostname=${hostname} is null."
        return 1
    fi

    sed -i '/ '$hostname'/d' /etc/hosts
    if [ $? -ne 0 ]; then
        echo "remove $ipaddr from /etc/hosts failed"
        return 1
    fi

    return 0
}

################################################################################
# Function: invalidate cgroup
# Description: invalidate cgroup
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_invalidate_cgroup()
{
    local config_name="DefaultInvalidateCgroup";
    local config_value="no";
    local config_file="/etc/systemd/system.conf";
    grep "^[[:space:]]*${config_name}[[:space:]]*=" ${config_file} > /dev/null
    if [ $? -ne 0 ]; then
        echo "${config_name} = ${config_value}" >> ${config_file}
    else
        sed -i "s/^[[:space:]]*${config_name}[[:space:]]*=.*/${config_name} = ${config_value}/g" ${config_file}
        if [ $? -ne 0 ]; then
            return 1
        fi
    fi
    return 0
}

################################################################################
# Function: expand_ipv6
# Description: expand ipv6 address
# Parameter:
#   input:
#   $1   压缩的ipv6地址
#   output:完整的ipv6地址
#   N/A
# Others: N/A
################################################################################
function expand_ipv6() {
    if [ -z "${1}" ]; then
        echo "The argument is empty of expand_ipv6: arg1=${1}"
        return 1
    fi
    local ipv6=$(echo "${1}" | tr 'A-Z' 'a-z')
    local colon_num=$(echo ${ipv6} | awk '{print gsub(/:/, "")}')
    local replace_str=""
    for (( i = 0; i <= $(( 7 - ${colon_num} )); ++ i )); do
        replace_str="${replace_str}:0"
    done
    replace_str="${replace_str}:"
    local ipv6_expanded=${ipv6/::/$replace_str}
    [[ ${ipv6_expanded} == *: ]] && ipv6_expanded="${ipv6_expanded}0"
    [[ ${ipv6_expanded} == :* ]] && ipv6_expanded="0${ipv6_expanded}"
    echo ${ipv6_expanded}
}


function hex2dec(){
    [ "$1" != "" ] && printf "%d" "$(( 0x$1 ))"
}

##########################################################
#    Description:compress_ipv6
#    Parameter:  $1 ipv6 address
#    Return:
##########################################################
function compress_ipv6() {
    if [ -z "$1" ]; then
        echo "Param is empty."
        return 1
    fi
    local tmpaddr=$(echo "${1}" | tr 'A-Z' 'a-z')
    # 先扩展，以防入参是压缩地址
    ip=$(expand_ipv6 "${tmpaddr}")
    blocks=$(echo $ip | grep -o "[0-9a-f]\+")
    set $blocks
    # 压缩前导0 0000->0
    ip=$(printf "%x:%x:%x:%x:%x:%x:%x:%x\n" \
        $(hex2dec $1) \
        $(hex2dec $2) \
        $(hex2dec $3) \
        $(hex2dec $4) \
        $(hex2dec $5) \
        $(hex2dec $6) \
        $(hex2dec $7) \
        $(hex2dec $8)
    )
    # 加上前缀：，易于匹配
    ip=:"$ip"
    # :: 压缩最长连续0，若有相同长度的，压缩左边的
    for pattern in :0:0:0:0:0:0:0:0 \
            :0:0:0:0:0:0:0 \
            :0:0:0:0:0:0 \
            :0:0:0:0:0 \
            :0:0:0:0 \
            :0:0:0 \
            :0:0; do
        if echo $ip | grep -qs $pattern; then
            ip=$(echo $ip | sed "s/$pattern/::/")
            ip=$(echo $ip | sed 's/:::/::/')
            break
        fi
    done
    echo $ip | grep -qs "^:[^:]" && ip=$(echo $ip | sed 's/://')
    echo $ip
}


################################################################################
# Function: preinstall_redhat_update_etc_hostname
# Description: config /etc/sysconfig/network
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_redhat_update_etc_hostname()
{
    local hostname="$1"
    local hostname_conf_file="/etc/sysconfig/network"
    
    #检查配置文件
    if [ -z "${hostname}" ]; then
        echo "hostname=${hostname} is null."
        return 1
    fi
    
    #高版本情况（hostnamectl命令存在）
    which hostnamectl > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        which hostname > /dev/null 2>&1
        if [ $? -ne 0 ]; then
            echo "Command hostname doesn't exist."
            return 1
        fi
        
        #即刻生效
        hostname "${hostname}"
        if [ $? -ne 0 ]; then
            echo "Modify hostname failed for ${hostname}."
            return 1
        fi
        
        #修改配置文件，永久生效
        echo "${hostname}" > "/etc/hostname"
        if [ $? -ne 0 ]; then
            echo "Modify /etc/hostname failed."
            return 1
        fi
        
        return 0
    fi
    
    #永久设置hostname
    grep "^[[:space:]]*HOSTNAME[[:space:]]*=" "${hostname_conf_file}" > /dev/null
    if [ $? -ne 0 ]; then
        echo "HOSTNAME=${hostname}" >> "${hostname_conf_file}"
    else
        sed -i "s/^[[:space:]]*HOSTNAME[[:space:]]*=.*/HOSTNAME=${hostname}/g" "${hostname_conf_file}"
        if [ $? -ne 0 ]; then
            echo "Modify ${hostname_conf_file} failed for HOSTNAME=${hostname}."
            return 1
        fi
    fi
                    
    #设置临时hostname(让hostname生效)
    hostname "${hostname}"
    if [ $? -ne 0 ]; then
        echo "run command hostname ${hostname} failed."
        return 1
    fi

    return 0
}

################################################################################
# Function: preinstall_suse_update_etc_hostname
# Description: config /etc/HOSTNAME
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_suse_update_etc_hostname()
{
    local hostname="$1"
    local hostname_conf_file="/etc/HOSTNAME"
    
    #检查配置文件
    if [ -z "${hostname}" ]; then
        echo "hostname=${hostname} is null."
        return 1
    fi
    
    yast dns edit hostname="${hostname}"
    return $?
}

################################################################################
# Function: preinstall_swap_off
# Description: turn off swap
# Parameter:
#   input: $1   swap dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_swap_off() 
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    /sbin/swapoff "$1"
    if [ $? -ne 0 ]; then
        echo "/sbin/swapoff $1 failed."
        return 1
    fi
    return 0
}

################################################################################
# Function: preinstall_rngd_start
# Description: start rngd
# Parameter:
#   input: 
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_rngd_start()
{
    bash /usr/local/rngd/rngd.sh -s > /dev/null 2>&1
    return $?
}

################################################################################
# Function: preinstall_rngd_start
# Description: stop rngd
# Parameter:
#   input: 
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_rngd_stop()
{
    bash /usr/local/rngd/rngd.sh -k > /dev/null 2>&1
    return $?
}


################################################################################
# Function: modify rngd config for suse 12 redhat 7
# Description: modify rngd
# Parameter:
#   input: 
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function modify_rngd_service()
{
    local rngd_service="/usr/lib/systemd/system/rngd.service"
    
    if [ -e "${rngd_service}" ]; then
        if ! grep -q "^ExecStart=/sbin/rngd -f -r /dev/urandom -o /dev/random" "${rngd_service}"; then
            sed -i 's:^ExecStart=/sbin/rngd.*:ExecStart=/sbin/rngd -f -r /dev/urandom -o /dev/random:' "${rngd_service}"
            return 0
        fi
        
        return 0
    fi
    
    return 1
}

###############################################################################
# Function: system_ctl
# Description: start or stop some services
# Parameter:
#   input:
#   $1     services name
#   $2     start or stop
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function system_ctl()
{
    local services_contrl="$1"
    local services_name="$2"
    local services_array=(crond sshd iptables cgconfig cron statmon ipmi ipmievd nscd sssd ntp ntpd rngd haveged osperf firewalld diskmgt)
    
    if ! which systemctl > /dev/null 2>&1; then
        echo "can not find systemctl command."
        return 1
    fi
    
    if [[ -z "${services_name}" ]]; then
        systemctl "${services_contrl}"
        return $?
    fi
    
    for element in $(seq 0 $((${#services_array[@]} - 1)))
    do
        if [ "X$services_name" == "X${services_array[$element]}" ]; then
            systemctl "${services_contrl}" "${services_name}"
            return $?
        fi
    done
    
    echo "unknow services name."
    return 1
}

###############################################################################
# Function: system_ctl_reload
# Description: systemctl daemon-reload
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function system_ctl_reload()
{
    if ! which systemctl > /dev/null 2>&1; then
        echo "can not find systemctl command."
        return 1
    fi
    
    #某些异常环境上会出现systemctl daemon-reload命令长时间卡住（超过1小时不结束）的情况，因此设置超时时间180秒
    timeout 180 systemctl daemon-reload
    return $?
}

################################################################################
# Function: disable_selinux
# Description: turn off selinux
# Parameter:
#   input: 
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function disable_selinux()
{
    #检查SELinux是否存在
    which sestatus > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "SELinux does not exist. Skip shutting down selinux."
        return 0
    fi
    
    #临时关闭SELinux（不用重启）
    which getenforce > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        echo "Get current selinux mode failed."
        return 1
    fi
    
    local currentMode=$(getenforce)
    if [ X$currentMode ==  XDisabled ]; then
        echo "SELinux had been disabled. Skip turning off it."
    else
        setenforce 0
        if [ $? -ne 0 ];then
            echo "Turn off SELinux failed."
            return 1
        fi
    fi

    #修改SELinux配置文件，永久生效
    local CONFIG_FILE="/etc/selinux/config"
    if [ ! -f $CONFIG_FILE ]; then
        echo "SELinux config file /etc/selinux/config doesn't exist."
        return 1 
    fi
    
    sed -i 's/^SELINUX=.*$/SELINUX=disabled/g' $CONFIG_FILE
    if [ $? -ne 0 ]; then
        echo "Failed to modify $CONFIG_FILE."
        return 1
    fi
       
    echo "Disable SELinux ok."
    return 0
}

################################################################################
# Function: preinstall_cp
# Description: copy file
# Parameter:
#   input:
#   $1      source path
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_cp ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "source path $1 does not exist."
        return 1
    fi
    
    cp -arf "$1" "$2"
    return $?
}

################################################################################
# Function: preinstall_cp_so
# Description: copy so file
# Parameter:
#   input:
#   $1      source so file
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_cp_so ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi

    install "$1" "$2"
    return $?
}

################################################################################
# Function: systemd_chmod
# Description: change mod systemd dir
# Parameter:
#   input:
#   $1      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function systemd_chmod ()
{
    local paths_array=("/usr/lib/systemd/system//osperf.service" "/usr/lib/systemd/system/osperf.service" \
                       "/usr/sbin//statmon" "/usr/sbin/statmon" \
                       "/etc/init.d//statmon" "/etc/init.d/statmon" "/etc/rc.d/init.d/statmon" \
                       "/usr/sbin/rcstatmon" "/usr/sbin//rcstatmon" \
                       "/usr/lib/systemd/system//statmon.service" "/usr/lib/systemd/system/statmon.service" \
                       "/etc/sysconfig/rngd" "/usr/local/rngd")

    if [[ -z "$1" ]]; then
        echo "arguments is null."
        return 1
    fi

    if [ ! -e "$1" ]; then
        echo "path $1 does not exist."
        return 1
    fi

    local file=$(readlink -f "$1")
    echo "${paths_array[@]}" | grep -q -E "^${file}[[:space:]]|[[:space:]]${file}[[:space:]]|[[:space:]]${file}$"
    if [ $? -eq 0 ]; then
        chmod "644" "${file}"
        return $?
    fi

    echo "chmod 644 $file : Permission denied"
    return 1
}

################################################################################
# Function: preinstall_chmod
# Description: change mod
# Parameter:
#   input:
#   $1      mod flag
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_chmod ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$2" ]; then
        echo "path $2 does not exist."
        return 1
    fi
    
    chmod "$1" "$2"
    return $?
}

################################################################################
# Function: preinstall_chmod_r
# Description: change mod 
# Parameter:
#   input:
#   $1      mod flag
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_chmod_r ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi
    
    if [ ! -e "$2" ]; then
        echo "source path does not exist."
        return 1
    fi
    
    chmod "$1" "$2" -R
    return $?
}

################################################################################
# Function: preinstall_is_dir
# Description: check path is dir
# Parameter:
#   input:
#   $1      check path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_is_dir ()
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    
    if [ -d "$1" ]; then
        return 0
    fi

    return 1
}

################################################################################
# Function: preinstall_is_file
# Description: check path is file
# Parameter:
#   input:
#   $1      check path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_is_file ()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ -f "$1" ]; then
         return 0
    fi

    return 1
}

################################################################################
# Function: preinstall_is_file
# Description: check path is file
# Parameter:
#   input:
#   $1      check path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_rm_f ()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    rm -rf "$1"
    return $?
}

################################################################################
# Function: preinstall_create_softlink
# Description: create softlink
# Parameter:
#   input:
#   $1      source path
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_create_softlink ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi
    
    ln -sf "$1" "$2"
    return $?
}

################################################################################
# Function: systemd_chown
# Description: change own systemd dir
# Parameter:
#   input:
#   $1      user and group
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function systemd_chown ()
{
    local paths_array=("/usr/lib/systemd/system//osperf.service" "/usr/lib/systemd/system/osperf.service" \
                       "/usr/sbin//statmon" "/usr/sbin/statmon" \
                       "/etc/init.d//statmon" "/etc/init.d/statmon" "/etc/rc.d/init.d/statmon" \
                       "/usr/sbin/rcstatmon" "/usr/sbin//rcstatmon" \
                       "/usr/lib/systemd/system//statmon.service" "/usr/lib/systemd/system/statmon.service" \
                       "/etc/sysconfig/rngd" "/usr/local/rngd")

    if [[ -z "$1" ]]; then
        echo "path is null."
        return 1
    fi
    local file=$(readlink -f "$1")
    echo "${paths_array[@]}" | grep -q -E "^${file}[[:space:]]|[[:space:]]${file}[[:space:]]|[[:space:]]${file}$"
    if [ $? -eq 0 ]; then
        chown "0:0" "${file}"
        return $?
    fi

    echo "chown 0:0 $file: Permission denied"
    return 1
}

################################################################################
# Function: preinstall_chown
# Description: change own 
# Parameter:
#   input:
#   $1      user and group
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_chown ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi
    
    chown "$1" "$2"
    return $?
}

################################################################################
# Function: preinstall_touch
# Description: touch file 
# Parameter:
#   input:
#   $1      file name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_touch ()
{
    file_name="$1"
    if [ -z "$file_name" ]; then
        echo "path is null."
        return 1
    fi
    
    local file_array=("/etc/crypttab")
    echo "${file_array[@]}" | grep -q -E "^${file_name}[[:space:]]|[[:space:]]${file_name}[[:space:]]|[[:space:]]${file_name}$|^${file_name}$"
    if [ $? -ne 0 ]; then
        echo "fail to verify $file_name."
        return 1
    fi
    
    touch "$1"
    return $?
}

################################################################################
# Function: preinstall_chown_r
# Description: change own 
# Parameter:
#   input:
#   $1      user and group
#   $2      target path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_chown_r ()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "path is null."
        return 1
    fi
    
    chown -R "$1" "$2"
    return $?
}

################################################################################
# Function: preinstall_mkdir_p
# Description: create dir
# Parameter:
#   input:
#   $1      dir path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_mkdir_p ()
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    
    mkdir -p "$1"
    return $?
}

#############################################################################################################################
# 函数描述： 初始化数据目录，递归向上查找挂载点目录的父目录，直到数据目录根目录的下一层，然后递归修改这个目录的权限和属主
#            如：挂载点为/srv/BigData/test1/test2/test3，配置文件中设置的属主为2000:wheel，权限为700
#            则会执行chown 2000:wheel /srv/BigData/test1 -R 以及 chmod 700 /srv/BigData/test1 -R
#            这样做主要是为了解决挂载点和数据根目录之间的层级目录权限未修改的问题
# 参数1说明：数据挂载点目录
#
# 返回值  ：0 成功
#           1 失败
##############################################################################################################################
function preinstall_init_data_dir()
{
    local dir="${1}"
    local user_group="${2}"
    local permission="${3}"
    local data_home=$(readlink -m "${4}")
    
    echo "$1" | grep -q ^"${data_home}"
    if [ $? -ne 0 ]; then
        echo "[ERROR] Dir ${1} is not under ${data_home}."
        return 1
    fi
    
    # 递归向上查找父父目录，直到父目录为数据目录根目录
    local currentDir="${dir}"
    local parentDir=$(dirname "${currentDir}")
    while [[ "${parentDir}" != "${data_home}" ]] && [[ "${parentDir}" != "/" ]]
    do
        currentDir="${parentDir}"
        parentDir=$(dirname "${currentDir}")
    done
    
    if [ "${parentDir}" = "/" ]; then
        echo "[ERROR] Invalid dir ${dir}. It is not a sub dir of ${data_home}."
        return 1
    fi
    
    echo "[INFO] Start to init dir ${currentDir} ."
    chown ${user_group} "${currentDir}" -R
    if [ $? -ne 0 ]; then
        echo "[ERROR] chown ${user_group} ${currentDir} -R failed."
        return 1
    fi
    
    if [ "${permission}" != "default" ]; then
        chmod "${permission}" "${currentDir}" -R
        if [ $? -ne 0 ]; then
            echo "[ERROR] chmod ${permission} ${currentDir} -R failed."
            return 1
        fi 
    fi
}

################################################################################
# Function: preinstall_cat
# Description: create dir
# Parameter:
#   input:
#   $1      dir path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_cat ()
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    
    cat "$1"
    return $?
}

################################################################################
# Function: preinstall_which
# Description: check cmd is exist
# Parameter:
#   input:
#   $1      cmd name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_which()
{
    if [ -z "$1" ]; then
        echo "argument is null."
        return 1
    fi
    
    which $1
    return $?
}

################################################################################
# Function: preinstall_swapon_s
# Description: show swap info
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_swapon_s()
{
    swapon -s
    return $?
}


################################################################################
# Function: preinstall_add_to_fstab
# Description: add file to fstab
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_add_to_fstab()
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "cat path does not exist."
        return 1
    fi
    
    cat "$1" >> /etc/fstab
    return $?
}

################################################################################
# Function: preinstall_mkfs_ext3
# Description: mkfs
# Parameter:
#   input:
#   $1      dev name
#   $2      log name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_mkfs_ext3()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    nohup mkfs.ext3 -m 0 "$1" >> "$2" 2>&1 &
    echo $!
    return 0
}

################################################################################
# Function: preinstall_mkfs_ext4
# Description: mkfs
# Parameter:
#   input:
#   $1      dev name
#   $2      log name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_mkfs_ext4()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    nohup mkfs.ext4 -F -m 0 "$1" >> "$2"  2>&1 &
    echo $!
    return 0
}

################################################################################
# Function: preinstall_mkfs_xfs
# Description: mkfs
# Parameter:
#   input:
#   $1      dev name
#   $2      log name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_mkfs_xfs()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    nohup mkfs.xfs -f $1 >> $2  2>&1 &
    echo $!
    return 0
}

################################################################################
# Function: preinstall_readlink_e
# Description: readlink -e
# Parameter:
#   input:
#   $1      path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_readlink_e()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    readlink -e $1
    return $?
}

################################################################################
# Function: preinstall_readlink_m
# Description: readlink -m
# Parameter:
#   input:
#   $1      path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_readlink_m()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    readlink -m $1
    return $?
}

################################################################################
# Function: preinstall_findfs
# Description: findfs
# Parameter:
#   input:
#   $1      UUID name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_findfs()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    findfs $1
    return $?
}

################################################################################
# Function: preinstall_echo_proc_scsi
# Description: rescan disk
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_echo_proc_scsi()
{
    if [ $# -eq 0 ]; then
        echo "arguments is null"
        return 1
    fi
    
    echo "$*" > /proc/scsi/scsi
    return $?
}

################################################################################
# Function: preinstall_file_s
# Description: get file type
# Parameter:
#   input:
#   $1      file name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_file_s()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "file $1 does not exist."
        return 1
    fi
    
    file -s $1
    return $?
}

################################################################################
# Function: preinstall_fdisk_l
# Description: show disk info
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_fdisk_l()
{
    fdisk -l
}

################################################################################
# Function: preinstall_parted
# Description: show disk info by parted
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted()
{
    parted "$@"
}

################################################################################
# Function: preinstall_blkid
# Description: get block id info
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_blkid()
{
    if [ -z "$1" ]; then
        blkid
    else
        blkid $1
    fi
    
}


################################################################################
# Function: preinstall_sfdisk_g
# Description: get disk info
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_sfdisk_g()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "file $1 does not exist."
        return 1
    fi
    
    sfdisk -g "$1"
    return $?
}

################################################################################
# Function: preinstall_wait
# Description: wait pid completed
# Parameter:
#   input:
#   $1         pid
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_wait()
{
    if [ $# -eq 0 ]; then
        echo "pid is empty"
        return 0
    fi
    
    local completed=0
        while true
    do
        completed=0
        for pid in "$@"
        do
            kill -0 $pid
            if [ $? -ne 0 ]; then
                ((completed++))
            fi
        done

        if [ $completed -eq $# ]; then
            break;
        fi

        sleep 5
    done

    return $?
}

################################################################################
# Function: preinstall_partprobe
# Description: partprobe cmd
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_partprobe()
{
    partprobe
}

################################################################################
# Function: preinstall_parted_s_mk_gpt
# Description: parted for gpt
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted_s_mk_gpt()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    parted -s "$1"  mklabel gpt
    return $?
}

################################################################################
# Function: preinstall_parted_unit_print
# Description: parted print info
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted_unit_print()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    parted "$1" unit s print
    return $?
}

################################################################################
# Function: preinstall_parted_unit_gb_print
# Description: parted print info
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted_unit_gb_print()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    parted "$1" unit GB print
    return $?
}

################################################################################
# Function: preinstall_parted_s_mk_logical
# Description: parted for logical
# Parameter:
#   input:
#   $1         dev name
#   $2         logical begin 
#   $3         logical end 
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted_s_mk_logical()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    parted -s "$1" mkpart logical ${2}s ${3}s
    return $?
}

################################################################################
# Function: preinstall_parted_s_mk_opt_logical
# Description: parted for logical
# Parameter:
#   input:
#   $1         dev name
#   $2         logical begin  GB
#   $3         logical end    GB
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_parted_s_mk_opt_logical()
{
    if [ -z "$1" -o -z "$2" -o -z "$3" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    parted -a optimal -s "$1" mkpart logical "$2" "$3"
    return $?
}

################################################################################
# Function: preinstall_pvscan_s
# Description: scan the PVs
# Parameter:
#   input:
#   $1         dev name
#   $2         logical begin  GB
#   $3         logical end    GB
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_pvscan_s()
{
    pvscan -s
}

################################################################################
# Function: preinstall_mount
# Description: mount dev
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_mount()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    mount "$1" "$2" -o noatime,nodiratime,nofail
    return $?
}

################################################################################
# Function: preinstall_umount
# Description: umount dev
# Parameter:
#   input:
#   $1         dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_umount()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    umount "$1"
}

################################################################################
# Function: preinstall_fuser_mk
# Description: fuser
# Parameter:
#   input:
#   $1       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_fuser_mk()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "path $1 does not exist."
        return 1
    fi
    
    fuser -mk "$1"
    return $?
}

################################################################################
# Function: preinstall_dd_clean_zero
# Description: dd clean
# Parameter:
#   input:
#   $1       dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_dd_clean_zero()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    dd if=/dev/zero of="$1" bs=512 count=1
    return $?
}

################################################################################
# Function: preinstall_install
# Description: dd clean
# Parameter:
#   input:
#   $1       dev name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_install()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    install -m "$1" -d "$2"
    return $?
}

################################################################################
# Function: preinstall_dos2unix
# Description: dos2unix
# Parameter:
#   input:
#   $1       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_dos2unix()
{
    if [ -z "$1" ]; then
        echo "arguments is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "dev $1 does not exist."
        return 1
    fi
    
    find "$1" -type f | xargs dos2unix >/dev/null 2>&1
    return $?
}

########################################################################
# 函数描述： 把diskmgt启动脚本写入开关机流程中
#
# 返回值  ： 0 成功
#            1 失败
########################################################################
function preinstall_addDiskmgt2reboot()
{    
    local os_local_file="/etc/rc.d/rc.local"
    local SERVICEPATH="/usr/local/diskmgt"
    local diskmgt_cmd="${SERVICEPATH}/script/diskmgt.sh -s"
    
    if [ ! -e "${os_local_file}" ]; then
        echo "os local file path does not exist."
        return 1
    fi

    cp "${SERVICEPATH}/script/diskmgt" "/etc/init.d/"
    if [ $? -ne 0 ]; then
        echo "cp ${CURRPATH}/script/diskmgt /etc/init.d/ -arf failed."
        return 1
    fi
    
    chmod 755 "/etc/init.d/diskmgt"
    if [ $? -ne 0 ]; then
        echo "chmod 755 /etc/init.d/diskmgt -R failed."
        return 1
    fi
    
    ln -sf /etc/init.d/diskmgt /etc/rc6.d/K01diskmgt
    if [ $? -ne 0 ]; then
        echo "ln -sf /etc/init.d/diskmgt /etc/rc6.d/K01diskmgt failed."
        return 1
    fi
    
    #往LOCAL文件登记REBOOT时执行的
    sed -n '1,$p' ${os_local_file} | grep "$diskmgt_cmd" > /dev/null
    if [ $? -ne 0 ]; then         
        echo "${diskmgt_cmd}" >> ${os_local_file}
    else
        echo "The diskmgt script has been written down in the local file."
    fi
    
    echo "Written diskmgt script to ${os_local_file} successfully."
    return 0
}

################################################################################
# Function: uninstall_diskmgt
# Description: 
# Parameter:
#   input:
#   $1       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function uninstall_diskmgt()
{
    bash /usr/local/diskmgt/script/uninstall.sh
    return $?
}



################################################################################
# Function: preinstall_rm_rf
# Description: 
# Parameter:
#   input:
#   $1       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_rm_rf()
{
    if [[ -z "$1" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    rm -rf "$@"
    return $?
}


################################################################################
# Function: preinstall_move
# Description: 
# Parameter:
#   input:
#   $1       path name
#   $2       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_move()
{
    if [[ -z "$1" || -z "$2" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    mv "$1" "$2"
    return $?
}


################################################################################
# Function: preinstall_add_to_crypttab
# Description: add items to /etc/crypttab
# Parameter:
#   input:
#   $1       path name
#   $2       path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_add_to_crypttab()
{
    if [ -z "$1" ]; then
        echo "path is null."
        return 1
    fi
    
    if [ ! -e "$1" ]; then
        echo "cat path does not exist."
        return 1
    fi
    
    local line=""
    local mapper=""
    
    if [ ! -f /etc/crypttab ]; then
        touch /etc/crypttab
        chmod 644 /etc/crypttab
    fi
    
    cp -pf /etc/crypttab /etc/crypttab_bak
    if [ $? -ne 0 ]; then
        echo "cp -pf /etc/crypttab /etc/crypttab_bak failed."
        return 1
    fi
    
    while read line
    do
        mapper=$(echo "$line" | awk '{print $1}')
        sed -i "/$mapper /d" /etc/crypttab_bak
    done <"$1"
    
    cat "$1" >> /etc/crypttab_bak
    if [ $? -ne 0 ]; then
        echo "cat $1 >> /etc/crypttab_bak failed."
        return 1
    fi
    
    mv -f /etc/crypttab_bak /etc/crypttab
    return $?
}


################################################################################
# Function: preinstall_cryptsetup
# Description: encrypt a partition
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_cryptsetup()
{
    if [[ -z "$1" ]]; then
        echo "arguments is null."
        return 1
    fi
    
    cryptsetup "$@"
    return $?
}

################################################################################
# Function: preinstall_stop_diskmgt
# Description: 
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_stop_diskmgt()
{
    local count=0
    local count_max=60
    local diskmgt_path="/usr/local/diskmgt"
    local diskmgt_script_path="${diskmgt_path}/script/diskmgt.sh"
    
    if [ ! -f "${diskmgt_script_path}" ]; then
        echo "can not find file ${diskmgt_script_path}, failed."
        return 1
    fi
        
    #循环停止服务，如果超过30秒则停止失败
    while [ ${count} -le ${count_max} ]
    do
        bash ${diskmgt_script_path} -k
        if [ $? -ne 0 ]; then
            ((count++))
        else
            return 0
        fi
        
        sleep 2
    done
    
    return 1
}


################################################################################
# Function: preinstall_start_diskmgt
# Description: 
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_start_diskmgt()
{
    local count=0
    local count_max=10
    local diskmgt_path="/usr/local/diskmgt"
    local diskmgt_script_path="${diskmgt_path}/script/diskmgt.sh"
    
    if [ ! -f "${diskmgt_script_path}" ]; then
        echo "can not find file ${diskmgt_script_path}, failed."
        return 1
    fi
        
    #启动diskmgt
    while [ ${count} -le ${count_max} ]
    do
        bash ${diskmgt_script_path} -s
        if [ $? -ne 0 ]; then
            ((count++))
        else
            #启动成功
            return 0
        fi
        
        sleep 2
    done
    
    return 1
}

################################################################################
# Function: preinstall_copy_libboost
# Description: 拷贝/usr/lib64/libboost_system.so.1.54.0解决suse15.1安装失败问题
# Parameter:
#   input:
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function preinstall_copy_libboost()
{
    local libboost_file=${1}
    cp -f ${libboost_file} /usr/lib64/
    if [ ! -f /usr/lib64/${libboost_file##*/} ]; then
        error "[${FUNCNAME}:${LINENO}]" "/usr/lib64/${libboost_file##*/} is not exist."
        return 1
    fi
    chmod 755 /usr/lib64/${libboost_file##*/}
    return $?
}


#########################################preinstall################################
#########################################precheck##################################

################################################################################
# Function: check_ethtool
# Description: 显示网卡详细信息
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : ethx
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function  check_ethtool()
{
    if [ $# -eq 0 ]; then
        return 1
    fi
    if [ -f /sbin/ethtool ]; then
        ETHTOOL="/sbin/ethtool"
    else
        ETHTOOL="/usr/sbin/ethtool"
    fi
    ${ETHTOOL} "$@"
    return $?
}

################################################################################
# Function: check_sudoers
# Description: 检查sudoers中配置
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_sudoers()
{
    cat /etc/sudoers
    return  $?
}
################################################################################
# Function: check_dd
# Description: 检查磁盘性能
# Parameter:
#   input:
#   dd参数
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_dd()
{
    if [ $# -eq 0 ]; then
        return 1
    fi
    
    dd "$@"
    return  $?
}
################################################################################
# Function: check_find
# Description: 检查查找文件
# Parameter:
#   input:
#   dd参数
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_find()
{
    if [ $# -eq 0 ]; then
        return 1
    fi
    
    find "$@"
    return  $?
}
################################################################################
# Function: check_cron
# Description: 检查cron配置
# Parameter:
#   input:
#   cron config
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function check_cron()
{
    croncfg="$1"
    if [ -z "${croncfg}" ];then
        return 1
    fi    
    cat "${croncfg}"
    return  $?
}
################################################################################
# Function: check_service
# Description: 查询服务状态
# Parameter:
#   input:
#   $1 : service name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_service()
{
    if [ $# -eq 0 ] ;then
        return 1
    fi
    servicename="$1"
    service ${servicename} status
    return  $?
}

################################################################################
# Function: check_hosts
# Description: 写入主机名与ip配置到/etc/hosts
# Parameter:
#   input:
#   $1 : serviceip
#   $2 : hostname
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_hosts()
{   
    serviceip="$1"
    hostNamecfg="$2"
    if [ -z "${serviceip}" ]||[ -z "${hostNamecfg}" ] ;then
        return 1
    fi
    echo "${serviceip}" "${hostNamecfg}" >>/etc/hosts
    return $?
}

################################################################################
# Function: check_mounta
# Description: 挂载所有分区
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_mounta()
{
    mount -a
    return $?    
}
################################################################################
# Function: check_dfP
# Description: 查询分区信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_dfP()
{
    df -P
    return $?  
}
################################################################################
# Function: check_pvs
# Description: 查询物理卷分区信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_pvs()
{
    /sbin/pvs
    return $?  
}

################################################################################
# Function: check_tail
# Description: 查询最新日志
# Parameter:
#   input:
#   $1 : StandardLinesToBeChecked
#   $2 : strSysLogPath
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_tail()
{
    StandardLinesToBeChecked="$1"
    strSysLogPath="$2"
    if [ -z "${StandardLinesToBeChecked}" ]||[ -z "${strSysLogPath}" ];then
        return 1
    fi
        
    tail -n ${StandardLinesToBeChecked} ${strSysLogPath}
    return $?  

}

################################################################################
# Function: check_sysctl
# Description: 显示内核参数
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_sysctl()
{
    /sbin/sysctl -p
    return $? 
}
################################################################################
# Function: check_sysctl
# Description: 显示内核参数
# Parameter:
#   input:
#   $1 : param
#   $2 : dev
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_smartctl()
{
    param="$1"
    dev="$2"
    /usr/sbin/smartctl $param $dev
    return $? 
}
################################################################################
# Function: check_stat
# Description: 显示文件信息
# Parameter:
#   input:
#   $1 : param
#   $2 : dev
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_stat()
{
    /usr/bin/stat "$@" 
}
################################################################################
# Function: check_iftop
# Description: iftop获取网络流量
# Parameter:
#   input:
#   $1 : Path
#   $2 : lan
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################    
function check_iftop()
{   
    Path="$1"
    lan="$2"
    if [ -z "${Path}" ]||[ -z "${lan}" ];then
        return 1
    fi    
    "${Path}"/Lib/iftop/iftop -n -N -B -t -s 15 -i ${lan}
}
################################################################################
# Function: check_find_ls
# Description: 查找子目录文件属性
# Parameter:
#   input:
#   $1 : path
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################  
function check_find_ls()
{   
    path="$1"
    checksubdirfile="$2"
    
    if [ -z "${path}" ];then
        return 1
    fi
   
    if [ "${checksubdirfile}" = "1" ];then
        #查询子目录文件权限
        find "${path}" -print0|xargs -0 ls -ld
    else
        #仅查寻目录权限
        ls -ld "${path}"
    fi  
    
    return $? 
}
#########################################end precheck###########################




##################################################################################
# Function: create_sudo_profile
# Description: 创建sudo脚本中要用到的环境变量文件
# Parameter:
#   input:
#   $1   param list
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
##################################################################################

function create_sudo_profile()
{
    mkdir -p /etc/profile.d
    if ! [ -f ${g_sudo_profile} ] ; then 
        touch ${g_sudo_profile}
    fi
}

##################################################################################
# Function: re_create_sudo_profile
# Description: 先删除再创建sudo脚本中要用到的环境变量文件
# Parameter:
#   input:
#   $1   param list
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
##################################################################################

function re_create_sudo_profile()
{
    mkdir -p /etc/profile.d
    rm -rf ${g_sudo_profile}
    touch ${g_sudo_profile}
}
##################################################################################
# Function: write_sudo_profile
# Description: 往文件中写sudo脚本中要用到的环境变量
# Parameter:
#   input:
#   $1   param list
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
##################################################################################
function write_sudo_profile()
{
    grep "$1" ${g_sudo_profile} > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        echo $1 >> ${g_sudo_profile}
    fi  
}
##################################################################################
# Function: write_sudo_profile_agent
# Description: 往agent节点文件中写sudo脚本中要用到的环境变量
# Parameter:
#   input:
#   $1   param list
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
##################################################################################
function write_sudo_profile_agent()
{
    grep "$2" ${g_sudo_profile} > /dev/null 2>&1
    if [ $? -ne 0 ] ; then
        echo $1 >> ${g_sudo_profile}
    fi
    
    chmod 644 ${g_sudo_profile}
}

################################################################################
# Function: delete_not_root_env
# Description: 删除/etc/profile.d/目录下其他用户环境变量文件
# Parameter:
#   input: 需要删除的环境变量文件
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function delete_not_root_env()
{
    local input_sudo_file="${1}"
    local -a env_vars=("/etc/profile.d/omm-sudo-oms.sh" "/etc/profile.d/omm-sudo-oma.sh")
    echo "Start to delete ${input_sudo_file}"
    local -i flag=1
    for env_var in "${env_vars[@]}"
    do
        if [ "$input_sudo_file"X == "$env_var"X ]; then
            rm -rf ${input_sudo_file}
            if [ $? -eq 0 ] ; then
                flag=0
            fi
            break
        fi
    done
    if [ ${flag} -ne 0 ]; then
        echo "Failed to delete ${input_sudo_file}"
        return 1
    fi
    echo "Success to delete ${input_sudo_file}"
    return 0
}

################################################################################
# Function: delete_root_env
# Description: 删除/etc/profile.d/sudoProfile.sh环境变量文件
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function delete_root_env()
{
    local logFile="${1}"
    log "INFO" "${LINENO}" "Start to delete ${g_sudo_profile}" "${logFile}"
    rm -rf ${g_sudo_profile}
    if [ $? -ne 0 ] ; then
        log "ERROR" "${LINENO}" "Fail to delete ${g_sudo_profile}" "${logFile}"
        return 1
    fi
    
    log "INFO" "${LINENO}" "Success to delete ${g_sudo_profile}" "${logFile}"
    return 0

}

#####################################Upgrade start################################

##################################################################################
# Function: verify_path
# Description: 校验所有操作路径是否合法（合法路径：安装目录/数据目录/日志目录/HOME目录）
# 只要其中一个参数路径不合法，返回非0
# Parameter:
#   input:
#   $1   param list
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
##################################################################################
verify_path()
{
    if [ $# -eq 0 ]; then
        return 1
    fi
    local BIDATA_ROOT_HOME=$(dirname $BIGDATA_HOME)

    local fi_common_dirs=("$LOG_HOME/Bigdata" "${BIDATA_ROOT_HOME}" "$BIGDATA_HOME" "$BIGDATA_DATA_HOME" "$OMM_USER_HOME" "$DB_CREATER_HOME" "$REDHAT_CRONTAB_FILE" "$SUSE_CRONTAB_FILE" "${g_sudo_profile}" "/var/lib/sudo/Bigdata")
    
    #校验操作路径，如果输入参数存在非FI的指定的路径，返回非0
    for param in "$@"
    do
        local -i permission_allow=${UPG_OPT_ILLEGAL_PATH}
        
        param="$(readlink -m "${param}")"
        for path in "${fi_common_dirs[@]}";
        do
            if [[ "$param" == "$path"* ]]; then
                permission_allow=0
                break;
            fi
        done
        
        if [ $permission_allow -ne 0 ]; then
            echo -e "Verify $param path failed."
            return $permission_allow
        fi
    done
    
    return $permission_allow
}

################################################################################
# Function: init_upgrade_log
# Description: 初始化升级日志目录和文件
# Parameter:
#   input:
#   $1  path name
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_upgrade_log()
{
    local log_file="$1"

    verify_path ${log_file} || return $?
    
    # 创建日志路径
    local log_path="$(dirname ${log_file})"
    mkdir -m 700 -p "${log_path}"

    # 创建日志文件
    if ! [ -f "${log_file}" ]; then
        touch "${log_file}"
        chown "${OMM_USER}":"${OMM_USER_GROUP}" "${log_path}" -R
        chmod 600 "${log_file}"
    fi
}

################################################################################
# Function: restrict_cp
# Description: 拷贝的源文件和目标文件须是FI的安装目录/数据目录/日志目录/HOME目录
# Parameter:
#   input:
#   [OPTION]... [-T] SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_cp()
{
    local option=''
    
    if [ $# -eq 3 ]; then
        option="$1"
        shift
        if [ "${#option}" -eq 0 ]; then
            return 1
        fi
        
        #cp命令OPTION以-字符开头
        if ! [[ "${option}" =~ ^-.* ]]; then
            return 1
        fi
    fi 

    local src_file="$1"
    shift

    local dst_file="$1"
    shift

    verify_path "${src_file}" "${dst_file}" || return $?
    
    # 创建日志路径
    if [ "${#option}" -eq 0 ]; then
        /bin/cp -rpf "$src_file" "$dst_file"
    else
        /bin/cp "$option" "$src_file" "$dst_file"
    fi
    
    return $?
}

################################################################################
# Function: restrict_mv
# Description: 移动的源文件和目标文件必须是FI的安装目录/数据目录/日志目录/HOME目录
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_mv()
{
    if [ $# -ne 2 ]; then
        return 1
    fi
    
    local src_file="$1"
    local dst_file="$2"

    verify_path "${src_file}" "${dst_file}" || return $?
    
    # 创建日志路径
    /bin/mv "$src_file" "$dst_file"
    
    return $?
}

################################################################################
# Function: restrict_rm
# Description: 只能删除FI安装目录、数据目录、日志目录和Home目录下的文件
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : FILE
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_rm()
{
    local option=''
    if [ $# -eq 2 ]; then
        option="$1"
        shift
        if [ "${#option}" -eq 0 ]; then
            return 1
        fi
        
        #rm命令OPTION以-字符开头
        if ! [[ "${option}" =~ ^-.* ]]; then
            return 1
        fi
    fi
    
    local opt_file="$1"

    verify_path "${opt_file}" || return $?
    
    # 创建日志路径
   
    
    if [ "${#option}" -eq 0 ]; then
         /bin/rm "$opt_file"
    else
        /bin/rm "$option" "$opt_file"
    fi
    
    return $?
}

################################################################################
# Function: restrict_mkdir
# Description: 只能在FI安装目录、数据目录、日志目录和Home目录下创建目录
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : FILE
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_mkdir()
{
    local option=''
    if [ $# -eq 2 ]; then
        option="$1"
        shift
        if [ "${#option}" -eq 0 ]; then
            return 1
        fi
        #rm命令OPTION以-字符开头
        if ! [[ "${option}" =~ ^-.* ]]; then
            return 1
        fi
    fi
    local opt_file="$1"
    verify_path "${opt_file}" || return $?
    # 创建目录
    if [ "${#option}" -eq 0 ]; then
         mkdir "$opt_file"
    else
        mkdir "$option" "$opt_file"
    fi
    return $?
}

################################################################################
# Function: restrict_chmod
# Description: 只能修改在FI安装目录、数据目录、日志目录和Home目录下文件权限
# Parameter:
#   input:
#   $1 : chmod命令参数，如: -R
#   $2 : 权限，如: 700
#   $3 : 目录或文件
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_chmod()
{
    local option=''
    if [ $# -eq 3 ]; then
        option="$1"; shift
        [ "${#option}" -eq 0 ] && return 1
        [[ "${option}" =~ ^-.* ]] || return 1
    fi 

    local permission="$1" ; shift
    local file="$1" ; shift
    verify_path "${file}" || return $?
    
    if [ "${#option}" -eq 0 ]; then
        chmod "${permission}" "$file" ; ret=$?
    else
        chmod "$option" "${permission}" "$file" ; ret=$?
    fi
    
    return $ret
}

################################################################################
# Function: restrict_chown
# Description: 只能修改在FI安装目录、数据目录、日志目录和Home目录下文件属组
# Parameter:
#   input:
#   $1 : chown命令参数，如: -R
#   $2 : 用户属组，如:omm:wheel
#   $3 : 目录或文件
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restrict_chown()
{
    local option=''
    if [ $# -eq 3 ]; then
        option="$1" ; shift
        [ "${#option}" -eq 0 ] && return 1
        [[ "${option}" =~ ^-.* ]] || return 1
    fi 

    local user_group="$1"; shift
    local file="$1" ; shift
    verify_path "${file}" || return $?
    
    if [ "${#option}" -eq 0 ]; then
        chown "${user_group}" "$file" ; ret=$?
    else
        chown "$option" "${user_group}" "$file" ; ret=$?
    fi
    
    return $ret
}

################################################################################
# Function: get_db_sync_status
# Description: 获取数据库同步状态
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : FILE
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_db_sync_status()
{
    local db_pwd="$1"
    db_sync_percent=$(su - ${DB_CREATER} -c "gs_ctl query -U ${DB_CREATER} -P ${db_pwd}" | grep 'SYNC_PERCENT' | awk -F ':' '{print $2}' | sed 's/^[[:space:]]*//g;s/[[:space:]]*$//g')
    echo $db_sync_percent
}

################################################################################
# Function: force_stop_database
# Description: force stop database
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : FILE
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
force_stop_database()
{
    su - "${DB_CREATER}" -c "gs_ctl stop"
    
    #如果停止数据库失败，强制杀死数据库进程
    local gaussdb_pid=$(ps -ef ww | grep "gaussdb/bin/gaussdb" | grep "${BIGDATA_HOME}/om-server" | grep -v grep | awk '{print $2}')
    if [ -n "$gaussdb_pid" ]; then
        kill -9 ${gaussdb_pid}
    fi
    
    #兼容升级期间812x gaussdb安装目录发送变化
    gaussdb_pid=$(ps -ef ww | grep "gaussdb/bin/gaussdb" | grep "${BIGDATA_ROOT_HOME}/Bigdata_gaussdb" | grep -v grep | awk '{print $2}')
    if [ -n "$gaussdb_pid" ]; then
        kill -9 ${gaussdb_pid}
    fi
    
    return 0
}

################################################################################
# Function: restart_database
# Description: restart database
# Parameter:
#   input:
#   $1 : OPTION
#   $2 : FILE
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
restart_database()
{
    local ha_mode="$1"
    if [ -z "$ha_mode" ]; then
        echo -e "Illegal parameters, ha mode is empty."
        return 1
    fi
    
    #停止数据库
    force_stop_database >/dev/null 2>&1
    
    #启动数据库
    su - "${DB_CREATER}" -c "gs_ctl start -M $ha_mode"
    
    return $?
}

################################################################################
# Function: delete_sudo_config
# Description: 删除/etc/sudoers配置的命令或脚本
# Parameter:
#   input:
#   $1 : /etc/sudoers中配置命令或脚本路径
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_sudo_config()
{
    local cmd_path="$(readlink -m "/${1}")" || return $?
    verify_path "${cmd_path}" || return $?
    local temp=$(echo "^${OMM_USER} ALL=(root) NOPASSWD: ${cmd_path}" | sed -e 's/\//\\\//g')
    sed -i "/$temp/d" /etc/sudoers || return $?
}



################################################################################
# Function: delete_backup_sudo_config
# Description: 删除/etc/sudoers配置的backup命令或脚本
# Parameter:
#   input:
#   $1 : /etc/sudoers中配置命令或脚本路径
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_backup_sudo_config()
{
    local backup_sudo="backup ALL=(root) NOPASSWD"
    sed -i  "/${backup_sudo}/d" /etc/sudoers
    if [ $? -ne 0 ] ; then
        echo  "Failed to delete backup_sudo."
        return 1
    fi
    return 0
}

################################################################################
# Function: delete_oms_sudo_config
# Description: 删除/etc/sudoers配置的oms命令或脚本
# Parameter:
#   input:
#   $1 : /etc/sudoers中配置命令或脚本路径
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_oms_sudo_config()
{
    sed -i "/change_user_exc.sh/d" /etc/sudoers
    sed -i "/config_db_chg_user.sh/d" /etc/sudoers
    if [ $? -ne 0 ] ; then
        echo  "Failed to delete omm_sudo."
    fi
    return 0
}

################################################################################
# Function: delete_profile_env
# Description: 升级场景使用，删除/etc/profile中的环境变量
# Parameter:
#   input:
#   $1 : /etc/profile环境变量名
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_profile_env()
{
    local input_env_var="${1}"
    local -a env_vars=("DB_INST_USR" "OMS_USER")
    
    local -i flag=1
    for env_var in "${env_vars[@]}"
    do
        if [ "$input_env_var" == "$env_var" ]; then
            flag=0
            break
        fi
    done
    
    if [ ${flag} -ne 0 ]; then
        echo -e "No permission to remove $input_env_var environment variable from the /etc/profile"
        return 1
    fi
    
    sed -i "/^export[[:space:]]*${input_env_var}=/d" /etc/profile || return $?
}

################################################################################
# Function: delete_profile_env
# Description: 升级场景使用，删除/etc/profile中的客户端环境变量
# Parameter:
#   input:
#   $1 : /etc/profile环境变量名
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
delete_profile_env_client()
{
    grep 'source /opt/client/bigdata_env' /etc/profile
    if [ $? -ne 0 ];then
        return 0
    fi
    let lineno=$(cat -n /etc/profile | grep 'source /opt/client/bigdata_env' | awk '{print $1}')
    let start=$lineno-1
    let end=$lineno+1

    sed -i "${start},${end}d" /etc/profile || return $?
}

#####################################Upgrade end################################

################################################################################
# Function: validate_software_dir_exist
# Description: 校验目录是否存在
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function validate_dir_exist()
{
    local dir="${1}"
    if [ -d "${dir}" ] ; then
        return 0
    else
        return 1
    fi
}

################################################################################
# Function: validate_file_exist
# Description: 校验文件是否存在
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function validate_file_exist()
{
    local file="${1}"
    if [ -f "${file}" ] ; then
        return 0
    else
        return 1
    fi
}
################################################################################
# Function: clear_install_user
# Description: 清除/etc/profile.d/sudoProfile.sh中的INSTALL_USER环境变量
# Parameter:
#   input:
#   SOURCE DEST
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clear_install_user()
{
    local sudoProfile="/etc/profile.d/sudoProfile.sh"
    if [ -f "${sudoProfile}" ] ; then
        sed -i '/INSTALL_USER/d' "${sudoProfile}"
        if [ $? -ne 0 ] ; then
            echo  "Failed to delete INSTALL_USER in ${sudoProfile}."
            return 1
        fi
    fi
    
    local env_file="/root/env_file"
    if [ -f "${env_file}" ] ; then
        sed -i '/INSTALL_USER/d' "${env_file}"
        if [ $? -ne 0 ] ; then
            echo  "Failed to delete INSTALL_USER in ${env_file}."
            return 1
        fi
    fi
}

################################################################################
# Function: clear_bashrc
# Description: 清除$HOME/.bashrc文件中的两个环境变量
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
clear_bashrc()
{
    local bashrc_file=${HOME}/.bashrc
    local env_file=${HOME}/env_file
    log "INFO" "${LINENO}"  "Start to clear ${bashrc_file} and delete ${env_file}."
    if [ -f "${bashrc_file}" ] ; then
        grep "^source ${env_file}" ${bashrc_file}  > /dev/null 2>&1
        if [ $? -eq 0 ] ; then
           tmp=$(echo "^source ${env_file}" | sed -e 's/\//\\\//g')
           sed -i "/$tmp/d" ${bashrc_file}
           if [ $? -ne 0 ] ; then
               log "ERROR" "${LINENO}"  "Failed to clear ${bashrc_file}."
               return 1
           fi
        fi
    fi
    if [ -f "${env_file}" ] ; then
        rm -rf "${env_file}" > /dev/null 2>&1
        if [ $? -ne 0 ] ; then
           log "ERROR" "${LINENO}"  "Failed to delete ${env_file}."
           return 1
        fi
    fi

    log "INFO" "${LINENO}"  "Succeed to clear ${bashrc_file} and delete ${env_file}."
    return 0
}

################################################################################
# Function: forbid_ommdba_login
# Description: 禁止ommdba远程登录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
forbid_ommdba_login()
{
    id "${DB_CREATER}" >> "${OMS_LOG_FILE}" 2>&1
    if [ $? -eq 0 ]; then
       passwd -l "${DB_CREATER}" >> "${OMS_LOG_FILE}" 2>&1
       if [ $? -ne 0 ] ; then
           echo "failed to execute forbid_ommdba_login" >> "${OMS_LOG_FILE}"
       fi
    fi
}

################################################################################
# Function: remove_forbid_ommdba_login
# Description: 解除禁止ommdba远程登录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
remove_forbid_ommdba_login()
{
    upgradelog_file="$1"
    id "${DB_CREATER}" >> "${upgradelog_file}" 2>&1
    if [ $? -eq 0 ]; then
       passwd -u "${DB_CREATER}" >> "${upgradelog_file}" 2>&1
       if [ $? -ne 0 ] ; then
           echo "failed to execute remove_forbid_ommdba_login" >> "${upgradelog_file}"
       fi
    fi
}

################################################################################
# Function: cp_sudo_file
# Description: copy  sudo executor file
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
cp_sudo_file()
{
    local sudo_file="$1"
    local sudo_target_path="$2"
    verify_path "${sudo_file}" || return 1
    verify_path "${sudo_target_path}" || return 1

    cp -rf ${sudo_file} ${sudo_target_path}
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}"  "Failed to cp ${sudo_file} to ${sudo_target_path}."
        return 1
    fi

    chmod -R u+x "${sudo_target_path}"
    if [ $? -ne 0 ]; then
        log "ERROR" "${LINENO}"  "Failed to chmod ${sudo_target_path}."
        return 1
    fi

    return 0
}

################################################################################
# Function: mk_components_sudo_dir
# Description: make sudo directory for components
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
mk_components_sudo_dir()
{
    if [ ! -f "${BIGDATA_HOME}/om-server/om/omsetup.completed" -a ! -d "${BIGDATA_SUDO_HOME}/sudo/install/components" ]; then
        /bin/mkdir -p ${BIGDATA_SUDO_HOME}/sudo/install/components
    fi
}

################################################################################
# Function: mk_bigdata_sudo_home_dir
# Description: make sudo home directory
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
mk_bigdata_sudo_home_dir()
{
    if [ ! -f "${BIGDATA_HOME}/om-server/om/omsetup.completed" -a ! -d "${BIGDATA_SUDO_HOME}" ]; then
        /bin/mkdir -p ${BIGDATA_SUDO_HOME}
        chown "root:${WHEEL_GROUP}" "${BIGDATA_SUDO_HOME}"
        chmod 750 "${BIGDATA_SUDO_HOME}"
        /bin/mkdir -m 750 "${BIGDATA_SUDO_HOME}/comp"
        chown "root:${WHEEL_GROUP}" "${BIGDATA_SUDO_HOME}/comp"
    fi
}

##############################################################################
# Function: replace_file
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   NA
# Others: N/A
################################################################################
function replace_file()
{
    local srcfile="$1"
    local dstfile="$2"

    verify_path "$dstfile" "$srcfile" || return 1
    
    if ! [ -e "$dstfile" ]; then
        return 1
    fi
    
    if [ -d "$dstfile" ]; then
        return 1
    fi
    
    local fuser=
    local fgroup=
    local facl=
    fuser=$(stat -c %U "$dstfile")
    fgroup=$(stat -c %G "$dstfile")
    facl=$(stat -c %a "$dstfile")
    
    if [ $(stat -c %h "$dstfile") -gt 1 ]; then 
        if ! cancel_hardLink "${dstfile}"; then
            return 1
        fi
    fi
    
    if ! cp -rf "$srcfile" "$dstfile"; then
        return 1
    fi
    
    chmod "$facl" "$dstfile"
    chown "$fuser:$fgroup" "$dstfile"

    return 0
}
##############################################################################
# Function: delete_file
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   NA
# Others: N/A
################################################################################
function delete_file()
{
    local file="$1"
    local whitelist="/etc/sudo.conf$"
    if  [[ ${file} =~ ($whitelist) ]] && [[ ! ${file} =~ "/.." ]] && [[ ! ${file} =~ ";" ]] ; then
        rm -rf "$file"
    else
        verify_path "$file" || return 1

        if ! [ -e "$file" ]; then
            return 0
        fi

        rm -rf "$file"
    fi

    return $?
}
##############################################################################
# Function: add_file
# Description: 
# Parameter:
#   input:
#   N/A
#   output:
#   NA
# Others: N/A
################################################################################
function add_file()
{
    local file="$1"
    local dstDir="$2"
    
    verify_path "$dstDir" "$file" || return 1
    
    if ! [ -e "$file" ]; then
        return 1
    fi
    
    if cp -af "$file" "$dstDir"; then
        return 0
    fi
    
    return 1
}

function cancel_hardLink()
{
    local file="$1"
    if ! [ -f "${file}" ]; then
        return 1
    fi
    
    local lnum=
    lnum=$(stat -c %h "$file")
    if [ "${lnum}" -eq 1 ]; then 
        return 0
    fi
    
    cp -pf "${file}" "${file}_bak.$$" && rm -rf "$file" && mv "${file}_bak.$$" "$file" && return 0
    return 1
}


function back_file()
{
    local file="$1"
    local dstDir="$2"
    
    verify_path "$dstDir" "$file" || return 1
    if ! [ -f "${file}" ]; then
        return 1
    fi
    
    cp -pf "${file}" "${dstDir}" && return 0
    return 1
}

check_linkfile()
{
    local file="${1}"
    
    if [ -L "${file}" ]; then
        return 1
    fi
    
    if [ -d "${file}" ] ; then
        return 0
    fi
    
    if [ -f "${file}" ]; then
        local inodeValue=$(ls -l "${file}" | awk '{print $2}')
        if [ ${inodeValue} -ge 2 ];then
            return 1
        fi
    fi
    
    return 0
}

function delete_innerFile()
{
    local dstFile="$1"
    local srcFile="$2"
    
    if ! [ -f "${dstFile}" ]; then
        return 1
    fi
    
    getfacl -p "$dstFile" > $$.acl
    local ret=0
    which zip >> /dev/null 2>&1
    if [ $? -eq 0 ];then
        unzip -t "${dstFile}" "$srcFile" >> /dev/null 2>&1
        if [ $? -ne 0 ]; then
            return 0
        fi
        
        #使用zip -d参数删除无用的jar包中的文件，不需要解压缩jar包
        zip -d "${dstFile}" "$srcFile" >> /dev/null 2>&1
        ret=$?
    else
        ret=1
    fi
    setfacl --restore=$$.acl; rm -f $$.acl
    
    return $ret
}

function update_innerFile()
{
    local dstFile="$1"
    local srcFile="$2"
    
    if ! [ -f "${dstFile}" ]; then
        return 1
    fi
    
    getfacl -p "$dstFile" > $$.acl
    local ret=0
    which jar  >> /dev/null 2>&1
    if [ $? -eq 0 ];then
        jar -uf "$dstFile" "$srcFile" >> /dev/null 2>&1
        ret=$?
        rm -f "${dstFile%/*}/jartmp*.tmp"
    else
        which zip >> /dev/null 2>&1
        if [ $? -eq 0 ];then
            zip  "$dstFile" "$srcFile" >> /dev/null 2>&1
            ret=$?
        else
            ret=1
        fi
    fi
    setfacl --restore=$$.acl; rm -f $$.acl
    
    return $ret
}

##############################################################################
# Function: preinstall_creatsoftlink
# Description: creating a Soft Link
# Parameter:
#   input:
#   $1  source_file
#   $2  linked_file
#   output:
#   NA
# Others: N/A
################################################################################
function preinstall_creatsoftlink()
{
    local source_file=${1}
    local linked_file=${2}
    local libboost_atomic_link=/usr/lib64/libboost_atomic.so.1.66.0
    local libboost_system_link=/usr/lib64/libboost_system.so.1.66.0
    if [ ! -f "${source_file}" ];then
        error "[${FUNCNAME}:${LINENO}]" "${source_file} does not exist."
        return 1
    fi

    if [ X"${linked_file}" != X"${libboost_atomic_link}"  ] && [ X"${linked_file}" != X"${libboost_system_link}"  ]  ;then
        error "[${FUNCNAME}:${LINENO}]" "Invalid parameter."
        return 1
    fi

    if [ -L "${linked_file}" -o -f "${linked_file}" ];then
        return 0
    fi

    ln -s "${source_file}" "${linked_file}"
    if [ $? -ne 0 ];then
        error "[${FUNCNAME}:${LINENO}]" "Failed to creatsoftlink $linked_file."
        return 1
    fi

    chmod 777 ${linked_file}
}
################################end of preinstall_creatsoftlink######################

function config_coredump_dir()
{
    local core_dump_dir=""
    local core_pattern_file="/proc/sys/kernel/core_pattern"
    local dump_profile_file="/home/omm/.dumpprofile"

    grep "^omm soft core unlimited" "/etc/security/limits.conf" > /dev/null
    if [ $? -eq 1 ] ; then
        echo "core dump is not open. skipped"
        return 0
    fi

    if [ -f "${core_pattern_file}" ]; then
        local core_pattern_content=`cat "${core_pattern_file}"`
        core_dump_dir="${core_pattern_content%/*}"

        if [ x"${core_dump_dir:0:1}" = x"/" ]; then
            if [ ! -d "${core_dump_dir}" ]; then
                mkdir -p "${core_dump_dir}"
                if [ $? -ne 0 ]; then
                    echo "error create dir ${core_dump_dir}"
                    return 1
                fi
                echo "create ${core_dump_dir} success"
            fi

            local file_count=`ls -A "${core_dump_dir}"|wc -w`
            if [ ${file_count} -ne 0 ]; then
                echo "${core_dump_dir} is not empty."
                return 1
            fi

            chown -R $OMM_USER:$WHEEL_GROUP "${core_dump_dir}"
            if [ $? -ne 0 ]; then
                echo "change owener failed on ${core_dump_dir}"
                return 1
            fi

            echo "COREDUMP_DIR=${core_dump_dir}" >> "${g_sudo_profile}"

            local core_mount_space=$(df ${core_dump_dir} | awk '{if(NR==2)print $4}')
            if [ $? -eq 0 ]; then
                echo "CORE_MOUNT_SPACE=${core_mount_space}" >> "${dump_profile_file}"
                chown $OMM_USER:$WHEEL_GROUP "${dump_profile_file}"
                if [ $? -ne 0 ]; then
                    echo "change owener failed on ${dump_profile_file}"
                    return 1
                fi
            fi

            echo "changed owener to omm:wheel on ${core_dump_dir} success"
        fi
        return 0
    else
        echo "${core_pattern_file} is not exist."
        return 1
    fi

}

function preinstall_config_coredump()
{
    local ret=0
    local core_pattern="%e#%h#%t"
    local core_pattern_file="/proc/sys/kernel/core_pattern"
    local limitstr="omm soft core unlimited"
    local limits_file="/etc/security/limits.conf"
    local sysctl_conf_file="/etc/sysctl.conf"
    local core_dump_enable=$1
    local core_dump_dir=$2

    if [ $core_dump_enable != 1 ]; then
        echo "core dump is not enable."
        # clear limits config
        grep "^${limitstr}" ${limits_file}
        ret=$?
        if [ $? -eq 0 ]; then
            tmp=$(echo "^omm soft core unlimited" | sed -e 's/\//\\\//g')
            sed -i "/$tmp/d" ${limits_file}
            ret=$?
            if [ $? -ne 0 ]; then
                echo "Failed to clear /etc/security/limits.conf."
                return 1
            fi
        fi
        return 0
    fi

    if [ ! -z "$core_dump_dir" ]; then
        # 1.检查core_dump_dir合法性校验 
        if [ "${core_dump_dir:0:1}" != "/" ]; then
            echo "core_dump_dir must be an absolute path."
            return 1 
        fi
        local n=${#core_dump_dir}-1 
        if [ "${core_dump_dir:n:1}" == "/" ]; then
            echo "core_dump_dir cannot end with a slash."
            return 1 
        fi
        if [ "${core_dump_dir:1:1}" == "." ]; then
            echo "core_dump_dir contains an invalid character."
            return 1
        fi

        #2. core_dump_dir必须为空
        ls ${core_dump_dir}/* > /dev/null 2>&1
        ret=$?
        if [ $ret -eq 0 ]; then
            echo "core_dump_dir must be empty , ${core_dump_dir} is not empty."
            return 1
        fi

        core_pattern="${core_dump_dir}/${core_pattern}"
    fi

    #检查远端是否存在core_pattern和limits.conf文件
    ls ${core_pattern_file}
    ret=$?
    if [ $ret -ne 0 ]; then
        echo "check core_pattern failed"
        return 1
    fi

    ls ${limits_file}
    ret=$?
    if [ $ret -ne 0 ]; then
        echo "check limits.config failed"
        return 1
    fi

    ls ${sysctl_conf_file}
    ret=$?
    if [ $ret -ne 0 ]; then
        echo "check sysctl.config failed"
        return 1
    fi

    #检查远端core_pattern和limits.conf文件中是否已配置,如果没有，怎添加配置
    grep "^${core_pattern}" ${core_pattern_file}
    ret=$?
    if [ $ret -eq 1 ]; then
        echo "${core_pattern}" > ${core_pattern_file}
        ret=$?
        if [ $ret -ne 0 ]; then
            echo "config core_pattern failed"
            return 1
        fi
    fi
    echo "config core_pattern success"

    grep "^${limitstr}" ${limits_file}
    ret=$?
    if [ $ret -eq 1 ]; then
        echo "${limitstr}" >> ${limits_file}
        ret=$?
        if [ $ret -ne 0 ]; then
            echo "config limits.config failed"
            return 1
        fi
    fi
    echo "config limits.config success"

    grep "^kernel.core_pattern = ${core_pattern}" ${sysctl_conf_file}
    ret=$?
    if [ $ret -eq 1 ]; then
        grep "^kernel.core_pattern" ${sysctl_conf_file}
        ret=$?
        if [ $ret -eq 0 ]; then
            sed -i "/^kernel.core_pattern.*/d" ${sysctl_conf_file}
            ret=$?
            if [ $ret -ne 0 ]; then
                echo "delete old pattern failed"
                return 1
            fi
        fi

        echo "kernel.core_pattern = ${core_pattern}" >> ${sysctl_conf_file}
        ret=$?
        if [ $ret -ne 0 ]; then
            echo "config sysctl.config failed"
            return 1
        fi
    fi
    echo "config sysctl.config success"
    return 0
}

################################################################################
# Function: node_hardware_type
# Description: 执行命令获取节点硬件类型
# Parameter: $1 node_hardware_type
#   input:
#   N/A
#   output:
#   N/A
# Return:
# Others:
################################################################################
function node_hardware_type()
{
 local hardwareType=""
 # 设定命令超时限制，命令执行超时，返回值为124，不影响上下文逻辑
 timeout 3s ipmitool fru print 0 >/dev/null 2>&1
 ret_ipmitool=$?

 # 设定命令超时限制，命令执行超时，返回值为124，不影响上下文逻辑
 timeout 3s dmidecode |grep -m1 "Product Name" >/dev/null 2>&1
 ret_dmidecode=$?

 if [ "$ret_ipmitool" -eq 0 ];then
   hardwareType=$(ipmitool fru print 0 |grep "Product Name" |awk -F ':' '{print$2}' 2>/dev/null)
 elif [ "$ret_dmidecode" -eq 0 ];then
   hardwareType=$(dmidecode |grep -m1 "Product Name"|awk -F ':' '{print $2}' 2>/dev/null)
 else
   hardwareType="Normal"
 fi

 echo "$hardwareType"
}

function clean_coredump_dir()
{
    local coredump_dir=`grep "COREDUMP_DIR" "$g_sudo_profile" | awk -F"=" '{print $2}'`
    if [ x"${coredump_dir}" != x ] && [ -d "${coredump_dir}" ]; then
        rm -rf ${coredump_dir}
    fi

    return 0
}

## 开机启动需要设置-x权限，否则不生效
function configHostRecovery(){
    if [ -f /etc/rc.d/rc.local ]; then
         sed -i '/hostRecovery.sh/d' /etc/rc.d/rc.local
         echo "sh ${BIGDATA_SUDO_HOME}/sudo/install/hostRecovery.sh" >> /etc/rc.d/rc.local
         chmod +x /etc/rc.d/rc.local
         return 0
    fi
    if [ -f /etc/rc.local ]; then
        sed -i '/hostRecovery.sh/d' /etc/rc.local
        echo "sh ${BIGDATA_SUDO_HOME}/sudo/install/hostRecovery.sh" >> /etc/rc.local
        chmod +x /etc/rc.local
        return 0
    fi
}

function cleanHostRecovery(){
    sed -i '/hostRecovery.sh/d' /etc/rc.local
    sed -i '/hostRecovery.sh/d' /etc/rc.d/rc.local
    rm -f /var/spool/omm_back
}

##########################方法#############################
##备份/etc/ldap.conf，升级时候使用
#######################################################
ldapc_install_backupConfig_cpf()
{
    local ldap_conf="/etc/ldap.conf"
    local ldap_tmp_conf="$1"
    
    
    verify_path "${ldap_tmp_conf}"
    if [ $? -ne 0 ]; then
        return 1
    fi
    
    cp -afp "${ldap_conf}" "${ldap_tmp_conf}"
    ret=$?
    if [ $ret -ne 0 ]; then
        echo "cp -afp ${ldap_conf} ${ldap_tmp_conf} failed"
        return 1
    fi
    
    return 0
}

##########################方法#############################
##生成日志收集文件
#######################################################
function generate_archivelog()
{
    local log_tar_name="$1"
    local base_dir="/var/log"
    if [ "${log_tar_name:0:8}" != "${base_dir}" ]; then
        return 1
    fi

    if [ ! -e "${base_dir}" ]; then
        mkdir -p "${base_dir}"
        recursive_chown "omm:wheel" "${base_dir}"
    fi

    shift
    local logFiles="$@"
    local targetFiles=(${logFiles})
    for f in "${targetFiles[@]}"; do
        if [ "${f:0:8}" != "/var/log" -a "${f:0:20}" != "/srv/BigData/Bigdata" -a "${f}" != "/opt/mrs_clusterinfo" -a "${f##*.}" != "log" \
            -a "${f:0:19}" != "/var/lib/cloud/data" -a "${f:0:9}" != "/home/omm" -a "${f:0:13}" != "/opt/executor" ]; then
            return 1
        fi
    done

    tar --warning=no-file-changed -czPf ${log_tar_name} ${logFiles}
    recursive_chown "omm:wheel" "${log_tar_name}"

    return 0
}

##########################方法#############################
##寻找最近n分钟发生变更文件
#######################################################
function find_log_file()
{
    local target_dir="$1"
    local duringtime="$2"
    local logFiles=$(find ${target_dir} -mmin -"${duringtime}" -type f )
    echo  "${logFiles}"
}


##寻找最近n分钟发生变更.log文件
#######################################################
function find_file_with_log_prefix()
{
    local target_dir="$1"
    local duringtime="$2"
    local logFiles=$(find "${target_dir}" -mmin -"${duringtime}" -type f -a -name "*.log" )
    echo  "${logFiles}"
}

####################此后方法为6.5.1版本适配MRS新加方法##############

####################################################################
#  FUNCTION     : config_mrs_crontab
#  DESCRIPTION  : 配置crontab
#  INPUT        : 
#  OUTPUT       : 
#  RETURN       : 
####################################################################
config_mrs_crontab()
{
    log "INFO" "${LINENO}" "config crontab."
    master1_ip=$1
    master2_ip=$2
    hostname=`hostname`
    hostname_inshort=""
    if [[ ${hostname} =~ master1 ]];then
        hostname_inshort="master1"
        local_ip=${master1_ip}
        peer_ip=${master2_ip}
    else
        hostname_inshort="master2"
        local_ip=${master2_ip}
        peer_ip=${master1_ip}
    fi

    if [ -f '/etc/centos-release' ]; then
        crond_file=/var/spool/cron/root
        restart="/sbin/service crond restart"
    else
        crond_file=/var/spool/cron/tabs/root
        restart="/sbin/service cron restart"
    fi
    chmod u+x /usr/sbin/bdsmonit.py
    echo -e "* * * * * (flock -xn /tmp/bdsmonit.lock /usr/bin/python /usr/sbin/bdsmonit.py ${hostname_inshort} ${local_ip} ${peer_ip};rm -rf /tmp/bdsmonit.lock)" >> ${crond_file}
    echo -e "* * * * * (sleep 30;flock -xn /tmp/bdsmonit.lock /usr/bin/python /usr/sbin/bdsmonit.py ${hostname_inshort} ${local_ip} ${peer_ip};rm -rf /tmp/bdsmonit.lock)" >> ${crond_file}
    ${restart}
}

switch_executor_knox_workspace()
{
    if [ "${1}" == "upgrade" ]; then
        mv /opt/executor /opt/executor-6.5.1
        ln -snf /opt/executor-8.0.2 /opt/executor
        mv /opt/knox /opt/knox-6.5.1
        ln -snf /opt/knox-8.0.2 /opt/knox
    elif [ "${1}" == "rollback" ]; then
        rm -rf /opt/executor-8.0.2
        if [ -L /opt/executor ]; then
            rm -rf /opt/executor
        fi
        mv /opt/executor-6.5.1 /opt/executor
        
        rm -rf /opt/knox-8.0.2
        if [ -L /opt/knox ]; then
            rm -rf /opt/knox
        fi
        mv /opt/knox-6.5.1 /opt/knox/
    fi
}

mk_path_knox_executor()
{
    mkdir /opt/knox-8.0.2
    chown omm:wheel /opt/knox-8.0.2
    chmod 700 /opt/knox-8.0.2
    
    mkdir /opt/executor-8.0.2
    chown omm:wheel /opt/executor-8.0.2
    chmod 700 /opt/executor-8.0.2
}

####################################################################
#  FUNCTION     : del_files_for_mrs
#  DESCRIPTION  : 删除为hcs纳管FI物理集群创建的目录和标志文件
#  INPUT        :
#  OUTPUT       :
#  RETURN       :
####################################################################
function del_files_for_mrs()
{
    rm -rf /opt/executor

    rm -rf /opt/knox

    rm -f /opt/mrs_clusterinfo

    rm -rf /var/log/Bigdata/executor

    rm -rf /var/log/Bigdata/knox

    if [ -L "/var/log/knox" ]; then
        rm -f /var/log/knox
    fi

    if [ -L "/var/log/executor" ]; then
        rm -f /var/log/executor
    fi

    if [ -L "/opt/Bigdata" ]; then
        rm -f /opt/Bigdata
    fi
}

####################################################################
#  FUNCTION     : delete_omm_tmpFiles
#  DESCRIPTION  : 卸载agent清理tmp目录下omm属主文件
####################################################################
function delete_omm_tmpFiles(){
    find /tmp -type f -user "${OMM_USER}" -group "${WHEEL_GROUP}" -print0 | xargs -0 rm -rf
    find /tmp -type d -user "${OMM_USER}" -group "${WHEEL_GROUP}" -print0 | xargs -0 rm -rf
}

rm_fake_controller_home()
{
    rm -rf /opt/Bigdata/om-0.0.1
}

##########################方法#############################
##修改文件，MRS适配使用
#######################################################
sed_file()
{
    sed $@
    return $?
}

##########################方法#############################
##发放集群安装oms修改IP
#######################################################
recoverIp()
{
    local g_server1IP1=$1
    local g_server2IP1=$2
    local g_wsFloatIP=$3
    local g_wsFloatIPNetmask=$4
    local g_wsGateway=$5
    local g_omFloatIP=$6
    local g_omFloatIPNetmask=$7
    local g_omGateway=$8
    local g_mediatorIP=$9
    local g_wsFloatIPInterface=${10}
    local g_omFloatIPInterface=${11}
    local g_ntpServerIP=${12}
    bash /home/recoverIp/recoverIP.sh "${g_server1IP1}" "${g_server2IP1}" "${g_wsFloatIP}" "${g_wsFloatIPNetmask}" "${g_wsGateway}" "${g_omFloatIP}" "${g_omFloatIPNetmask}" "${g_omGateway}" "${g_mediatorIP}" "${g_wsFloatIPInterface}" "${g_omFloatIPInterface}" "${g_ntpServerIP}"
    return $?
}

####################################################################
#  FUNCTION     : check_cloud_init
#  DESCRIPTION  : 检测cloud init是否执行成功
#  INPUT        :
#  OUTPUT       :
#  RETURN       :
####################################################################
check_cloud_init()
{
  local cloudparam=$1
  log "INFO" "${LINENO}" "check cloud init."
  hostname=`hostname -I`
  if [ $cloudparam = "cloudinit_v1" ]; then
    sh /opt/Bigdata_func/cloudinit/check_cloudinit.sh
    if [ $? -ne 0 ]; then
      echo "Cloud init executed failed with errors in ${hostname}"
      return 1
    fi
  else
    ret=`cat /var/lib/cloud/data/result.json | awk -F ":" '/errors/{print$2}'`
    if [[ ${ret} =~ \[\] ]]; then
       echo "Cloud init executed successfully in ${hostname}"
       return 0
    else
       echo "Cloud init executed failed with errors in ${hostname}"
       return 1
    fi
  fi
  echo "Cloud init executed successfully in ${hostname}"
  return 0
}

####################此前方法为6.5.1版本适配MRS新加方法##############

if [ -z ${BIGDATA_SUDO_HOME} ]; then
    BIGDATA_SUDO_HOME="/var/lib/sudo/Bigdata"
fi

#####################################Upgrade end################################
##########################OMM sudo 方法#############################
##OMM_SUOD_METHOD##
#######################################################
# ---------------------------------------------------------------------------- #
#                                   导入OMM sudo头文件                                 #
# ---------------------------------------------------------------------------- #

if [ -d "${G_CUR_PATH}/components" ]; then
    for sudo_file in ${G_CUR_PATH}/components/*
    do
        if [ -f "${sudo_file}" ]; then
            owner="$(stat --format '%U' "${sudo_file}")"
            if [ "${owner}" = "root" ]; then
                . "${sudo_file}" || { log "ERROR" "${LINENO}" "Failed to load ${sudo_file}"; exit 1; }
            fi
        fi
    done
fi
################################################################################
# Function: main
# Description: Entrance of the script
# Parameter:
#   input:
#   $1  function's name & arguments
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
main()
{
    # 如果不是root用户，则退出安装
    if [ $(id -u) -ne 0 ] ; then
        echo "Only super user can execute this script."
        return 1
    fi

    # 至少有一个入参
    if [ $# -lt 1 ]; then
        echo "Illegal argument, accept 1 argument at least."
        return 1
    fi

    #判断是否是OMM的方法
    if [ "$1" == "omm" ] ; then
        local function_name="$2"
        shift 2
        function_name=omm_$function_name
        $function_name "$@"
    else
        local function_name="$1"
        shift
    
        if echo "${g_fuctionArray[@]}" | grep -w "${function_name}" &>/dev/null; then
       $function_name "$@"
    else
       echo "Fuction $function_name is not exist in $(basename $0)."
       return 1
        fi
    fi
}

PATH="$PATH:/sbin/:/usr/sbin/"


umask 027
if [ -f /sbin/ifconfig ]; then
    IFCONFIG="/sbin/ifconfig"
else
    IFCONFIG="/usr/bin/ifconfig"
fi
main "$@"
exit $?
